/// <reference path="../modules/localStorage/aralco.localStorage.js" />
/// <reference path="aralco.mobile.fw/aralco.mobile.fw.js" />
/// <reference path="../Scripts/underscore.js" />


(function () {
    "use strict";
    var specificallyHandleInProgress = false;
    var HEADER_NAME = "aralco.mobile-Handle-Errors-Generically";

    var app = angular.module("aralco.mobile", [
        "ionic",
        "ngCordova",
        "base64",
        "aralco.translator",
        "aralco.setting",
        "aralco.sql",
        "aralco.database",
        "aralco.product",
        "aralco.images",
        "aralco.store",
        "aralco.physicalcount",
        "aralco.map",
        "aralco.controlpanel",
        "aralco.login",
        "aralco.localStorage",
        "aralco.inventory",
        "aralco.customer",
        "aralco.about",
        "aralco.reports",
        "aralco.pos",
        "aralco.dimension",
        "aralco.taxes",
        "aralco.salutation",
        "aralco.transfers",
        "aralco.purchaseorderstore",
        "aralco.returntovendor",
        "aralco.register",
        "aralco.staff",
        "aralco.supplier",
        "aralco.bossetup",
        "aralco.possetup",
        "aralco.productssetup",
        "aralco.productsDetails",
        "aralco.tenderkeysetup",
        "aralco.coupons",
        "aralco.discountreasons",
        "aralco.expenses",
        "aralco.giftcards",
        "aralco.pointsplan",
        "aralco.remarkoptions",
        "aralco.returnreasons",
        "aralco.possalutations",
        "aralco.storegroups",
        "aralco.barcodesets",
        "aralco.storetypes",
        "aralco.suppliergroups",
        "aralco.inventoryzones",
        "aralco.province",
        "aralco.customergroups",
        "aralco.pricezones",
        "aralco.taxtables",
        "aralco.freightservices",
        "aralco.dutyrates",
        "aralco.departments",
        "aralco.productgroups",
        "aralco.pricerounding",
        "aralco.promotionstables",
        "aralco.bosusergroups",
        "aralco.posusergroups",
        "aralco.currencies",
        "aralco.unitsofmeasures",
        "aralco.dimensions",
        "aralco.security"
    ]);

    app.filter('modify',function()
    {
        return function(value){
    
        if(value == null || value == 0)
        return "";
        }
    });

    app.config(['$translateProvider', function ($translateProvider) {
        //$translateProvider.translations('en', translations); // A list of works to translate is needed for this to work (js object)
        //$translateProvider.preferredLanguage('en'); // A word list is needed for this to work (file en.txt)
        $translateProvider.useSanitizeValueStrategy('sanitize');
    }]);

    app.config(['$stateProvider','$ionicConfigProvider', '$provide', '$urlRouterProvider', '$httpProvider', 'localStorageServiceProvider',
        function ($stateProvider, $ionicConfigProvider, $provide, $urlRouterProvider, $httpProvider, localStorageServiceProvider) {
            

            $ionicConfigProvider.tabs.position('bottom');
            function addHeaderToConfig(config) {
                config = config || {};
                config.headers = config.headers || {};

                config.headers['Cache-Control'] = 'max-age=0';
                config.headers['Access-Control-Allow-Origin'] = '*';

                // Add the header unless user asked to handle errors himself
                if (!specificallyHandleInProgress) {
                    config.headers[HEADER_NAME] = true;
                }

                return config;
            }

            $httpProvider.defaults.useXDomain = true;
            $httpProvider.interceptors.push('errorFctr');


            $stateProvider
            // setup an abstract state for the tabs directive
                .state('tab', {
                    url: "/tab",
                    cache: false,
                    abstract: true,
                    templateUrl: "templates/tabs.html"
                })

                .state('tab.dash', {
                    url: '/dash',
                    cache: false,
                    LoginRequired: true,
                    views: {
                        'tab-dash': {
                            //templateUrl: 'modules/pos/templates/pos-end-day-receipt.html',
                            templateUrl: 'templates/tab-dash.html',
                            controller: 'mainCtr'
                        }
                    }
                })

                .state('tab.inventory', {
                    url: '/inventory',
                      cache: false,
                    LoginRequired: true,
                    views: {
                        'tab-inventory': {
                            templateUrl: 'templates/tab-inventory.html',
                            controller: 'mainCtr'
                        }
                    }
                })
                .state('tab.view', {
                    url: '/view',
                      cache: false,
                    LoginRequired: true,
                    views: {
                        'tab-view': {
                            templateUrl: 'templates/tab-view.html',
                            controller: 'mainCtr'
                        }
                    }
                });
                

            // if none of the above states are matched, use this as the fallback
            $urlRouterProvider.otherwise(function ($injector, $location) {
                var accountFctr = $injector.get('accountFctr');
                var path = accountFctr.isLogged() ? '/tab/dash' : '/login';
                $location.path(path);
                $location.replace();

            });

            /*set the interceptor for the http request*/
            // $httpProvider.interceptors.push('httpRequestInterceptor');

            $provide.decorator('$http', ['$delegate', function ($delegate) {

                function decorateRegularCall(method) {
                    return function (url, config) {
                        return $delegate[method](url, addHeaderToConfig(config));
                    };
                }

                function decorateDataCall(method) {
                    return function (url, data, config) {
                        return $delegate[method](url, data, addHeaderToConfig(config));
                    };
                }

                function copyNotOverriddenAttributes(newHttp) {
                    for (var attr in $delegate) {
                        if (!newHttp.hasOwnProperty(attr)) {
                            if (typeof ($delegate[attr]) === 'function') {
                                newHttp[attr] = function () {
                                    return $delegate.apply($delegate, arguments);
                                };
                            } else {
                                newHttp[attr] = $delegate[attr];
                            }
                        }
                    }
                }

                var newHttp = function (config) {
                    return $delegate(addHeaderToConfig(config));
                };

                newHttp.get = decorateRegularCall('get');
                newHttp.delete = decorateRegularCall('delete');
                newHttp.head = decorateRegularCall('head');
                newHttp.jsonp = decorateRegularCall('jsonp');
                newHttp.post = decorateDataCall('post');
                newHttp.put = decorateDataCall('put');

                copyNotOverriddenAttributes(newHttp);

                return newHttp;
            }]);
        }]);
        app.constant('handleStoreValue', {
           storeValue:null,
           registerValue:null
     });

    app.controller('subHeaderCtr', ['$scope','handleStoreValue','accountFctr', function ($scope,handleStoreValue,accountFctr) {
          $scope.IsUserLoggedIn = function () {
            return accountFctr.isLogged();
            };
          $scope.handleStoreValue =null;
          if(handleStoreValue.storeValue!=undefined || handleStoreValue.storeValue!=0 || handleStoreValue.storeValue!=null)
            $scope.handleStoreValue = handleStoreValue;
     }]);
    app.controller('mainCtr', ['$scope','$state', '$ionicSideMenuDelegate', '$ionicHistory', '$ionicPopover', 'accountFctr', '$rootScope', '$location', function ($scope, $state, $ionicSideMenuDelegate, $ionicHistory, $ionicPopover, accountFctr, $rootScope, $location) {
        $scope.UserLogged = function () {
            return accountFctr.isLogged();
        };

        $scope.ShowMenu = function ($event) {
            $ionicPopover.fromTemplateUrl('modules/controlpanel/templates/access-menu.html', {
                scope: $scope
            }).then(function (popover) {
                $scope.popover = popover;
                $rootScope.$broadcast('popover.showing');
                $scope.popover.show($event);
            });
        };
        //Add Sub-Menu
        $scope.showSubMenu = function($event) {
           $ionicPopover.fromTemplateUrl('modules/controlpanel/templates/sub-menu.html', {
               scope: $scope
           }).then(function (popover) {
               $scope.popover = popover;
               $rootScope.$broadcast('popover.showing');
               $scope.popover.show($event);
           });
       };
        $rootScope.$on('popover.hideme', function () {
            if ($scope.popover)
                $scope.popover.hide();
        });

        //Cleanup the popover when we're done with it!
        $scope.$on('$destroy', function () {
            if ($scope.popover)
                $scope.popover.remove();
        });

        $scope.$on('popover.hidden', function () {
            // Execute action
        });
        // Execute action on remove popover
        $scope.$on('popover.removed', function () {
            // Execute action
        });

        $scope.viewMenu = [];
        $scope.inventoryMenu = [];

        $scope.viewMenu.push(new MenuItem("Product", "ion-tshirt", "#/tab/productsDetails", 'Create or edit Product'));
        $scope.viewMenu.push(new MenuItem("Stores", "ion-briefcase", "#/tab/Stores", 'Access to the list of of stores'));
        $scope.viewMenu.push(new MenuItem("Registers", "ion-clipboard", "#/tab/Registers", 'Access to the list of of registers'));
        $scope.viewMenu.push(new MenuItem("Customers", "ion-ios-people", "#/tab/customer", 'Access to the list of your customers'));
        $scope.viewMenu.push(new MenuItem("Staff", "ion-person-add", "#/tab/staffs", 'Staff form'));
        $scope.viewMenu.push(new MenuItem("Suppliers", "ion-plane", "#/tab/suppliers", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("General", "ion-gear-b", "#/tab/productssetup", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("POS", "ion-gear-b", "#/tab/possetup", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("BOS", "ion-gear-b", "#/tab/bossetup", 'Suppliers form'));
        $scope.inventoryMenu.push(new MenuItem("Product Lookup", "ion-ios-glasses", "#/tab/products", 'View products and inventories'));
        $scope.inventoryMenu.push(new MenuItem("PO Requisites", "ion-calculator", "#/tab/purchaseorderstore", 'Manage existing purchase orders'));
        $scope.inventoryMenu.push(new MenuItem("RTV Requisites", "ion-calculator", "#/tab/returntovendor", 'Manage return to vendor'));
        $scope.inventoryMenu.push(new MenuItem("Receiving", "ion-archive", "#/tab/purchaseorder", 'Manage purchase order and good receiving'));
        $scope.inventoryMenu.push(new MenuItem("Physical Count", "ion-calculator", "#/tab/physicalcount", 'Manage existing physical count'));
        $scope.inventoryMenu.push(new MenuItem("Transfer", "ion-ios-fastforward-outline", "#/tab/transfers", 'Manage purchase order and good receiving'));
       /* $scope.inventoryMenu.push(new MenuItem("Reports", "ion-clipboard", "", 'Reports'));*/
        //$scope.inventoryMenu.push(new MenuItem("Product Lookup", "ion-ios-glasses", "#/tab/transfers", 'Lookup'));
        $scope.inventoryMenu.push(new MenuItem("Adjustment", "ion-calculator", "#/tab/transfers", 'Adjustment'));
        $scope.inventoryMenu.push(new MenuItem("Barcode", "ion-ios-barcode", "#/tab/transfers", 'Barcode'));


        $rootScope.$watch(function () {
            return $ionicHistory.viewHistory()
        }, function (val) {
            if (val.currentView == null && accountFctr.isLogged()) {
                $location.path('/tab/dash');
            }
        });

        function MenuItem(text, icon, url, description) {
            /// <summary>
            /// Create an element for a grid menu
            /// </summary>
            /// <param name="text"></param>
            /// <param name="icon"></param>
            /// <param name="url"></param>
            /// <param name="description"></param>
            /// <returns type=""></returns>
            return {
                text: text,
                icon: icon,
                url: url,
                description: description
            };
        }
        
    }]);

    app.provider('$exceptionHandler', function () {
        // In the provider function, you cannot inject any
        // service or factory. This can only be done at the
        // "$get" method.

        this.$get = function ($injector) {
            return function (exception, cause) {
                var rScope = $injector.get('$rootScope');
                var $ionicLoading = $injector.get('$ionicLoading');
                var popupFctr = $injector.get('popupFctr');
                exception = exception || {}; // in case it somehow recives a undefined exception. Had it happen once.
                rScope.$broadcast('exception', exception, cause);
                $ionicLoading.hide();
                console.error(exception);
                var message = exception;
                if (exception.useInner){
                    message = exception.message;
                }
                if(!rScope.exceptionHandlerPopup || rScope.exceptionHandlerPopup.$$state.status !== 0){
                    rScope.exceptionHandlerPopup = popupFctr.alert((exception.title || 'There was an error...'), message);
                }
                $ionicLoading.hide();
            }
        };
    });

    app.run(['$window','handleStoreValue','$ionicLoading', '$ionicPlatform', '$rootScope', 'localStorageService', 'settingFctr', 'accountFctr','$state',
             function ($window, handleStoreValue,$ionicLoading, $ionicPlatform, $rootScope, localStorageService, settingFctr, accountFctr,$state) {
        var cfg = "prod";

        function setFramework(config) {
            $ionicLoading.show({
                template: 'Establishing Cloud connection, please wait...'
            });
            settingFctr.$get(config).then(function (stg) {
                var conn = stg.connection;
                var url = 'http' + (conn.SSL === true ? 's' : '') + '://' + conn.server;
                if (!_.isEmpty(conn.port))
                    url = url + ':' + conn.port;

                $f.serviceUrl = url + '/';
                $f.moduleSetting.Product.maxItems = stg.Product.maxItem || 20;
                $f.moduleSetting.Store.ID = stg.Store.ID || $f.moduleSetting.pos.Store.ID  || 0;
                $f.moduleSetting.Store.Code =  stg.Store.Code || $f.moduleSetting.pos.Store.Code || 0;
                console.log("Selected StoreCode = " + $f.moduleSetting.Store.Code || '<not selected yet>');
                if(!_.isEmpty($state.current.name)) {
                    if(!($state.current.name.lastIndexOf("pos", 0) === 0)){
                        handleStoreValue.storeValue = stg.Store.Code ||$f.moduleSetting.Store.Code || 0;
                    };
                } else {
                    handleStoreValue.storeValue = 0;
                }

                
                $f.ForceLoad = stg.QueryOption.ForceLoad || false;

                /*pos option*/
                $f.store = stg.store || null;
             
                $f.moduleSetting.pos.customerMode = stg.pos.customerMode;
                $ionicLoading.hide();
            });
        }

        setFramework(cfg);

        $rootScope.$on('setting.updated', function (event, args) {
            setFramework(cfg);
        });

        $rootScope.WaitForEmployeeData = function () {
            if($f.UserInfo.EmployeeID === null && $f.isLogged){
                if(!$rootScope.exceptionHandlerPopup || $rootScope.exceptionHandlerPopup.$$state.status !== 0){
                    $ionicLoading.show({
                        template: "Wait..."
                    });
                }
                $rootScope.employeeDataLoading = true;
                $rootScope.waitForEmployeeDatatTimout = setTimeout($rootScope.WaitForEmployeeData, 3000);
                accountFctr.isLogged(new Date());
            } else if ($rootScope.employeeDataLoading){
                clearTimeout($rootScope.waitForEmployeeDatatTimout);
                $rootScope.waitForEmployeeDatatTimout = null;
                $rootScope.employeeDataLoading = false;
                $ionicLoading.hide();
                if ($rootScope.preventedState != null){
                    $state.go($rootScope.preventedState);
                }
            }
        };

        //Force Check Store Selection Throughout the program
        $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams){
            console.log((fromState.name || "null") + " -> " + (toState.name || "null"));
            if(toState.name!="tab.dash" && toState.name!="setting" && fromState.name !="setting"){
                if(toState.name !== null && $f.isLogged){
                    var message = "You are not authorized to access the {0} module. Please ensure you have the {0} " +
                        "mobile permission in the BOS enabled."; // Base message
                    var replaceString; // Module that will replace {0} in the above string
                    if($f.UserInfo.EmployeeID === null){
                        $rootScope.preventedState = toState.name; // For callback when employee data becomes available.
                        event.preventDefault(); // Stop State Change
                    } else if (toState.name.startsWith("pos.") && !$f.UserInfo.BosOptions.Pos) {
                        replaceString = "POS";
                    } else if ((toState.name === "tab.purchaseorderstore" || toState.name === "tab.returntovendor" ||
                            toState.name === "tab.polist" || toState.name === "tab.transfers")
                            && !$f.UserInfo.BosOptions.Advanced) {
                        replaceString = "Advanced";
                    } else if ((toState.name === "tab.productsDetails" || toState.name === "tab.stores" ||
                            toState.name === "tab.registers" || toState.name === "tab.customer" ||
                            toState.name === "tab.staffs" || toState.name === "tab.suppliers" ||
                            toState.name === "tab.productssetup" || toState.name === "tab.possetup" ||
                            toState.name === "tab.bossetup" || toState.name === "tab.products" ||
                            toState.name === "tab.physicalcount") &&
                            !($f.UserInfo.BosOptions.Basic || $f.UserInfo.BosOptions.Advanced)) {
                        replaceString = "Basic";
                    }
                    if (replaceString){
                        $rootScope.preventedState = null;
                        event.preventDefault(); // Stop State Change
                        var error = new Error(message.split("{0}").join(replaceString));
                        // ^ .split().join() -> Replace all occurences
                        error.title = "Access Denied";
                        error.useInner = true;
                        throw(error);
                    }
                }
                $rootScope.WaitForEmployeeData();
                var timeOut = accountFctr.isLogged(new Date());
            }

                       
            if (toState.name  != undefined) {
                if(!(toState.name.lastIndexOf("pos", 0) === 0)){
                 handleStoreValue.storeValue = $f.moduleSetting.Store.Code;
                 handleStoreValue.registerValue = null;
                }
            }

            // if(toState.name!="tab.dash" && toState.name!="setting" && fromState.name !="setting"
            // && accountFctr.isLogged() && ($f.moduleSetting.Store.ID ==0 || $f.moduleSetting.Store.ID == null)&&
            // (toState.StoreRequired!=true && toState.name!="pos.assignstore") ){
            //     var timeout;
            //     setTimeout(function(){
            //         $ionicLoading.hide();
            //         window.location.href= '#/setting/app';
            //     }, 2000);
            //
            //     $ionicLoading.show({
            //       template: 'No Stores Selected. Please choose a store!'
            //     });
            //
            // }
        });
        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);
            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleDefault();
            }
        });

        /**
           Destroy the session when unloading

           Note that this is far from perfect and will also
           trigger a log-out during a browser refresh.
         */

       /// $window.onbeforeunload = function (event) {
       //     accountFctr.logout();
       // };
    }]);

    app.filter('reverse', function () {
        return function (items) {
            var RetVal = items;
            if ((items) && (Array.isArray(items))) {
                RetVal = items.slice().reverse();
            }
            return RetVal;
        };
    });

    app.filter('htmlcompliant', function () {
        return function (input) {
            console.clear();
            input = input || '';

            input = input.replace(/(?:\r\n|\r|\n)/g, '<br />');
            console.log(input);
            return input;
        };
    });


    app.directive('barcodeReader', function () {
        return {
            scope: {
                barcodeMode: "@"
            },
            link: function (scope, element, attrs, modelCtrl) {

                scope.$on('native.keyboardshow', function () {
                    var cs = scope.barcodemode || true;
                    if (cs) {
                        cordova.plugins.Keyboard.close();
                    }
                });
            }
        }
    });

    //app.directive('input', ['$compile', '$timeout', function ($compile, $timeout) {
    //    return {
    //        require: 'ngModel',
    //        priority: 1500,
    //        link: function (scope, el, attrs, ctrl) {
    //            return;

    //            // limit to input element of specific types
    //            var inputTypes = /text|search|tel|url|email|password/i;
    //            if (el[0].nodeName === "INPUT") {
    //                if (!inputTypes.test(attrs.type)) {
    //                    throw new Error("Invalid input type for resetField: " + attrs.type);
    //                }
    //            } else if (el[0].nodeName !== "TEXTAREA") {
    //                throw new Error("resetField is limited to input and textarea elements");
    //            }

    //            // compiled reset icon template
    //            var template = $compile('<i ng-show="enabled" ng-click="reset()" class="icon ion-android-close reset-field-icon"></i>')(scope);
    //            el.addClass("reset-field");
    //            el.after(template);

    //            scope.reset = function () {
    //                alert('Hi there!');
    //                ctrl.$setViewValue(null);
    //                ctrl.$render();
    //                $timeout(function () {
    //                    el[0].focus();
    //                }, 0, false);
    //                scope.enabled = false;
    //            };

    //            el.bind('input', function () {
    //                scope.enabled = !ctrl.$isEmpty(el.val());
    //            })
    //            .bind('focus', function () {
    //                $timeout(function () { //Timeout just in case someone else is listening to focus and alters model
    //                    scope.enabled = !ctrl.$isEmpty(el.val());
    //                    scope.$apply();
    //                }, 0, false);
    //            })
    //           .bind('blur', function () {
    //               $timeout(function () {
    //                   scope.enabled = false;
    //                   scope.$apply();
    //               }, 0, false);
    //           });
    //        }
    //    };
    //}]);

    app.directive('ngEnter', [function () {
        return function (scope, element, attrs) {
            element.bind("keydown keypress", function (event) {
                if (event.which === 13) {
                    scope.$apply(function () {
                        //scope.$eval(attrs.ngEnter);
                        scope.$eval(attrs.ngEnter, {$event:event});
                    });

                    event.preventDefault();
                }
                else if (event.which === 9) {
                  var isAndroid = ionic.Platform.isAndroid();
                  if(isAndroid)
                  {
                    scope.$apply(function () {
                        //scope.$eval(attrs.ngEnter);
                        scope.$eval(attrs.ngEnter, {$event:event});
                    });
                    event.preventDefault();
                  }
                }
            });
        };
    }]);
    app.directive('cardMenu', [function () {
        return {
            transclude: true,
            scope: {
                cardColor: "@",
                cardIcon: "@",
                cardUrl: "@",
                cardTitle: "@",
                cardDescription: "@"
            },
            templateUrl: "templates/card-menu.html"
        }
    }]);

    app.directive('showWhen', ['$window', function ($window) {

        return {
            restrict: 'A',
            link: function ($scope, $element, $attr) {

                function checkExpose() {
                    var mq = $attr.showWhen == 'large' ? '(min-width:768px)' : $attr.showWhen;
                    if ($window.matchMedia(mq).matches) {
                        $element.removeClass('ng-hide');
                    } else {
                        $element.addClass('ng-hide');
                    }
                }

                function onResize() {
                    debouncedCheck();
                }

                var debouncedCheck = ionic.debounce(function () {
                    $scope.$apply(function () {
                        checkExpose();
                    });
                }, 300, false);

                checkExpose();

                ionic.on('resize', onResize, $window);

                $scope.$on('$destroy', function () {
                    ionic.off('resize', onResize, $window);
                });

            }
        };
    }]);

    app.directive('ngCurrency', ['$filter', '$locale', function ($filter, $locale) {
        return {
            require: 'ngModel',
            link: function (scope, element, attrs, ngModel) {

                function decimalRex(dChar) {
                    return new RegExp("\\d|\\-|\\" + dChar, 'g');
                }

                function clearRex(dChar) {
                    return new RegExp("\\-{0,1}((\\" + dChar + ")|([0-9]{1,}\\" + dChar + "?))&?[0-9]{0,2}", 'g');
                }

                function clearValue(value) {
                    value = String(value);
                    var dSeparator = $locale.NUMBER_FORMATS.DECIMAL_SEP;
                    var cleared = null;

                    if (new RegExp("^-[\\s]*$", 'g').test(value)) {
                        value = "-0";
                    }

                    if (decimalRex(dSeparator).test(value)) {
                        cleared = value.match(decimalRex(dSeparator))
                            .join("").match(clearRex(dSeparator));
                        cleared = cleared ? cleared[0].replace(dSeparator, ".") : null;
                    }
                    else {
                        cleared = null;
                    }

                    return cleared;
                }

                function currencySymbol() {
                    if (angular.isDefined(scope.currencySymbol)) {
                        return scope.currencySymbol;
                    } else {
                        return $locale.NUMBER_FORMATS.CURRENCY_SYM;
                    }
                }

                ngModel.$parsers.push(function (viewValue) {
                    var cVal = clearValue(viewValue);
                    return parseFloat(cVal);
                });

                element.on("blur", function () {
                    element.val($filter('currency')(ngModel.$modelValue, currencySymbol()));
                });

                ngModel.$formatters.unshift(function (value) {
                    return $filter('currency')(value, currencySymbol());
                });

                scope.$watch(function () {
                    return ngModel.$modelValue
                }, function (newValue, oldValue) {
                    runValidations(newValue);
                });

                function runValidations(cVal) {
                    if (isNaN(cVal)) {
                        return
                    }
                    if (scope.min) {
                        var min = parseFloat(scope.min);
                        ngModel.$setValidity('min', cVal >= min)
                    }
                    if (scope.max) {
                        var max = parseFloat(scope.max);
                        ngModel.$setValidity('max', cVal <= max)
                    }
                }
            }
        }
    }]);

    app.factory('popupFctr', ['$rootScope','$ionicPopup', '$q','$timeout', function ($rootScope,$ionicPopup, $q,$timeout) {
        var self = this;
        self.isAlertActive = false;
        self.alert = function (title, message,focusOnFieldID) {
            self.isAlertActive = true;
            var def = $q.defer();
            title = title || 'Alert!';
            message = message || '';
            var $scope = $rootScope.$new(true);
            
            $scope.closePopup = function ($event){
                if ($scope.alertPopup && typeof $scope.alertPopup.close === 'function')
                    $scope.alertPopup.close();
                    self.isAlertActive = false;
                    if(focusOnFieldID != undefined)
                        document.getElementById(focusOnFieldID).focus();
            };
            
            $timeout(function () { 
                $scope.alertPopup = $ionicPopup.alert({
                    title: title,
                    scope:$scope,
                    template: '<input autofocus data-ng-enter="closePopup($event)" style="position: absolute; left: -9999px"><span style="text-align:center;">'
                        +message+"</span>"
                });
                $scope.alertPopup.then(function (res) {
                    self.isAlertActive = false;
                    def.resolve(res);
                })}, 400);
            return def.promise;
        };

        self.errorAlert = function (title, message) {
            self.isAlertActive = true;
            var def = $q.defer();
            title = title || 'Alert!';
            message = message || '';
            $timeout(function () { var errorAlertPopup = $ionicPopup.alert({
                title: title,
                template: message
            });
            errorAlertPopup.then(function (res) {
                self.isAlertActive = false;
                def.resolve(res);
            })}, 400);

            return def.promise;
        };

        self.confirm = function (title, message) {
            var def = $q.defer();
            self.isAlertActive = true;
            title = title || 'Are you sure?';
            message = message || '';

            $timeout(function () { var confirmPopup = $ionicPopup.confirm({
                title: title,
                template: message,
                cancelType: 'custom-popup-buttons'
            });

            confirmPopup.then(function (res) {
                self.isAlertActive = false;
                def.resolve(res);
            })}, 400);

            return def.promise;
        };

        self.notificationSound = null;
        self.playNotificationSound = function(){
            console.log("Play Sound: asked to play sounds");
            $timeout(function () {
              if(self.notificationSound==null){
                  console.log("Play Sound: asked to play sounds>notificationSound == Null");
                  self.notificationSound  =  document.getElementById("notificationAudioSound");
                  self.notificationSound.muted = true;
                  self.notificationSound.play();
                  setTimeout(function () { 
                    self.notificationSound.pause();
                    }, 150);
              } else {
                  console.log("Play Sound: asked to play sounds>notificationSound != Null");
                  self.notificationSound.muted = false;
                  self.notificationSound.play();
              }
            },500);
        };

        return self;
    }]);

    app.factory('errorFctr', ['$q', '$injector', function ($q, $injector) {
        return {
            // --- The user's API for claiming responsiblity for requests ---
            specificallyHandled: function (specificallyHandledBlock) {
                specificallyHandleInProgress = true;
                try {
                    return specificallyHandledBlock();
                } finally {
                    specificallyHandleInProgress = false;
                }
            },

            // --- Response interceptor for handling errors generically ---
            responseError: function (rejection) {
                var shouldHandle = (rejection && rejection.config && rejection.config.headers &&
                                    rejection.config.headers[HEADER_NAME]);

                if (shouldHandle) {
                    //var popfact = $injector.get("popupFctr");
                    //var loader = $injector.get("$ionicLoading");
                    //var $log = $injector.get("$log");
                    //$log.error(JSON.stringify(rejection));
                    //loader.hide();
                    var message = rejection.data ? rejection.data.Message : rejection.statusText;
                    var status = message || 'Connection to the cloud has failed, Please try again!';

                    var errorTitle = '';
                    switch(rejection.status){
                        case 400:
                            errorTitle = 'Invalid Request'
                            break;
                        case 401:
                            errorTitle = 'Unauthorized'
                            break;
                        case 403:
                            errorTitle = 'Access Denied';
                            break;
                        // Redundant, but in case we change the default
                        case 500:
                            errorTitle = 'Cloud Connection Failed';
                            break;
                        default:
                            errorTitle = "Cloud Connection Failed";
                            break;    
                    }

                    var error = new Error(status);

                    error.title = errorTitle;
                    error.useInner = true;
                    throw error;

                    //popfact.alert('Error', status);
                    //loader.hide();
                }

                return $q.reject(rejection);
            }
        };
    }]);
    //This directive has been added to have FOCUS on elements explicitly
    app.directive('focusMe', function ($timeout) {
        return {
            link: function (scope, element, attrs) {
            if (attrs.focusMeDisable === "true") {
                return;
            }
            //event.preventDefault();
            $timeout(function () {

                if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                    console.log("in native keyboard Show Code-Directive");
                    element[0].focus();
                    cordova.plugins.Keyboard.show(); //open keyboard manually
                }
                else{
                    console.log("in NONnative Focus-Directive");
                    element[0].focus();
                }
            }, 350);
            }
        };
    });
    //Directive to customize Toggle To Show Text
    app.directive('ionToggleText', function () {

        var $ = angular.element;

        return {
            restrict: 'A',
            link: function ($scope, $element, $attrs) {

            // Try to figure out what text values we're going to use

            var textOn = $attrs.ngTrueValue || 'on',
                textOff = $attrs.ngFalseValue || 'off';

            if ($attrs.ionToggleText) {
                var x = $attrs.ionToggleText.split(';');

                if (x.length === 2) {
                textOn = x[0] || textOn;
                textOff = x[1] || textOff;
                }
            }

            // Create the text elements

            var $handleTrue = $('<div class="handle-text handle-text-true">' + textOn + '</div>'),
                $handleFalse = $('<div class="handle-text handle-text-false">' + textOff + '</div>');

            var label = $element.find('label');

            if (label.length) {
                label.addClass('toggle-text');

                // Locate both the track and handle elements

                var $divs = label.find('div'),
                $track, $handle;

                angular.forEach($divs, function (div) {
                var $div = $(div);

                if ($div.hasClass('handle')) {
                    $handle = $div;
                } else if ($div.hasClass('track')) {
                    $track = $div;
                }
                });

                if ($handle && $track) {

                // Append the text elements

                $handle.append($handleTrue);
                $handle.append($handleFalse);

                // Grab the width of the elements

                var wTrue = $handleTrue[0].offsetWidth,
                    wFalse = $handleFalse[0].offsetWidth;

                // Adjust the offset of the left element

                $handleTrue.css('left', '-' + (wTrue + 10) + 'px');

                // Ensure that the track element fits the largest text

                var wTrack = Math.max(wTrue, wFalse);
                $track.css('width', (wTrack + 60) + 'px');
                }
            }
            }
        };

        });

})();
