﻿

/// <reference path="../../lib/ionic/js/angular/angular.js" />
(function () {
    "use strict";
    var app = angular.module("aralco.mobile");


    app.directive("clearInput", ['$compile', function ($compile) {
        return {
            require: 'ngModel',
            scope: {},
            link: function (scope, element, attrs, ngModel) {

                if (element.next().length) {
                    element.next().insertBefore(element);
                }

                var tpl = '<span> <i class="icon ion-close-circled placeholder-icon clear-element" ng-show="show" ></i></span>';
                var clear = angular.element(tpl);

                scope.setValue = function (val) {
                    ngModel.$setViewValue(val);
                    ngModel.$render();
                    scope.$apply();
                };

                clear.on('click touch',
                    function () {
                        scope.setValue();
                    });

                element.bind('blur', function () { scope.setValue(ngModel.$modelValue); });

                scope.$watch(function () {
                    return ngModel.$modelValue;
                }, function (val) {
                    scope.show = val == null ? null : val.length > 0;
                });

                $compile(clear)(scope);
                element.after(clear);
            }
        }
    }]);

})();