﻿/// <reference path="../../Scripts/underscore.js" />
function Address() {
    this.Address1 = null;
    this.Address2 = null;
    this.Address3 = null;
    this.City = null;
    this.ZipPostalCode = null;
    this.Country = null;
    this.ProvinceState = null;
    this.Latitude = null;
    this.Longitude = null;
    this.address = null;
};

Address.prototype.toString = function () {
    var retVal = '';

    var _a = _.filter([this.Address1, this.Address2, this.Address3], function (item) {
        return (item || '').trim() == '';
    });

    _.each(_a, function (item) { retVal = retVal + ' ' + item });


    if (!_.isEmpty(this.City))
        retVal = retVal + (retVal.trim() == '' ? '' : ',') + this.City;


    if (!_.isEmpty(this.ZipPostalCode))
        retVal = retVal + (retVal.trim() == '' ? '' : ' - ') + this.ZipPostalCode;


    if (!_.isEmpty(this.Country))
        retVal = retVal + (retVal.trim() == '' ? '' : ' ') + this.ProvinceState;

    if (!_.isEmpty(this.Country))
        retVal = retVal + (retVal.trim() == '' ? '' : ', ') + this.Country;

    return retVal;
}

Address.prototype.init = function (data) {
    /// <summary>
    /// Init the class with a json
    /// </summary>
    /// <param name="data"></param>
    if (_.isEmpty(data))
        return;

    var self = this;

    if (!_.isObject(data))
        data = JSON.parse(data);

    //create a 'raw' property
    Address.raw = data;


    var ks = _.keys(data);

    _.each(ks, function (k) {
        if (_.has(self, k)) {
            if (!_.isObject(self[k]))
                self[k] = data[k];
            else if (!(_.isUndefined(self[k].init)))
                self[k].init(data[k]);
        }
    });


}