﻿/// <reference path="../../Scripts/underscore.js" />

function department(source) {
    var self = this;

    self.ID = null;
    self.Name = null;
    self.Description = null;

    var init = function (obj) {
        /// <summary>
        /// Fill the object data from a json
        /// </summary>
        /// <returns type=""></returns>
        if (!_.isObject(obj))
            obj = JSON.parse(obj);

        if (obj != null) {
            self.ID = obj.ID;
            self.Name = obj.Name;
            self.Description = obj.Description;
        }


    };

    if (source != null)
        init(source);

    return self;

}

function matrix(source) {
    var self = this;

    self.Dimension1 = null;
    self.Dimension2 = null;
    self.Dimension3 = null;
    self.Dimension4 = null;

    var init = function (obj) {
        /// <summary>
        /// Fill the object data from a json
        /// </summary>
        /// <returns type=""></returns>
        if (!_.isObject(obj))
            obj = JSON.parse(obj);

        if (obj != null) {
            self.Dimension1 = obj.Dimension1;
            self.Dimension2 = obj.Dimension2;
            self.Dimension3 = obj.Dimension3;
            self.Dimension4 = obj.Dimension4;
        }


    };

    if (source != null)
        init(source);

    return self;
};

function typeInfo(source) {
    var self = this;
    self.InventoryItem = false;
    self.ShelfTag = false;
    self.SaleItem = false;
    self.SerialNumber = false;

    var init = function (obj) {
        /// <summary>
        /// Fill the object data from a json
        /// </summary>
        /// <returns type=""></returns>
        if (!_.isObject(obj))
            obj = JSON.parse(obj);

        if (obj != null) {
            self.InventoryItem = obj.InventoryItem;
            self.ShelfTag = obj.ShelfTag;
            self.SaleItem = obj.SaleItem;
            self.SerialNumber = obj.SerialNumber;
        }

    };

    if (source != null)
        init(source);

    return self;
};

function image(source) {
    var self = this;
    self.value = null;
    self.Index = null;
    self.Type = null;

    var init = function (obj) {
        /// <summary>
        /// Fill the object data from a json
        /// </summary>
        /// <returns type=""></returns>
        if (!_.isObject(obj))
            obj = JSON.parse(obj);

        if (obj != null) {
            self.value = obj.value;
            self.Index = obj.Index;
            self.Type = obj.Type;
        }

    };

    if (source != null)
        init(source);


    return self;
}

function product(source) {
    var self = this;

    self.Department = new department();
    self.Matrix = new matrix();
    self.MSRP = null;
    self.RetailPrice = null;
    self.Cost = null;
    self.Unit = null;
    self.UnitWeight = null;
    self.Grid1 = null;
    self.Grid2 = null;
    self.Grid3 = null;
    self.Grid4 = null;
    self.OrderBy = null;
    self.InventoryBy = null;
    self.SellBy = null;
    self.ID = null;
    self.Code = null;
    self.Name = null;
    self.Description = null;
    self.Barcode = null;
    self.TypeInfo = null;
    self.hasGrid = null;
    self.images = null;
    self.MainImage = null;
    self.PointPlanID = null;
    self.PointsPerDollar = 0;

    var init = function (obj) {
        /// <summary>
        /// Fill the object data from a json
        /// </summary>
        /// <returns type=""></returns>
        if (!_.isObject(obj))
            obj = JSON.parse(obj);

        if (obj != null) {
            //self = obj;
            self.RetailPrice = obj.RetailPrice;
            self.MSRP = obj.MSRP;
            self.Cost = obj.Cost;
            self.Unit = obj.Unit;
            self.UnitWeight = obj.UnitWeight;
            self.Grid1 = obj.Grid1;
            self.Grid2 = obj.Grid2;
            self.Grid3 = obj.Grid3;
            self.Grid4 = obj.Grid4;
            self.OrderBy = obj.OrderBy;;
            self.InventoryBy = obj.InventoryBy;;
            self.SellBy = obj.SellBy;;
            self.ID = obj.ID;;
            self.Code = obj.Code;;
            self.Name = obj.Name;;
            self.Description = obj.Description;
            self.Barcode = obj.Barcode;
            self.PointPlanID = obj.PointPlanID;
            self.PointsPerDollar = obj.PointsPerDollar;
            //images
            if (obj.images != null) {
                self.images = [];
                _.each(obj.images, function (img) {
                    self.images.push(new image(img));
                });
                self.MainImage = self.images[0];
            };

            //typeInfo
            self.TypeInfo = new typeInfo(obj.TypeInfo);

            //department
            self.Department = new department(obj.Department);

            //matrix
            //[C-STARTS]Cenedex Changes-Fix Show Dimensions on Physical Inventory Screen
            //obj.Matrix = new matrix(obj.Matrix);
            self.Matrix = new matrix(obj.Matrix);
            //[C-ENDS]

        };
    }

    if (source != null)
        init(source);


    return self;
};
