 function transactionManager() {
        var self = this;
        var settings = $f.moduleSetting.pos.Settings;   
        var _tran = new transaction(); 
        var _totalCalculator = function (products) {
            var self = this;
            var _products = products;
            var taxInclmsg = ''; 
            var hasInclTax = false;
                  
            var taxSetting = settings.filter(function (s) {
                            return (s.Property == 'PrintTaxNonTaxInfo');
                        });
            var taxIncl = (!_.isEmpty(taxSetting[0]) && taxSetting[0].Value == 'Yes') ? true : false;
            var taxInclmsg = taxIncl ? ' (Included)' : '';


            var saleItemPointsSetting = settings.filter(function (s) {
                return (s.Property == 'SaleItemPoints');
            });
            var saleItemPoints = (!_.isEmpty(saleItemPointsSetting[0]) && saleItemPointsSetting[0].Value == 'Yes') ? true : false;

            // Select:   'Always' to issue Loyalty Points regardless of method of payment 
            //(including payment by Loyalty Points);   
            //'Prorated' to issue Loyalty Points only on the portion of the payment 
            //made without Loyalty Points.
            var pointsIssuedSetting = settings.filter(function (s) {
                return (s.Property == 'PointsIssued');
            });
            var pointsIssued = (!_.isEmpty(pointsIssuedSetting[0]) && pointsIssuedSetting[0].Value == 'Always') ? "Always" : "Prorated";


            function printToConsole(text){
                console.log(text);
            }
            //Before Calling This Function Make Sure getTaxes() is called
            function getRefundTotal(){
                var retVal = 0;
                _.each(_products, function (p) {
                    if(p.returnFlag){ //Add Sum only when Item is not marked for Return
                        retVal = parseFloat(retVal) + (p.Quantity * p.RetailPrice) + p.totaltaxamount - p.discount;
                    }
                });
                return retVal>0?Math.round(retVal * 100) / 100:retVal;
            }
            //A. Get Return Total w/disc,w/tax
            function getReturnTotal(){
                var retVal = 0;

                _.each(_products, function (p) {
                    if(p.returnFlag) //Add Sum only when Item is not marked for Return
                        retVal = parseFloat(retVal) + (p.Quantity * p.RetailPrice);
                });

                return retVal>0?Math.round(retVal * 100) / 100:retVal;
            }
            //B. Get Sales Total w/disc,w/tax
            function getSalesTotal(){
                var retVal = 0;

                _.each(_products, function (p) {
                    if(!p.returnFlag) //Add Sum only when Item is not marked for Return
                        retVal = parseFloat(retVal) + (p.Quantity * p.RetailPrice);
                });


                return retVal>0?Math.round(retVal * 100) / 100:retVal;
            }
            //C. Get SubTotal (Sales-Returns) w/dic,w/tax
            function getSubtotal() {
                /// <summary>
                /// Return the subtotal
                /// </summary>
                /// <returns type=""></returns>
                var retVal = 0;

                retVal = getSalesTotal() - getReturnTotal();
                return retVal>0?Math.round(retVal * 100) / 100:retVal;
            }


            //Calculate Discount
            function calculateDiscount ()
            {
                var discount = 0
                if(!_.isEmpty(_tran.posOption_discountBy))
                {
                    if(_tran.posOption_discountBy == 'discountbypercentage' && _tran.posOption_discountByPercentage_value!=null)
                    {
                        //discount = (parseFloat(getSubtotal()) * _tran.posOption_discountByPercentage_value)/100;
                        _.each(_products, function (p) {
                            //Add/Calculate Only master Discounts

                            if(p.item_discountByAmount_value==null && p.item_discountByPercentage_value==null ){

                                p.discount = parseFloat( (parseFloat(p.Quantity * p.RetailPrice) * _tran.posOption_discountByPercentage_value)/100 );

                                p.discount = p.discount>0 ? Math.round(p.discount * 100) / 100 : p.discount;

                                //Return  changes
                                if(!p.returnFlag)
                                    discount = discount + p.discount;
                                else
                                    discount = discount + (-Math.abs(p.discount));
                            }
                        });
                    }
                    else if(_tran.posOption_discountBy == 'discountbyamount' && _tran.posOption_discountByAmount_value!=null)
                    {
                        _.each(_products, function (p) {
                            //Add/Calculate Only master Discounts

                            if(p.item_discountByAmount_value==null && p.item_discountByPercentage_value==null ){

                                p.discount = parseFloat( parseFloat(_tran.posOption_discountByAmount_value/Math.abs(getSalesTotal()+getReturnTotal())) * parseFloat(p.Quantity * p.RetailPrice)  );

                                //p.discount = p.discount>0 ? Math.round(p.discount * 100) / 100 : p.discount;

                                //Return  changes
                                if(!p.returnFlag)
                                    discount = discount + p.discount;
                                else
                                    discount = discount + (-Math.abs(p.discount));
                            }
                        });
                        //discount = _tran.posOption_discountByAmount_value;
                    }
                }

                //Add Item Level Discounts also
                 _.each(_products, function (p) {

                    if((p.item_discountBy==='discountbyamount' && p.item_discountByAmount_value!=null) ||
                       (p.item_discountBy==='discountbypercentage' && p.item_discountByPercentage_value!=null) ||
                       (p.item_discountBy==='discountbyquantity' && p.item_discountByQuantity_value!=null)) {
                        //Return  changes
                        if(!p.returnFlag)
                            discount = discount + p.discount;
                        else
                            discount = discount + (-Math.abs(p.discount));
                    }
                 });
                return discount;
            }

            //D. Get Total (Effective) Discount (Discount of Sales - Discount of Return)
            function getDiscount() {
                /// <summary>
                /// Return the discount
                /// </summary>
                /// <returns type=""></returns>
                var retVal = calculateDiscount();
                return retVal>0?Math.round(retVal * 100) / 100:retVal;
            }

            //E. Get NetTotal (SubTotal - Total Discount)
            function getNetTotal() {
                /// <summary>
                /// Return the net total
                /// </summary>
                /// <returns type=""></returns>
                var totalDiscount = getDiscount();
                var retVal = 0;
                /*var subtot = parseFloat(getSubtotal());
                retVal =  Math.abs(subtot) - parseFloat(getDiscount());
                if(subtot<0) retVal = -Math.abs(retVal)*/
                retVal = parseFloat(getSubtotal()) - parseFloat(getDiscount())
                return retVal?Math.round(retVal * 100) / 100:retVal;
            }
            //F. Get ( Effective)Total Taxes on NetPrice (RPrice-discount) [Taxes on Sales -Taxes on Returns]
            function getTaxes() {
                /// <summary>
                /// Return the array with all the taxes
                /// </summary>
                /// <returns type=""></returns>
                var retVal = [];
                /*Add all the taxes for the store*/
                _.each(_tran.taxes, function (t) {
                    var tax = {
                        id: t.ID||t.id,
                        name: (t.Name || t.name),
                        percentage: t.Percentage||t.percentage,
                        oot: t.OutOfProvince||t.oot,
                        includeTax: t.IncludeTaxInPrice||t.includeTax,
                        show: (t.IncludeTaxInPrice == true || t.includeTax == true)? taxIncl : true,
                        total: 0,
                        applicable: t.applicable===undefined?true:t.applicable
                    };
                    retVal.push(tax);
                });
                //This calculates discount on individual products ,if not already calculated
                //So this function updates each product with its respeftive discount amount
                calculateDiscount();
                _.each(_products, function (p) {
                    var cp = p;
                    cp.totaltaxamount =0; //Initialize
                    _.each(p.taxes, function (t) {
                        var tt = _.findWhere(retVal, {id: t.ID});
                        if (tt) {
                            if(t.item_applicable===true){
                                var taxedAmount = (cp.Quantity * cp.RetailPrice) - cp.discount;
                                // For proper rounding, /100 *100 /100 is intentional!
                                if(t.IncludeTaxInPrice){
                                    cp.taxamount = taxedAmount - Math.round(((taxedAmount / (1 + tt.percentage/100) * 100))) / 100;
                                    hasInclTax = true;
                                } else {
                                    cp.taxamount = Math.round(((taxedAmount * (tt.percentage/100) * 100))) / 100;
                                }
                                
                                //tt.total = parseFloat(tt.total) + (((cp.Quantity * cp.RetailPrice) * tt.percentage)/100);
                                if(!cp.returnFlag)
                                    tt.total = parseFloat(tt.total) + cp.taxamount;
                                else /*--  For Return Items, Tax Amount of Returned Items should be subtracted from Total tax Amount--*/
                                     tt.total = parseFloat(tt.total) + (-Math.abs(cp.taxamount));
                                //tt.total = tt.total!=0?Math.round(tt.total * 100) / 100:tt.total
                                cp.totaltaxamount += cp.taxamount;
                            }
                            else{
                                printToConsole("Taxes Not Applied On: "+cp.barcode);
                                cp.taxamount = 0;
                            }

                        }
                    });
                });

                return retVal;
            }

            //G Get points calculation per product
            function getPointsEarned(){
                var retVal = 0;
                
                //Points are assinged only at sale level. (0 = Sales)
                //TODO: When we create order processing, chick this to transfer into a sale.
                if($f.pos_choiceType == 0){
                    _.each(_products, function (p) {
                        if(p.product && p.product.PointPlanID > 0) // If a points plan exists then 
                            if(!saleItemPoints && p.discount > 0)
                                var nothing = null; // Do nothing
                            else
                                retVal += Math.round((p.product.PointsPerDollar * p.Quantity * p.RetailPrice), 0);
                    });
    
                    // If the setting is set then remove prorated amount from total points.
                    if(pointsIssued == "Prorated"){
                        var points = _tran.payments.filter(function ( obj ) {
                            return obj.Code == 'O' && obj.Description == 'Points';
                        })[0];
                        // Percentage of points amount in relation to total
                        if(!_.isEmpty(points)){
                            var pointsDiff = 1 - points.amount / _tran.netTotal;
                            // Remove that percentage
    
                            retVal *= pointsDiff < 0 ? 0 : pointsDiff;
                            retVal = Math.round(retVal, 0);
                        }
                    }
                }
                return retVal>0?Math.round(retVal):retVal;
            }

            function getTotal() {
                /// <summary>
                /// Return the total
                /// </summary>

                var retVal = 0;
                //1. Calculate Tax for Every Product
                var taxAmount = _.reduce(_.pluck(getTaxes(), "total"), function (sum, el) {
                    return parseFloat(sum) + parseFloat(el)
                }, 0);
                taxAmount = (taxAmount!=0)?Math.round(taxAmount * 100) / 100:taxAmount
                /*assuming the possible discount is always after taxes and by amount*/
                /*Zeeshan Note, we have already Subtracted The Discount from SubTotal*/
                //retVal = (parseFloat(getNetTotal()) + parseFloat(taxAmount)) - parseFloat(getDiscount());
                if(hasInclTax)
                    taxAmount = 0;
                retVal = (parseFloat(getNetTotal()) + parseFloat(taxAmount)) ;
                return retVal?Math.round(retVal * 100) / 100:retVal;
            }
            self.taxInclmsg = taxInclmsg;
            self.taxIncl = taxIncl;

            // If tax included is set to true
            self.total =  taxIncl ? getSubtotal() : getTotal();

            self.netTotal = getNetTotal() ;
            self.subTotal = getSubtotal() ;
            self.discount = getDiscount() ;
            self.taxes = getTaxes() ;
            self.refundTotal = getRefundTotal();
            self.pointsEarned = getPointsEarned();
            
            return self;
        };

        this.transaction = _tran;

        this.$init = function (tran) {
            /// <summary>
            /// Init the manager with the specific transaction
            /// </summary>
            /// <param name="tran"></param>
            _.extend(_tran, tran);
            _refresh();
        };

        var _refresh = function () {
            var tot = new _totalCalculator(_tran.products);
            _tran.total = tot.total;
            _tran.netTotal = tot.netTotal;
            _tran.subTotal = tot.subTotal;
            _tran.discount = tot.discount;
            _tran.taxInclmsg = tot.taxInclmsg;
            _tran.taxes = tot.taxes;
            _tran.pointsEarned = tot.pointsEarned;
            _tran.refundTotal = tot.refundTotal;//This should be  called only after Taxes
            var _refunddue = (parseFloat(_tran.refundTotal) - parseFloat(_tran.refundedamt));
            var _bal = (parseFloat(_tran.total) - parseFloat(_tran.paid) + parseFloat(_tran.refundedamt));

            if(!(_tran.total<0)){
                if (_bal < 0 ) {
                    _tran.balance = 0;
                    _tran.change = Math.round(Math.abs(_bal)* 100)/100;
                } else {
                    _tran.balance = _bal;
                    _tran.change = 0;
                }
            }
            else{ //REFUND Transaction
                if (_bal < 0 ) {
                    _tran.balance = _bal;
                    _tran.change =0;
                }
                else{
                    _tran.balance = 0;
                    _tran.change =  Math.round(Math.abs(_bal)* 100)/100;
                }
            }
        };

        this.$pay = function (value) {
            self.transaction.paid = value;
            _refresh();
        };
        this.$refund = function (value) {
            self.transaction.refundedamt = Math.abs(value);
            _refresh();
        };

        this.$refresh = _refresh;

        this.$add = function (item) {
            _tran.products.push(item);
            _refresh();
        };
        this.$remove = function(index){
            _tran.products.splice(index,1);
            _refresh();
        }


    }