(function () {
    
	var module = angular.module('aralco.bosusergroups',['ionic']);
	
	module.factory('bosuserGroupFactory', function($filter) {

        var elementId = 10;

        var groupList = [
            {
                name: "Accounting",
                value: false
            },
            {
                name: "Add/Edit Customer Points",
                value: false
            },
            {
                name: "Adjustment",
                value: false
            },
            {
                name: "Adjustment Add",
                value: false
            },
            {
                name: "Adjustment Edit",
                value: false
            },
            {
                name: "Allow Activation Records",
                value: false
            },
            {
                name: "Allow backup",
                value: false
            },
            {
                name: "Allow BOS Order Discount override",
                value: false
            },
            {
                name: "Allow BOS Order Price override",
                value: false
            },
            {
                name: "Allow changing of inventory location",
                value: false
            },
            {
                name: "Allow FTP/WWW Updates",
                value: false
            },
            {
                name: "Allow Inventory Lookup Drilldown",
                value: false
            },
            {
                name: "Allow product deactivation",
                value: false
            },
            {
                name: "Allow Recurring Charges",
                value: false
            },
            {
                name: "Allow Sending Purchase Orders",
                value: false
            },
            {
                name: "Alter Item Menu",
                value: false
            },
            {
                name: "Auto Replenishment",
                value: false
            },
            {
                name: "Average Cost Adjustment",
                value: false
            },
            {
                name: "Barcodes",
                value: false
            },
            {
                name: "BOS Order Access",
                value: false
            },
            {
                name: "BOS Order Add",
                value: false
            },
            {
                name: "BOS Order Deletion",
                value: false
            },
            {
                name: "BOS Order Edit",
                value: false
            },
            {
                name: "Customer Accounting Tab",
                value: false
            },
            {
                name: "Customer Add",
                value: false
            },
            {
                name: "Customer Deletion",
                value: false
            },
            {
                name: "Customer Discount Rate",
                value: false
            },
            {
                name: "Customer Edit",
                value: false
            },
            {
                name: "Customers",
                value: false
            },
            {
                name: "Data",
                value: false
            },
            {
                name: "Edit Average",
                value: false
            },
            {
                name: "Cost",
                value: false
            },
            {
                name: "Edit OMS past entries",
                value: false
            },
            {
                name: "Employee File",
                value: false
            },
            {
                name: "Goods Received",
                value: false
            },
            {
                name: "Goods Received Add",
                value: false
            },
            {
                name: "Goods Received Edit",
                value: false
            },
            {
                name: "Import price from another zone",
                value: false
            },
            {
                name: "Inventory Lookup",
                value: false
            },
            {
                name: "Order Management",
                value: false
            },
            {
                name: "Order Management Edit",
                value: false
            },
            {
                name: "Physical Count",
                value: false
            },
            {
                name: "POS",
                value: false
            },
            {
                name: "Product",
                value: false
            },
            {
                name: "Product Add",
                value: false
            },
            {
                name: "Product Deletion",
                value: false
            },
            {
                name: "Product Edit",
                value: false
            },
            {
                name: "Purchase Order",
                value: false
            },
            {
                name: "Purchase Order Add",
                value: false
            },
            {
                name: "Purchase Order Edit",
                value: false
            },
            {
                name: "Reports",
                value: false
            },
            {
                name: "Return To Vendor",
                value: false
            },
            {
                name: "Return To Vendor Add",
                value: false
            },
            {
                name: "Return To Vendor Edit",
                value: false
            },
            {
                name: "Staff Hours Edit",
                value: false
            },
            {
                name: "Staff Hours View",
                value: false
            },
            {
                name: "Store",
                value: false
            },
            {
                name: "Supplier",
                value: false
            },
            {
                name: "Supplier Add",
                value: false
            },
            {
                name: "Supplier Edit",
                value: false
            },
            {
                name: "System",
                value: false
            },
            {
                name: "System Options",
                value: false
            },
            {
                name: "Transfer",
                value: false
            },
            {
                name: "Transfer Add",
                value: false
            },
            {
                name: "Transfer Edit",
                value: false
            },
            {
                name: "Use Report Organizer",
                value: false
            },
            {
                name: "View and Edit Costs",
                value: false
            },
            {
                name: "View Costs",
                value: false
            },
            {
                name: "View Costs in Inventory Drill Down",
                value: false
            },
            {
                name: "View Costs in Return to Vendor",
                value: false
            },
            {
                name: "View Inventory from all zones",
                value: false
            },
            {
                name: "View PO/GR costs",
                value: false
            }
        ];
            
		var bosuserGroups = [
			{
                ID: 1,
                name: "Accounting",
                desc: "Accounting",
                groups: angular.copy(groupList)
            },
            {
                ID: 2,
                name: "Asst. ManAdminr",
                desc: "Asst. ManAdminr",
                groups: angular.copy(groupList)
            },
            {
                ID: 3,
                name: "Admin",
                desc: "Admin",
                groups: angular.copy(groupList)
            },
            {
                ID: 4,
                name: "Demo video",
                desc: "Demo video",
                groups: angular.copy(groupList)
            },
            {
                ID: 5,
                name: "Purchasing",
                desc: "Purchasing",
                groups: angular.copy(groupList)
            },
            {
                ID: 6,
                name: "Sales",
                desc: "Sales",
                groups: angular.copy(groupList)
            },
            {
                ID: 7,
                name: "Sales Managers",
                desc: "Sales Managers",
                groups: angular.copy(groupList)
            },
            {
                ID: 8,
                name: "Senior Manager",
                desc: "Senior Manager",
                groups: angular.copy(groupList)
            },
            {
                ID: 9,
                name: "US Staff",
                desc: "US Staff",
                groups: angular.copy(groupList)
            }
		];

		return {
			getBOSuserGroups : function(searchText) {
				return $filter('filter')(bosuserGroups, {name: searchText})
            },
            getGroupList : function() {
                return groupList;
            },
            addBOSuserGroup : function(bosuserGroup) {
                var temp = {
                    ID: elementId++,
                    name: bosuserGroup.name,
                    desc: bosuserGroup.desc,
                    groups: angular.copy(bosuserGroup.groups)
                }

                bosuserGroups.push(temp);
            },
            deleteBOSuserGroup: function(item) {
                var index = bosuserGroups.findIndex(bosuserGroup => bosuserGroup.ID == item.ID);
                bosuserGroups.splice(index, 1);
            },
            saveBOSuserGroup: function(item,bosuserGroup) {
                var index = bosuserGroups.findIndex(bosuserGroup => bosuserGroup.ID == item.ID);
                bosuserGroups[index].name = bosuserGroup.name;
                bosuserGroups[index].desc = bosuserGroup.desc;
                bosuserGroups[index].groups =angular.copy(bosuserGroup.groups);
			},
			getBOSuserGroupByIndex : function(item) {
                return bosuserGroups.filter(bosuserGroup => bosuserGroup.ID == item.ID)[0];
            }
		};
    });
    
	module.config(['$stateProvider', '$provide', '$urlRouterProvider',
	'$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
		$stateProvider
		.state('tab.bosusergroups', {
			url: '/bosusergroups',
			LoginRequired: true,
			views: {
				'tab-view': {
					templateUrl: 'modules/common_html/templates/view.html',
					controller: 'BOSuserGroupController'
				}
			}
		})
		.state('tab.editbosusergroups', {
			url: '/editbosusergroup/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/bosuser_groups/templates/bosuser-groups-edit.html',
                    controller: 'EditBOSuserGroupController'
				}
			}
		})
		.state('tab.addbosusergroups', {
			url: '/editbosusergroup/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/bosuser_groups/templates/bosuser-groups-edit.html',
                    controller: 'AddBOSuserGroupController'
				}
			}	
		})
	}]);

    module.controller('BOSuserGroupController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,bosuserGroupFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;
        $scope.title = "Manage BOS User Groups";
        $scope.searchTitle = "BOSuser Groups"


        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'edit' && $scope.selectedItem != null){
                $state.go('tab.editbosusergroups',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'add'){
                $state.go('tab.addbosusergroups',{name: 'add'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteItem = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        bosuserGroupFactory.deleteBOSuserGroup($scope.selectedItem);
                        $rootScope.$emit('updateBOSuserGroups', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }

        $scope.searchItem = function() {
            $scope.entries = angular.copy(bosuserGroupFactory.getBOSuserGroups($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updateBOSuserGroups', function(event, arg) {
            $scope.entries = angular.copy(bosuserGroupFactory.getBOSuserGroups($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditBOSuserGroupController', function($scope,$state,$stateParams,$ionicPopup,$ionicHistory,$filter,$rootScope,bosuserGroupFactory){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.bosuserGroup = angular.copy(bosuserGroupFactory.getBOSuserGroupByIndex($scope.selectedItem));
        $scope.bosuserGroup.groups = $filter('orderBy')($scope.bosuserGroup.groups,['-value','name']);
        $scope.searchTitle = $scope.bosuserGroup.name;
        $scope.title = "Edit BOS User Groups";


        $scope.autoFillDescription = function() {
            if($scope.bosuserGroup.desc.length == 0) {
                $scope.bosuserGroup.desc = $scope.bosuserGroup.name;
            }
        }

        $scope.goBack = function() {
            var BOSuserGroup = angular.copy(bosuserGroupFactory.getBOSuserGroupByIndex($scope.selectedItem));
            BOSuserGroup.groups = $filter('orderBy')(BOSuserGroup.groups,['-value','name']);

            if(!angular.equals($scope.bosuserGroup, BOSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveBOSuserGroup(); 
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.saveBOSuserGroup = function() {
            bosuserGroupFactory.saveBOSuserGroup($scope.selectedItem,$scope.bosuserGroup);
            $rootScope.$emit('updateBOSuserGroups', {
                editType: "Saved"
            });
            var popupMessage = $ionicPopup.alert( {
                title: 'Record saved successfully.',
                subTitle: ''
            })
            $scope.bosuserGroup.groups = $filter('orderBy')($scope.bosuserGroup.groups,['-value','name']);
        }

        $scope.clearBOSuserGroup = function() {
            var BOSuserGroup = angular.copy(bosuserGroupFactory.getBOSuserGroupByIndex($scope.selectedItem));
            BOSuserGroup.groups = $filter('orderBy')(BOSuserGroup.groups,['-value','name']);

            if(!angular.equals($scope.bosuserGroup, BOSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveBOSuserGroup(); 
                    }
                    else{
                        $scope.bosuserGroup = angular.copy(bosuserGroupFactory.getBOSuserGroupByIndex($scope.selectedItem));
                        $scope.bosuserGroup.groups = $filter('orderBy')($scope.bosuserGroup.groups,['-value','name']);
                    }
                })
            }
        }

        $scope.deleteBOSuserGroup = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    bosuserGroupFactory.deleteBOSuserGroup($scope.selectedItem);
                    $rootScope.$emit('updateBOSuserGroups', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            var BOSuserGroup = angular.copy(bosuserGroupFactory.getBOSuserGroupByIndex($scope.selectedItem));
            BOSuserGroup.groups = $filter('orderBy')(BOSuserGroup.groups,['-value','name']);

            if(!angular.equals($scope.bosuserGroup, BOSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.bosuserGroup = angular.copy(bosuserGroupFactory.getBOSuserGroupByIndex($scope.selectedItem));
                        $scope.bosuserGroup.groups = $filter('orderBy')($scope.bosuserGroup.groups,['-value','name']);
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('AddBOSuserGroupController', function($scope,$ionicPopup,$ionicHistory,$rootScope,bosuserGroupFactory){
        $scope.showSearchbar = true;
        $scope.title = "Add BOS User Group";

        $scope.bosuserGroup = {
            name : "",
            desc : "",
            groups: angular.copy(bosuserGroupFactory.getGroupList())
        }
        var oriBOSuserGroup = angular.copy($scope.bosuserGroup);

        $scope.autoFillDescription = function() {
            if($scope.bosuserGroup.desc.length == 0) {
                $scope.bosuserGroup.desc = angular.copy($scope.bosuserGroup.name);
            }
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.bosuserGroup, oriBOSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveBOSuserGroup(); 
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.saveBOSuserGroup = function() {
            if(!angular.equals($scope.bosuserGroup, oriBOSuserGroup)) {
                bosuserGroupFactory.addBOSuserGroup($scope.bosuserGroup);
                $rootScope.$emit('updateBOSuserGroups', {
                    editType: "Added"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                }).then(function() {
                    $scope.bosuserGroup = angular.copy(oriBOSuserGroup);
                })
            }
        }

        $scope.addBOSuserGroup = function() {
            $scope.clearBOSuserGroup();
        }

        $scope.clearBOSuserGroup = function() {
            if(!angular.equals($scope.bosuserGroup, oriBOSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveBOSuserGroup(); 
                    }
                    $scope.bosuserGroup = angular.copy(oriBOSuserGroup);
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.bosuserGroup, oriBOSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.bosuserGroup = angular.copy(oriBOSuserGroup); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })
})();