﻿/// <reference path="../../Scripts/underscore.js" />
/// <reference path="../../js/aralco.mobile.fw/aralco.mobile.fw.js" />

(function () {
    'use strict';

    var module = angular.module('aralco.controlpanel', ['aralco.login']);
    module.config(['$httpProvider', '$stateProvider', '$urlRouterProvider', '$provide', function ($httpProvider, $stateProvider, $urlRouterProvider, $provide) {
        $stateProvider.state('userinfo', {
            url: '/userinfo',
            LoginRequired: true,
            templateUrl: 'modules/controlpanel/templates/account-info.html',
            controller: 'userCtr'
        })
    }]);

    module.controller('menuCtr', ['$scope', '$rootScope', 'accountFctr', '$state', 'popupFctr', 'handleStoreValue', 'posFctr',
    function ($scope, $rootScope, accountFctr, $state, popupFctr, handleStoreValue, posFctr) {
        Init();
        
        function Init() {
            var info = {};
            $scope.isLogged = $f.isLogged || false;

            info.name = $f.isLogged ?  $f.UserInfo.FullName() : "Login";
            $scope.info = info;

            var stateName = $state.current.name;
            $scope.mode = '';
            if(stateName === 'tab.transfers-scan'){
                $scope.mode = 'N-Tfr-Order';
                
            }
            else if(stateName === 'tab.physicalcount-scan'){
                $scope.mode = 'Physical-Count'; 
            }
            else if(stateName === 'pos.main'){
               $scope.mode = 'products-search'; 
           }

        }

       
        $scope.login = function () {
            $state.transitionTo('signin');
        };

        $scope.resetKey = function () {
            popupFctr.confirm(null, 'This action cannot be rollback. Continue?').then(function (val) {
                if (val == true) {
                    handleStoreValue.storeValue = 0;
                    handleStoreValue.registerValue = 0;
                    posFctr.transaction.$deletePosConfigurationValue('POS_BOD');
                    $f.EndPOSSession();
                    accountFctr.keys.$reset();
                    accountFctr.logout().then(function () { Init() });
                }
            });
        };

        $scope.logout = function () {
            popupFctr.confirm(null, 'Are you sure you want to logout?').then(function (val) {
                if (val == true) {
                    accountFctr.logout().then(function () { Init() });
                }
            });
        }

        $rootScope.$on(['popover.showing'], function (event, data) {
            //Init();
        });




    }]);

    module.controller('userCtr', ['$scope', '$rootScope', function ($scope, $rootScope) {
        $scope.user = {};
        init();

        $rootScope.$on('loggedin', function (event, args) {
            init();
        });

        function init() {
            $scope.user = $f.UserInfo;
        }
    }]);

    module.directive('hideMenu', ['$rootScope', function ($rootScope) {
        return {
            link: function (scope, element, attrs) {

                element.bind('click', function () {
                    $rootScope.$broadcast('popover.hideme');
                });
                
            }
        }}]);

}
)();