(function () {
    
	var module = angular.module('aralco.currencies',['ionic']);
	
	module.factory('currencyFactory', function($filter) {

        var elementId = 13;

		var currencies = [
			{
                ID: 1,
                name: "CAD",
                desc: "CAD",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 2,
                name: "Derham",
                desc: "Derham",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 3,
                name: "Dinar",
                desc: "Dinar",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 4,
                name: "DM",
                desc: "DM",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 5,
                name: "Euro",
                desc: "Euro",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 6,
                name: "French Fr",
                desc: "French Fr",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 7,
                name: "Japanese",
                desc: "Japanese",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 8,
                name: "PESO $",
                desc: "PESO $",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 9,
                name: "Rials",
                desc: "Rials",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 10,
                name: "UK",
                desc: "UK",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 11,
                name: "US $",
                desc: "US $",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            },
            {
                ID: 12,
                name: "JMD",
                desc: "JMD",
                localCurrency: false,
                symbol: "",
                exchangeRate: 0,
                lastUpdateDate: ""
            }
		];

		return {
			 getCurrencies : function(searchText) {
                return $filter('filter')(currencies, {name: searchText})
             },
			 addCurrency : function(currency) {
				var temp = {
                    ID: elementId++,
					name: currency.name,
                    desc: currency.desc,
                    symbol: currency.symbol,
                    exchangeRate: currency.exchangeRate,
                    localCurrency: currency.localCurrency,
                    lastUpdateDate: currency.lastUpdateDate
				}

				currencies.push(temp);
			 },
			 deleteCurrency: function(item) {
                var index = currencies.findIndex(currency => currency.ID == item.ID);
                currencies.splice(index, 1);
             },
			 saveCurrency: function(item,currency) {
                var index = currencies.findIndex(currency => currency.ID == item.ID);
				currencies[index].name = currency.name;
                currencies[index].desc = currency.desc;
                currencies[index].localCurrency = currency.localCurrency;
                currencies[index].symbol = currency.symbol;
                currencies[index].lastUpdateDate = currency.lastUpdateDate;
                currencies[index].exchangeRate = (currency.exchangeRate != undefined? currency.exchangeRate: 0);
			},
			getCurrencyByIndex : function(item) {
                return currencies.filter(currency => currency.ID == item.ID)[0];
            }
		};
    });
    
    module.directive('selectOnClick', ['$window', function ($window) {
        if(ionic.Platform.isIOS()) {
            return {
                restrict: 'A',
                link: function (scope, element, attrs) {
                    element.on('click', function () {
                        if (!$window.getSelection().toString()) {
                            this.setSelectionRange(0, this.value.length)
                        }
                    });
                }
            };
        }
        else {
            return {
                restrict: 'A',
                link: function (scope, element) {
                    var focusedElement;
                    element.on('click', function () {
                        this.select();
                        focusedElement = this;
                    });
                    element.on('blur', function () {
                        focusedElement = null;
                    });
                }
            };
        }
    }]);
	
	module.config(['$stateProvider', '$provide', '$urlRouterProvider',
	'$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
		$stateProvider
		.state('tab.currencies', {
			url: '/currencies',
			LoginRequired: true,
			views: {
				'tab-view': {
					templateUrl: 'modules/common_html/templates/view.html',
					controller: 'CurrencyController'
				}
			}
		})
		.state('tab.editcurrencies', {
			url: '/editcurrency/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/currencies/templates/currencies-edit.html',
                    controller: 'EditCurrencyController'
				}
			}
		})
		.state('tab.addcurrencies', {
			url: '/editcurrency/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/currencies/templates/currencies-edit.html',
                    controller: 'AddCurrencyController'
				}
			}	
		})
	}]);

    module.controller('CurrencyController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,currencyFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;
        $scope.title = "Manage Currencies";
        $scope.searchTitle = "Currencies"

        
       

        
            
            {
        }

        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'edit' && $scope.selectedItem != null){
                $state.go('tab.editcurrencies',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'add'){
                $state.go('tab.addcurrencies',{name: 'add'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteItem = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        currencyFactory.deleteCurrency($scope.selectedItem);
                        $rootScope.$emit('updateCurrencies', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }

        $scope.searchItem = function() {
            $scope.entries = angular.copy(currencyFactory.getCurrencies($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updateCurrencies', function(event, arg) {
            $scope.entries = angular.copy(currencyFactory.getCurrencies($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditCurrencyController', function($scope,$state,$stateParams,$ionicPopup,$ionicHistory,$filter,$rootScope,currencyFactory){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.currency = angular.copy(currencyFactory.getCurrencyByIndex($scope.selectedItem));
        $scope.searchTitle = $scope.currency.name;
        $scope.title = "Edit Currency";

        
       

        
            
            {
        }

        $scope.autoFillDescription = function() {
            if($scope.currency.desc.length == 0) {
                $scope.currency.desc = $scope.currency.name;
            }
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.currency, currencyFactory.getCurrencyByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        var errorCheck = document.getElementsByClassName('error-message');
                        var validity = true;
                        for(var i = 0; i < errorCheck.length; i++) {
                            if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                                validity = false;
                            }
                        }
            
                        if(validity) {
                            currencyFactory.saveCurrency($scope.selectedItem,$scope.currency);
                            $rootScope.$emit('updateCurrencies', {
                                editType: "Saved"
                            });
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Record saved successfully.',
                                subTitle: ''
                            })
                            $ionicHistory.goBack();
                        } else {
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Invalid Input.',
                                subTitle: ''
                            })
                        }
                    } else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.saveCurrency = function() {
            var errorCheck = document.getElementsByClassName('error-message');
            var validity = true;
            for(var i = 0; i < errorCheck.length; i++) {
                if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                    validity = false;
                }
            }

            if(validity) {
                currencyFactory.saveCurrency($scope.selectedItem,$scope.currency);
                $rootScope.$emit('updateCurrencies', {
                    editType: "Saved"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                })
            } else {
                var popupMessage = $ionicPopup.alert( {
                    title: 'Invalid Input.',
                    subTitle: ''
                })
            }
        }

        $scope.clearCurrency = function() {
            var Currency = angular.copy(currencyFactory.getCurrencyByIndex($scope.selectedItem));
            Currency.groups = $filter('orderBy')(Currency.groups,['-value','name']);

            if(!angular.equals($scope.currency, Currency)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveCurrency();
                    }
                    else{
                        $scope.currency = angular.copy(currencyFactory.getCurrencyByIndex($scope.selectedItem));
                    }
                })
            }
        }

        $scope.deleteCurrency = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    currencyFactory.deleteCurrency($scope.selectedItem);
                    $rootScope.$emit('updateCurrencies', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            var Currency = angular.copy(currencyFactory.getCurrencyByIndex($scope.selectedItem));
            Currency.groups = $filter('orderBy')(Currency.groups,['-value','name']);
            
            if(!angular.equals($scope.currency, Currency)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.currency = angular.copy(currencyFactory.getCurrencyByIndex($scope.selectedItem));
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('AddCurrencyController', function($scope,$ionicPopup,$ionicHistory,$rootScope,currencyFactory){
        $scope.showSearchbar = true;
        $scope.title = "Add Currency";
        $scope.currency = {
            name : "",
            desc : "",
            symbol: "",
            localCurrency: false,
            exchangeRate: 0,
            lastUpdateDate: "",
        }
        var oriCurrency = angular.copy($scope.currency);

        $scope.autoFillDescription = function() {
            if($scope.currency.desc.length == 0) {
                $scope.currency.desc = angular.copy($scope.currency.name);
            }
        }

        
       //var margintop = 75 + subtoppadding - 55;

        
            
            {
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.currency, oriCurrency)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        var errorCheck = document.getElementsByClassName('error-message');
                        var validity = true;
                        for(var i = 0; i < errorCheck.length; i++) {
                            if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                                validity = false;
                            }
                        }
            
                        if(validity) {
                            currencyFactory.addCurrency($scope.currency);
                            $rootScope.$emit('updateCurrencies', {
                                editType: "Added"
                            });
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Record saved successfully.',
                                subTitle: ''
                            }).then(function() {
                                $scope.currency = angular.copy(oriCurrency);
                            })
                            $ionicHistory.goBack();
                        } else {
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Invalid Input.',
                                subTitle: ''
                            })
                        }
                    } else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.saveCurrency = function() {
            if(!angular.equals($scope.currency, oriCurrency)) {
                var errorCheck = document.getElementsByClassName('error-message');
                var validity = true;
                for(var i = 0; i < errorCheck.length; i++) {
                    if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                        validity = false;
                    }
                }
    
                if(validity) {
                    currencyFactory.addCurrency($scope.currency);
                    $rootScope.$emit('updateCurrencies', {
                        editType: "Added"
                    });
                    var popupMessage = $ionicPopup.alert( {
                        title: 'Record saved successfully.',
                        subTitle: ''
                    }).then(function() {
                        $scope.currency = angular.copy(oriCurrency);
                    })
                } else {
                    var popupMessage = $ionicPopup.alert( {
                        title: 'Invalid Input.',
                        subTitle: ''
                    })
                }
            }
        }

        $scope.addCurrency = function() {
            $scope.clearCurrency();
        }

        $scope.clearCurrency = function() {
            if(!angular.equals($scope.currency, oriCurrency)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveCurrency(); 
                    }
                    $scope.currency = angular.copy(oriCurrency);
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.currency, oriCurrency)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.currency = angular.copy(oriCurrency); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })
})();