(function () {
    
	var module = angular.module('aralco.customergroups',['ionic']);
	
	module.factory('customerGroupFactory', function($filter) {

        var elementId = 20;

		var customerGroups = [
			{
                ID: 1,
                name: "CCRA-R&D",
                desc: "CCRA-R&D",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 2,
                name: "Client",
                desc: "Client",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 3,
                name: "Client-Salvatio",
                desc: "Client-Salvatio",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 4,
                name: "Competitors",
                desc: "Competitors",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 5,
                name: "Consultents",
                desc: "Consultents",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 6,
                name: "Dead Lead",
                desc: "Dead Lead",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 7,
                name: "Dealer 25%",
                desc: "Dealer 25%",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 8,
                name: "Dealer 30%",
                desc: "Dealer 30%",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 9,
                name: "Dealer 45%",
                desc: "Dealer 45%",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 10,
                name: "Demo",
                desc: "Demo",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 11,
                name: "Distributor",
                desc: "Distributor",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 12,
                name: "Dormant",
                desc: "Dormant",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 13,
                name: "e-shop",
                desc: "e-shop",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 14,
                name: "Gov. Subsidies",
                desc: "Gov. Subsidies",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 15,
                name: "Host",
                desc: "Host",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 16,
                name: "It Partners",
                desc: "It Partners",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 17,
                name: "Lead Sources",
                desc: "Lead Sources",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 18,
                name: "Leasing Co.",
                desc: "Leasing Co.",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            },
            {
                ID: 19,
                name: "Lost Deals",
                desc: "Lost Deals",
                discount: 0,
                deactivate: "",
                applyDisc: ""
            }
		];

		return {
			getCustomerGroups : function(searchText) {
                return $filter('filter')(customerGroups, {name: searchText})
			},
			addCustomerGroup : function(customerGroup) {
				var temp = {
                    ID: elementId++,
					name: customerGroup.name,
                    desc: customerGroup.desc,
                    discount: customerGroup.discount,
                    deactivate: customerGroup.deactivate,
                    applyDisc: customerGroup.applyDisc
				}

				customerGroups.push(temp);
			},
			deleteCustomerGroup: function(item) {
                var index = customerGroups.findIndex(customerGroup => customerGroup.ID == item.ID);
                customerGroups.splice(index, 1);
            },
			 saveCustomerGroup: function(item,customerGroup) {
                var index = customerGroups.findIndex(customerGroup => customerGroup.ID == item.ID);			
                customerGroups[index].name = customerGroup.name;
                customerGroups[index].desc = customerGroup.desc;
                customerGroups[index].discount = (customerGroup.discount != undefined? customerGroup.discount: 0);
                customerGroups[index].deactivate = customerGroup.deactivate;
                customerGroups[index].applyDisc = customerGroup.applyDisc;
			},
			getCustomerGroupByIndex : function(item) {
                return customerGroups.filter(customerGroup => customerGroup.ID == item.ID)[0];
            }
		};
    });
    
    module.directive('selectOnClick', ['$window', function ($window) {
        if(ionic.Platform.isIOS()) {
            return {
                restrict: 'A',
                link: function (scope, element, attrs) {
                    element.on('click', function () {
                        if (!$window.getSelection().toString()) {
                            this.setSelectionRange(0, this.value.length)
                        }
                    });
                }
            };
        }
        else {
            return {
                restrict: 'A',
                link: function (scope, element) {
                    var focusedElement;
                    element.on('click', function () {
                        this.select();
                        focusedElement = this;
                    });
                    element.on('blur', function () {
                        focusedElement = null;
                    });
                }
            };
        }
    }]);
	
	module.config(['$stateProvider', '$provide', '$urlRouterProvider',
	'$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
		$stateProvider
		.state('tab.customergroups', {
			url: '/customergroups',
			LoginRequired: true,
			views: {
				'tab-view': {
					templateUrl: 'modules/common_html/templates/view.html',
					controller: 'CustomerGroupController'
				}
			}
		})
		.state('tab.editcustomergroups', {
			url: '/editcustomergroup/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/customer_groups/templates/customer-groups-edit.html',
                    controller: 'EditCustomerGroupController'
				}
			}
		})
		.state('tab.addcustomergroups', {
			url: '/editcustomergroup/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/customer_groups/templates/customer-groups-edit.html',
                    controller: 'AddCustomerGroupController'
				}
			}	
		})
	}]);

    module.controller('CustomerGroupController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,customerGroupFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;
        $scope.title = "Manage Customer Groups";
        $scope.searchTitle = "Customer Groups"

        
       

        
            
            {
        }

        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'edit' && $scope.selectedItem != null){
                $state.go('tab.editcustomergroups',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'add'){
                $state.go('tab.addcustomergroups',{name: 'add'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteItem = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        customerGroupFactory.deleteCustomerGroup($scope.selectedItem);
                        $rootScope.$emit('updateCustomerGroups', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }

        $scope.searchItem = function() {
            $scope.entries = angular.copy(customerGroupFactory.getCustomerGroups($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updateCustomerGroups', function(event, arg) {
            $scope.entries = angular.copy(customerGroupFactory.getCustomerGroups($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditCustomerGroupController', function($scope,$state,$stateParams,$ionicPopup,$ionicHistory,$rootScope,customerGroupFactory){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.customerGroup = angular.copy(customerGroupFactory.getCustomerGroupByIndex($scope.selectedItem));
        $scope.searchTitle = $scope.customerGroup.name;
        $scope.title = "Edit Customer Group";

        
       

        
            
            {
        }

        $scope.autoFillDescription = function() {
            if($scope.customerGroup.desc.length == 0) {
                $scope.customerGroup.desc = $scope.customerGroup.name;
            }
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.customerGroup, customerGroupFactory.getCustomerGroupByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        var errorCheck = document.getElementsByClassName('error-message');
                        var validity = true;
                        for(var i = 0; i < errorCheck.length; i++) {
                            if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                                validity = false;
                            }
                        }
            
                        if(validity) {
                            customerGroupFactory.saveCustomerGroup($scope.selectedItem,$scope.customerGroup);
                            $rootScope.$emit('updateCustomerGroups', {
                                editType: "Saved"
                            });
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Record saved successfully.',
                                subTitle: ''
                            })
                            $ionicHistory.goBack(); 
                        } else {
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Invalid Input.',
                                subTitle: ''
                            })
                        }
                    } else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.saveCustomerGroup = function() {
            var errorCheck = document.getElementsByClassName('error-message');
            var validity = true;
            for(var i = 0; i < errorCheck.length; i++) {
                if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                    validity = false;
                }
            }

            if(validity) {
                customerGroupFactory.saveCustomerGroup($scope.selectedItem,$scope.customerGroup);
                $rootScope.$emit('updateCustomerGroups', {
                    editType: "Saved"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                })
            } else {
                var popupMessage = $ionicPopup.alert( {
                    title: 'Invalid Input.',
                    subTitle: ''
                })
            }
        }

        $scope.clearCustomerGroup = function() {
            if(!angular.equals($scope.customerGroup, customerGroupFactory.getCustomerGroupByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveCustomerGroup(); 
                    }
                    else{
                        $scope.customerGroup = angular.copy(customerGroupFactory.getCustomerGroupByIndex($scope.selectedItem));
                    }
                })
            }
        }

        $scope.deleteCustomerGroup = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    customerGroupFactory.deleteCustomerGroup($scope.selectedItem);
                    $rootScope.$emit('updateCustomerGroups', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.customerGroup, customerGroupFactory.getCustomerGroupByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.customerGroup = angular.copy(customerGroupFactory.getCustomerGroupByIndex($scope.selectedItem));
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('AddCustomerGroupController', function($scope,$ionicPopup,$ionicHistory,$rootScope,customerGroupFactory){
        $scope.showSearchbar = true;
        $scope.title = "Add Customer Grouping";
        $scope.customerGroup = {
            name : "",
            desc : "",
            discount: 0,
            deactivate: "",
            applyDisc: ""
        }
        var oriCustomerGroup = angular.copy($scope.customerGroup);

        $scope.autoFillDescription = function() {
            if($scope.customerGroup.desc.length == 0) {
                $scope.customerGroup.desc = angular.copy($scope.customerGroup.name);
            }
        }

        
       //var margintop = 75 + subtoppadding - 55;

        
            
            {
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.customerGroup, oriCustomerGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        var errorCheck = document.getElementsByClassName('error-message');
                        var validity = true;
                        for(var i = 0; i < errorCheck.length; i++) {
                            if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                                validity = false;
                            }
                        }
            
                        if(validity) {
                            customerGroupFactory.addCustomerGroup($scope.customerGroup);
                            $rootScope.$emit('updateCustomerGroups', {
                                editType: "Added"
                            });
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Record saved successfully.',
                                subTitle: ''
                            }).then(function() {
                                $scope.customerGroup = angular.copy(oriCustomerGroup);
                            })
                            $ionicHistory.goBack(); 
                        } else {
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Invalid Input.',
                                subTitle: ''
                            })
                        } 
                    } else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.saveCustomerGroup = function() {
            if(!angular.equals($scope.customerGroup, oriCustomerGroup)) {
                var errorCheck = document.getElementsByClassName('error-message');
                var validity = true;
                for(var i = 0; i < errorCheck.length; i++) {
                    if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                        validity = false;
                    }
                }
    
                if(validity) {
                    customerGroupFactory.addCustomerGroup($scope.customerGroup);
                    $rootScope.$emit('updateCustomerGroups', {
                        editType: "Added"
                    });
                    var popupMessage = $ionicPopup.alert( {
                        title: 'Record saved successfully.',
                        subTitle: ''
                    }).then(function() {
                        $scope.customerGroup = angular.copy(oriCustomerGroup);
                    })
                } else {
                    var popupMessage = $ionicPopup.alert( {
                        title: 'Invalid Input.',
                        subTitle: ''
                    })
                }
            }
        }

        $scope.addCustomerGroup = function() {
            $scope.clearCustomerGroup();
        }

        $scope.clearCustomerGroup = function() {
            if(!angular.equals($scope.customerGroup, oriCustomerGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveCustomerGroup(); 
                    }
                    $scope.customerGroup = angular.copy(oriCustomerGroup);
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.customerGroup, oriCustomerGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.customerGroup = angular.copy(oriCustomerGroup); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })
})();