angular.module('aralco.giftcards').factory('giftCardFctr', ['$q', '$http', '$ionicLoading',
function($q, $http, $ionicLoading) {

    this.GetBalance = function (giftCardNo){
        /// <summary>
        /// Get gift card information
        /// </summary>
        /// <param name="giftCardNo">Gift Card Number</param>
        var deferred = $q.defer();

        var url = $f.serviceUrl + 'giftcard/GetBalance?giftCard=' + giftCardNo;
        var req = {
            method: 'get',
            url: url
        }


        $http(req).
          success(function (data, status, headers, config) {
              deferred.resolve(data)
          }, function (data, status) {
              deferred.reject(data, status);
          });

        return deferred.promise;
    }

    this.Create = function (giftCardDetails){
        //debugger;
        var def= $q.defer();
        var giftCardItems = [];
        var paymentItems = [];
        var process = 'giftcard/process';

        var url = $f.serviceUrl + process;
        var customer = [];

        var billingAddress = null;
        var payment = null;
        var paymentMethod = null;

        for(var i=0;i<giftCardDetails.products.length;i++){
            
            var items = {
                "amount": giftCardDetails.products[i].product.RetailPrice,
                "code": giftCardDetails.products[i].product.Barcode,
                "discount": giftCardDetails.products[i].discount,
                "quantity": giftCardDetails.products[i].Quantity
            }
            giftCardItems.push(items);
        }

        for(var i=0;i<giftCardDetails.payments.length;i++){
            var paymentMethod = {
                "TenderCode": giftCardDetails.payments[i].Code,
                "ScrDesc": giftCardDetails.payments[i].FullDescription,
                "Desc": giftCardDetails.payments[i].Description || "",
                "Status": giftCardDetails.payments[i].Status,
                "Message": giftCardDetails.payments[i].Message || "",
                "Amount": giftCardDetails.payments[i].amount,
                "ExchAmount": giftCardDetails.payments[i].exchAmount,
                "AuthorizationNumber": giftCardDetails.payments[i].AuthorizationNumber|| "",
                "ReferenceNumber": giftCardDetails.payments[i].ReferenceNumber|| "",
                "PaymentMethod": "",
                "GiftCard": giftCardDetails.payments[i].GiftCard
            }
            paymentItems.push(paymentMethod);
        }

        if(giftCardDetails.customer){
            customer.ID = giftCardDetails.customer.ID;
            customer.CustomerGUID = giftCardDetails.customer.CustomerGUID;
        }

        var payment = {
            "message": giftCardDetails.remarks,
            "status": giftCardDetails.status,
            "subTotal": giftCardDetails.subTotal,
            "shipping": 0.00, // nahi mil raha hai
            "tax1": giftCardDetails.taxes[0] ? giftCardDetails.taxes[0].total : 0,
            "tax1ID": giftCardDetails.taxes[0] ? giftCardDetails.taxes[0].id : 0,
            "tax2": giftCardDetails.taxes[1] ? giftCardDetails.taxes[1].total : 0,
            "tax2ID": giftCardDetails.taxes[1] ? giftCardDetails.taxes[1].id : 0,
            "total": giftCardDetails.total,
            "totalPaid": giftCardDetails.paid,
            "totalDue": giftCardDetails.balance,
            "pointsIssued": giftCardDetails.pointsEarned,
            "pointsSpent": giftCardDetails.pointsSpent
        }

        var paramsValues =  {
            "clerkId": $f.UserInfo.EmployeeID,
            "transType": giftCardDetails.type,
            "customer": customer,
            "SessionID": giftCardDetails.session.SessionID,
            "SessionGUID": giftCardDetails.session.SessionGUID,
            "POSSessionID": giftCardDetails.session.POSSessionID,
            "POSSystem": $f.POSSystem.retrieve(),
            "Receipt": giftCardDetails.receipt,
            "remarks": giftCardDetails.remarks,
            "storeid": giftCardDetails.store.ID,
            "regCode": giftCardDetails.register.RegisterCode,
            "registerId": giftCardDetails.register.RegisterID,
            "registerGUID": giftCardDetails.register.GUID,
            "items":giftCardItems,
            "payment": payment,
            "paymentMethods": paymentItems,
        }

        var req = {
            method: 'post',
            url: url,
            data: paramsValues
        };
        
        $http(req).
            success(function (data, status, headers, config) {
                console.log("GiftCard Created Succefully");
                def.resolve(data)
            }).
            error(function (data, status) {
                console.log("API call failed please check connection");
                def.reject(data, status);
            });
        return def.promise;
    }
    return this;
}]);