﻿(function () {
    'use strict';

    var module = angular.module('aralco.inventory', ['aralco.localStorage', 'aralco.translator', 'aralco.database']);

    module.config(['$httpProvider', '$stateProvider', '$urlRouterProvider', '$provide', function ($httpProvider, $stateProvider, $urlRouterProvider, $provide) {

        var moduleRootFolder = 'modules/inventory/purchase_order/';

        $stateProvider.state('tab.polist', {
            url: '/purchaseorder',
            views: {
                'tab-inventory': {
                    LoginRequired: true,
                    templateUrl: moduleRootFolder+'templates/po-list.html',
                    controller: 'polistCtr'
                }
            }

        })
        .state('tab.ponew', {
                  url: '/ponew',
                  views: {
                      'tab-inventory': {
                          LoginRequired: true,
                          templateUrl: moduleRootFolder + 'templates/po-new.html',
                          controller: 'poNewCtr'
                      }
                  }
              })
        .state('tab.podetail', {
            url: '/purchaseorder/det/:id',
            views: {
                'tab-inventory': {
                    LoginRequired: true,
                    templateUrl: moduleRootFolder + 'templates/po-detail.html',
                    controller: 'podetailCtr'
                }
            }
        })
        .state('tab.poscan', {
            url: '/purchaseorder/scan/:id/:ponumber',
            views: {
                'tab-inventory': {
                    LoginRequired: true,
                    templateUrl: moduleRootFolder + 'templates/po-scan.html',
                    controller: 'poscanCtr'
                }
            }
        });
    }]);
  

})();