﻿/// <reference path="../../js/aaralco.mobile.fwaralco.mobile.fw.js" />
/// <reference path="../../Scripts/underscore.js" />
(function () {
    'use strict';

    var module = angular.module('aralco.inventory');

    module.controller('polistCtr', ['$scope', '$stateParams', '$ionicLoading', '$q', 'poFctr', function ($scope, $stateParams, $ionicLoading, $q, poFctr) {
        Init();

        $scope.search = function () {

            $scope.param.MoreAvailable = false;
            $scope.param.TotalFound = null;
            $scope.param.page = 0;
            $ionicLoading.show({
                template: 'Searching...'
            });

            $scope.loadMore().then(function () {
                $ionicLoading.hide();
            }, function () {
                $ionicLoading.hide();
            });
        };

        $scope.moreDataCanBeLoaded = function () {
            return _.isEmpty($scope.param) ? false : $scope.param.MoreAvailable || false;
        };

        $scope.loadMore = function () {
            var def = $q.defer();


            $scope.param.page = $scope.param.page + 1;

            poFctr.$search($scope.param).then(

                function (searchResult) {
                    if ($scope.param.page <= 1)
                        $scope.pos = [];
                    if (!_.isEmpty(searchResult.Result)) {
                        $scope.param.TotalFound = searchResult.Total || searchResult.Result.length;
                        $scope.param.MoreAvailable = searchResult.MoreAvailable || false;
                        _.each(searchResult.Result, function (p) {
                            $scope.pos.push(p);
                        });
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    def.resolve();
                },
               function () {
                   def.reject();
               });


            return def.promise;
        };

        function Init() {
            $scope.param = poFctr.$param;
            $scope.pos = [];
        }

    }]);

    module.controller('podetailCtr', ['$scope', '$stateParams', '$ionicLoading', '$q', 'poFctr', function ($scope, $stateParams, $ionicLoading, $q, poFctr) {
        var id = $stateParams.id || 0;
        Init();

        function Init() {
            $scope.po = null;

            poFctr.$get(id).then(function (data)
            {
                $scope.po = data;
            })
        };
    }]);

    module.controller('poNewCtr', [function ()
    { }]);
})();