﻿(function () {
    'use strict';
var module = angular.module('aralco.physicalcount');
    
module.controller('PhysicalCountCtrl', ['$scope','$rootScope','$ionicPopover', '$q', '$stateParams', '$ionicPopup', '$timeout', '$ionicLoading', '$ionicModal', 'popupFctr', 'physicalCountFctr', 'localScanService', 'errorFctr', 'helperFctr', 'prodSearchFctr', 'storeFctr', 
    function ($scope,$rootScope,$ionicPopover, $q, $stateParams, $ionicPopup, $timeout, $ionicLoading, $ionicModal, popupFctr, physicalCountFctr, localScanService, errorFctr, helperFctr, prodSearchFctr, storeFctr) {
        $ionicLoading.show({
            template: 'wait ...'
        });
        
        $scope.scan_type = 95;
        $scope.param = {
            barcode: '',
            sn:null,
            allowovershipment: true
        };
        $scope.selectedItem = null;
        $scope.pcid = $stateParams.pcid;
        $scope.sid = $stateParams.sid;
        $scope.transfersStore ={ID: 0};
        $scope.transfersStore.ID = $f.moduleSetting.Store.ID;
 
        $ionicModal.fromTemplateUrl('summaryModal.html', function (modal) {
           $scope.summaryModal = modal;
        }, {
           scope: $scope,
           animation: 'slide-in-up'
        });

        var _saveAndAdd = function($scope, ns) {
            helperFctr.$saveLocally($scope, ns, $scope.scan_type).then(function(key) {
                ns.ScanID = key;
                $scope.items.push(ns);
            },function(err) {
                throw err;
            })
        };

        $scope.ShowSummary = function () {
            var barcodes = _.uniq(_.pluck($scope.items, 'Barcode'));
            var scansByProd = _.countBy($scope.items, function (scan) { return scan.ID; });
            var scansByBarcode = _.countBy($scope.items, function (scan) { return scan.Barcode; });

            var summaryItems = [];
            _.each(barcodes, function (bc) {

                var sns = _.pluck(_.where($scope.items, { Barcode: bc }), 'SerialNumber')

                //For each barcode, get the info for the product and sum the quantity
                var total = _.reduce(_.map(_.where($scope.items, { Barcode: bc }), function (item) { return item.count.scanned.count }),
                    function (memo, num) { return memo + num; }, 0);

                //Get the first product in the list for retrieve the info
                var prod = _.find($scope.items, { Barcode: bc });
                var descs = [];

                if (prod.Grid1)
                    descs.push(prod.Matrix.Dimension1.Name + ' ' + prod.Grid1.Value);
                if (prod.Grid2)
                    descs.push(prod.Matrix.Dimension2.Name + ' ' + prod.Grid2.Value);
                if (prod.Grid3)
                    descs.push(prod.Matrix.Dimension3.Name + ' ' + prod.Grid3.Value);
                if (prod.Grid4)
                    descs.push(prod.Matrix.Dimension4.Name + ' ' + prod.Grid4.Value);

                //Summary By Barcode
                var barcodeSummaryItem = {
                    Images: prod.Images,
                    Barcode: prod.Barcode,
                    Matrix: prod.Matrix,
                    Grid1: prod.Grid1,
                    Grid2: prod.Grid2,
                    Grid3: prod.Grid3,
                    Grid4: prod.Grid4,
                    serialNumbers: sns,
                    TotalQuantity: total,
                    Entries: scansByBarcode[prod.Barcode],
                    Description: descs.toString()
                }

                var relatedItem = _.find(summaryItems, function (item) { return item.ProductID == prod.ID });
                if (_.isEmpty(relatedItem)) {
                    summaryItems.push(
                        {
                            ProductID: prod.ID,
                            ProductCode: prod.Code,
                            ProductName: prod.Name,
                            MainImage: prod.mainImage,
                            summary: [barcodeSummaryItem]
                        })
                } else {
                    relatedItem.summary.push(barcodeSummaryItem);
                }
            });

            $scope.Summary = summaryItems;
            $scope.summaryModal.show();
        }

        $scope.closeSummaryModal = function () {
           $scope.summaryModal.hide();
        };

        $scope.deleteItem = function (index) {
           var confirmPopup = $ionicPopup.confirm({
               title: 'Delete',
               template: 'Are you sure you want to delete the item with barcode ' + $scope.items[index].barcode + '?'
           });
           confirmPopup.then(function (res) {
               if (res) {
                   localScanService.DeleteScan($scope.items[index],$scope.scan_type).then(function () {
                       $scope.items.splice(index, 1);
                   }, function () { throw ex; })
               }
           });
        };

        $scope.editItem = function (index){
            helperFctr.$editItem($scope, index, $scope.scan_type);
        };

        $scope.Search = function () {
            errorFctr.specificallyHandled(function() {
                physicalCountFctr.Snapshots.Product.$verify($scope.Snapshots.ID, $scope.param.barcode).then(function(val) {
                    if(val){
                        $scope.setBarcodeTextFieldBulr();
                        prodSearchFctr.$scan($scope.param.barcode, $scope.transfersStore.ID).then(function(prod) {
                            prod.mainImage = (prod.images || [])[0];
                            $scope.items = $scope.items || [];
                        
                            var Scan = new scan(prod);
                            Scan.count = {
                                manual: {
                                    count: 0,
                                    modifiedBy: '',
                                    modifiedOn: Date.now()
                                },
                                scanned: {
                                    count: 1,
                                    modifiedBy: $f.UserInfo.FullName(),
                                    modifiedOn: Date.now(),
                                    manuallyUpdated: false
                                }
                            };
                            Scan.location = $scope.param.location;
                            Scan.UserInfo = $f.UserInfo;
                            Scan.parentReference = $scope.sid || $scope.transfersStore.ID || 0;
                            
                            if ((Scan.product.TypeInfo.SerialNumber || false)) {
                                _saveAndAdd($scope, Scan);
                            } else {
                                helperFctr.$enterQuantity($scope, Scan).then(function(quantity) {
                                    Scan.count.scanned.count = quantity;
                                    _saveAndAdd($scope, Scan);
                                },
                                function(err) {
                                    throw err;
                                })
                            };
                            $scope.param.barcode = "";
                            $ionicLoading.hide();
                        }, function (error) {
                            $ionicLoading.hide();
                            popupFctr.playNotificationSound();
                            popupFctr.alert('Error', error,'barcodeInput');
                            $scope.setBarcodeTextFieldFocus();
                        });     
                    } else {
                        popupFctr.alert('Incorrect Product', 'This Product is not a part of this Snapshot', 'barcodeInput');
                    }
                });
            });
        };

        $scope.setBarcodeTextFieldBulr = function(){
            $timeout(function () {
                if(document.getElementById("barcodeInput"))
                document.getElementById("barcodeInput").blur();
            },300);
        };

        $scope.setBarcodeTextFieldFocus = function(){
            $timeout(function () {
            if(document.getElementById("barcodeInput"))
                document.getElementById("barcodeInput").focus();
            },300);
        };
        /****************************************/
        // View load initialization notification Sound
        popupFctr.notificationSound = null;
        popupFctr.playNotificationSound();
        /****************************************/
       
        $scope.Reset = function () {
            if ($scope.popover)
                $scope.popover.hide();
            var confirmPopup = $ionicPopup.confirm({
                title: 'Clear',
                template: 'Are you sure you want to reset this physical count?',
                cancelType: 'custom-popup-buttons'
            });
            confirmPopup.then(function (res) {
                if (res) {
                    localScanService.Reset($scope.sid, $scope.scan_type).then(init());
               }
            });
        }

        $scope.ShowOtherMenu = function ($event) {
            $ionicPopover.fromTemplateUrl('modules/inventory/physical_count/templates/other-menu.html', {
                scope: $scope
            }).then(function (popover) {
                $scope.popover = popover;
                $rootScope.$broadcast('popover.showing');
                $scope.popover.show($event);
                $ionicLoading.hide();
            });
        }

        $scope.Send = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Confirm',
                template: 'Are you sure you want to submit this physical count?'

            });
            confirmPopup.then(function (res) {
                if (res) {
                    $ionicLoading.show({
                        template: 'Submitting the Physical Count to the Aralco BOS...'
                    });
                physicalCountFctr.Snapshots.$submit($scope.sid, $scope.scan_type).then(function () {
                    localScanService.Reset($scope.sid, $scope.scan_type).then(function () {
                        init();
                        popupFctr.alert('Items SENT successfully');
                    }).finally(function () {
                        $ionicLoading.hide();
                    });
                })
                }
            });
        };

        $ionicModal.fromTemplateUrl('imgModal.html', function (modal) {
            $scope.gridModal = modal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });

        // open image modal
        $scope.openModal = function (selected) {
            if(selected instanceof Object)
                $scope.data.selected =selected;
            else
            $scope.data.selected = {
                value:selected
            };
            $scope.gridModal.show();
        };

        // close image modal
        $scope.closeImgModal = function () {
            $scope.gridModal.hide();
        };

        //Cleanup the video modal when we're done with it!
        $scope.$on('$destroy', function () {
            $scope.gridModal.remove();
            $scope.summaryModal.remove();
        });
        //[STARTS-C]CenedeX changes to show Dimenesions
        $scope.hasGrid= function(prod) {
            return prod && prod.Matrix &&
                   ( !_.isEmpty(prod.Matrix.Dimension1) ||
                     !_.isEmpty(prod.Matrix.Dimension2) ||
                     !_.isEmpty(prod.Matrix.Dimension3) ||
                     !_.isEmpty(prod.Matrix.Dimension4) );
        };
        //[Ends-C] Cenedex changes to show Dimensions

        init();

        function init() {
            //[STARTS-C]CenedeX changes to show Dimenesions
            //Modified to account for numeric values
            $scope.getValues = function (grid) {
                return helperFctr.$GetGridValues(grid);
            };

           //[ENDS-C]

            var forceload = $f.forceload || true; //Always good to force load for this module
            $scope.ShowAll = false;
            $scope.items = [];
            $scope.data = {};
            $scope.data.quantity = 0;
            $scope.Summary = null;

            var calls = [
                physicalCountFctr.Snapshots.$get($scope.sid),
                localScanService.GetScans($scope.sid, $scope.scan_type),
                //We need stores info for Serial# based items
                storeFctr.Get()
            ];
            $scope.sid
            $q.all(calls).then(function (values) {
                $scope.Snapshots = values[0];
                $scope.items = values[1] || [];
                $scope.stores = values[2];
                //if($scope.items.length>0){
                //    $scope.param.location = $scope.items[0].location;
                //};
            }, function (e, ex) {
                throw ex;
            }).finally(function () {
                // $ionicLoading.hide();
                setTimeout($ionicLoading.hide, 100);
            });
       }
    }]);
})();
