/// <reference path="../../../Scripts/underscore.js" />
(function () {
    'use strict';
    var module = angular.module('aralco.physicalcount');
    module.factory('helperFctr', ['$rootScope', '$q', '$ionicPopup', '$timeout','$ionicModal', '$ionicLoading', 'prodFctr', 'popupFctr', 'localScanService', 
    function ($rootScope, $q, $ionicPopup, $timeout, $ionicModal, $ionicLoading, prodFctr, popupFctr,  localScanService) {
        var self = this;

        var enterSerial = function (barcode,name,items,allowedSerialNumbersofproduct,scan_type) {
            /// <summary>
            /// Require Serial#
            /// </summary>
            /// <param name="barcode"></param>
            var def = $q.defer();
            var $scope = $rootScope.$new(true);
            $scope.setBarcodeTextFieldBulr = function(){
                    $timeout(function () {
                        if(document.getElementById("barcodeInput"))
                            document.getElementById("barcodeInput").blur();
                    },300);
            };
            $scope.setBarcodeTextFieldFocus = function(){
                    $timeout(function () {
                        if(document.getElementById("barcodeInput"))
                            document.getElementById("barcodeInput").focus();
                    },300);
            };

            $scope.inputs = [{
                value: '',
                class: '',
                erromessage: ''
            }];                
            $scope.addInput = function (index) {
                console.log("new input");
                //Add a New Input only when existing is in Valid state 
                //and no Input is left blank
                var isAnyInputBlank = _.find($scope.inputs,function(item){
                    if(_.isEmpty(item.value) || item.class==='ng-invalid') return true;
                });
                if(!isAnyInputBlank && $scope.inputs[index].class ==='ng-valid'){
                    $scope.inputs.push({
                        value: null,
                        class: '',
                        errormessage: ''
                    });
                    $timeout(function () {
                            console.log("sninput"+($scope.inputs.length-1));
                            document.getElementById("sninput"+($scope.inputs.length-1)).focus();
                        },150);
                }
                else{
                    //Don't let add input and Play Error Sound if class is invalid
                    if($scope.inputs[index].class ==='ng-invalid'){
                        //Playerror Sound
                        popupFctr.playNotificationSound();
                    }
                }
                
            }
            $scope.removeInput = function (index) {
                    $scope.inputs.splice(index, 1);
            }

            var allowedSerialNumbers = _.pluck(allowedSerialNumbersofproduct,'Value');
            var unallowedSerial = _.pluck(_.where(items, { barcode: barcode }), 'SerialNumber');
            $scope.validateInput = function(inputValue,index){
                    if(_.isEmpty(inputValue)) {
                        $scope.inputs[index].class= "";
                        $scope.inputs[index].errormessage = "";
                        return false;
                    }

                    if(!$scope.isValueDuplicate(inputValue,index)
                    && !$scope.isSerialNumberAlreadyAdded(inputValue,index)
                    && $scope.isSerialNumberOfThisProduct(inputValue,index)){
                        return;
                    }
            } 
            $scope.isValueDuplicate = function(inputValue,index){
                    if(_.isEmpty(inputValue)) return false;
                    var inputsIndex = -1;
                    var duplicatevalue = _.find($scope.inputs,function(item){
                        inputsIndex ++;
                        if(index!= inputsIndex && item.value === inputValue){ //Don't compare currentTypedvalue
                            $scope.inputs[index].class= "ng-invalid";
                            $scope.inputs[index].errormessage = "duplicate serial #";
                            return inputValue;
                        }
                    });
                    if(_.isEmpty(duplicatevalue)){
                        $scope.inputs[index].class= "";
                        $scope.inputs[index].errormessage = "";
                        return false;
                    }
                    else{
                        return true;
                    }
            }

            $scope.isSerialNumberAlreadyAdded = function(inputValue,index){
                     var serialNumberValue = _.find(unallowedSerial,function(item){
                        if(item === inputValue){
                            $scope.inputs[index].class= "ng-invalid";
                            $scope.inputs[index].errormessage = "serial # already added to count";
                            return inputValue;
                        }
                    });
                    if(_.isEmpty(serialNumberValue)){
                        $scope.inputs[index].class= "";
                        $scope.inputs[index].errormessage = "";
                        return false;
                    }
                    else{
                        return true;
                    }
            }
            var validSerialNumbers = [];
            $scope.isSerialNumberOfThisProduct = function(input,index){
                    var snumber = _.find(allowedSerialNumbersofproduct,function(arrE1){
                        var storeToValidate = $f.moduleSetting.Store.ID;
                        if(!_.isEmpty(scan_type) && scan_type.indexOf("TR:TSTORE==") !== -1){
                             storeToValidate =   parseInt(scan_type.split('==')[1]);
                        }
                        else if(!_.isEmpty(scan_type) && scan_type.indexOf("POS:STORE==") !== -1){
                            storeToValidate =   parseInt(scan_type.split('==')[1]);
                        }
                        if(input === arrE1.Value && storeToValidate === arrE1.Store){
                            $scope.inputs[index].class= "ng-valid";
                            $scope.inputs[index].errormessage = "serial # is correct";
                            if(_.isEmpty(validSerialNumbers)){
                                validSerialNumbers.push(input);
                            }
                            else{
                                (validSerialNumbers.indexOf(input)>=0) ? null : validSerialNumbers.push(input);    
                            }
                            return arrE1.Value;
                        }
                        else if(input === arrE1.Value && storeToValidate != arrE1.Store){
                            $scope.inputs[index].class= "ng-invalid";
                            $scope.inputs[index].errormessage = "Found at store# "+arrE1.StoreCode;
                            return 'other-store-serial-number';
                        }   
                    });
                    /*var snumber = _.find(allowedSerialNumbers,function(arrEl){ 
                        if(input === arrEl){
                            
                        }
                    });*/
                    if(_.isEmpty(snumber)){
                        $scope.inputs[index].class= "ng-invalid";
                        $scope.inputs[index].errormessage = "serial # not valid";
                        return false;
                    }
                    else if(snumber === 'other-store-serial-number'){
                        return false;
                    }
                    else
                        return true;
            }
            $scope.enterSerialInputEnterEvent = function(e)
            {   
                    var invalidSerialNumbers = [];
                    var checkForEmptyValues= function (inputs){
                        var status = false;
                        angular.forEach(inputs,function(input,index){
                            if(!status && _.isEmpty(input.value)){
                                //$scope.invalidFields.push({index:true})
                                $scope.inputs[index].class = "ng-invalid";
                                $scope.inputs[index].erromessage = "value is empty";
                                status = false
                            } else {
                               status = true 
                            }          
                        });
                        return status;
                    }
                    if(!checkForEmptyValues($scope.inputs))
                    {
                        //Nothing was entered
                        e.preventDefault();
                    } else {
                        //if($scope.isValueDuplicate() || $scope.isSerialNumberAlreadyAdded() || !$scope.isSerialNumberOfThisProduct()){
                        validSerialNumbers = _.pluck(_.where($scope.inputs, { class: 'ng-valid'}), 'value');
                        if(_.isEmpty(validSerialNumbers)){
                            //Don't Let user submit prompt unless he clears above conditions
                            e.preventDefault();
                        } else {
                            if(SNInput)
                                SNInput.close();
                             $scope.inputs = [{
                                value: '',
                                class: '',
                                errormessage:''
                            }];
                            $scope.setBarcodeTextFieldFocus();
                            var retVal = validSerialNumbers;
                            def.resolve(retVal);
                        }

                       
                    }
            }
        
            $ionicLoading.hide();
            var SNInput = $ionicPopup.show({
                    /*template: '<input autofocus type="text" data-ng-enter="enterSerialInputEnterEvent($event)" data-ng-model="param.sn">',*/
                    templateUrl:'modules/inventory/physical_count/templates/serial-number-popup.html',
                    title: 'Insert serial numbers',
                    //subTitle: 'referred to the barcode ' + barcode,
                    subTitle: 'for '+name+' (barcode ' + barcode +')' ,
                    scope: $scope,
                    buttons: [
                        { text: 'Cancel',
                        type: 'custom-popup-buttons'
                        },
                        {
                            text: '<b>Save</b>',
                            type: 'button-positive',
                            onTap: function (e) {
                                var validSerialNumbers = [];
                                var invalidSerialNumbers = [];
                                var checkForEmptyValues= function (inputs){
                                    var status = false;
                                    angular.forEach(inputs,function(input,index){
                                        if(!status && _.isEmpty(input.value)){
                                            //$scope.invalidFields.push({index:true})
                                            $scope.inputs[index].class="ng-invalid";
                                            status = false
                                        } 
                                        else{
                                            //Allows User to proceed if he fills atleast one input
                                            status = true 
                                        }          
                                    });
                                    return status;
                                }
                                //We wll allow user to go through if atleast one field has been submitted
                                if(!checkForEmptyValues($scope.inputs)){
                                    //Nothing was entered
                                    e.preventDefault();
                                } else {
                                    validSerialNumbers = _.pluck(_.where($scope.inputs, { class: 'ng-valid'}), 'value');
                                    if(_.isEmpty(validSerialNumbers)){
                                        //Don't Let user submit prompt unless he clears above conditions
                                        e.preventDefault();
                                    }
                                    else{
                                        document.getElementById("barcodeInput").focus();
                                        var retVal = validSerialNumbers;
                                        return retVal;
                                    }
                                }
                            }
                        }
                    ]
            });

            SNInput.then(function (res) {
                    //THis function is even called when you handle it via Enter
                    if(res){
                        $scope.inputs = [{
                                value: '',
                                class: '',
                                errormessage:''
                        }];
                        $scope.setBarcodeTextFieldFocus();
                        def.resolve(res);
                    }
            });

            return def.promise;
        };

        var enterQuantity = function ($scope,Scan) {
            var def = $q.defer();
            $ionicLoading.hide();
            var temp = '<input name="qty_input" autofocus type="number" min="0" inputmode="numeric" data-ng-enter="quantityInputEnterEvent($event)"  ng-pattern="/^[0-9]+(\.[0-9]{1,2})?$/" step="1" ng-model="param.quantity"> '

            if(Scan.product.InventoryBy != null ){
                temp += 'Quantity Entered In: <span class="badge badge-assertive">'+Scan.product.InventoryBy.Code+'</span>';
            }
            $scope.quantityInputEnterEvent = function(e){
                if( !$scope.param.quantity || $scope.param.quantity<=0 ){
                    e.preventDefault();
                } else {               
                    var retVal = $scope.param.quantity;
                    $scope.param.quantity = null;
                    if ((retVal)) {
                        if(QuantityInput)
                            QuantityInput.close();
                        $scope.setBarcodeTextFieldFocus();
                        def.resolve(retVal);
                    }
                }   
            }
            var QuantityInput = $ionicPopup.show({
                template: temp,
                title: 'Enter Quantity',
                subTitle: 'for '+ Scan.product.Name +' (barcode ' + Scan.barcode+')' ,
                scope: $scope,
                buttons: [{ text: 'Cancel',
                    type: 'custom-popup-buttons'
                    },
                    {
                        text: '<b>Save</b>',
                        type: 'button-positive',
                        onTap: function (e) {                  
                        //var pattern_input_qty = "/^[0-9]+(\.[0-9]{1,2})?$/";
                        if(!$scope.param.quantity || $scope.param.quantity<=0){
                            //don't allow the user to close unless he enters wifi password
                            e.preventDefault();
                        }
                        else {
                            var retVal = $scope.param.quantity;
                            $scope.param.quantity = null;
                            return retVal;
                        }
                        }
                    }
                ]
            });
            QuantityInput.then(function (res) {
                if ((res)) {
                    $scope.setBarcodeTextFieldFocus();
                    def.resolve(res);
                }
                else{
                    $scope.setBarcodeTextFieldFocus();
                }
            });
            return def.promise;
        };

        this.enterNumber = function ($scope, msg){
            /// <summary>
            /// Require Number
            /// </summary>
            var def = $q.defer();
            $scope.numberInputEnterEvent = function(e){
                if(!_.isEmpty($scope.param.number) ){
                    e.preventDefault();
                    popupFctr.alert('Invalid input', 'Please enter a valid value');
                } else {               
                    var retVal = $scope.param.number;
                    $scope.param.number = null;
                    if(NumberInput)
                        NumberInput.close();
                    $scope.setBarcodeTextFieldFocus();
                    def.resolve(retVal);
                }   
            }
            var NumberInput = $ionicPopup.show({
                template: '<input name="number_input" id="numberInput" autofocus type="number" inputmode="numeric" data-ng-enter="numberInputEnterEvent($event)"  ng-pattern="/^-?[0-9]+(\.[0-9]{1,2})?$/" step="0.01" ng-model="param.number">',
                title: msg,
                scope: $scope,
                buttons: [{ text: 'Cancel',
                    type: 'custom-popup-buttons'
                    },
                    {
                        text: '<b>Enter</b>',
                        type: 'button-positive',
                        onTap: function (e) {                  
                        //var pattern_input_qty = "/^[0-9]+(\.[0-9]{1,2})?$/";
                        if(!_.isEmpty($scope.param.number)){
                            e.preventDefault();
                        }
                        else {
                            var retVal = $scope.param.number;
                            $scope.param.number = null;
                            return retVal;
                        }
                        }
                    }
                ]
            });

            NumberInput.then(function (res) {
                if ((res)) {
                       
                        def.resolve(res);
                }
                else{
                    $scope.setBarcodeTextFieldFocus();
                }
            });


            $scope.setBarcodeTextFieldBulr = function(){
            $timeout(function () {
                if(document.getElementById("numberInput"))
                document.getElementById("numberInput").blur();
            },300);
            };

            $scope.setBarcodeTextFieldFocus = function(){
            $timeout(function () {
            if(document.getElementById("numberInput"))
                document.getElementById("numberInput").focus();
            },300);
            };
            return def.promise;


        }

        this.enterText = function ($scope, msg){
            /// <summary>
            /// Require Text
            /// </summary>
            var def = $q.defer();
            var retVal = null;
            $scope.param = [];
            $scope.textInputEnterEvent = function(e){
                if( _.isEmpty($scope.param.text) ){
                    e.preventDefault();
                    popupFctr.alert('Invalid input', 'Please enter a valid value');
                    def.reject();
                } else {               
                    retVal = $scope.param.text;
                    $scope.param.text = null;
                    if(TextInput)
                        TextInput.close();
                    $scope.setTextInputFieldFocus();
                    def.resolve(retVal);
                }   
            }
            var TextInput = $ionicPopup.show({
                template: '<input name="text_input" id="textInput" autofocus type="text"  data-ng-enter="textInputEnterEvent($event)"  ng-model="param.text">',
                title: msg,
                scope: $scope,
                buttons: [{ text: 'Cancel',
                    type: 'custom-popup-buttons',
                    onTap: function(e){
                        retVal = null;
                        return retVal;
                    }
                    },
                    {
                        text: '<b>Enter</b>',
                        type: 'button-positive',
                        onTap: function (e) {                  
                        //var pattern_input_qty = "/^[0-9]+(\.[0-9]{1,2})?$/";
                        if(_.isEmpty($scope.param.text)){
                            e.preventDefault();
                        } else {
                            retVal = $scope.param.text;
                            $scope.param.text = null;
                            return retVal;
                        }
                        }
                    }
                ]
            });

            TextInput.then(function (res) {
                $scope.setTextInputFieldFocus();
                def.resolve(res);
            });


            $scope.setTextInputFieldBulr = function(){
            $timeout(function () {
                if(document.getElementById("textInput"))
                document.getElementById("textInput").blur();
            },300);
            };

            $scope.setTextInputFieldFocus = function(){
            $timeout(function () {
            if(document.getElementById("textInput"))
                document.getElementById("textInput").focus();
            },300);
            };
            return def.promise;


        }
        
        // Retrieves Alphabetical values of grids
        var getGridValues = function(grids){
            var retval = '',
            reA = /[^a-zA-Z]/g,
            reN = /[^0-9]/g;
            if (grids) {
                var values = _.pluck(grids.Grids, 'Value').sort(function sortAlphaNum(a,b) {
                    var AInt = parseInt(a, 10);
                    var BInt = parseInt(b, 10);

                    if(isNaN(AInt) && isNaN(BInt)){
                        var aA = a.replace(reA, "");
                        var bA = b.replace(reA, "");
                        if(aA === bA) {
                            var aN = parseInt(a.replace(reN, ""), 10);
                            var bN = parseInt(b.replace(reN, ""), 10);
                            return aN === bN ? 0 : aN > bN ? 1 : -1;
                        } else {
                            return aA > bA ? 1 : -1;
                        }
                    } else if(isNaN(AInt)) {//A is not an Int
                        return 1;//to make alphanumeric sort first return -1 here
                    } else if(isNaN(BInt)) {//B is not an Int
                        return -1;//to make alphanumeric sort first return 1 here
                    } else {
                        return AInt > BInt ? 1 : -1;
                    }
                });
                if (values) {
                    retval = values.join(' | ');
                }
            }
            return retval;
        }

        var editItem =function ($scope,index,scan_type) {
            var item = $scope.items[index]
            var editItemInputRequest = function (res) {
                if(myPopup)
                    myPopup.close();
                //$scope.setBarcodeTextFieldFocus();
                if (!_.isNaN(res) && res>=0) {
                     //If Over Shipment Is allowed, no need to validate for quanties check
                    if($scope.param.allowovershipment ){
                        $scope.items[index].count.scanned = {
                            manuallyUpdated: true,
                            modifiedOn: Date.now(),
                            count: res,
                            modifiedBy: $f.UserInfo.FullName()
                        };
                       localScanService.UpdateScan($scope.items[index],scan_type).then(function (item) {
                        }, function (ex) { throw ex });
                    } else {
                        $ionicLoading.show({
                            template: 'wait...'
                        });
                        _quantityCheck($scope,$scope.items[index],res).then(
                            function(val){
                                if(val.sufficient){
                                    $scope.items[index].count.scanned = {
                                        manuallyUpdated: true,
                                        modifiedOn: Date.now(),
                                        count: res,
                                        modifiedBy: $f.UserInfo.FullName()
                                    }
                                    localScanService.UpdateScan($scope.items[index],scan_type).then(function (item) {
                                        $ionicLoading.hide();
                                    }, function (ex) { throw ex });
                                } else{
                                    $ionicLoading.hide();
                                    popupFctr.playNotificationSound();
                                    popupFctr.alert('Not Allowed','Excess quantity not allowed </br> Available: ' + val.available,'barcodeInput');
                                }
                            }
                        );
                    }
                }
            };
           //$scope.data.quantity = $scope.items[index].count.scanned.count;
           //We are not prepopulating the Qty Input field with Existing count.
           $scope.data.quantity = null;
           $scope.editItemInputEnterEvent = function (e) {
                if (!$scope.data.quantity && $scope.data.quantity>=0) {
                    //don't allow the user to close unless he enters wifi password
                    e.preventDefault();
                } else {
                    editItemInputRequest($scope.data.quantity);
                }
                
            };

            var myPopup = $ionicPopup.show({
               template: '<input autofocus type="number"  min="0" inputmode="numeric" data-ng-enter="editItemInputEnterEvent($event)" ng-pattern="/^[0-9]+(\.[0-9]{1,2})?$/" step="0.01" ng-model="data.quantity">',
               title: 'Change quantity',
               subTitle: 'Modify scanned quantity for item ' + $scope.items[index].barcode,
               scope: $scope,
               buttons: [{
                  text: 'Cancel',
                  type: 'custom-popup-buttons'
                 },
                 {
                     text: '<b>Save</b>',
                     type: 'button-positive',
                     onTap: function (e) {
                         if (!$scope.data.quantity && $scope.data.quantity>=0) {
                             //don't allow the user to close unless he enters wifi password
                             e.preventDefault();
                         } else {
                             return $scope.data.quantity;
                         }
                     }
                     
                 }
               ]
           });

           myPopup.then(function (res) {
               //if (!_.isNaN(res) && !_.isEmpty(res)) {
                editItemInputRequest(res);
           });
        };

        function _quantityCheck($scope,Product,quantity){
            var def = $q.defer();
            var reqParam = prodFctr.inventory.param;
            reqParam.prodID = Product.product.ID;
            reqParam.forceLoad = $f.ForceLoad;
            //After API Changes, Complete Inventory for a product will only be sent back ,
            //if you skip store Number in Request param
            reqParam.getInventoryForThisStore = $scope.transfersStore.ID;
            prodFctr.inventory.$get(reqParam).then(function (data) {
                console.log('value of overshipment flag is: '+$scope.param.allowovershipment);
                var existingCount = quantity;
                //Check The already Scanned Items for This Barcode
                if($scope.items.length>0){
                    var existingProducts = $scope.items.filter(function (p) {
                        return (p.barcode == Product.barcode);
                    });
                    _.each($scope.items, function (item) {
                        existingCount += item.count.scanned.count;
                    });
                    //var existingProduct = _.findWhere($scope.items,{barcode:Product.barcode});
                   // existingCount = (existingProduct === undefined) ? existingCount : (existingCount + existingProduct.count.scanned.count);
                    //existingCount = existingCount + existingProduct.count.scanned.count;
                }
                var val = {};
                val.sufficient = false;
                var stillAvailable = data.Available - existingCount + quantity;
                val.available = (stillAvailable) < 0 ? 0 : stillAvailable;
                if(data.Available>existingCount){
                    val.sufficient = true
                }
                def.resolve(val);
            }, function (data) {
                //No Inventory Data could be retrieved
                popupFctr.alert('Error','Inventory of Product could not be loaded','barcodeInput');
                def.reject();
            });
           return def.promise;
        };

        var saveLocally = function ($scope, scan, scan_type) {
            var def = $q.defer();
            //If Over Shipment Is allowed, no need to validate for quanties check
            if($scope.param.allowovershipment ){
                localScanService.SaveScan(scan,scan_type).then(function (value) {
                    def.resolve(value);
                }, function (e, ex) { def.reject(e, ex); });
            } else {
                _quantityCheck($scope, scan, scan.count.scanned.count).then(
                    function(val){
                        if(val.sufficient){
                            localScanService.SaveScan(scan,scan_type).then(function (value) {
                                def.resolve(value);
                            }, function (e, ex) { def.reject(e, ex); });
                        } else{
                            //popupFctr.alert('Not Allowed','Excess quantity not allowed');
                            def.reject('Excess Quantity not allowed, </br> Available: ' + val.available);
                        }    
                    }
               );
            }
            return def.promise;
        }

        self.$enterSerial = enterSerial;
        self.$enterQuantity = enterQuantity;
        self.$editItem = editItem;
        self.$saveLocally = saveLocally;
        self.$GetGridValues = getGridValues;
        return self;
}])

})();

