(function () {
    'use strict';

    var module = angular.module('aralco.purchaseorderstore');

    module.controller('PurchaseOrderStoreScanCtrl', ['$scope', '$q','$state', '$stateParams',
    '$ionicLoading', 'storeFctr','popupFctr','helperFctr', 'poFctr',
     'prodSearchFctr', '$timeout','$ionicPopup','localScanService','$ionicModal',
      function ($scope, $q,$state, $stateParams, $ionicLoading, storeFctr,popupFctr,helperFctr, poFctr, prodSearchFctr, $timeout,$ionicPopup,localScanService,$ionicModal) {
        
        //For Purchase Order Scan Type would be 3.
        var scan_type = 3;
        $scope.scan_type = scan_type;
        $scope.param = {
            barcode: '',
            sn:null,
            allowovershipment: true
        };
         /****************************************/
        // View load initialization notification Sound
        popupFctr.notificationSound = null;
        popupFctr.playNotificationSound();
        /****************************************/
        initialisePurchaseOrderScanController();

        //Initialise Function ,Of This Controller.
        //This function should be called first
        function initialisePurchaseOrderScanController(){
            $ionicLoading.show({
               template: 'wait...'
           });
            $scope.selectedItem = null;
            $scope.param.barcode='';
            $scope.param.sn=null;
            $scope.data = {};
            $scope.data.quantity = 0;
            //Its value will be changed when Toggle in SubMenu
            //$scope.mode='N-Tfr-Order';
            //$scope.allowOverShipment=  false; //Check whether this needs to be carried from First Screen
            $scope.ShowAll = false;
            $scope.items = [];

            // Check if any scans exist for this store
            storeFctr.Get().then(function (data) {
                $scope.stores = data;
                $scope.transfersStore = _.findWhere($scope.stores, {ID: parseInt($stateParams.tsid)});
                localScanService.GetScans(JSON.stringify($scope.transfersStore.ID), scan_type)
                    .then(function(data){
                         $scope.items = data;
                         $ionicLoading.hide();
                    });
            });

            
        };
        $scope.setBarcodeTextFieldBulr = function(){
            $timeout(function () {
                if(document.getElementById("barcodeInput"))
                    document.getElementById("barcodeInput").blur();
                },300);
            }
        $scope.setBarcodeTextFieldFocus = function(){
            $timeout(function () {
            if(document.getElementById("barcodeInput"))
                document.getElementById("barcodeInput").focus();
            },300);
        }

        $scope.Search = function($event){
            $scope.setBarcodeTextFieldBulr();
            
            prodSearchFctr.$scan($scope.param.barcode, null, null, 7).then(function(prod) {
                prod.mainImage = (prod.images || [])[0];
                $scope.items = $scope.items || [];
            
                var Scan = new scan(prod);
                Scan.count = {
                    manual: {
                        count: 0,
                        modifiedBy: '',
                        modifiedOn: Date.now()
                    },
                    scanned: {
                        count: 1,
                        modifiedBy: $f.UserInfo.FullName(),
                        modifiedOn: Date.now(),
                        manuallyUpdated: false
                    }
                };
                Scan.UserInfo = $f.UserInfo;
                Scan.parentReference = JSON.stringify($scope.transfersStore.ID);
            
                if ((Scan.product.TypeInfo.SerialNumber || false)) {
                    saveLocally(Scan);
                } else {
                    helperFctr.$enterQuantity($scope, Scan).then(function(quantity) {
                        Scan.count.scanned.count = quantity;
                        saveLocally(Scan);
                    },
                    function(err) {
                        throw err;
                    })
                };
                $scope.Scan = Scan;
                $ionicLoading.hide();
            }, function (error) {
                $ionicLoading.hide();
                popupFctr.playNotificationSound();
                $scope.setBarcodeTextFieldFocus();
                popupFctr.alert('Error', error,'barcodeInput');
            });
        }

        var saveLocally = function (scan) {
            helperFctr.$saveLocally($scope, scan, $scope.scan_type).then(function (key){
                scan.ScanID = key;
                $scope.items.push(scan);
            },function(err) {
                throw err;
            })
        }

        $scope.GetPicture = function (item) {
            if (item.barcodeImages != null && item.barcodeImages[0].value == $f.PhotoNotAvail) {
                item.barcodeImages = null;
            }
            return (item.barcodeImages == null) ? item.images[0].value : item.barcodeImages[0].value;
        };

        $ionicModal.fromTemplateUrl('imgModal.html', function (modal) {
           $scope.gridModal = modal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });

        // open image modal
        $scope.openModal = function (selected) {
            if(selected instanceof Object)
                $scope.data.selected =selected;
            else
            $scope.data.selected = {
                value:selected
            };
            $scope.gridModal.show();
        };

        // close image modal
        $scope.closeImgModal = function () {
            $scope.gridModal.hide();
        };

        //Cleanup the video modal when we're done with it!
        $scope.$on('$destroy', function () {
            $scope.gridModal.remove();
        });
        function prepareScanObject(prod){
            var Scan = new scan(prod);
            Scan.product = prod;
            Scan.UserInfo = $f.UserInfo;
            Scan.parentReference = JSON.stringify($scope.transfersStore.ID);
            return Scan;
        }

        //Reset Function
        $scope.Reset = function(){
            var message = $filter('translate')('Are you sure you want to reset current Purchase Order?');
            popupFctr.confirm(message).then(function (result) {
                if (result) {
                    // DB.restart();
                    localScanService.Reset(JSON.stringify($scope.transfersStore.ID),scan_type)
                    .then(function (){
                        initialisePurchaseOrderScanController()
                    });
                }
            });
        }

        //delete Scanned Item Function
        $scope.deleteItem = function (index) {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Delete',
                template: 'Are you sure you want to delete the item with barcode ' + $scope.items[index].barcode + '?'
            });
            confirmPopup.then(function (res) {
                if (res) {
                    localScanService.DeleteScan($scope.items[index],scan_type).then(function () {
                        $scope.items.splice(index, 1);
                    }, function () { throw ex; })
                }
            });
        };
        $scope.editItem = function (index){
            helperFctr.$editItem($scope,index, scan_type);
        };

        //Send Function
        $scope.Send = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Confirm',
                template: 'Are you sure you want to submit this PO Requisite?'

            });
            confirmPopup.then(function (res) {
                if (res) {
                    $ionicLoading.show({
                        template: 'Submitting the PO Requisite to the Aralco BOS...'
                    });
                poFctr.$postRequisite($scope.transfersStore.ID, $scope.scan_type).then(function () {
                    localScanService.Reset($scope.transfersStore.ID, $scope.scan_type).then(function () {
                        popupFctr.alert('Items SENT successfully').then(function (){
                            $state.go('tab.dash');  
                        })
                    }).finally(function () {
                        $ionicLoading.hide();
                    });
                })
                }
            });
        };

    }]);
})();
