angular.module('aralco.purchaseorderstore').factory('poFctr', ['$q', '$http', 'localScanService', function ($q, $http, localScanService) {
    var self = this;

    function _param() {
        this.input = "";
        this.page = 1;
        this.maxitems = $f.moduleSetting.PurchaseOrder.maxItems || $f.genericReturnList;
        this.forceLoad = $f.ForceLoad;
        return this;
    }

    function _search(param) {
        /// <summary>
        /// Execute a search for the purchase order
        /// </summary>
        /// <param name="param"></param>
        /// <returns type=""></returns>
        var def = $q.defer();


        // PurchaseOrder/Get/{Number}?maxitems={maxitems}&page={page}&ForceLoad={ForceLoad}

        var url =$f.serviceUrl + "PurchaseOrder/Search/{Number}?maxitems={maxitems}&page={page}&ForceLoad={ForceLoad}"
        param = param || new _param();

        url = url.replace("{Number}", param.input || '');
        url = url.replace("{maxitems}", param.maxitems || '0');
        url = url.replace("{page}", param.page || '0');
        url = url.replace("{ForceLoad}", param.forceLoad || $f.ForceLoad);
        var req = {
            method: 'get',
            url: url
        };

        $http(req).
            success(function (data, status, headers, config) {
                def.resolve(data)
            }).
            error(function (data, status) {
                def.reject(data, status);
            });

        return def.promise;
    }

    function _load(id, forceLoad)
    {
        /// <summary>
        /// Execute a search for the purchase order
        /// </summary>
        /// <param name="param"></param>
        /// <returns type=""></returns>
        var def = $q.defer();


        // PurchaseOrder/Get/{Number}?maxitems={maxitems}&page={page}&ForceLoad={ForceLoad}

        var url = $f.serviceUrl + "PurchaseOrder/Get/{id}?&ForceLoad={ForceLoad}"

        url = url.replace("{id}", id || '0');
        url = url.replace("{ForceLoad}", forceLoad || $f.ForceLoad);
        var req = {
            method: 'get',
            url: url
        };

        $http(req).
            success(function (data, status, headers, config) {
                def.resolve(data)
            }).
            error(function (data, status) {
                def.reject(data, status);
            });

        return def.promise;
    }

    function _postRequisite(snID,scan_type) {
        var deferred = $q.defer();
        var paramsValues = [];
        localScanService.GetScans(snID, scan_type).then(function(source){
            for(var i=0;i<source.length;i++){
                var User = source[i].UserInfo || $f.UserInfo;
                var item =  {
                    "Input": source[i].input || source[i].barcode,
                    "Product": {
                        ID: source[i].product.ID,
                        Barcode: source[i].product.Barcode,
                        SerialNumber: source[i].SerialNumber || null
                    },
                    "Snapshot": {
                        ID: source[i].parentReference
                    },
                    "Location": {
                        Name: source[i].location
                    },
                    "Employee": {
                        "ID": User.EmployeeID,
                    },
                    "Quantity": {
                        "Quantity": source[i].count.scanned.count,
                        "TimeStamp": new Date(source[i].count.scanned.modifiedOn).toISOString()
                    }
                }
                paramsValues.push(item);
            }
            
            var url = $f.serviceUrl + 'PurchaseOrder/PostRequisite';
            var req = {
                method: 'post',
                url: url,
                data: paramsValues
            };
            $http(req).
                success(function (data, status, headers, config) {
                    deferred.resolve(data)
                }).
                error(function (data, status) {
                    deferred.reject(data, status);
                });
           
        });
        return deferred.promise;
    }

    self.$search = _search;
    self.$param = new _param();
    self.$get = _load;
    self.$postRequisite = _postRequisite;

    return self;


}]);