/// <reference path="../../js/models/scan.js" />
var module = angular.module('aralco.returntovendor', ['ionic', 'aralco.database', 'aralco.sql', 'aralco.product']);
module.config(['$stateProvider','$urlRouterProvider',
function ($stateProvider, $urlRouterProvider) {
    // Each tab has its own nav history stack:
    $stateProvider.state('tab.returntovendor', {
        url: '/returntovendor',
        cache:false,
        views: {
            'tab-inventory': {
                templateUrl: 'modules/inventory/return_to_vendor/templates/returntovendor-store-selection.html',
                controller: 'ReturnToVendorStoreCtrl'
            }
        }
    });
    $stateProvider.state('tab.returntovendor-scan', {
        url: '/returntovendor/scan/:tsid',
        cache:false,
        views: {
            'tab-inventory': {
                templateUrl: 'modules/inventory/return_to_vendor/templates/retruntovendor-scan.html',
                controller: 'ReturnToVendorStoreScanCtrl'
            }
        }
    });
}]);
module.controller('ReturnToVendorStoreCtrl',['$scope','$rootScope','storeFctr','$ionicModal','$ionicLoading','$q','popupFctr','localScanService','$timeout',
function($scope,$rootScope,storeFctr,$ionicModal,$ionicLoading,$q,popupFctr,localScanService,$timeout){
   $ionicLoading.show({
        template: 'wait ...'
    });
    //debugger;
    $scope.param={};
    $scope.data = {};
    $scope.param.TransfersStore={
        Code:'',
        Name:'',
        ID:''
    };
    localScanService.CheckPendingScans(4).then(function (data)
    {
      if(data!=null){
            var storeIDs = data;
            $timeout(function(){
                // $ionicLoading.hide();
                setTimeout($ionicLoading.hide, 100);
                window.location.href='#/tab/returntovendor/scan/'+storeIDs;
            }, 2000);
        }
        else{
            // $ionicLoading.hide();
            setTimeout($ionicLoading.hide, 100);
        }
    });
    $scope.goScan = function (){
        if($scope.param.TransfersStore.ID===''){
            popupFctr.alert('Invalid Store Selection!','Please select store.');
        }
        else{
            window.location.href='#/tab/returntovendor/scan/'+$scope.param.TransfersStore.ID;
        }
    }
    $scope.SearchStore = function(storeType){
        $scope.param.activeStore = $scope.param.TransfersStore;
        $ionicLoading.show({
            template: 'wait ...'
        });
        //Retrieve Store Data
        initStoreData().then(function(){
            //Show Pre-selected Store in The List based on User's Input
            var store = _.findWhere($scope.Stores, {Code: $scope.param.activeStore.Name});
            if(store!= undefined || store!=null){
                $scope.data.selectedStoreID = store.ID;
            }
            //Even if User has entered a In-Valid Store Code, we still preset him with store list
            else{
                $scope.data.selectedStoreID ='';
            }
        });
        showStoreSelectionModal();
    }
    //Retreives Store List Data
    function initStoreData() {
        $scope.Stores = [];
        var calls = [storeFctr.Get()];
        return $q.all(calls).then(function (res) {
            $scope.Stores = res[0];
            _.each($scope.Stores, function (item) {
                item.Address = item.Address || {};
                item.Address.Latitude = item.Address.Latitude || 0;
                item.Address.Longitude = item.Address.Longitude || 0;
            });
            $ionicLoading.hide();
            $q.resolve();
        });
    };
    //Show Store List Modal
    function showStoreSelectionModal(){
        storeFctr.ChooseStore($scope).then(function (storeID) {
            var store = _.findWhere($scope.Stores, {ID: parseInt(storeID)});
            $scope.param.activeStore.Code= store.Code;
            $scope.param.activeStore.ID = store.ID;
            $scope.param.activeStore.Name=store.Value;
        });
    }
}
]);
