(function () {
    'use strict';

    var module = angular.module('aralco.returntovendor');

    module.controller('ReturnToVendorStoreScanCtrl', ['$scope', '$q', '$stateParams', '$ionicSideMenuDelegate',
    '$ionicLoading', 'storeFctr','errorFctr','popupFctr','helperFctr',
     'prodHelpFctr','$timeout','$ionicPopup','localScanService','$ionicModal',
      function ($scope, $q, $stateParams, $ionicSideMenuDelegate, $ionicLoading, storeFctr,
      errorFctr,popupFctr,helperFctr, prodHelpFctr, $timeout,$ionicPopup,localScanService,$ionicModal) {
        //For return to vendor Scan Type would be 4.
        var scan_type = 4;
        $scope.scan_type = scan_type;
        $scope.param = {
            barcode: '',
            sn:null,
            allowovershipment: false
        };
         /****************************************/
        // View load initialization notification Sound
        popupFctr.notificationSound = null;
        popupFctr.playNotificationSound();
        /****************************************/
        initialiseTransfersScanController();

        //Initialise Function ,Of This Controller.
        //This function should be called first
        function initialiseTransfersScanController(){
            $ionicLoading.show({
               template: 'wait...'
           });
            $scope.selectedItem = null;
            //$scope.ponumber = $stateParams.ponumber;

            $scope.param.barcode='';
            $scope.param.sn=null;
            $scope.data = {};
            $scope.data.quantity = 0;
            //Its value will be changed when Toggle in SubMenu
            //$scope.mode='N-Tfr-Order';
            //$scope.allowOverShipment=  false; //Check whether this needs to be carried from First Screen
            $scope.ShowAll = false;
            $scope.items = [];
            storeFctr.Get().then(function (data) {
                $scope.stores = data;
                $scope.transfersStore = _.findWhere($scope.stores, {ID: parseInt($stateParams.tsid)});
                localScanService.GetScans(JSON.stringify($scope.transfersStore.ID),scan_type)
                    .then(function(data){
                         $scope.items = data;
                         // $ionicLoading.hide();
                         setTimeout($ionicLoading.hide, 100);
                    });
            });

            $scope.setBarcodeTextFieldBulr = function(){
                $timeout(function () {
                    if(document.getElementById("barcodeInput"))
                        document.getElementById("barcodeInput").blur();
                    },300);
                }
            $scope.setBarcodeTextFieldFocus = function(){
                $timeout(function () {
                if(document.getElementById("barcodeInput"))
                    document.getElementById("barcodeInput").focus();
                },300);
            }
        };

        $scope.Search = function($event){
            // TODO:: Will need to use prodSearchFctr, trying to clean up
            //prodHelpFctr.$Search($scope,event);
            
        }

        var _saveAndAdd = function (ns) {
            saveLocally(ns).then(

                function (key) {
               	    ns.ScanID = key;
                    //Temporary Code to sort items
                    $scope.items.push(ns);
                    $scope.setBarcodeTextFieldFocus();
                     $ionicLoading.hide();
                }
                , function (err) {
                     $ionicLoading.hide();
                    popupFctr.playNotificationSound();
                    popupFctr.alert('Error',err,'barcodeInput');
                })

        };
        var saveLocally = function (scan) {
            helperFctr.$saveLocally($scope,scan, scan_type);
        }
        $scope.GetPicture = function (item) {
            if (item.barcodeImages != null && item.barcodeImages[0].value == $f.PhotoNotAvail) {
                item.barcodeImages = null;
            }
            return (item.barcodeImages == null) ? item.images[0].value : item.barcodeImages[0].value;
        };

        $ionicModal.fromTemplateUrl('imgModal.html', function (modal) {
           $scope.gridModal = modal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });

        // open image modal
        $scope.openModal = function (selected) {
            if(selected instanceof Object)
                $scope.data.selected =selected;
            else
            $scope.data.selected = {
                value:selected
            };
            $scope.gridModal.show();
        };

        // close image modal
        $scope.closeImgModal = function () {
            $scope.gridModal.hide();
        };

        //Cleanup the video modal when we're done with it!
        $scope.$on('$destroy', function () {
            $scope.gridModal.remove();
        });
        function prepareScanObject(prod){
            var Scan = new scan(prod);
            Scan.product = prod;
            Scan.UserInfo = $f.UserInfo;
            Scan.parentReference = JSON.stringify($scope.transfersStore.ID);
            return Scan;
        }

        //Reset Function
        $scope.Reset = function(){
            var message = $filter('translate')('Are you sure you want to reset current Transfer Order?');
            popupFctr.confirm(message).then(function (result) {
                if (result) {
                    // DB.restart();
                    localScanService.Reset(JSON.stringify($scope.transfersStore.ID),scan_type)
                    .then(function (){
                        initialiseTransfersScanController()
                    });
                }
            });
        }

        //delete Scanned Item Function
        $scope.deleteItem = function (index) {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Delete',
                template: 'Are you sure you want to delete the item with barcode ' + $scope.items[index].barcode + '?'
            });
            confirmPopup.then(function (res) {
                if (res) {
                    localScanService.DeleteScan($scope.items[index],scan_type).then(function () {
                        $scope.items.splice(index, 1);
                    }, function () { throw ex; })
                }
            });
        };
        $scope.editItem = function (index){
            helperFctr.$editItem($scope,index, scan_type);
        };

        //Send Function
        $scope.Send = function(){
            $ionicLoading.show({
                    template: 'this feature coming soon...'
            });
            setTimeout(function(){
                $ionicLoading.hide();
            }, 2000);
        }

    }]);
})();
