angular.module('aralco.transfersControllers').controller('TransfersCtrl',['$scope','$rootScope','storeFctr','$ionicModal','$ionicLoading','$q','popupFctr','localScanService','$timeout',
function($scope,$rootScope,storeFctr,$ionicModal,$ionicLoading,$q,popupFctr,localScanService,$timeout){
   $ionicLoading.show({
        template: 'wait ...'
    });
    $scope.param={};
    $scope.data = {};
    $scope.param.TransfersFromStore={
        Code:'',
        Name:'',
        ID:''
    };
    $scope.param.TransfersToStore={
        Code:'',
        Name:'',
        ID:''
    };
    localScanService.CheckPendingScans(94).then(function (data) 
    {
        if(data!=null){
            var storeIDs = data.split("-");
            $timeout(function(){
                // $ionicLoading.hide();
                setTimeout($ionicLoading.hide, 100);
                window.location.href='#/tab/transfers/scan/'+storeIDs[0]+'/'+storeIDs[1];
            }, 2000);
        } else {
            // $ionicLoading.hide();
            setTimeout($ionicLoading.hide, 100);
        }
    }); 
    $scope.goScan = function (){
        if($scope.param.TransfersFromStore.ID==='' || $scope.param.TransfersToStore.ID===''){
            popupFctr.alert('Invalid Store Selection!','Please select both stores.');
        } else if($scope.param.TransfersFromStore.ID === $scope.param.TransfersToStore.ID) {
            popupFctr.alert('Invalid Store Selection!','From and To Stores cannot be same.');
        } else {
            window.location.href='#/tab/transfers/scan/'+$scope.param.TransfersFromStore.ID+'/'+$scope.param.TransfersToStore.ID;
        }
    }
    $scope.SearchStore = function(storeType){
        if(storeType==='From'){
            $scope.param.activeStore = $scope.param.TransfersFromStore;
        } else {
             $scope.param.activeStore = $scope.param.TransfersToStore;
        }
        $ionicLoading.show({
            template: 'wait ...'
        });
        //Retrieve Store Data
        initStoreData().then(function(){
            //Show Pre-selected Store in The List based on User's Input
            var store = _.findWhere($scope.Stores, {Code: $scope.param.activeStore.Name});
            if(store!= undefined || store!=null){
                $scope.data.selectedStoreID = store.ID;
                $scope.param.activeStore.Code= store.Code;
                $scope.param.activeStore.ID = store.ID;
                $scope.param.activeStore.Name=store.Value;
            } else { 
                $scope.data.selectedStoreID ='';  
                showStoreSelectionModal();  
            }   
                  
        });
            
    }
    //Retreives Store List Data
    function initStoreData() {
        $scope.Stores = [];
        var calls = [storeFctr.Get()];
        return $q.all(calls).then(function (res) {
            $scope.Stores = res[0];
            _.each($scope.Stores, function (item) {
                item.Address = item.Address || {};
                item.Address.Latitude = item.Address.Latitude || 0;
                item.Address.Longitude = item.Address.Longitude || 0;
            });
            //$ionicLoading.hide();
            setTimeout($ionicLoading.hide, 100);
            $q.resolve();
        });
    };
    //Show Store List Modal
    function showStoreSelectionModal(){
        storeFctr.ChooseStore($scope).then(function (storeID) {
            var store = _.findWhere($scope.Stores, {ID: parseInt(storeID)});
            $scope.param.activeStore.Code= store.Code;
            $scope.param.activeStore.ID = store.ID;
            $scope.param.activeStore.Name=store.Value;
        });
    }
}]);
