
angular.module('aralco.transfersControllers').controller('TransfersScanCtrl', ['$scope', '$q', '$stateParams', 
'$ionicLoading', 'storeFctr','popupFctr','helperFctr', 'prodSearchFctr','transfersFctr', '$timeout','$ionicPopup','localScanService','$ionicModal',
  function ($scope, $q, $stateParams, $ionicLoading, storeFctr,popupFctr,helperFctr, prodSearchFctr, transfersFctr, $timeout, $ionicPopup,localScanService,$ionicModal) {
    //For Transfers Scan Type would be 94.
    $scope.scan_type = 94;
    $scope.param = {
        barcode: '',
        sn:null,
        allowovershipment: false
    };
     /****************************************/
    // View load initialization notification Sound
    popupFctr.notificationSound = null;
    popupFctr.playNotificationSound();
    /****************************************/
    initialiseTransfersController();
    //Initialise Function ,Of This Controller.
    //This function should be called first
    function initialiseTransfersController(){
        $ionicLoading.show({
           template: 'wait...'
        });
        $scope.selectedItem = null;
        //$scope.ponumber = $stateParams.ponumber;
        $scope.param.barcode='';
        $scope.param.sn=null;
        $scope.data = {};
        $scope.data.quantity = 0;
        //Its value will be changed when Toggle in SubMenu
        //$scope.mode='N-Tfr-Order';
        //$scope.allowOverShipment=  false; //Check whether this needs to be carried from First Screen
        $scope.ShowAll = false;
        $scope.items = [];
        storeFctr.Get().then(function (data) {
            $scope.stores = data;
            $scope.transfersStore = _.findWhere($scope.stores, {ID: parseInt($stateParams.fsid)});
            $scope.transfersToStore = _.findWhere($scope.stores, {ID: parseInt($stateParams.tsid)});
            localScanService.GetScans(JSON.stringify($scope.transfersStore.ID+'-'+$scope.transfersToStore.ID), $scope.scan_type)
                .then(function(data){
                     $scope.items = data;
                     // $ionicLoading.hide();
                     setTimeout($ionicLoading.hide, 100);
                });
        });

        $scope.setBarcodeTextFieldBulr = function(){
            $timeout(function () {
                if(document.getElementById("barcodeInput"))
                    document.getElementById("barcodeInput").blur();
            },300);
        }
        $scope.setBarcodeTextFieldFocus = function(){
            $timeout(function () {
            if(document.getElementById("barcodeInput"))
                document.getElementById("barcodeInput").focus();
            },300);
        }
    };
    $scope.Search = function($event){
        $scope.setBarcodeTextFieldBulr();
        prodSearchFctr.$scan($scope.param.barcode, $scope.transfersStore.ID).then(function(prod) {
            prod.mainImage = (prod.images || [])[0];
            $scope.items = $scope.items || [];
        
            var Scan = new scan(prod);
            Scan.count = {
                manual: {
                    count: 0,
                    modifiedBy: '',
                    modifiedOn: Date.now()
                },
                scanned: {
                    count: 1,
                    modifiedBy: $f.UserInfo.FullName(),
                    modifiedOn: Date.now(),
                    manuallyUpdated: false
                }
            };
            Scan.UserInfo = $f.UserInfo;
            Scan.parentReference = JSON.stringify($scope.transfersStore.ID+'-'+$scope.transfersToStore.ID);
        
            if ((Scan.product.TypeInfo.SerialNumber || false)) {
                saveLocally(Scan);
            } else {
                helperFctr.$enterQuantity($scope, Scan).then(function(quantity) {
                    Scan.count.scanned.count = quantity;
                    saveLocally(Scan);
                },
                function(err) {
                    throw err;
                })
            };
            $scope.Scan = Scan;
            
            $scope.param.barcode = "";
            $ionicLoading.hide();
        }, function (error) {
            $ionicLoading.hide();
            popupFctr.playNotificationSound();
            popupFctr.alert('Error', error,'barcodeInput');
            $scope.setBarcodeTextFieldFocus();
        });
    }
    

    var saveLocally = function (scan) {
        helperFctr.$saveLocally($scope, scan, $scope.scan_type).then(function (key){
            scan.ScanID = key;
            $scope.items.push(scan);
        },function(err) {
            throw err;
        })
    }
    $scope.GetPicture = function (item) {
        if (item.barcodeImages != null && item.barcodeImages[0].value == $f.PhotoNotAvail) {
            item.barcodeImages = null;
        }
        return (item.barcodeImages == null) ? item.images[0].value : item.barcodeImages[0].value;
    };
    $ionicModal.fromTemplateUrl('imgModal.html', function (modal) {
       $scope.gridModal = modal;
    }, {
        scope: $scope,
        animation: 'slide-in-up'
    });
    // open image modal
    $scope.openModal = function (selected) {
        if(selected instanceof Object)
            $scope.data.selected =selected;
        else
        $scope.data.selected = {
            value:selected
        };
        $scope.gridModal.show();
    };
    // close image modal
    $scope.closeImgModal = function () {
        $scope.gridModal.hide();
    };
    //Cleanup the video modal when we're done with it!
    $scope.$on('$destroy', function () {
        $scope.gridModal.remove();
    });

    //Reset Function
    $scope.Reset = function(){
        var message = $filter('translate')('Are you sure you want to reset current Transfer Order?');
        popupFctr.confirm(message).then(function (result) {
            if (result) {
                // DB.restart();
                localScanService.Reset(JSON.stringify($scope.transfersStore.ID+'-'+$scope.transfersToStore.ID), $scope.scan_type)
                .then(function (){
                    initialiseTransfersController()
                });
            }
        });
    }
    //delete Scanned Item Function
    $scope.deleteItem = function (index) {
        var confirmPopup = $ionicPopup.confirm({
            title: 'Delete',
            template: 'Are you sure you want to delete the item with barcode ' + $scope.items[index].barcode + '?'
        });
        confirmPopup.then(function (res) {
            if (res) {
                localScanService.DeleteScan($scope.items[index], $scope.scan_type).then(function () {
                    $scope.items.splice(index, 1);
                }, function () { throw ex; })
            }
        });
    };
    $scope.editItem = function (index){
        helperFctr.$editItem($scope,index, $scope.scan_type);
    };
    //Send Function
    $scope.Send = function(){
        var transfer = prepareTransfer($scope.items, $scope.transfersStore, $scope.transfersToStore)
        transfersFctr.PostTransfer(transfer).then(function(transferNo){
            if(transferNo != null){
                popupFctr.alert('Transfer Saved', 'Transfer number: ' + transferNo).then(function(){
                    localScanService.Reset(JSON.stringify($scope.transfersStore.ID+'-'+$scope.transfersToStore.ID), $scope.scan_type)
                    .then(function (){
                        initialiseTransfersController()
                    });
                });
            }
        });
        
       //$ionicLoading.show({
       //        template: 'this feature coming soon...'
       //});
       //setTimeout(function(){
       //    $ionicLoading.hide();
       //}, 2000);
    }

    function prepareTransfer(items,storeFrom,storeTo){
        var transfer = new Transfer();
    
    
        transfer.OrderDate = Date.now();
        transfer.TransferDate = Date.now();
        transfer.RequiredDate = Date.now();
        transfer.CompletedDate = null;
        transfer.Status = 0x00000011;
        transfer.ShipVia = "";
        transfer.ShippingTerms = "";
        transfer.Remarks = "Entered via Mobile Device at store "+ $f.moduleSetting.Store.Code +" by " + $f.UserInfo.FirstName;
        transfer.CreatedBy = $f.UserInfo.EmployeeID;
    
        for(var i=0;i<items.length;i++){
            var product = {
                ID: items[i].product.ID,
                GridID1: items[i].product.GridID1,
                GridID2: items[i].product.GridID2,
                GridID3: items[i].product.GridID3,
                GridID4: items[i].product.GridID4,
                SerialNumber: items[i].SerialNumber,
                Quantity: items[i].count.scanned.count,
                Cost: items[i].product.Cost
            }
            transfer.Products.push(product);
        }
        transfer.StoreTo = storeTo;
        transfer.StoreFrom = storeFrom;
        
        return transfer;
    };

}]);
