﻿(function () {
	'use strict';

	var module = angular.module('aralco.map', ['ionic', 'ngMap']);

	module.factory("locationFctr", function ()
	{
		var self = this;

		self.deviceposition = ['$q', function ($q) {

			var def = $q.defer();

			var onSuccess = function (position) {
				var retVal = {
					Latitude: +position.coords.latitude,
					Longitude: position.coords.longitude,
					Altitude: position.coords.altitude,
					Accuracy: position.coords.accuracy,
					AltitudeAccuracy: position.coords.altitudeAccuracy,
					Heading: position.coords.heading,
					Speed: position.coords.speed,
					Timestamp: position.timestamp
				};

				def.resolve(retVal);
				
			};

			
			function onError(error) {
				def.reject(error);
			}

			navigator.geolocation.getCurrentPosition(onSuccess, onError, { timeout: 30000 });

			return def.promise;
		}];

		return self;
	});

	module.directive('mapRender', function ()
	{

		return {
			restrict: 'A',
			scope: {
				source: '='
			},
			transclude:true,
			controller: function ($scope, $ionicLoading) {
				$scope.positions = [{
					lat: $scope.source.Latitude || null,
					lng: $scope.source.Longitude || null
				}];

				$scope.MapAvailable = function () {
					return $scope.positions[0].lat !=null && 
						$scope.positions[0].lng != null;
				};

				$scope.$on('mapInitialized', function (event, map) {
					$scope.map = map;
				});

				$scope.centerOnMe = function () {
					$scope.positions = [];

					$ionicLoading.show({
						template: 'Loading...'
					});


					navigator.geolocation.getCurrentPosition(function (position) {
						var pos = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
						$scope.positions.push({ lat: pos.k, lng: pos.B });
						console.log(pos);
						$scope.map.setCenter(pos);
						$ionicLoading.hide();
					});

				};
			},
			templateUrl: '/modules/map/templates/map.html'
		};

	});
		
})()