/// <reference path="../../js/aralco.mobile.fw/aralco.mobile.fw.js" />
/// <reference path="../../Scripts/underscore.js" />
/// <reference path="../../js/models/address.js" />
(function() {

    var module = angular.module('aralco.pos', ['aralco.product', 'aralco.customer', 'aralco.dimension', 'aralco.store', 'aralco.database', 'aralco.sql', 'aralco.pos.controllers', 'aralco.pos.services', 'aralco.security']);

    module.config(['$stateProvider', '$urlRouterProvider', function($stateProvider, $urlRouterProvider) {
        $stateProvider
            /*.state('pos', {
                url: "/pos",
                abstract: true,
                templateUrl: 'modules/pos/templates/tabs.html',
                controller: "POSTabCtrl"
            })*/
            .state('pos', {
                url: "/pos",
                cache: false,
                abstract: true,
                templateUrl: "templates/tabs.html"
            })
    
            .state('pos.saved', {
                url: '/saved',
                cache: false,
                views: {
                    'pos-view': {
                        templateUrl: 'modules/pos/templates/tab-select-customers.html',
                        controller: 'posSelCustomer'
                    }
                }
            })
            .state('pos.assignstore', {
                url: '/posstart',
                cache: false,
                views: {
                    'pos-view': {
                        //templateUrl: 'modules/pos/templates/pos-assign-store.html',
                        templateUrl: 'modules/pos/templates/pos-start.html',
                        //controller: 'posStoreAssignement'
                        controller: 'posStart'
                    }
                }
            })
            .state('pos.assignregister', {
                url: '/posstart',
                cache: false,
                views: {
                    'pos-view': {
                        //templateUrl: 'modules/pos/templates/pos-assign-store.html',
                        templateUrl: 'modules/pos/templates/pos-start.html',
                        //controller: 'posStoreAssignement'
                        controller: 'posStart'
                    }
                }
            })
            .state('pos.customer', {
                url: '/start/:tid',
                StoreRequired: true,
                cache: false,
                views: {
                    'pos-view': {
                        templateUrl: 'modules/pos/templates/tab-select-customers.html',
                        controller: 'posSelCustomer'
                    }
                }
            })
            .state('pos.main', {
                url: '/products/:tid',
                StoreRequired: true,
                cache: false,
                views: {
                    'pos-view': {
                        templateUrl: 'modules/pos/templates/tab-pos-container.html',
                        controller: 'posContainer'
                    }
                }
            })

            .state('pos.giftcards', {
                url: '/giftcards/:tid',
                StoreRequired: true,
                cache: false,
                views: {
                    'pos-view': {
                        templateUrl: 'modules/pos/templates/tab-pos-giftcards.html',
                        controller: 'posContainer'
                    }
                }
            })

            .state('pos.end', {
                url: '/posend/',
                StoreRequired: true,
                cache: false,
                views: {
                    'pos-view': {
                        templateUrl: 'modules/pos/templates/tab-end-day.html',
                        controller: 'posEnd'
                    }
                }
            })
    
            .state('pos.pay', {
                url: '/pay/:tid',
                StoreRequired: true,
                cache: false,
                views: {
                    'pos-view': {
                        templateUrl: 'modules/pos/templates/tab-pos-pay.html',
                        controller: 'posPayment'
                    }
                }
            });
    }]);

    module.run(['$ionicPlatform', '$state', '$rootScope', 'accountFctr', 'localStorageService', '$q', 'posFctr',
        function($ionicPlatform, $state, $rootScope, accountFctr, localStorageService, $q, posFctr) {
            $ionicPlatform.ready(function() {
                $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
                    toState = toState || {};
                    var StoreRequired = toState.StoreRequired || false;
    
                    /* Commenting This Code to Enable POS Store Selection to proceed
                    if (StoreRequired && $f.store == null) {
                        event.preventDefault();
                        $state.transitionTo('pos.assignstore');
                    }*/
    
                    if ((toState.name == 'pos.customer') && $f.moduleSetting.pos.customerMode != 0 && $f.moduleSetting.pos.customerMode !== undefined) {
                        event.preventDefault();
                        var trMan = new transactionManager();
                        trMan.transaction.store = $f.moduleSetting.pos.Store;
                        trMan.transaction.type = $f.pos_choiceType;
                        posFctr.transaction.$save(trMan.transaction).then(function(t) {
                            $state.go('pos.main', {
                                'tid': t
                            });
                            //$state.transitionTo('pos.main', {'tid': t});
                        });
                    }
    
                    if (!_.isEmpty(toState.name)) {
                        var posState = toState.name.indexOf('pos.main') > -1;
                        $rootScope.posView = posState;
                    }
                });
            })
        }
    ]);

    module.filter('tel', function() {
        return function(tel) {
            if (!tel) {
                return '';
            }
            var value2 = tel.toString().trim().replace(/^\+/, '');
            var value = value2.replace(/[^0-9]+/g, '')
            if (value.match(/[^0-9]/)) {
                return tel;
            }
            var country, city, number;
    
            switch (value.length) {
                case 10: // +1PPP####### -> C (PPP) ###-####
                    country = 1;
                    city = value.slice(0, 3);
                    number = value.slice(3);
                    break;
    
                case 11: // +CPPP####### -> CCC (PP) ###-####
                    country = value[0];
                    city = value.slice(1, 4);
                    number = value.slice(4);
                    break;
    
                case 12: // +CCCPP####### -> CCC (PP) ###-####
                    country = value.slice(0, 3);
                    city = value.slice(3, 5);
                    number = value.slice(5);
                    break;
    
                default:
                    return tel;
            }
    
            if (country == 1) {
                country = "";
            }
    
            number = number.slice(0, 3) + '-' + number.slice(3);
    
            return (country + " (" + city + ") " + number).trim();
        };
    });

    module.directive('posDepartments', [function() {
        return {
            restrict: "A",
            transclude: true,
            templateUrl: 'modules/pos/templates/pos-departments.html',
            controller: ['$scope', '$rootScope', '$ionicLoading', '$filter', '$ionicActionSheet', '$ionicPopup', 'departmentFctr',
                function($scope, $rootScope, $ionicLoading, $filter, $ionicActionSheet, $ionicPopup, departmentFctr) {
                    $scope.loadnextdep = function() {
                        //Check if we are on last page
                        if ($scope.departments.length === ($scope.param.begin + $scope.param.limit)) {
                            //we are on last page,disable Next
                            $scope.param.isNextDepAvailable = false;
                        } else {
                            $scope.param.begin += $scope.param.limit;
                            $scope.param.isPrevDepAvailable = true;
                            departmentFctr.$LoadDepartmentImages($scope.departments.slice($scope.param.begin, $scope.param.begin + $scope.param.limit));
                        }
                    };
    
                    $scope.loadprevdep = function() {
                        if ($scope.param.begin > 0) {
                            $scope.param.begin -= $scope.param.limit;
                        } else {
                            $scope.param.isPrevDepAvailable = false;
                        }
                    };
    
                    //**Return Departments based on filter**/
                    $scope.loadFilteredDepartments = function() {
                        var filterString = $scope.param.departmentsearch;
                        console.log('FilterString is' + filterString);
    
                        if (!_.isEmpty(filterString)) {
                            $scope.param.filtered = true;
                            $scope.filteredDepartments = [];
                            $scope.param.begin = 0;
                            angular.forEach($scope.departments, function(el) {
                                if (el.Name && el.Name.toUpperCase().indexOf(filterString.toUpperCase()) > -1) {
                                    $scope.filteredDepartments.push(el);
                                }
                            });
                            loaddepartmentImages($scope.filteredDepartments);
                        } else {
                            $scope.param.filtered = false;
                            $scope.filteredDepartments = $scope.departments;
                        }
                    }
    
                    function loaddepartmentImages(departments) {
                        _.each(departments, function(department) {
                            //if(department.Image ==='./img/logo-barcode.png'){
                            if (_.isEmpty(department.Image)) {
                                console.log('fetching deptt Image');
                                departmentFctr.$GetDepartmentPicture(department.ID).then(function(image) {
                                    department.Image = image[0].value;
                                }, function(error) {
                                    console.log('error');
                                });
    
                            }
                        });
                    }
                }
            ]
        }
    }]);

    module.directive('posProducts', [function() {
        return {
            restrict: "A",
            scope: {
                products: "=products"
            },
            transclude: true,
            //templateUrl: 'modules/pos/templates/pos-products.html',
            templateUrl: 'modules/physical_count/templates/snapshot-item.html',
            controller: ['$scope', '$rootScope', '$ionicLoading', '$filter', '$ionicActionSheet', '$ionicPopup', function($scope, $rootScope, $ionicLoading, $filter, $ionicActionSheet, $ionicPopup) {
                $scope.GetPicture = function(item) {
                    if (item.barcodeImages != null && item.barcodeImages[0].value == $f.PhotoNotAvail) {
                        item.barcodeImages = null;
                    }
    
                    return (item.barcodeImages == null) ? item.images[0].value : item.barcodeImages[0].value;
                };
                $ionicModal.fromTemplateUrl('imgModal.html', function(modal) {
                    $scope.gridModal = modal;
                }, {
                    scope: $scope,
                    animation: 'slide-in-up'
                });
    
                // open image modal
                $scope.openModal = function(selected) {
                    if(selected instanceof Object)
                        $scope.data.selected =selected;
                    else
                    $scope.data.selected = {
                        value:selected
                    };
                    $scope.gridModal.show();
                };
    
                // close image modal
                $scope.closeImgModal = function() {
                    $scope.gridModal.hide();
                };
    
                $scope.showprod = function(item) {
                    alert(item.Name);
                };
    
                $scope.showpictures = function(item) {
                    alert('Pictureeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeees');
                };
    
                _changeRetailPrice = function(item, itemIndex) {
                    $scope.data = {
                        retailPrice: item.RetailPrice
                    };
    
                    var myPopup = $ionicPopup.show({
                        template: '<input type="text" numbers-only="numbers-only" ng-model="data.retailPrice">',
                        title: 'Change Retail Price',
                        scope: $scope,
                        subTitle: 'Modify retail price for item ' + item.Name,
                        buttons: [{
                                text: 'Cancel'
                            },
                            {
                                text: '<b>Save</b>',
                                type: 'button-positive',
                                onTap: function(e) {
                                    if (!$scope.data.retailPrice) {
                                        //don't allow the user to close unless he enters wifi password
                                        e.preventDefault();
                                    } else {
                                        item.RetailPrice = $scope.data.retailPrice;
                                    }
                                    $scope.$parent.manager.$refresh();
                                }
                            }
                        ]
                    });
                    myPopup.then(function(res) {
                        if (res) {
                            item.Quantity = res;
                        }
                    });
                };
    
                _updateQuantity = function(item, itemIndex) {
                    $scope.data = {
                        quantity: item.Quantity
                    };
    
                    var myPopup = $ionicPopup.show({
                        template: '<input type="text" numbers-only="numbers-only" ng-model="data.quantity">',
                        title: 'Change quantity',
                        scope: $scope,
                        subTitle: 'Modify scanned quantity for item ' + item.Name,
                        buttons: [{
                                text: 'Cancel'
                            },
                            {
                                text: '<b>Save</b>',
                                type: 'button-positive',
                                onTap: function(e) {
                                    if (!$scope.data.quantity) {
                                        //don't allow the user to close unless he enters wifi password
                                        e.preventDefault();
                                    } else {
                                        if ($scope.data.quantity <= 0) {
                                            $scope.products.splice(itemIndex, 1);
                                        } else {
                                            item.Quantity = $scope.data.quantity;
                                        }
    
                                        $scope.$parent.manager.$refresh();
                                    }
                                }
                            }
                        ]
                    });
                    myPopup.then(function(res) {
                        if (res) {
                            item.Quantity = res;
                        }
                    });
                };
    
                $scope.hold = function(item, itemIndex) {
                    var translate = $filter('translate');
                    $ionicActionSheet.show({
                        titleText: translate('Manage') + ' ' + item.Name,
                        buttons: [{
                                text: '<i class="icon ion-edit"></i> ' + translate('Edit quantity')
                            },
                            {
                                text: '<i class="icon ion-cash"></i> ' + translate('Change retail price')
                            }
                        ],
                        destructiveText: 'Delete',
                        cancelText: 'Cancel',
                        cancel: function() {
                            console.log('CANCELLED');
                        },
                        buttonClicked: function(index) {
                            switch (index) {
                                case 0:
                                    _updateQuantity(item, itemIndex);
                                    break;
                                case 1:
                                    _changeRetailPrice(item, itemIndex);
                                default:
                                    break;
                            }
                            return true;
                        },
                        destructiveButtonClicked: function() {
                            $ionicPopup.confirm({
                                title: translate('Remove item'),
                                template: translate('Are you sure you want to remove the') + ' ' + item.Name + "?"
                            }).then(function(res) {
                                if (res) {
                                    $scope.products.splice(itemIndex, 1);
                                }
                            });
    
                            return true;
                        }
                    });
                };
            }]
        }
    }]);
})();