angular.module('aralco.pos.controllers').controller('posContainer', ['$scope', '$state', '$rootScope', '$stateParams', '$q', '$ionicModal', '$ionicLoading', '$filter', '$ionicActionSheet', '$ionicPopover', 'taxFctr', 'prodFctr', 'prodSearchFctr','posFctr',
    'popupFctr', 'localScanService', 'errorFctr','$ionicPopup','$timeout',
    'helperFctr','storeFctr','departmentFctr','$ionicHistory', 'salutationSrv', 'giftCardFctr', 'securityFctr',
        function ($scope, $state, $rootScope, $stateParams, $q, $ionicModal, $ionicLoading, $filter,
        $ionicActionSheet, $ionicPopover, taxFctr, prodFctr, prodSearchFctr, posFctr, popupFctr,
        localScanService, errorFctr,$ionicPopup,$timeout,helperFctr,storeFctr,departmentFctr,$ionicHistory, salutationSrv, giftCardFctr, securityFctr
        ) {
            $ionicLoading.hide();
            /****************************************/
            // View load initialization notification Sound
            popupFctr.notificationSound = null;
            popupFctr.playNotificationSound();
            /****************************************/
            $scope.param = {
                barcode: '',
                sn:null,
                allowovershipment: false,
                isPos:true
            };

            var scan_type=3;
            var _newCustomer = null;

            init();



            // Init posContainer
            function init() {
                $scope.pos_choice = $f.pos_choice;
                $ionicLoading.show({
                    template: 'wait...'
                });
                $scope.param.barcode='';
                $scope.param.sn=null;
                $scope.data = {};
                $scope.items=[];
                $scope.data.quantity = 0;
                $scope.ShowAll = true;
                var _tranID = $stateParams.tid;
                $scope.manager = new transactionManager();
                $scope.manager.transaction.store = $f.moduleSetting.pos.Store;
                posFctr.transaction.$get(_tranID).then(
                    function(data){
                        //check Data form
                        var transaction =  data||$scope.manager.transaction;
                        var asyncCalls = [
                            storeFctr.Get(),
                            localScanService.GetScans(JSON.stringify(_tranID),transaction.type)
                        ];

                        $q.all(asyncCalls).then(function(data){
                            $scope.stores = data[0];
                            transaction.products = data[1]||[];
                            transaction.number = _tranID;
                            if(_.isEmpty(transaction.taxes))
                                transaction.taxes = $f.moduleSetting.pos.Store.taxes;
                            $scope.manager.$init(transaction);
                            $scope.items = $scope.manager.transaction.products;
                            $ionicLoading.hide();
                            //Store is selected in the Tran Already at Creation
                            //$scope.manager.transaction.store = $f.store;

                            //Set Focus to Scan Product Field
                            $scope.setBarcodeTextFieldFocus();
                            //document.getElementById("barcodeInput").focus();
                        },function(error){
                            console.log('Error Thrown at');
                        });
                        //$scope.items= (data!=null && data.products!=null && data.products.length>0)  ? data.products : [];
                        //$ionicLoading.hide();
                    }
                 );

                //must get this from database or something
                //$scope.title = $filter('translate')('Transaction #');
                //$scope.findBarcode = "";
                //$scope.customer = null;

                //$scope.usereader = false;

                //$scope.transaction = _tranMan.transaction

                /*posFctr.transaction.$get(_tranID).then(function (t) {
                    $scope.manager.$init(t);
                    $scope.title = $filter('translate')('Transaction #') + $scope.manager.transaction.number;
                });*/
            }


            $ionicModal.fromTemplateUrl('modules/pos/templates/pos-options.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.posoptionmodal = modal;
            });
            $ionicModal.fromTemplateUrl('modules/pos/templates/pos-item-options.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.positemoptionmodal = modal;
            });

            $ionicModal.fromTemplateUrl('modules/pos/templates/transaction_popover.html',{
                scope:$scope
            }).then(function(popover){
                $scope.transaction_popover = popover;
            });

            $scope.showPosItemOptions = function(index){
                //This variable will always contain the Index of the product,
                //  of which Item Options was clicked on
                $scope.currentItemIndex = index;

                var currentItem = $scope.manager.transaction.products[$scope.currentItemIndex];

                /* Parameters */
                // Rounds the price, not sure why it sets it to null later.
                //$scope.param.itemPrice = Math.round(currentItem.RetailPrice* 100)/100;
                //$scope.param.isLableitemPrice = $scope.param.itemPrice;
                $scope.param.isLableitemPrice = Math.round(currentItem.RetailPrice* 100)/100;
                $scope.param.itemPrice = null;

                // Remarks and return
                $scope.param.item_remarks = currentItem.remarks;
                $scope.param.item_returnFlag = currentItem.returnFlag || false;

                // Discounts
                $scope.param.dbq_value = currentItem.item_discountByQuantity_value;
                $scope.param.dba_value = currentItem.item_discountByAmount_value;
                $scope.param.dbp_value = currentItem.item_discountByPercentage_value;
                $scope.param.discountModifiedByHand = currentItem.discountModifiedByHand || false;
                $scope.manager.transaction.products[$scope.currentItemIndex].item_discountBy = (function () {
                    if ($scope.param.dbp_value != null){
                        return "discountbypercentage";
                    } else if ($scope.param.dba_value != null) {
                        return "discountbyamount";
                    } else if ($scope.param.dbq_value != null) {
                        return "discountbyquantity";
                    }
                    else return "nodiscount";
                })();

                // Taxes
                $scope.itemtaxes = [];
                _.each($scope.manager.transaction.taxes,function(tax){
                    _.each(currentItem.taxes,function(itemTax){
                        if(tax.id===itemTax.ID){
                            itemTax.item_applyFlag = itemTax.item_applicable;
                            $scope.itemtaxes.push(itemTax);
                        }

                    });
                });

                /* Options */
                $scope.oldQuantity = currentItem.Quantity;

                // Item Price, Tax, Discount, Remarks, Returns, Inventory
                $scope.showitempriceoption = false;
                $scope.showitemtaxoption = false;
                $scope.showitemdiscountoption = false;
                $scope.showitemremarksoption = false;
                $scope.showitemreturnoption = false

                //Inventory Related
                $scope.showiteminventoryoption = false;
                $scope.showiteminventorydata = false;
                $scope.showitemquantityoption = false;

                $scope.iteminventorycontent = null;

                // Display all in a modal
                $scope.positemoptionmodal.show();
            };

            $scope.cancelPosItemOptions = function (event) {
                $scope.editQuantity($scope.currentItemIndex, $scope.oldQuantity);
                $scope.positemoptionmodal.hide(event);
            };

            $scope.applyPosItemOptions = function(index){
                var item =  $scope.manager.transaction.products[index];
                var isItemChanged = false;
                console.log("Index of POSITEM apply: "+index);
                //* 1. Quantity *//
                //handled as of now with prompt
                //* 2. Price *//
                if($scope.param.itemPrice!=null){
                    isItemChanged = true;
                    item.RetailPrice = $scope.param.itemPrice;
                    if(item.product.SellBy!=null && item.product.SellBy.Multiplicator!=null && item.product.RetailPriceQty!=null)
                        item.product.RetailPrice = $scope.param.itemPrice/(item.product.SellBy.Multiplicator);
                    else
                        item.product.RetailPrice = item.RetailPrice;

                }
                //* 3. discounts
                if($scope.param.dba_value!=null || $scope.param.dbp_value!=null || $scope.param.dbq_value!=null){
                    isItemChanged = true;
                    //console.log('POS ITEM Discount: '+item.item_discountBy);
                    //console.log($scope.param.dba_value+"-"+$scope.param.dbp_value);
                    if ($scope.param.item_remarks === "Quantity Discount Applied" ||
                        $scope.param.item_remarks === "Amount Discount Applied" ||
                        $scope.param.item_remarks === "Percentage Discount Applied"){
                        $scope.param.item_remarks = "";
                    }
                    switch (item.item_discountBy) {
                        case 'discountbypercentage':
                            item.item_discountByAmount_value = null;
                            item.item_discountByQuantity_value = null;
                            item.item_discountByPercentage_value = $scope.param.dbp_value;
                            //When we apply Discounts By percentage,
                            //All Previous Discounts Applied Yo This Product Only by Amount(if any) Should be Quashed

                            // QUESTION: POS does Retail price, Moes asks for MSRP
                            item.discount =  parseFloat(parseFloat(item.item_discountByPercentage_value/100) * parseFloat(item.product.RetailPrice * item.Quantity));
                            popupFctr.alert('Notification', item.item_discountByPercentage_value + '% discount applied on Retail price of ' + item.product.RetailPrice);
                            item.discountModifiedByHand = true;
                            if (Math.abs(item.discount) > 0.01){
                                item.discountReason = "Percentage Discount Applied";
                            }
                            break;
                        case 'discountbyamount':
                            item.item_discountByPercentage_value = null;
                            item.item_discountByQuantity_value = null;
                            item.item_discountByAmount_value = $scope.param.dba_value;
                            item.discount = item.item_discountByAmount_value;
                            item.discountModifiedByHand = true;
                            if (Math.abs(item.discount) > 0.01){
                                item.discountReason = "Amount Discount Applied";
                            }
                            break;
                        case 'discountbyquantity':
                            item.item_discountByAmount_value = null;
                            item.item_discountByPercentage_value = null;
                            item.item_discountByQuantity_value = $scope.param.dbq_value;
                            item.discount = item.item_discountByQuantity_value;
                            if (Math.abs(item.discount) > 0.01){
                                item.discountReason = "Quantity Discount Applied";
                            }
                            break;
                        default:
                            item.discountReason = null;
                            break;
                    }
                    if ($scope.param.item_remarks === "" && item.discountReason != null){
                        $scope.param.item_remarks = item.discountReason;
                    }
                }

                //* 4. Taxes
                _.each($scope.itemtaxes,function(tax){
                    var t = _.findWhere(item.taxes, {ID: tax.ID});
                        if(t.item_applicable != tax.item_applyFlag){
                            isItemChanged = true;
                        }
                    t.item_applicable =  tax.item_applyFlag?true:false;
                });

                //* 5. Remarks
                if($scope.param.item_remarks !== item.remarks){
                    isItemChanged = true;
                    item.remarks = $scope.param.item_remarks;
                }
                //* 6. Returns
                if($scope.param.item_returnFlag!= item.returnFlag){
                    isItemChanged = true;
                    item.returnFlag = $scope.param.item_returnFlag;
                }
                //Save and Update the Product Only when Item props has changed
                if(isItemChanged)   saveAndRefreshProduct(item);

                $scope.positemoptionmodal.hide();
            };

            function _getInventoryDataByProductID(id){
                var def = $q.defer();
                var reqParam = prodFctr.inventory.param;
                reqParam.prodID = id;
                reqParam.forceLoad = $f.ForceLoad;
                //After API Changes, Complete Inventory for a product will only be sent back ,
                //if you skip store Number in Request param
                reqParam.skipStore = true;
               // reqParam.getInventoryForThisStore = storeID;
                prodFctr.inventory.$get(reqParam).then(function (data) {
                    var val = data.Available;
                    def.resolve(data);
                }, function (data) {
                    //No Inventory Data could be retrieved
                    popupFctr.alert('Error','Inventory of Product could not be loaded','barcodeInput');
                });
                return def.promise;
            };

            $scope.showPosOptions = function(){
                //Add Default Values or Precursor Values
                $scope.showtransactionoption= false;
                $scope.param.transaction_remarks = $scope.manager.transaction.remarks;
                $scope.showremarksoption = false;
                $scope.showtaxoption = false;
                $scope.showdiscountoption = false;
                $scope.showstaffoption = false;
                $scope.showcustomeroption = false;
                $scope.showreturnoption = false;
                $scope.showvoidtransactionoption = false;
                $scope.voidtransactionoptionoption={isCheck:false};
                $scope.rightsText = '';
                $scope.rightsCode = 0;
                //1. For Taxes (By Default All Taxes are applied,if they have not been applied previously)
                _.each($scope.manager.transaction.taxes,function(tax){
                     tax.applyFlag = tax.applicable;
                });
                //2. discounts
                $scope.param.dba_value = $scope.manager.transaction.posOption_discountByAmount_value;
                $scope.param.dbp_value = $scope.manager.transaction.posOption_discountByPercentage_value;
                $scope.manager.transaction.posOption_discountBy = $scope.param.dba_value==null?"discountbypercentage":"discountbyamount";

                //when POS Options is submitted, This Param will be used to check whether Discount Option Values were changed
                $scope.param.current_posOption_discountBy = $scope.manager.transaction.posOption_discountBy;
                //console.log($scope.manager.transaction.posOption_discountBy);
                $scope.posoptionmodal.show();

                //returns
                $scope.param.returnFlag = $scope.manager.transaction.returnFlag;
            };

            $scope.hidePosOptions = function () {
                $scope.transaction_popover.hide();
                $scope.posoptionmodal.hide();
            };

            $scope.onSelectVoidTransaction = function(){
              var confirmPopup = $ionicPopup.confirm({
                 title: 'Void This Transaction',
                 template: 'Are you sure you want to Void this transaction?',
                 cancelType: 'custom-popup-buttons'
              });
             confirmPopup.then(function (res) {
                 if (res) {
                   $scope.voidtransactionoptionoption.isCheck=true;
                   $scope.hidePosOptions();
                   $scope.voidThisTransaction();
                  }
                 else {
                   $scope.voidtransactionoptionoption.isCheck=false;
                 }
             });
            }

            $scope.voidThisTransaction =  function(){
                    console.log('Transaction sent to API');
                    $ionicHistory.clearHistory();
                     $scope.manager.transaction.status = 1;
                    //posFctr.transaction.$save($scope.manager.transaction).then(function (t){
                        posFctr.transaction.$delete(JSON.stringify($scope.manager.transaction.number),$scope.manager.transaction.type);
                        localScanService.Reset(JSON.stringify($scope.manager.transaction.number),$scope.manager.transaction.type)

                        $ionicLoading.show({
                            template:'This transaction has been voided<br/> wait...'
                        });
                           $timeout(function(){
                             $state.go('pos.assignstore');
                            $ionicLoading.hide();
                        },3000);
            }

            $scope.togglePosOption = function(pos_option){
                switch (pos_option) {
                    case 'tax-option':
                        $scope.showtaxoption = !$scope.showtaxoption;
                        break;
                    case 'discount-option':
                        securityFctr.SecurityAccess(59, 'Discount an Item').then(function(permit){
                            if(permit)
                            $scope.showdiscountoption= !$scope.showdiscountoption;
                        });   
                        break;
                    case 'transaction-option':
                        $scope.showtransactionoption = !$scope.showtransactionoption;
                        $scope.dateNow = Date.now();
                        $scope.clerk = $f.UserInfo.FirstName;
                        $scope.transaction_popover.show();
                        break;
                    case 'remarks-option':
                        $scope.showremarksoption = !$scope.showremarksoption;
                        break;
                    case 'staff-option':
                        $scope.showstaffoption = !$scope.showstaffoption;
                        break;
                    case 'customer-option':
                        $scope.showcustomeroption = !$scope.showcustomeroption;
                        break;
                    case 'item-tax-option':
                        $scope.showitemtaxoption = !$scope.showitemtaxoption;
                        break;
                    case 'item-discount-option':
                        securityFctr.SecurityAccess(59, 'Discount an Item').then(function(permit){
                            if(permit)
                                $scope.showitemdiscountoption= !$scope.showitemdiscountoption;
                            });   
                        break;
                    case 'item-quantity-option':
                        $scope.editQuantity($scope.currentItemIndex);
                        //$scope.showitemquantityoption = !$scope.showitemquantityoption;
                        break;
                    case 'item-price-option':
                        securityFctr.SecurityAccess(79, 'Override a Price').then(function(permit){
                            if(permit){
                                $scope.showitempriceoption = !$scope.showitempriceoption;
                                if($scope.showitempriceoption){
                                    $timeout(function () {
                                        if(document.getElementById("isItemPriceInputText"))
                                            document.getElementById("isItemPriceInputText").focus();
                                    },300);
                                 } else {
                                    $timeout(function () {
                                        if(document.getElementById("isItemPriceInputText"))
                                            document.getElementById("isItemPriceInputText").blur();
                                    },300);
                                  }
                            }
                        });  
                        break;
                    case 'item-remarks-option':
                        $scope.showitemremarksoption = !$scope.showitemremarksoption;
                        break;
                    case 'item-return-option':
                        $scope.showitemreturnoption = !$scope.showitemreturnoption;
                        break;
                    case 'return-option':
                        $scope.showreturnoption = !$scope.showreturnoption;
                        break;
                    case 'item-inventory-option':
                        $scope.showiteminventoryoption = !$scope.showiteminventoryoption;
                        //console.log("Show Inventory :-"+ $scope.showiteminventoryoption);

                        $scope.order = '-Available';
                        $scope.setOrder = function (order) {
                            $scope.order = order;
                        };
                        $scope.sortOrder = function() {
                            // Show the action sheet
                            var sortSheet = $ionicActionSheet.show({
                                buttons: [
                                { text: 'Availability' },
                                { text: 'Store Name' },
                                { text: 'Store Number' }
                                ],
                                cancelText: 'Cancel',
                                cancel: function() {
                                    // add cancel code..
                                    },
                                buttonClicked: function(index) {
                                switch (index){
                                    case 0 :
                                        $scope.setOrder('-Available');
                                        return true;
                                    case 1 :
                                        $scope.setOrder('Store.Info.Name');
                                        return true;
                                    case 2 :
                                        $scope.setOrder('Store.Code');
                                        return true;
                                }
                                }
                            });
                        };

                        if($scope.showiteminventoryoption && _.isEmpty($scope.iteminventorycontent) ){
                            var item = $scope.items[$scope.currentItemIndex];
                            _getInventoryDataByProductID(item.product.ID).then(
                                function(inventoryData){
                                    $scope.showiteminventorydata = true;
                                    $scope.iteminventorycontent = inventoryData;
                                    //console.log("Inventory Data fetched from Server:-"+inventoryData);
                                });
                        }
                        break;
                    case 'void-transaction-option':
                        $scope.showvoidtransactionoption = !$scope.showvoidtransactionoption;
                        if($scope.showvoidtransactionoption){
                            $timeout(function () {
                            if(document.getElementById("voidTrans"))
                                document.getElementById("voidTrans").scrollIntoView();
                            },300);
                        }
                        break;
                    default:
                }
            };
            function evaluateTaxesOption(){
                var def = $q.defer();
                var itemLevelTaxesExist = false;
                _.each($scope.manager.transaction.taxes,function(tax){
                    if(!itemLevelTaxesExist){
                        _.each($scope.manager.transaction.products, function (p) {
                            if(!itemLevelTaxesExist){
                                _.each(p.taxes, function (t) {
                                    if(t.ID === tax.id){
                                        if(t.item_applicable != tax.applicable){
                                            //This means Item Level Taxes Exist
                                            console.log("Item Level Taxes Exists");
                                            itemLevelTaxesExist = true;
                                        }
                                    }
                                });
                            }
                        });
                    }
                });
                //If Item Level taxes are applied and Main taxes have changed ,
                // prompt the user for his action
                var taxeschanged = isTaxesChanged();
                if(itemLevelTaxesExist && taxeschanged){
                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Apply New Taxes',
                        template: 'Clear all existing taxes and apply new Taxes?'
                    });
                    confirmPopup.then(function (res) {
                        if (res) {
                            //If Operator wants to use Master Taxes, Clear Item level Taxes and apply master
                            applyMasterTaxes();
                            def.resolve(true);
                        }
                    });
                }
                //This Scenario is for First Time Taxes application or when Item Level taxes are not there
                else if(taxeschanged){
                    applyMasterTaxes();
                    def.resolve(true);
                }
                else{
                    def.resolve(true);
                }
                return def.promise;
            };
            function evaluateDiscountOption(){
                var def = $q.defer();
                //console.log('POS Discount: '+$scope.manager.transaction.posOption_discountBy);
                //console.log($scope.param.dba_value+"-"+$scope.param.dbp_value);

                //When Operator Submits Main POS options, check if any previous ITEM discounts were applied
                //If So, Prompt opertor if he wishes to clear prev
                var itemLevelDiscountExists = false;
                _.each($scope.manager.transaction.products,function(p){
                    if(p.item_discountByAmount_value!=null || p.item_discountByPercentage_value!=null ||
                        p.item_discountByQuantity_value!=null) itemLevelDiscountExists = true;
                });
                if(itemLevelDiscountExists && isDiscountsChanged()){
                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Apply New Discounts',
                        template: 'Clear all existing discounts and apply new discount?'
                    });
                    confirmPopup.then(function (res) {
                        if (res) {
                            //If Operator wants to use Master Discount, Clear Item level discounts and apply master
                            clearAllItemLevelDiscounts();
                            applyMasterDiscount();
                            def.resolve(true);
                            //applyAndSavePOSOptions();
                        }
                        /*else{
                            applyAndSavePOSOptions();
                            //Operator chooses NO, Dont apply new discounts
                            //Leave the discount structure as it is
                        }*/

                    });
                }
                else{
                    //If no prev discounts existed,apply master tax without any prompt
                    applyMasterDiscount();
                    def.resolve(true);
                    //applyAndSavePOSOptions();
                }
                return def.promise;
            };
            function evaluateReturnOption(){
                if($scope.param.returnFlag != $scope.manager.transaction.returnFlag){
                     $scope.manager.transaction.returnFlag = $scope.param.returnFlag;
                    _.each($scope.manager.transaction.products, function (p) {
                        p.returnFlag = $scope.manager.transaction.returnFlag;
                    });
                }
            }
            $scope.applyPosOptions = function(){
                //1.Retrieve Tax option Values
                //Check if any Item Level Taxes exist
                evaluateTaxesOption().then(function(data){
                    //2. Retreive Discount options
                    evaluateDiscountOption().then(function(data){
                       $scope.manager.transaction.remarks = $scope.param.transaction_remarks;
                       evaluateReturnOption();
                       applyAndSavePOSOptions();
                    });
                });
            };

            function isTaxesChanged(){
                var changed = false;
                if(!changed){
                    _.each($scope.manager.transaction.taxes,function(tax){
                        if(tax.applyFlag != tax.applicable){
                            changed= true;
                        }
                    });
                }
                return changed;
            };
            function applyMasterTaxes(){
                _.each($scope.manager.transaction.taxes,function(tax){
                    tax.applicable =  tax.applyFlag?true:false;
                    _.each($scope.manager.transaction.products, function (p) {
                        _.each(p.taxes, function (t) {
                            if(t.ID === tax.id){
                            t.item_applicable = tax.applicable;
                            }
                        });
                        localScanService.UpdateScan(p,$scope.manager.transaction.type);
                    });
                });
            }
            function isDiscountsChanged(){
                var changed = false;
                if(   ($scope.param.current_posOption_discountBy != $scope.manager.transaction.posOption_discountBy)
                   || ($scope.manager.transaction.posOption_discountByPercentage_value != $scope.param.dbp_value)
                   || ($scope.manager.transaction.posOption_discountByAmount_value != $scope.param.dba_value) ){
                    changed = true;
                }
                //console.log("HMG Discounts Changed: "+changed);
                return changed;
            }
            function applyAndSavePOSOptions(){
                saveAndRefreshTransaction();
                $scope.hidePosOptions();
            }
            function applyMasterDiscount(){
                $scope.param.dbp_value = $scope.param.dbp_value==null?0:$scope.param.dbp_value;
                $scope.param.dba_value = $scope.param.dba_value==null?0:$scope.param.dba_value;
                $scope.param.dbq_value = $scope.param.dbq_value==null?0:$scope.param.dbq_value;
                switch ($scope.manager.transaction.posOption_discountBy) {
                    case 'discountbypercentage':
                        $scope.manager.transaction.posOption_discountByAmount_value = null;
                        $scope.manager.transaction.posOption_discountByPercentage_value = $scope.param.dbp_value;
                        //When we apply Discounts By percentage,
                        //All Previous Discounts Applied by Amount(if any) Should be Quashed
                        /*_.each($scope.manager.transaction.products, function (p) {
                            //clear the HMG level discounts only
                            if(p.discount>0 && (p.item_discountByAmount_value!=null || p.item_discountByPercentage_value!=null) ){
                                p.discount = 0;
                            }
                        });*/
                        break;
                    case 'discountbyamount':
                        $scope.manager.transaction.posOption_discountByPercentage_value = null;
                        $scope.manager.transaction.posOption_discountByAmount_value = $scope.param.dba_value;
                        //Apply discount by Amount here only,
                        //as we need to update products to Database with resp discount
                        //_refershProductDiscount();
                        break;
                    default:
                        break;
                }
            }
            function clearAllItemLevelDiscounts(){
                _.each($scope.manager.transaction.products,function(p){
                    p.item_discountBy = null;
                    p.item_discountByAmount_value = null;
                    p.item_discountByPercentage_value = null;
                    p.item_discountByQuantity_value = null;
                    p.discountModifiedByHand = true;
                    localScanService.UpdateScan(p,$scope.manager.transaction.type);
                });
            }
            /*function _refershProductDiscount(){
                _.each($scope.manager.transaction.products, function (p) {
                            var discount = 0;
                            p.discount = parseFloat( ($scope.manager.transaction.posOption_discountByAmount_value/$scope.manager.transaction.subTotal) * (p.Quantity * p.RetailPrice)  );
                            console.log("DiscountbyA: B4"+ p.barcode+" : "+p.discount);
                            p.discount = p.discount>0 ? Math.round(p.discount * 100) / 100 : p.discount;
                            console.log("DiscountbyA: "+ p.barcode+" : "+p.discount);
                            localScanService.UpdateScan(p,3);
                });
            }*/
            function saveAndRefreshTransaction(product){
                posFctr.transaction.$save($scope.manager.transaction)
                $scope.manager.$refresh();
            }
            function saveAndRefreshProduct(product){
                localScanService.UpdateScan(product,$scope.manager.transaction.type);
                $scope.manager.$refresh();
            }
            $scope.setBarcodeTextFieldBulr = function(){
                $timeout(function () {
                    if(document.getElementById("barcodeInput"))
                        document.getElementById("barcodeInput").blur();
                },1);

            }
            $scope.setBarcodeTextFieldFocus = function(){
                $timeout(function () {
                if(document.getElementById("barcodeInput"))
                    document.getElementById("barcodeInput").focus();
                },400);
            }
            $scope.GetPicture = function (item) {
                if (item == null ) return;
                if (_.isEmpty(item.images) && _.isEmpty(item.barcodeImages)) return;
                if (item.barcodeImages != null && item.barcodeImages[0].value == $f.PhotoNotAvail) {
                    item.barcodeImages = null;
                }
                return (item.barcodeImages == null) ? item.images[0].value : item.barcodeImages[0].value;
            };
            $ionicModal.fromTemplateUrl('imgModal.html',
                function (modal) {
                    $scope.gridModal = modal;
                },
                {
                    scope: $scope,
                    animation: 'slide-in-up'
                }
            );
            // open image modal
            $scope.openModal = function (selected) {
                if(selected instanceof Object)
                    $scope.data.selected =selected;
                else
                $scope.data.selected = {
                    value:selected
                };
                $scope.gridModal.show();
            };
            // close image modal
            $scope.closeImgModal = function () {
                $scope.gridModal.hide();
            };


            $ionicPopover.fromTemplateUrl('modules/pos/templates/pos-tax-detail.html', {
                scope: $scope
            }).then(function (popover) {
                $scope.totalPopOver = popover;
            });

            $ionicPopover.fromTemplateUrl('pos-option.html', {
                scope: $scope
            }).then(function (popover) {
                $scope.optionPopOver = popover;
            });

            $ionicModal.fromTemplateUrl('customer-detail.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.customerModal = modal;
            });

            $ionicModal.fromTemplateUrl('customer-selection.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.selectCutstomer = modal;
            });
            $ionicModal.fromTemplateUrl('customer-extra-details.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.selectShowCutstomerExtraDetails = modal;
            });

            //0  > Required
            //1  > Optional
            //2  > Not required
            $scope.customerMode = $f.moduleSetting.pos.customerMode;

            $scope.go = function () {
                $scope.selectCutstomer.hide();

                if (_newCustomer) {
                    delete _newCustomer['$$hashKey'];
                    $scope.manager.transaction.customer = _newCustomer;
                    posFctr.transaction.$save($scope.manager.transaction);
                }
            };

            $rootScope.$on('selCustomer.selected', function (e, item) {
                _newCustomer = item;
            });

            $scope.$on('$destroy', function () {
                $scope.selectCutstomer.remove();
            });

            $scope.cancel = function () {
                _newCustomer = null;
                $scope.selectCutstomer.hide();
            };
            $scope.posCustomer=[];

            $scope.salutations = null;

            $scope.showSelectCustomerExtraDetails = function (){
                salutationSrv.get().then(function (data) {
                    $scope.salutations = data;
                    $ionicLoading.hide();
                });

                //$scope.posCustomer = $scope.manager.transaction.customer;
                //console.log($scope.manager.transaction.customer);
                $rootScope.$broadcast("aralco.posContainerCtrl.updateCustomerInfo", $scope.manager.transaction.customer.ID);
                $ionicLoading.show({
                    template:'wait...'
                })
            }

            $scope.$on('aralco.customer.customerInfoUpdated', function (event, data) {
                //console.log(event.name);
                //console.log(data);
                $scope.posCustomer = data;
                $ionicLoading.hide();
                $scope.selectShowCutstomerExtraDetails.show();
            });

            $scope.phoneNumberValidation = function(tel, type){
                // tel =$filter('tel')(tel);
                if(type === 'Mobile'){
                    $scope.posCustomer.Contact.Contact.Mobile1 = tel;
                } else {
                    $scope.posCustomer.Contact.Contact.Phone1 = tel;
                }
            };

            $rootScope.$on('customer.ok-customer-update', function (event, data) {
                if(!_.isNull($scope.manager.transaction.customer.image) ){
                    var imgTemp = $scope.manager.transaction.customer.image;
                }
                $scope.manager.transaction.customer = data;
                $scope.manager.transaction.customer.image = imgTemp;
                $scope.selectShowCutstomerExtraDetails.hide();
            });
            $scope.customerExtraDetailsOkButton = function (){
                $scope.selectShowCutstomerExtraDetails.hide();
            }
            $scope.customerExtraDetailsCancelButton = function (){
                $scope.selectShowCutstomerExtraDetails.hide();
            }
            $scope.showSelectCustomer = function () {
                $scope.optionPopOver.hide();
                _newCustomer = null;
                $scope.selectCutstomer.show();
            };

            $scope.removeCustomer = function () {
                $scope.optionPopOver.hide();
                var message = $filter('translate')('Are you sure you want to remove the current customer?');
                popupFctr.confirm(message).then(function (result) {
                    if (result === true) {
                        $scope.optionPopOver.hide();
                        $scope.manager.transaction.customer = null;
                    }
                });
            };

            $scope.showCustomerDetail = function () {
                $scope.customerModal.show();
            };

            $scope.pay = function () {
                $scope.manager.transaction.register = $f.moduleSetting.pos.Register;
                $scope.manager.transaction.settings = $f.moduleSetting.pos.Settings;
                $scope.manager.transaction.session = $f.moduleSetting.pos.Session;
                posFctr.transaction.$save($scope.manager.transaction).then(function (t) {
                    //$state.go('pos.pay', {'tid': t});
                    window.location.href='#/pos/pay/'+$scope.manager.transaction.number;
                });
            };

            $scope.departments_modal = $ionicModal.fromTemplate('<div pos-departments></div>', {
                scope: $scope,
                animation: 'slide-in-up'
            });
            $ionicModal.fromTemplateUrl('modules/pos/templates/pos-department-products.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.dept_products_modal = modal;
            });

            $scope.param.isNextDepAvailable = false;
            $scope.param.isPrevDepAvailable = false;

            $scope.filteredDepartments = [];
            $scope.loadDepartments = function(){
                $scope.param.departmentsearch ="";
                $scope.param.limit=15;
                $scope.param.begin =0;
                $scope.copyBeginValue= 0;
                $ionicLoading.show({
                    template:'wait...'
                })
                if(_.isEmpty($scope.departments)){
                    departmentFctr.$LoadDepartments().then(function(data){
                        $scope.departments = [];
                        data =  _.sortBy( data, 'Name' );
                        //temporary Probably
                        _.each(data,function(department){
                            //department.Image = './img/logo-barcode.png';
                            $scope.departments.push(department); //.push({ID:department.ID,Name: department.Name, image: department.Image});
                        });
                        if($scope.departments.length>$scope.param.limit)
                            $scope.param.isNextDepAvailable = true;
                         $scope.filteredDepartments =  $scope.departments
                        //console.log(data);
                        $ionicLoading.hide();
                        $scope.departments_modal.show();
                        departmentFctr.$LoadDepartmentImages($scope.departments.slice($scope.param.begin,$scope.param.begin+$scope.param.limit));
                        //$scope.LoadDepartmentImages();
                    }
                    ,function (error) {
                        popupFctr.alert('Not found', 'Product not found','barcodeInput');
                        $ionicLoading.hide();
                    });
                } else {
                    $ionicLoading.hide();
                    $scope.departments_modal.show();
                }
            }
            /*********************************************** */
            //*Fetch Products using Department ID **/

            $scope.loadProductsByDepID = function(id){
              //$scope.selecteddepartment = _.findWhere($scope.departments,ID:id);
                if (id!=null) {
                    $ionicLoading.show({
                        template:'wait...'
                    });
                    $scope.param.input = id;
                    $scope.param.store = $f.moduleSetting.pos.Store.ID;
                    $scope.param.MoreAvailable = false;
                    $scope.param.includePictures= true;
                    $scope.param.mode = 6;
                    $scope.param.TotalFound = null;
                    $scope.param.page = 0;
                    $scope.param.ExcludeDeactivated = true;
                    $scope.param.CustomerID = $scope.manager.transaction.customer!=null ?$scope.manager.transaction.customer.ID:null;
                    $scope.loadMore(true).then(function () {
                        $ionicLoading.hide();
                        $scope.dept_products_modal.show();
                    }, function () {
                        $ionicLoading.hide();
                    });
                    $scope.departments_modal.hide();
                }
            };

            // Assuming that loading MORE means, something has already been loaded right?
            $scope.loadMore = function (firstLoad = false) {
                if ($scope.param.input != null) {

                    // If this is the first load the start with the first page which is 0.
                    // Note for future developers: when you start developing, assume that the function doesn't work to begin with, it will save you time
                    $scope.param.page += firstLoad ? 0:1;
                    
                    return prodFctr.Retrieve.$search($scope.param)
                        .then(function (searchResult) {
                            if ($scope.param.page == 0) {
                                $scope.dept_products = [];
                            }
                            if (!_.isEmpty(searchResult.Result)) {
                                $scope.param.TotalFound = searchResult.Total || searchResult.Result.length;
                                $scope.param.MoreAvailable = searchResult.MoreAvailable || false;
                                _.each(searchResult.Result, function (p) {
                                    if (!_.isEmpty(p.images)) {
                                        //p.image = {value: p.images[0].value};
                                        p.image=p.images[0].value;
                                        p.MainImage = p.images[0];
                                    }
                                    p.Quantity=1;
                                    p.countAdded=0;
                                    $scope.dept_products.push(p);
                                });
                            } else {
                                popupFctr.alert('No Products', 'No products found for this department');
                            }
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        });
                }
            };
            $scope.moreDataCanBeLoaded = function () {
                return _.isEmpty($scope.param) ? false : $scope.param.MoreAvailable || false;
            };
            $scope.addProduct = function(prod){
                $scope.currentDepttProduct = prod;
                $ionicLoading.show({
                    template: 'wait...'
                });
                //If we already have a Barcode, No Need to Check For Product Grids and Barcode,
                //We can directly Add the Product
                if(!_.isEmpty(prod.Barcode)){
                    _addProductToTransaction(prod).then(function(val){
                        $ionicLoading.show({
                            template:"<i class='icon ion-checkmark-circled'></i>  Product Added Successfully"
                        })
                        $timeout(function(){
                            $ionicLoading.hide();
                        },2400);
                        $ionicLoading.hide();
                     });
                } else {
                  //debugger;
                    prodSearchFctr.$selectProductGrids(prod).then(function(barcode){
                        var customerID = $scope.manager.transaction.customer!=null ?$scope.manager.transaction.customer.ID:null;
                        prodFctr.Retrieve.$getByBarcode(barcode,undefined,$f.moduleSetting.pos.Store.ID,customerID).then(function(product){
                            console.log('barcode found: '+barcode);
                            product.Quantity = prod.Quantity;
                            //$scope.param.barcode = barcode;
                            //$scope.find();
                            _addProductToTransaction(product).then(function(val){
                                /*$ionicLoading.show({
                                    template:"<i class='icon ion-checkmark-circled'></i>  Product Added Successfully"
                                })
                                $timeout(function(){
                                    $ionicLoading.hide();
                                },2400);*/
                                $ionicLoading.hide();
                            })
                        });
                    },function (error) {
                        $ionicLoading.hide();
                        console.log('product Dimensions could not be retrieved!')
                    });
                }
            };

            $scope.incrementQuantity = function(item){
                item.Quantity+=1;
            }
            $scope.decrementQuantity = function(item){
                item.Quantity = item.Quantity>1?(item.Quantity-1):item.Quantity;
            }
            /************************************************ */

            /**
             * Find a product by barcode/Name
             *
             * Perform an API product lookup by barcode based on the contents
             * of $scope.findBarcode.
             *
             */
            $scope.find = function () {
                if(_.isEmpty($scope.param.barcode)){
                    $scope.loadDepartments();
                    return;
                }
                $scope.setBarcodeTextFieldBulr();
                $ionicLoading.show({
                    template: 'wait...'
                });
                /// <summary>
                /// Find the inserted barcode
                /// </summary>
                var barcode = $scope.param.barcode || '';

                errorFctr.specificallyHandled(function () {
                   if (!_.isEmpty(barcode) && !_.isNull(barcode)) {
                       var customerID = $scope.manager.transaction.customer!=null ?$scope.manager.transaction.customer.ID:null;
                       prodSearchFctr.$scan(barcode,$f.moduleSetting.pos.Store.ID,customerID).then(function (prod) {
                           _addProductToTransaction(prod);
                       }, function (error) {
                           //$scope.setBarcodeTextFieldBulr();
                           $ionicLoading.hide();
                           popupFctr.playNotificationSound();
                           popupFctr.alert('Error', error,'barcodeInput');
                           //$scope.setBarcodeTextFieldFocus();
                       });
                   }
                });
            };

            var _addProductToTransaction = function(prod){
                var def = $q.defer();
                if (prod == null) {
                    //$scope.setBarcodeTextFieldBulr();
                    $ionicLoading.hide();
                    popupFctr.playNotificationSound();
                    popupFctr.alert('Not found', 'Product not found','barcodeInput');
                    def.reject('Product not found');
                    //$scope.setBarcodeTextFieldFocus();
                } else {
                    $scope.items = $scope.items || [];
                    prod.Quantity = prod.Quantity|| 1;
                    $ionicLoading.show({
                        template: 'wait...'
                    });
                    if (!_.isEmpty(prod.images)) {
                        //p.image = {value: p.images[0].value};
                        prod.image=prod.images[0].value;
                        prod.MainImage = prod.images[0];
                    }
                    taxFctr.$getByProduct(prod.ID).then(function (taxes) {
                        prod.taxes = taxes;
                        
                        var Scan = prepareScanObject(prod);
                        if(Scan.product.TypeInfo.InventoryItem || Scan.product.Department.Name ==='Grocery' || Scan.product.InventoryBy!=null){
                            //POS Customisation - Ask for quantity in SellBy Units instead of Inventory Units
                            if (Scan.product.SellBy !== null && Scan.product.InventoryBy !== null) {
                                Scan.product.InventoryBy.Code = Scan.product.SellBy.Code;
                            }
                            helperFctr.$enterQuantity($scope,Scan).then(
                                function (quantity) {
                                    Scan.Quantity = quantity;
                                    Scan.count.scanned.count = quantity;
                                    _saveAndAdd(Scan).then(function(){
                                        def.resolve(true)
                                    });
                                    //$ionicLoading.hide();
                                }
                            , function (err) { throw err; })
                        } else {
                            return _saveAndAdd(Scan).then(function(){
                                def.resolve(true)
                            });
                        }
                        $scope.param.barcode = "";
                    });
                }
                return def.promise;
            };
            var _saveAndAdd = function (ns) {
                if(!_.isEmpty($scope.currentDepttProduct)) $scope.currentDepttProduct.countAdded += ns.Quantity;
                return localScanService.SaveScan(ns,$scope.manager.transaction.type).then(
                    function (key) {
                        ns.ScanID = key;
                        $scope.manager.$add(ns); //This somehow refreshes/adds to the $scope.items also
                        //Set Focus to Scan Product Field
                        //document.getElementById("barcodeInput").focus();
                        if(!_.isEmpty($scope.param.barcode)){
                            $scope.param.barcode = "";
                            $scope.setBarcodeTextFieldFocus();
                        }
                        $ionicLoading.hide();
                    }
                , function (err) {
                    $ionicLoading.hide();
                    throw err;
                });
            };


            function prepareScanObject(prod){
                var Scan = new scan(prod);
                _.each($scope.manager.transaction.taxes,function(tax){
                    _.each(prod.taxes, function (t) {
                        if(t.ID === tax.id){
                            t.item_applicable = tax.applicable?true:false;
                        }
                    });
                });
                prod.taxes = prod.taxes.filter(function (t) {
                    return (t.item_applicable == true);
                });
                Scan.product = prod;
                Scan.product.RetailPrice = Scan.product.RetailPrice || prod.MSRP;
                Scan.RetailPrice = prod.RetailPrice || prod.MSRP;
                if(prod.SellBy!=undefined && prod.SellBy.Multiplicator!= undefined && prod.RetailPriceQty!=undefined){
                    Scan.RetailPrice = (prod.RetailPrice * prod.SellBy.Multiplicator )

                }

                Scan.Quantity= prod.Quantity||1;
                Scan.taxes= prod.taxes;

                //Set Tax default Values to POS OPtions
                

                Scan.discount = 0;
                //THis field is added to check ITEM Line Dscount option
                Scan.item_discountBy = null;
                Scan.item_discountByPercentage_value = null;
                Scan.item_discountByAmount_value = null;
                Scan.returnFlag = false; //This Flag is used to check whether iTem is Marked for Returns
                //Scan.transactionNumber = $scope.manager.transaction.number;
                Scan.remarks = "";
                Scan.UserInfo = $f.UserInfo;
                Scan.parentReference = JSON.stringify($scope.manager.transaction.number);
                Scan.count = {
                    manual: {
                        count: 0,
                        modifiedBy: '',
                        modifiedOn: Date.now()
                    },
                    scanned: {
                        count: prod.Quantity||1,
                        modifiedBy: $f.UserInfo.FullName(),
                        modifiedOn: Date.now(),
                        manuallyUpdated: false
                    }
                };
                return Scan;
            }

            //delete Scanned Item Function
            $scope.deleteItem = function (index) {
                document.getElementById("barcodeInput").blur();
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Delete',
                    template: 'Are you sure you want to delete the item with barcode ' + $scope.items[index].barcode + '?'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        localScanService.DeleteScan($scope.items[index],$scope.manager.transaction.type).then(function () {
                            //$scope.items.splice(index, 1);
                            $scope.manager.$remove(index);
                            //Set Focus to Scan Product Field
                            //document.getElementById("barcodeInput").focus();
                            $scope.setBarcodeTextFieldFocus();
                        }, function () { throw ex; })
                    }
                });
            };

            $scope.updateQuantityDiscount = function (item) {
                var defer = $q.defer();
                $scope.param.dbq_value = null;
                if ($scope.param.item_remarks === "Quantity Discount Applied"){
                    $scope.param.item_remarks = "";
                }
                if (item.discountReason === "Quantity Discount Applied"){
                    item.discountReason = null;
                }
                if (item.discountModifiedByHand !== true){
                    prodFctr.getProductQuantityDiscounts(item.product.ID, item.Quantity).then(function (result) {
                        if (result !== "" && Math.abs(result) > 0.01) {
                            $scope.param.dbq_value = result;
                            $scope.param.dba_value = null;
                            $scope.param.dbp_value = null;
                            item.item_discountBy = "discountbyquantity";
                        } else {
                            $scope.param.dbq_value = null;
                            if ($scope.param.dbq_value !== "" || $scope.param.dba_value !== "0"){
                                $scope.param.dbq_value = 0;
                            }
                        }
                        defer.resolve(item);
                    });
                }
                return defer.promise;
            };

            $scope.editQuantity = function (index, quantity) {
                //var item = $scope.items[index]
                $scope.setBarcodeTextFieldBulr();
                var item =  $scope.manager.transaction.products[index];
                var editItemInputRequest = function (res) {
                    if(myPopup)
                        myPopup.close();
                    //$scope.setBarcodeTextFieldFocus();
                    if (!_.isNaN(res) && res>=0) {
                        item.Quantity = res;
                        item.count.scanned = {
                            manuallyUpdated: true,
                            modifiedOn: Date.now(),
                            count: res,
                            modifiedBy: $f.UserInfo.FullName()
                        };
                        $scope.updateQuantityDiscount(item).then(function (newItem) {
                            item = newItem;
                            localScanService.UpdateScan($scope.items[index],$scope.manager.transaction.type).
                            then(function (item) {
                                    //Set Focus to Scan Product Field
                                    //document.getElementById("barcodeInput").focus();
                                    $scope.setBarcodeTextFieldFocus();
                                },
                                function (ex) { throw ex });
                            $scope.manager.$refresh();
                        });
                    }
                };

                //We are not prepopulating the Qty Input field with Existing count.
                $scope.data.quantity = null;
                $scope.editItemInputEnterEvent = function (e) {
                    if (!$scope.data.quantity && $scope.data.quantity>=0) {
                        //don't allow the user to close unless he enters wifi password
                        e.preventDefault();
                    } else {
                        editItemInputRequest($scope.data.quantity);
                    }
                };

                var myPopup = $ionicPopup.show({
                    template: '<input focus-me focus-me-disable={{false}}  type="number"  min="0" inputmode="numeric" data-ng-enter="editItemInputEnterEvent($event)" ng-pattern="/^[0-9]+(\.[0-9]{1,2})?$/" step="0.01" ng-model="data.quantity">',
                    title: 'Change quantity',
                    subTitle: 'Modify scanned quantity for item ' + $scope.items[index].barcode,
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'custom-popup-buttons'
                        },
                        {
                            text: '<b>Save</b>',
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.data.quantity && $scope.data.quantity>=0) {
                                    //don't allow the user to close unless he enters wifi password
                                    e.preventDefault();
                                } else {
                                    return $scope.data.quantity;
                                }
                            }

                        }
                    ]
                });
                if (quantity){
                    editItemInputRequest(quantity)
                } else {
                    myPopup.then(function (res) {
                        //if (!_.isNaN(res) && !_.isEmpty(res)) {
                        editItemInputRequest(res);
                    });
                }
            };

            $scope.editItem = function(index){
                $scope.showPosItemOptions(index);
            };

            //Reset Function
            $scope.Reset = function(){
                var message = $filter('translate')('Are you sure you want to reset current Transaction?');
                popupFctr.confirm(message).then(function (result) {
                    if (result) {
                    // DB.restart();
                        localScanService.Reset(JSON.stringify($scope.manager.transaction.number),$scope.manager.transaction.type)
                        .then(function(){
                            $scope.manager.transaction.products = [];
                            Init();
                        });
                    }      
                });
            }

            $scope.toggleReader = function () {
                $scope.usereader = !$scope.usereader;
                $scope.findBarcode = "";
            };

            $scope.$watchCollection("transaction.items", function (newValue, oldValue) {
                $scope.manager.$refresh();
            }, true);

            
            //Find a giftcard by code
            $scope.findGiftCard = function () {
                if(_.isEmpty($scope.param.giftcard)){
                    //$scope.loadDepartments();
                    return;
                }
                $scope.setBarcodeTextFieldBulr();
                $ionicLoading.show({
                    template: 'wait...'
                });
                /// <summary>
                /// Find the inserted giftcard code
                /// </summary>
                var giftCard = $scope.param.giftcard || '';

                errorFctr.specificallyHandled(function () {
                    if (!_.isEmpty(giftCard) && !_.isNull(giftCard)) {
                        //var customerID = $scope.manager.transaction.customer!=null ?$scope.manager.transaction.customer.ID:null;
                        // Check if this giftcard exists
                        giftCardFctr.GetBalance(giftCard).then(function (result) {
                            $ionicLoading.hide();
                            // If it does then display current amount;
                            var msg = (!_.isEmpty(result)) ? '(Current Amount: ' + result.Available + ') ' : '';
                            msg += 'Amount to load:'
                            helperFctr.enterNumber($scope, msg).then(function(number){
                                var prod = {};
                                prod.Name = 'Gift Card';
                                prod.Barcode = result.GiftCardNo || $scope.param.giftcard;
                                prod.Quantity = 1;
                                
                                prod.RetailPrice = number;
                                prod.parentReference = JSON.stringify($scope.manager.transaction.number);

                                var Scan = new scan(prod);
                                Scan.count = {
                                    manual: {
                                        count: 0,
                                        modifiedBy: '',
                                        modifiedOn: Date.now()
                                    },
                                    scanned: {
                                        count: 1,
                                        modifiedBy: $f.UserInfo.FullName(),
                                        modifiedOn: Date.now(),
                                        manuallyUpdated: false
                                    }
                                };
                                Scan.type = $f.pos_choiceType;
                                Scan.Quantity = 1;
                                Scan.RetailPrice = number;
                                Scan.count.scanned.count = 1;
                                return _saveAndAdd(Scan).then(function(){
                                    $scope.param.giftcard = "";
                                });
                            });
                        }, function (error) {
                            $ionicLoading.hide();
                            popupFctr.playNotificationSound();
                            popupFctr.alert('Error', error,'barcodeInput');
                        });
                    }
                });
            };
            
        }]);
