/// <reference path="../../../js/models/tendKey.js" />
angular.module('aralco.pos.controllers').controller('posEnd', ['$scope', '$q','$window', '$timeout', 'sessionFctr', 'settingFctr', 'popupFctr', 'posFctr', '$ionicLoading', '$ionicHistory', '$ionicModal', 'helperFctr', '$ionicPopup',
    function ($scope, $q, $window, $timeout, sessionFctr, settingFctr, popupFctr, posFctr, $ionicLoading, $ionicHistory, $ionicModal, helperFctr, $ionicPopup ) {
        Init();

        function Init(){
            $ionicLoading.show({
                template:'wait...'
            });
            $scope.tendKeys = []; 
            $scope.param = [];
            $scope.countedTendKeys = [];
            $scope.eod = [];
            $scope.eod.payments = [];
            $scope.eod.Recorded = 0.00;
            $scope.eod.RecordedwoExch = 0.00;
            $scope.eod.Counted = 0.00;
            $scope.eod.ShortOver = 0.00;
            $scope.eod.ShortOverTitle = '';
            $scope.eod.ShortOverReason = null;
            $scope.transactionMade = false;
            $scope.transMin = 0;
            $scope.transMax = 0;
            $scope.logo = '';

            var calls = [];
            calls.push(sessionFctr.GetRecordedTenders($f.moduleSetting.pos.Session.SessionID, $f.POSSystem.retrieve()));
            calls.push(settingFctr.$getLogo());

            $q.all(calls).then(function (result) {
                _.each(result[0], function (k) {
                    // Change to float included
                    if(k.Code == 'A'){
                        k.Recorded += $f.moduleSetting.pos.sodFloat;
                        k.ExchAmtRecorded = k.Recorded;
                        k.FullDescription += ' (Float incl.)';
                    }
                    k.Counted = 0;
                    k.ShortOver = 0;
                });
                

                
                $scope.tendKeys = result[0];
                
                if(result[1] != null)
                        $scope.logo += result[1].value;;
                $ionicLoading.hide();
                
                $scope.eod.Recorded = totalRecorded(); 
                $scope.eod.RecordedwoExch = totalRecordedwoExch();  
            });
        }

        $ionicModal.fromTemplateUrl('modules/pos/templates/pos-end-day-receipt.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
                $scope.printReceiptModal = modal;
        });

        $scope.countInput = function(key){
            var msg = key.FullDescription + ' counted:';
            $scope.param.number = key.ExchAmtRecorded;
            helperFctr.enterNumber($scope, msg).then(function(number){
                
                // Remove old value from the list
                $scope.countedTendKeys = $scope.countedTendKeys.filter(function ( obj ) {
                    return obj.Code != key.Code;
                });
                // Re-select tender key from the original list
                var tenderKeyorg = $scope.tendKeys.filter(function ( obj ) {
                    return obj.Code == key.Code;
                })[0];

                var tenderKey = new tendKey(tenderKeyorg);
                // Round Values
                if(tenderKey.Recorded != tenderKey.ExchAmtRecorded)
                    tenderKey.ExchangeRate = Math.abs(tenderKey.Recorded / tenderKey.ExchAmtRecorded);
                tenderKey.Counted = Math.round(Math.abs(number)* 100)/100;
                tenderKeyorg.Counted = tenderKey.Counted;
                if(tenderKey.ExchangeRate > 1){
                    tenderKey.Exchanged = Math.round(Math.abs(tenderKey.Counted * tenderKey.ExchangeRate)* 100)/100 - Math.abs(tenderKey.Counted);    
                } else {
                    tenderKey.Exchanged = Math.round(Math.abs(tenderKey.Counted * tenderKey.ExchangeRate)* 100)/100;  
                }
                  
                tenderKey.Show = true;
                tenderKey.ShortOver = Math.round(Math.abs(tenderKey.Counted - tenderKey.ExchAmtRecorded)* 100)/100;
                tenderKeyorg.ShortOver = tenderKey.ShortOver;
                // Re-add to the list
                $scope.countedTendKeys.push(tenderKey);
                refresh();
            });
        };
        
        function refresh(){
            $scope.eod.Counted = 0;
            $scope.eod.Counted = totalCounted();
            $scope.eod.ShortOver = totalShortOver();
        }

        function totalRecorded(){
            var recorded = 0;
            _.each($scope.tendKeys, function (t) {
                recorded += t.Recorded;     
            });
            return recorded;
        }

        function totalRecordedwoExch(){
            var recordedwoExch = 0;
            _.each($scope.tendKeys, function (t) {
                recordedwoExch += t.ExchAmtRecorded;     
            });
            return recordedwoExch;
        }

        function totalCounted(){
            var counted = 0;
            _.each($scope.countedTendKeys, function (t) {
                if(t.ExchangeRate > 0){
                    counted += t.Counted*t.ExchangeRate;
                } else {
                    counted += t.Counted;  
                }    
                 
            });
            return counted;
        }

        function totalShortOver(){
            var shortOver = 0;
            _.each($scope.countedTendKeys, function (t) {

                if(t.ExchangeRate > 0){
                    shortOver += t.ShortOver*t.ExchangeRate;
                } else {
                    shortOver += t.ShortOver;
                }  
                
            });
            return shortOver;
        }

        function totalShortOverwExch(){
            var shortOverExch = 0;
            _.each($scope.countedTendKeys, function (t) {
                
                if(t.ExchangeRate > 0){
                    shortOverExch += t.ShortOver*t.ExchangeRate;
                } else {
                    shortOverExch += t.ShortOver
                }

            });
            return shortOverExch;
        }

        function tendKeysTotal(){
            var tendKeyTotal = 0;
            _.each($scope.countedTendKeys, function (t) {
                if(t.ExchangeRate > 0){
                    tendKeyTotal += t.Counted + t.Exchanged;
                } else {
                    tendKeyTotal += t.Counted ;
                }    
            });
            tendKeyTotal += ($scope.eod.eodFloat - $scope.eod.sodFloat);
            return tendKeyTotal;
        }
        
        function totalPayments(payments){
            var totals = [];
            totals.total = 0;
            totals.tax1 = 0;
            totals.tax2 = 0;
            totals.discount = 0;
            totals.returns = 0;
            _.each(payments, function (p) {
                if(p.Amount < 0)
                    totals.returns += p.Amount - p.Tax1 - p.Tax2;
                totals.total += p.Amount;  
                totals.tax1 += p.Tax1; 
                totals.tax2 += p.Tax2;
                totals.discount += p.Discount;    
            });
            return totals;
        }

        function netSale(payments){
            var netSale = 0;
            netSale = payments.total - payments.tax1 - payments.tax2;
            return netSale;
        }

        function sale(payments){
            var sale = 0;
            sale = $scope.eod.taxIncl ? payments.total - payments.returns : (payments.netSale - payments.returns);
            return sale;
        }

        //Save for later
        function bankDeposit(){
            var bankdeposit = 0;
            _.each($scope.countedTendKeys, function (t) {
                if(t.BankDeposit){
                    if(t.ExchangeRate > 0){
                        bankdeposit += t.Counted + t.Exchanged;
                    } else {
                        bankdeposit += t.Counted;  
                    }    
                }
            });
            return bankdeposit;
        }

        function getTranMinMax(payments){
            var tran = 'From Trans to Trans '
            $scope.transMin = !_.isEmpty(payments[0]) ? payments[payments.length-1].TransNo : 0;
            $scope.transMax = !_.isEmpty(payments[0]) ? payments[0].TransNo : 0;
            if(!_.isEmpty(payments))
                tran += payments[payments.length-1].TransNo + ' - ' + payments[0].TransNo;
            return tran;
        }

        function FinishEOD(reason){
            //sessionFctr.GetPaymentTotals(13, '106_A_SRVR-DEV').then(function (result) {
            sessionFctr.GetPaymentTotals($f.moduleSetting.pos.Session.SessionID, $f.POSSystem.retrieve()).then(function (result) {
                // Retrieve information for end of day receipt
                $scope.eod.store = $f.moduleSetting.pos.Store;
                $scope.eod.register = $f.moduleSetting.pos.Register;
                $scope.eod.exchanges = $f.moduleSetting.pos.Exchanges;
                $scope.eod.clerk = $f.UserInfo.FirstName;
                $scope.eod.sodFloat = $f.moduleSetting.pos.sodFloat;
                $scope.eod.date = new Date();
                $scope.eod.ShortOverReason = reason;

                // Check for settings
                var settings = $f.moduleSetting.pos.Settings;         
                var eodFloatSetting = settings.filter(function (s) {return (s.Property == 'MaxFloat');});
                var taxInclSetting = settings.filter(function (s) {return (s.Property == 'PrintTaxNonTaxInfo');});
                $scope.eod.taxIncl = (!_.isEmpty(taxInclSetting[0]) && taxInclSetting[0].Value == 'Yes') ? true : false;
                $scope.eod.eodFloat = (!_.isEmpty(eodFloatSetting[0])) ? Number(eodFloatSetting[0].Value) : $scope.eod.sodFloat;

                $scope.eod.payments = totalPayments(result);
                $scope.eod.payments.netSale = netSale($scope.eod.payments);
                $scope.eod.payments.sale = sale($scope.eod.payments);
                $scope.eod.tranMinMax = getTranMinMax(result);
                _.each($scope.countedTendKeys, function (c) {
                    if(c.ExchAmtRecorded < c.Recorded){
                        var exchange = $scope.eod.exchanges.filter(function (t) {
                            return (t.TenderCode == c.Code || t.Code == c.Code);
                        });
                        c.ExchangeRate = exchange[0].ExchangeRate;  
                        c.Recorded = c.ExchAmtRecorded
                    }
                });
                // Cash float added
                $scope.cashFloatAdd = false;            
                // Float conditions
                // If start of day float is lower than the setting then add extra line into end of day
                if($scope.eod.sodFloat < $scope.eod.eodFloat && $scope.countedTendKeys.length > 0){
                    
                    // Difference in floats
                    $scope.cashFloat = {};
                    
                    _.each($scope.countedTendKeys, function (c) {
                        if(c.Code == 'A'){
                            // If the float can be increased to full amount then increase it
                            if(c.Counted > $scope.eod.eodFloat){
                                $scope.cashFloat = {
                                    FullDescription: "Cash Float",
                                    Counted: Math.round(Math.abs($scope.eod.eodFloat - $scope.eod.sodFloat)* 100)/100,
                                    Show: true,
                                    ShortOver: 0
                                }
                                $scope.cashFloatAdd = true;
                            } else if (c.Counted <= $scope.eod.eodFloat) {
                                $scope.cashFloat = {
                                    FullDescription: "Cash Float",
                                    Counted: Math.round(Math.abs(c.Counted - $scope.eod.sodFloat)* 100)/100,
                                    Show: true,
                                    ShortOver: 0
                                }
                                $scope.eod.eodFloat = c.Counted;
                                c.Show = false;
                            }
                            c.Counted -= $scope.eod.eodFloat;
                            c.Counted = Math.round(Math.abs(c.Counted)* 100)/100;
                            c.Recorded -= $scope.eod.eodFloat;
                            c.Recorded = Math.round(Math.abs(c.Recorded)* 100)/100;
                            c.ExchAmtRecorded -= $scope.eod.sodFloat;
                            c.ExchAmtRecorded = Math.round(Math.abs(c.ExchAmtRecorded)* 100)/100;
                        } else {
                            c.Show = true;
                        }


                    });
                    // If there hasn't been any money allocated to cash float then use the start of day float.
                    if(_.isEmpty($scope.cashFloat)){
                        $scope.eod.eodFloat = $scope.eod.sodFloat;
                    };
                } else {
                    $scope.eod.eodFloat = $scope.eod.sodFloat;
                }
                $scope.eod.tendKeysTotal = tendKeysTotal();
                $scope.eod.TotalShortOverwExch = totalShortOverwExch();

                // ::TODO::
                // ** Will need to get total from depositable tender keys then substract the difference of floats
                $scope.eod.bankDeposit = bankDeposit();


                posFctr.transaction.$setPOSConfigValue('POS_EOD',$scope.eod);
                $f.moduleSetting.pos.eod = $scope.eod;
                $f.moduleSetting.pos.eod.countedTendKeys = $scope.countedTendKeys;
                $scope.printReceiptModal.show();
            });
        }

        $scope.Finish = function (){
            if($scope.countedTendKeys.length != $scope.tendKeys.length){
                popupFctr.alert('Mismatch', 'Please count all currencies');
            } else {
                if($scope.eod.ShortOver != 0){
                    var shortOverMsg = ($scope.eod.ShortOver < 0)? 'short': 'over';
                    var msg = 'Please give a reason for being ' + shortOverMsg;
                    helperFctr.enterText($scope, msg).then(function(reason){
                        $scope.eod.ShortOverTitle = 'Reason for being ' + shortOverMsg + ': ' + reason;
                        FinishEOD(reason);
                    });
                } else {
                    FinishEOD(null);
                }
            }   
        }


        $scope.Receipt = function(){
            $scope.date = new Date();
            $scope.clerk = $f.UserInfo.FirstName;
            $scope.printReceiptModal.show();
         }

         $scope.closePrintModal = function () {
            _.each($scope.countedTendKeys, function (c) {
                if(c.Code == 'A'){
                    c.Counted += $scope.eod.eodFloat;
                    c.Recorded += $scope.eod.eodFloat;
                    c.ExchAmtRecorded += $scope.eod.sodFloat;
                }
            });
            $scope.printReceiptModal.hide();
            if($scope.transactionMade){
                posFctr.transaction.$deletePosConfigurationValue('POS_BOD');
                $f.EndPOSSession();
                $ionicLoading.hide();
                $ionicHistory.clearHistory();           
                window.location.href='#/pos/posstart/';
            }
        };

        $scope.$on('$destroy', function () {
            $scope.printReceiptModal.remove();
        });

        function sendNativeEmailOnAndroidIOS(emailID,subject,body){
            var emailBody = "Hi ,<br/><br/><br/>Please see attached End of Day receipt<br/><br/><br/>";
            emailBody += $scope.eod.store.Info.Name+"<br/>"+$scope.eod.store.Info.Phone1+"<br/>"+$scope.eod.store.Address.address;
            emailBody += '<br/><br/>' + $f.moduleSetting.pos.eod.receipt;

            console.log('Starting Plugins Email');
            cordova.plugins.email.isAvailable(
                function (isAvailable) {
                    console.log(";"+isAvailable);
                    if(isAvailable){
                        console.log('email plugin is available');
                        cordova.plugins.email.open({
                            to:      emailID,
                            subject: subject,
                            body:  emailBody,
                            attachments: 'base64:aralco_eod_' + $scope.transMin + '_' + $scope.transMax +'.html//'+$window.btoa(body),
                            isHtml:  true
                        });
                    }
                    else{
                        console.log('this functionality is not available on this device');
                    }
                }
            );
        }

        $scope.printModal = function(){
            //Print Function Is Invvoked here//
            //Send Transaction to Sql Here itself, disable everything other than Complete Transaction Button
            if(!$scope.transactionMade){
                sendTransactionToBackend().then(function(){
                    $scope.transactionMade = true;
                });
            }
            var htmlContent = '<html>'+document.getElementById('print-content').innerHTML+'</html>';
            if(ionic.Platform.platforms[0]=="browser")
            {
                var mywindow = window.open('', 'Aralco_Receipt_End_of_Day_'+$f.moduleSetting.pos.Session.SessionID+'');
                mywindow.document.write(htmlContent);
                //mywindow.document.close(); // necessary for IE >= 10
                //mywindow.focus(); // necessary for IE >= 10
                mywindow.print();
                $timeout(function () {
                    mywindow.close();
                },150);
            } else {
                cordova.plugins.printer.pick(function (uri) {
                    cordova.plugins.printer.print(htmlContent,{ printerId: uri });
                });
            }
        }
        $scope.emailModal = function(){
            if(ionic.Platform.platforms[0]=="browser")
            {
                $ionicLoading.hide();
                popupFctr.alert('Function Not Available','this functionality is not available on this device');
            } else {
            $scope.sendEmailData = function(){
                if (!$scope.inputEmail.email || $scope.inputEmail.email=='') {
                    return;
                }
                if(EmailPopup!= undefined){
                    document.getElementById("promptInput").blur();
                    EmailPopup.close();
                }

                if(!$scope.transactionMade){
                    sendTransactionToBackend().then(function(){
                        $scope.transactionMade = true;
                    });
                }

                $ionicLoading.show({
                    template:'sending receipt email to <br/><b><i>'+$scope.inputEmail.email
                });
                //Make an API Call Here To send EmailData via API
                var emailHtmlContent = '<html>'+document.getElementById('print-content').innerHTML+'</html>';
                sendNativeEmailOnAndroidIOS($scope.inputEmail.email,$scope.eod.store.Info.Name+' - End of Day Receipt attached',emailHtmlContent)
                $timeout(function(){
                    /*$ionicLoading.show({
                        template:'Email Sent'
                    });*/

                    $ionicLoading.hide();
                },2000);
                //Send Email Logic
            };
            //Check if Email of Customer is Already Present in Transaction
            //Otherwise prompt for EmailId
            $scope.inputEmail = {
                    email:''
            };
            var EmailPopup = $ionicPopup.show({
            template: '<input id="promptInput" autofocus type="email"  data-ng-enter="sendEmailData();"  ng-model="inputEmail.email">',
            title: 'Enter EmailID',
            scope:$scope,
            buttons: [{ text: 'Cancel',
                type: 'custom-popup-buttons'
                },
                {
                    text: '<b>Send</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        if (!$scope.inputEmail.email || $scope.inputEmail.email=='') {
                            e.preventDefault();
                        } else {
                            $scope.sendEmailData();
                        }
                    }
                }]
            });
          }  //$window.open("mailto:"+ 'test@text.com' + "?subject=" + 'testSubject'+"&body="+emailHtmlContent,"_blank");
        };    

        $scope.startEOD = function(){
            sendTransactionToBackend().then(function(data){
                posFctr.transaction.$deletePosConfigurationValue('POS_BOD');
                $f.EndPOSSession();
                $timeout(function() {
                    $ionicLoading.hide();
                    $ionicHistory.clearHistory();
                    window.location.href='#/pos/posstart/';
                }, 2000);
            });
        }

        // Send End of Day to back end ( done this way so the receipt gets created)
        function sendTransactionToBackend(){
            var def = $q.defer();
            $ionicLoading.show({
                template:'End of day completed successfully<br/> wait...'
            });
            $f.moduleSetting.pos.eod.receipt = _buildReceipt($f.moduleSetting.pos.eod);
            sessionFctr.EndOfDay($f.moduleSetting.pos.eod).then(function(data){
                def.resolve(data);
            });
            return def.promise;
        }


        //Build Receipt for End of Day
        function _buildReceipt(session){
            var date = new Date();
            var receipt = pad('RECEIPT', 40, ' ', 3) + '\r\n';
            receipt += pad('DATE : '+ date.getDayAbbr() +' ' + date.getDate() + '-' + date.getMonthAbbr() + '-'+ date.getFullYear(), 25, ' ', 2);
            receipt += pad('TIME: '+ date.getHours() + ':' + ('0'+date.getMinutes()).slice(-2), 15, ' ', 1) + '\r\n';
            receipt += 'STORE# '+ session.store.Code + ' REG# ' + session.register.RegisterCode + '\r\n';
            receipt += 'STAFF# '+ $f.UserInfo.UserLogin + '\r\n';
            receipt += '========================================' + '\r\n';
            receipt += '\r\n';
            receipt += session.tranMinMax + '\r\n';
            receipt += '\r\n';
            receipt += pad('SOD Float ', 20, ' ', 2);
            receipt += pad(session.sodFloat.toFixed(2), 10, ' ', 1) + '\r\n';
            receipt += pad('EOD Float ', 20, ' ', 2);
            receipt += pad(session.eodFloat.toFixed(2), 10, ' ', 1) + '\r\n';
            receipt += '----------------------------------------' + '\r\n';
            receipt += '\r\n';
            receipt += pad('TENDER SUMMARY', 20, ' ', 2) + '\r\n';
            receipt += '----------------------------------------' + '\r\n';
            for(var i=0;i<session.countedTendKeys.length;i++){
                receipt += pad(session.countedTendKeys[i].FullDescription, 25, ' ', 2);
                receipt += pad(session.countedTendKeys[i].Recorded, 10, ' ', 1) + '\r\n';
                if(session.countedTendKeys[i].ExchangeRate > 0){
                    receipt += pad('[ Rate' + session.countedTendKeys[i].ExchangeRate + ' ]', 20, ' ', 2);
                    receipt += pad('', 10, ' ', 1) + '\r\n';
                }
            }    
            receipt += '----------------------------------------' + '\r\n';
            receipt += pad('Tender Total ', 20, ' ', 2);
            receipt += pad(session.tendKeysTotal.toFixed(2), 10, ' ', 1) + '\r\n';
            receipt += '----------------------------------------' + '\r\n';
            receipt += pad('SALES SUMMARY', 20, ' ', 2) + '\r\n';
            receipt += '----------------------------------------' + '\r\n';
            receipt += pad('Sales ', 20, ' ', 2);
            receipt += pad(session.sodFloat.toFixed(2), 10, ' ', 1) + '\r\n';
            receipt += pad('Returns  ', 20, ' ', 2);
            receipt += pad(session.sodFloat.toFixed(2), 10, ' ', 1) + '\r\n';
            receipt += pad('Net Sales ', 20, ' ', 2);
            receipt += pad(session.sodFloat.toFixed(2), 10, ' ', 1) + '\r\n';
            for(var i=0;i<session.store.taxes.length;i++){
                receipt += pad(session.store.taxes[i].Name, 20, ' ', 2);
                if(i == 0){
                    receipt += pad(session.payments.tax1.toFixed(2), 10, ' ', 1) + '\r\n';
                } else if(i == 1){
                    receipt += pad(session.payments.tax2.toFixed(2), 10, ' ', 1) + '\r\n';
                }
            }
            receipt += '----------------------------------------' + '\r\n';
            receipt += pad('Gross Sales ', 20, ' ', 2);
            receipt += pad(session.payments.total.toFixed(2), 10, ' ', 1) + '\r\n';
            receipt += '\r\n';
            // CASH EXPENSES GO HERE
            receipt += pad('TRANSACTION SUMMARY', 20, ' ', 2) + '\r\n';
            receipt += '----------------------------------------' + '\r\n';
            receipt += pad('+ Gross Sales ', 20, ' ', 2);
            receipt += pad(session.payments.total.toFixed(2), 10, ' ', 1) + '\r\n';
            receipt += pad('+ Deposits ', 20, ' ', 2);
            receipt += pad('', 10, ' ', 1) + '\r\n';
            receipt += pad('+ Money Received ', 20, ' ', 2);
            receipt += pad('', 10, ' ', 1) + '\r\n';
            receipt += pad('- Money Paid Out ', 20, ' ', 2);
            receipt += pad('', 10, ' ', 1) + '\r\n';
            receipt += pad('- Cash Expenses ', 20, ' ', 2);
            receipt += pad('', 10, ' ', 1) + '\r\n';
            receipt += pad('- Previous Deposits ', 20, ' ', 2);
            receipt += pad('', 10, ' ', 1) + '\r\n';
            receipt += '----------------------------------------'+ '\r\n';
            receipt += pad('Total ', 20, ' ', 2);
            receipt += pad(session.payments.total.toFixed(2), 10, ' ', 1) + '\r\n';
            receipt += '----------------------------------------'+ '\r\n';
            if(session.ShortOverReason){
                receipt += pad(session.ShortOverTitle, 20, ' ', 2);
                receipt += pad(session.ShortOverReason, 10, ' ', 1) + '\r\n';
            }
            if(session.bankDeposit){
                receipt += pad('Bank Deposits  ', 20, ' ', 2);
                receipt += pad(session.bankDeposit.toFixed(2), 10, ' ', 1) + '\r\n';
            }
            console.log(receipt);
            //debugger;
            return receipt;
        }

        var STR_PAD_LEFT = 1;
        var STR_PAD_RIGHT = 2;
        var STR_PAD_BOTH = 3;

        function pad(str, len, pad, dir) {
        
            if (typeof(len) == "undefined") { var len = 0; }
            if (typeof(pad) == "undefined") { var pad = ' '; }
            if (typeof(dir) == "undefined") { var dir = STR_PAD_RIGHT; }
        
            if (len + 1 >= str.length) {
                switch (dir){
                    case STR_PAD_LEFT:
                        str = Array(len + 1 - str.length).join(pad) + str;
                    break;
                
                    case STR_PAD_BOTH:
                        var right = Math.ceil((padlen = len - str.length) / 2);
                        var left = padlen - right;
                        str = Array(left+1).join(pad) + str + Array(right+1).join(pad);
                    break;
                
                    default:
                        str = str + Array(len + 1 - str.length).join(pad);
                    break;
                } // switch
            }
            return str;
        }
}]);