/// <reference path="../../../js/models/tendKey.js" />
angular.module('aralco.pos.controllers').controller('posPayment', ['$scope', '$state', '$stateParams', '$q', '$ionicModal', '$ionicPopover', '$ionicLoading', '$filter', 'posFctr', 'tendKeyFctr', 'sessionFctr', 'settingFctr', 'customerFct', 'popupFctr',
    'giftCardFctr', 'helperFctr', '$ionicHistory','$timeout','$window','localScanService','$ionicPopup',
        function ($scope, $state, $stateParams, $q, $ionicModal, $ionicPopover, $ionicLoading, $filter,
        posFctr, tendKeyFctr, sessionFctr, settingFctr, customerFct, popupFctr, giftCardFctr, helperFctr,  $ionicHistory,$timeout,$window,
        localScanService,$ionicPopup) {

            function Payment(tendkey, amount) {
                var self = this;

                init(tendkey, amount);

                self.tendKey = null;
                self.amount = 0;
                self.creditCardNumber = null;
                self.issuedDate = null;
                self.expiringDate = null;
                self.secureCode = null;

                function init(key, amount) {
                    self.tendKey = key;
                    self.amount = amount;
                    self.creditCardNumber = null;
                    self.issuedDate = new Date();
                    self.expiringDate = new Date();
                    self.secureCode = null;
                }

                self.IsValid = function () {
                    var isValid = true;
                    isValid = isValid && (parseFloat(self.amount || '0') > 0);

                    //var ccRegex="^(?:4[0-9]{12}(?:[0-9]{3})?"          //# Visa
                    //             + "  |  5[1-5][0-9]{14}"                  //# MasterCard
                    //             + "  |  3[47][0-9]{13}"                   //# American Express
                    //             + "  |  3(?:0[0-5]|[68][0-9])[0-9]{11}"   //# Diners Club
                    //             + "  |  6(?:011|5[0-9]{2})[0-9]{12}"      //# Discover
                    //             + "  |  (?:2131|1800|35\d{3})\d{11}"      //# JCB
                    //             + " )$";

                    if (tendkey.isCard) {
                        isValid = isValid && (!_.isEmpty(self.creditCardNumber));
                        isValid = isValid && (cardIsExpired(self.expiringDate));
                        isValid = isValid && (!_.isEmpty(self.secureCode));
                        // isValid = isValid && (self.secureCode.test("The best things in life are free!"));
                    }

                    return IsValid;
                };

                function cardIsExpired(date) {
                    /// <summary>
                    /// check if the card is expired
                    /// </summary>
                    /// <param name="date"></param>
                    /// <returns type=""></returns>
                    var RetVal = false;

                    if (_.isDate(date)) {
                        var today = new Date();
                        today = today.setFullYear(today.getFullYear(), today.getMonth(), 1);
                        date = today.setFullYear(date.getFullYear(), date.getMonth(), date.getDate());
                        RetVal = today <= date;
                    }
                    return RetVal;
                }
                return self;
            }

            init();
            $ionicPopover.fromTemplateUrl('modules/pos/templates/pos-tax-detail.html', {
                scope: $scope
            }).then(function (popover) {
                $scope.totalPopOver = popover;
            });

            $ionicModal.fromTemplateUrl('modules/pos/templates/pos-payment-amount.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.payByCash = modal;
            });

            $ionicModal.fromTemplateUrl('modules/pos/templates/pos-payment-card.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.payByCard = modal;
            });

            $ionicModal.fromTemplateUrl('modules/pos/templates/pos-receipt.html', {
                scope: $scope,
                animation: 'slide-in-up',
                backdropClickToClose: false,
                hardwareBackButtonClose: false
            }).then(function (modal) {
                $scope.printReceiptModal = modal;
            });
            $scope.printModal = function(){
                //Print Function Is Invvoked here//
                //Send Transaction to Sql Here itself, disable everything other than Complete Transaction Button
                // if(!$scope.transactionMade){
                //     sendTransactionToBackend().then(function(){
                //         $scope.transactionMade = true;
                //     });
                // }
                $scope.transactionMade = true;
                
                var htmlContent = '<html>'+document.getElementById('print-content').innerHTML+'</html>';
                if(ionic.Platform.platforms[0]=="browser")
                {
                    var mywindow = window.open('', 'Aralco_Receipt_'+$scope.manager.transaction.currentNo+'');
                    mywindow.document.write(htmlContent);
                    //mywindow.document.close(); // necessary for IE >= 10
                    //mywindow.focus(); // necessary for IE >= 10
                    mywindow.print();
                    $timeout(function () {
                        mywindow.close();
                    },150);
                } else {
                    //cordova.plugins.printer.print(htmlContent, 'Aralco_Receipt_'+$scope.manager.transaction.number+'.html');
                    cordova.plugins.printer.pick(function (uri) {
                        cordova.plugins.printer.print(htmlContent,{ printerId: uri });
                    });
                }
                //mywindow.close();

                //return true;*/
                //window.print();
            }
            $scope.emailModal = function(){
                $scope.inputEmail = {
                    email:''
                };
                if(ionic.Platform.platforms[0]=="browser"){
                    $ionicLoading.hide();
                    popupFctr.alert('Function Not Available','this functionality is not available on this device');
                } else {
                $scope.sendEmailData = function(){
                    if (!$scope.inputEmail.email || $scope.inputEmail.email=='') {
                        return;
                    }
                    if(EmailPopup!= undefined){
                        document.getElementById("promptInput").blur();
                        EmailPopup.close();
                    }
                    // if(!$scope.transactionMade){
                    //     sendTransactionToBackend().then(function(){
                    //         $scope.transactionMade = true;
                    //     });
                    // }
                    $scope.transactionMade = true;
                    $ionicLoading.show({
                        template:'sending receipt email to <br/><b><i>'+$scope.inputEmail.email
                    });
                    //Make an API Call Here To send EmailData via API
                    var emailHtmlContent = '<html>'+document.getElementById('print-content').innerHTML+'</html>';
                    sendNativeEmailOnAndroidIOS($scope.inputEmail.email,$scope.manager.transaction.store.Info.Name+' - Receipt/Invoice attached',emailHtmlContent)
                    $timeout(function(){
                        /*$ionicLoading.show({
                            template:'Email Sent'
                        });*/
                        $ionicLoading.hide();
                    },2000);
                    //Send Email Logic
                };
                //Check if Email of Customer is Already Present in Transaction
                //Otherwise prompt for EmailId

                if($scope.manager.transaction.customer!=null
                    && !_.isEmpty($scope.manager.transaction.customer.Contact.Contact.Email)){
                      $scope.inputEmail.email = $scope.manager.transaction.customer.Contact.Contact.Email;
                }
                var EmailPopup = $ionicPopup.show({
                    template: '<input id="promptInput" autofocus type="email"  data-ng-enter="sendEmailData();"  ng-model="inputEmail.email">',
                    title: 'Enter EmailID',
                    scope:$scope,
                    buttons: [{ text: 'Cancel',
                        type: 'custom-popup-buttons'
                        },
                        {
                            text: '<b>Send</b>',
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.inputEmail.email || $scope.inputEmail.email=='') {
                                    e.preventDefault();
                                } else {
                                    $scope.sendEmailData();
                                }
                            }
                        }]
                });
              }  //$window.open("mailto:"+ 'test@text.com' + "?subject=" + 'testSubject'+"&body="+emailHtmlContent,"_blank");
            };

            function sendNativeEmailOnAndroidIOS(emailID,subject,body){
                var emailBody = "Hi "
                if(!_.isEmpty($scope.manager.transaction.customer)){
                    emailBody += $scope.manager.transaction.customer.Contact.Contact.Value;
                }
                emailBody += ',<br/><br/><br/>Please see attached receipt/invoice.<br/><br/>Thank you for your business.<br/><br/><br/><br/>';
                emailBody += $scope.manager.transaction.store.Info.Name+"<br/>"+$scope.manager.transaction.store.Info.Phone1+"<br/>"+$scope.manager.transaction.store.Address.address;
                emailBody += '<br/><br/>' + body;

                console.log('Starting Plugins Email');
                cordova.plugins.email.isAvailable(
                    function (isAvailable) {
                        console.log(";"+isAvailable);
                        if(isAvailable){
                            console.log('email plugin is available');
                            cordova.plugins.email.open({
                                to:      emailID,
                                subject: subject,
                                body:  emailBody,
                                attachments: 'base64:aralco_receipt_'+$scope.manager.transaction.currentNo+'.html//'+$window.btoa(body),
                                isHtml:  true
                            });
                        }
                        else{
                            console.log('this functionality is not available on this device');
                        }
                    }
                );
            }
            $scope.$on('$destroy', function () {
                $scope.printReceiptModal.remove();
            });

            $scope.paymentMade = function(){
                made = false;
                made = ($f.pos_choice == 'Sales/Refunds' && $scope.manager.transaction.total > $scope.manager.transaction.paid ) || ($f.pos_choice == 'Gift Cards' && $scope.manager.transaction.total > $scope.manager.transaction.paid );
                return made
            };

            $scope.completeTransaction = function(){
                // if($scope.paymentMade()){
                //     popupFctr.alert('Warning','Full payment must be made!');
                // } else {
                //     sendTransactionToBackend().then(function(){
                //        $state.go('pos.assignstore');
                //     });
                // }
            };

            $scope.closeCompleteTransactionWindow = function(){
                $scope.printReceiptModal.hide();
                $state.go('pos.assignstore');
            };


            function clearHistoryStorageRecord(){
                $ionicLoading.hide();
                $ionicHistory.clearHistory();
                //We send the Tran to API when we print/email receipt
                //It Might have been already sent to API by clicking EMAIL/PRINT option
                if($scope.manager.transaction.status<1) {
                    console.log('Transaction sent to API');
                     $scope.manager.transaction.status = 1;
                    //posFctr.transaction.$save($scope.manager.transaction).then(function (t){
                        posFctr.transaction.$delete(JSON.stringify($scope.manager.transaction.number),$scope.manager.transaction.type);
                        localScanService.Reset(JSON.stringify($scope.manager.transaction.number),$scope.manager.transaction.type)
                    //});
                }
            }

            // Check for change and set it to a negative value
            function checkForChange(){
                var def = $q.defer();
                if($scope.manager.transaction.change <= 0){
                    def.resolve();
                } else {
                    var change = _.findWhere($scope.tendkeys, {Number: 'A'});
                    var t = new tendKey(change);
                    t.amount = -$scope.manager.transaction.change;
                    t.exchAmount = t.amount;
                    t.tendKey = t.Number;
                    t.RefDescription = 'Change';
                    $scope.manager.transaction.payments.push(t);
                    def.resolve();
                }
                return def.promise;
            }

            function sendTransactionToBackend(silent){
                var def = $q.defer();
                if (!silent){
                    $ionicLoading.show({
                        template:'Transaction: '+ $f.pos_choice +' completed successfully<br/> wait...'
                    });
                }
                checkForChange().then(function(){
                    if($scope.manager.transaction.type == 0 || $scope.manager.transaction.type == 7 || $scope.manager.transaction.type == 8 || $scope.manager.transaction.type == 11){
                        // Call API Web service for transaction process
                        $scope.manager.transaction.receipt = _buildReceipt($scope.manager.transaction);
                        posFctr.transaction.$completeTransaction($scope.manager.transaction).then(function(){
                            //debugger;
                            //window.location.href='#/pos/start/';
                            setTimeout(function(){
                                $ionicLoading.hide();
                                clearHistoryStorageRecord();
                                def.resolve();
                            },2000);
                        },function(error){
                            //debugger;
                            $ionicLoading.hide();
                            popupFctr.alert('Transaction Error','Please try again !!');
                            console.log('Transaction Error');
                            def.reject();
                        });
                    } else if ($scope.manager.transaction.type == 12) {
                        // Call API Web service for transaction process
                        $scope.manager.transaction.receipt = _buildReceipt($scope.manager.transaction);
                        giftCardFctr.Create($scope.manager.transaction).then(function(){
                            //debugger;
                            //window.location.href='#/pos/start/';
                            setTimeout(function(){
                                $ionicLoading.hide();
                                clearHistoryStorageRecord();
                                def.resolve();
                            },2000);
                        },function(error){
                            //debugger;
                            $ionicLoading.hide();
                            popupFctr.alert('Transaction Error','Please try again !!');
                            console.log('Transaction Error');
                            def.reject();
                        });
                    } else {
                        setTimeout(function(){
                            $ionicLoading.hide();
                            clearHistoryStorageRecord();
                            def.resolve();
                        },2000);
                    }
                });
                return def.promise;
            }

            // close image modal
            $scope.closePrintModal = function () {
                $scope.printReceiptModal.hide();
                if($scope.transactionMade){
                    $state.go('pos.assignstore');
                }
            };

            $scope.clearTendKey = function(number){
                var t = _.findWhere($scope.tendkeys, {Number: number});
                t.amount = 0;
                t.exchAmount = 0;
                t.tendKey = null;
                t.command = 'remove';

                //Special Condition for points to remove points spent
                if(t.Code == 'O' && t.Description == 'Points'){
                    $scope.manager.transaction.pointsSpent = t.exchAmount;
                }

                $scope.refreshDue(t);
            }

            // Manually set tender amount
            $scope.setFocusToInput = function(number){
                var bal = $filter('currency')($scope.manager.transaction.balance)
                console.log("--"+bal);
                var t = _.findWhere($scope.tendkeys, {Number: number});
                $scope.setFocusNow = function(number,amount,e){
                    document.getElementById("promptInput").blur();
                    if( !$scope.custom.amount || $scope.custom.amount<=0 ){
                        e.preventDefault();
                    } else {
                        amountPopup.close();
                        //var t = _.findWhere($scope.tendkeys, {Number: number});
                        t.exchAmount = parseFloat($scope.custom.amount).toFixed(2);
                        t.exchAmount = Math.abs(t.exchAmount);
                        t.amount = t.exchAmount;
                        if(t.ExchangeRate > 0){
                            var exchange = $f.moduleSetting.pos.Exchanges.filter(function (e) {
                                return (e.TenderCode == t.Code || e.Code == t.Code);
                            });
                            t.amount *= exchange[0].ExchangeRate; 
                            t.amount = parseFloat(t.amount).toFixed(2);
                        }      
                        t.command =  'add';

                        // Special condition for Points, check is there is a sufficient amount
                        if(t.Code == 'O' && t.Description == 'Points'){
                            _processPoints(t, exchange);
                        }

                        // Special condition for Gift Cards, check is there is a sufficient amount
                        else if(t.GiftCard){
                            _processGiftCard(t);
                        }
                        else {
                            $scope.refreshDue(t);
                        }

                    }
                 };
                $scope.custom = {};
                $scope.custom.number = number;
                var amountPopup = $ionicPopup.show({
                    template: '<input id="promptInput" autofocus type="number"  min="0" inputmode="numeric" data-ng-enter="setFocusNow(custom.number,custom.amount,$event)"  ng-pattern="/^[0-9]+(\.[0-9]{1,2})?$/" step="0.01" ng-model="custom.amount">',
                    title: 'Enter Amount',
                    subTitle:'Balance: '+bal +' - Tender Type: <b>'+t.FullDescription+'</b>',
                    scope:$scope,
                    buttons: [{ text: 'Cancel',
                        type: 'custom-popup-buttons'
                        },
                        {
                            text: '<b>Send</b>',
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.custom.amount) {
                                    e.preventDefault();
                                } else {
                                    $scope.setFocusNow(number,$scope.custom.amount,e);
                                }
                            }
                        }
                    ]
                });
            }

            $scope.InsertPaymentInfo = function (tendkey) {
                var modal = $scope.payByCash;
                if (tendkey.IsCard) {
                    modal = $scope.payByCard;
                }

                modal.show();
            };
            $scope.goBackToItems = function(){
                $ionicHistory.goBack();
            }
            
            $scope.refreshDue = function (t) {
                var totals = 0;
                
                totals = _.reduce(_.pluck($scope.tendkeys, 'amount'), function (sum, el) {
                    el = parseFloat(el);
                    //if (!_.isNumber(el) || _.isNaN(el) || el <= 0) {
                    if (!_.isNumber(el) || _.isNaN(el) ) {
                        el = 0;
                    }
                    return (parseFloat(sum) + parseFloat(el)).toFixed(2)
                }, 0);
                $scope.manager.transaction.payments = $scope.manager.transaction.payments.filter(function(el){
                    return el.Number !== t.Number;
                });
                if (totals == 0)
                    t.command = 'remove';


                    
                if (t.command == 'add')
                    $scope.manager.transaction.payments.push(t);

                
                $scope.manager.transaction.total>=0?$scope.manager.$pay(totals):$scope.manager.$refund(totals);
            };

            // Automatically fill tender amount
            $scope.fillDefault = function (number) {
                var t = _.findWhere($scope.tendkeys, {Number: number});
                t.amount = parseFloat($scope.manager.transaction.balance).toFixed(2);
                t.amount = Math.abs(t.amount);
                t.exchAmount = t.amount;
                if(t.ExchangeRate > 0){
                    var exchange = $f.moduleSetting.pos.Exchanges.filter(function (e) {
                        // Both because of database inconsistency
                        return (e.TenderCode == t.Code || e.Code == t.Code);
                    });
                    t.exchAmount /= exchange[0].ExchangeRate; 
                    t.exchAmount = parseFloat(t.exchAmount).toFixed(2);
                    t.exchAmount = Math.abs(t.exchAmount);
                }      
                t.tendKey = t.Number;
                t.command = 'add';
                
                // Special condition for Points, check is there is a sufficient amount
                if(t.Code == 'O' && t.Description == 'Points'){
                    _processPoints(t, exchange);
                }

                // Special condition for Gift Cards, check is there is a sufficient amount
                else if(t.GiftCard){
                    _processGiftCard(t);
                }
                else {
                    $scope.refreshDue(t);
                }
            };

            $scope.close = function () {
                $scope.payByCard.close();
                $scope.payByCash.close();
            };

            $scope.okToGo = function (type) {
                return false;
            };

            $scope.togglemode = function () {
                $scope.paymentMode = !$scope.paymentMode;
            };

            $scope.sendAndPrint = function () {
                $ionicLoading.show({
                    template:'Completing Transaction...'
                });
                sendTransactionToBackend(true).then(function () {
                    $ionicLoading.hide();
                    $scope.print(true);
                })
            };

            $scope.print = function(processTransactionNow){
                if($scope.paymentMade()){
                    popupFctr.alert('Warning','Full payment must be made!');
                } else {
                    $scope.istransactiontype = "Receipt";
                    if (processTransactionNow){
                        $scope.processTransactionNow = true;
                        switch ($scope.manager.transaction.type) {
                            case 0:
                                $scope.istransactiontype = 'Sale';
                                break;
                            case 8:
                                $scope.istransactiontype = 'Quote';
                                break;
                            case 7:
                                $scope.istransactiontype = 'Orders';
                                break;
                            case 10:
                                $scope.istransactiontype = 'Rentals';
                                break;
                            case 1:
                                $scope.istransactiontype = 'Layaway';
                                break;
                            case 11:
                                $scope.istransactiontype = 'Gifts Registry';
                                break;
                            default:
                                break;
                        }
                    } else {
                        $scope.processTransactionNow = false;
                        $scope.istransactiontype = "Receipt Preview"
                    }

                    $scope.date = new Date();
                    $scope.clerk = $f.UserInfo.FirstName;
                    $scope.topMessage = $scope.settings.filter(function (s) {
                        return (s.Property == 'TopMessage');
                    });
                    $scope.bottomMessage = $scope.settings.filter(function (s) {
                        return (s.Property == 'BottomMessage');
                    });
                    $scope.printReceiptModal.show();
                }
            };

            // Process points calculation and update the values
            function _processPoints(t, exchange){
                //Check if the customer exists
                if(!_.isEmpty($scope.manager.transaction.customer)){
                    customerFct.$getPoints($scope.manager.transaction.customer.ID).then(function(currentPoints){
                        $scope.manager.transaction.customer.Attributes.Points = currentPoints;
                        if($scope.manager.transaction.customer.Attributes.Points == 0){ 
                            t.amount = 0;
                            t.exchAmount = 0;
                            popupFctr.alert('Nothing to redeem','The current point balance is zero.');
                        }  else if($scope.manager.transaction.customer.Attributes.Points < t.exchAmount){
                            popupFctr.alert('Partial points applied','' + $scope.manager.transaction.customer.Attributes.Points+ ' have been applied for this transaction, 0 remaining').then(function(){
                                t.exchAmount = $scope.manager.transaction.customer.Attributes.Points;
                                t.amount = t.exchAmount * exchange[0].ExchangeRate;
                                t.amount = parseFloat(t.amount).toFixed(2);
                                t.amount = Math.abs(t.amount);
                                $scope.manager.transaction.pointsSpent = t.exchAmount;
                                $scope.refreshDue(t);
                            })
                        } else {
                            $scope.manager.transaction.pointsSpent = t.exchAmount;
                            $scope.refreshDue(t);
                        }
                        
                    });
                } else {
                    t.amount = 0;
                    t.exchAmount = 0;
                    $scope.refreshDue(t);
                    popupFctr.alert('Customer required to redeem points','Please select a customer in the previous menu');

                }
            }

            // Process giftcard calculation and update the values
            function _processGiftCard(t){
                //Check if the customer exists
                helperFctr.enterText($scope, 'Enter gift card code').then(function(giftCode){
                    if(giftCode == null){
                        t.amount = 0;
                        t.exchAmount = 0;
                        $scope.refreshDue(t);
                    } else {
                        giftCardFctr.GetBalance(giftCode).then(function(giftCard){
                            if(!_.isEmpty(giftCard)){ 
                                if(giftCard.Available == 0){
                                    t.amount = 0;
                                    t.exchAmount = 0;
                                    popupFctr.alert('Insufficient funds','There are no funds available on this giftcard');
                                } else {
                                    helperFctr.enterNumber($scope, 'Enter Amount to be withdrawn').then(function(value){
                                        if(value > giftCard.Available)
                                            value = giftCard.Available;
                                        var message = 'Available funds $' + giftCard.Available + ', payment $' + value + '. Accept?';
                                        popupFctr.confirm(message).then(function (result) {
                                            if (result) {
                                                t.ReferenceNumber = giftCode;
                                                t.exchAmount = value;
                                                t.amount = value;
                                                t.amount = parseFloat(t.amount).toFixed(2);
                                                t.amount = Math.abs(t.amount);
                                                $scope.refreshDue(t);
                                            }
                                        });    
                                    });
                                }      
                            } else {
                                t.amount = 0;
                                t.exchAmount = 0;
                                $scope.refreshDue(t);
                                popupFctr.alert('Invalid','Cannot find this giftcard code');
                                
                            }   
                        });
                    }
                })
            }


            function _buildReceipt(productDetails){
                var topMessage = $scope.settings.filter(function (s) {
                    return (s.Property == 'TopMessage');
                });
                if (topMessage.length === 0){
                    topMessage[0] = {
                        'Value': ""
                    };
                }

                var bottomMessage = $scope.settings.filter(function (s) {
                    return (s.Property == 'BottomMessage');
                });
                if (bottomMessage.length === 0){
                    bottomMessage[0] = {
                        'Value': ""
                    };
                }

                var date = new Date();
                var receipt = pad('RECEIPT', 40, ' ', 3) + '\r\n';
                receipt += ' \r\n';
                receipt += ' \r\n';
                receipt += pad(productDetails.store.Info.Name, 40, ' ', 3) + '\r\n';
                receipt += pad(productDetails.store.Address.Address1 + ', ' + productDetails.store.Address.City, 40, ' ', 3) + '\r\n';
                receipt += ' \r\n';
                receipt += pad(topMessage[0].Value.substring(0,40), 40, ' ', 3)+ '\r\n';
                receipt += '----------------------------------------' + '\r\n';
                receipt += 'TRANS# '+ productDetails.currentNo + '\r\n';
                receipt += 'SYSREF '+ productDetails.store.Code + '-' + productDetails.register.RegisterCode + '-' + productDetails.currentNo + '\r\n';
                receipt += pad('DATE : '+ date.getDayAbbr() +' ' + date.getDate() + '-' + date.getMonthAbbr() + '-'+ date.getFullYear(), 25, ' ', 2);
                receipt += pad('TIME: '+ date.getHours() + ':' + ('0'+date.getMinutes()).slice(-2), 15, ' ', 1) + '\r\n';
                receipt += 'STORE# '+ productDetails.store.Code + ' REG# ' + productDetails.register.RegisterCode + '\r\n';
                receipt += 'STAFF# '+ $f.UserInfo.UserLogin + '         ' + $f.UserInfo.FirstName +'\r\n';
                receipt += '----------------------------------------' + '\r\n';
                if(!_.isEmpty(productDetails.customer)){
                    receipt += pad('CUSTOMER: ', 10, ' ', 2);
                    receipt += pad(productDetails.customer.Contact.Contact.Value, 30, ' ', 2) + '\r\n';
                    
                    if(!_.isEmpty(productDetails.customer.Company)){
                        receipt += pad('', 10, ' ', 2);
                        receipt += pad(productDetails.customer.Company, 30, ' ', 2) + '\r\n';
                    }
                    if(!_.isEmpty(productDetails.customer.Contact.Address)){
                        if(!_.isEmpty(productDetails.customer.Contact.Address.Address1)){
                            receipt += pad('', 10, ' ', 2);
                            receipt += pad(productDetails.customer.Contact.Address.Address1, 30, ' ', 2) + '\r\n';
                        }
                        if(!_.isEmpty(productDetails.customer.Contact.Address.City)){
                            receipt += pad('', 10, ' ', 2);
                            receipt += pad(productDetails.customer.Contact.Address.City + ', ' 
                            + !_.isEmpty(productDetails.customer.Contact.Address.ProvinceState)? productDetails.customer.Contact.Address.ProvinceState : '', 30, ' ', 2) + '\r\n';
                        }
                        if(!_.isEmpty(productDetails.customer.Contact.Address.ZipPostalCode)){
                            receipt += pad('', 10, ' ', 2);
                            receipt += pad(productDetails.customer.Contact.Address.ZipPostalCode, 30, ' ', 2) + '\r\n';
                        }
                        if(!_.isEmpty(productDetails.customer.Contact.Address.Country)){
                            receipt += pad('', 10, ' ', 2);
                            receipt += pad(productDetails.customer.Contact.Address.Country, 30, ' ', 2) + '\r\n';
                        }
                    }
                    if(!_.isEmpty(productDetails.customer.Contact.Contact.Phone1)){
                        receipt += pad('', 10, ' ', 2);
                        receipt += pad('Tel. '+ productDetails.customer.Contact.Contact.Phone1, 30, ' ', 2) + '\r\n';
                    }
                    receipt += '----------------------------------------' + '\r\n';
                }
                
                receipt += ' \r\n';
                for(var i=0;i<productDetails.products.length;i++){
                    var gridDim =  _getGridDim(productDetails.products[i].product);
                    receipt += pad(productDetails.products[i].product.Barcode, 10, ' ', 2);
                    receipt += pad(productDetails.products[i].product.Name.replace(/(.{16})/g, "$1\r\n         "), 16, ' ', 2) + '\r\n';
                    if(gridDim.Dim1.Name != '') 
                        receipt += gridDim.Dim1.Name + ': ' + gridDim.Grid1.Value + '\r\n';
                    if(gridDim.Dim2.Name != '') 
                        receipt += gridDim.Dim2.Name + ': ' + gridDim.Grid2.Value + '\r\n';
                    if(gridDim.Dim3.Name != '') 
                        receipt += gridDim.Dim3.Name + ': ' + gridDim.Grid3.Value + '\r\n';  
                    if(gridDim.Dim4.Name != '') 
                        receipt += gridDim.Dim4.Name + ': ' + gridDim.Grid4.Value + '\r\n';
                    
                    if(productDetails.products[i].count.scanned.count > 1)
                        receipt += productDetails.products[i].count.scanned.count + ' @ ';
                    receipt += productDetails.products[i].product.RetailPrice.toFixed(2);
                    if(!_.isEmpty(productDetails.products[i].discount)){
                        receipt += pad('\r\n' + 'less ' + productDetails.products[i].discount.toFixed(2) + ' (' + ((productDetails.products[i].discount / (productDetails.products[i].count.scanned.count * productDetails.products[i].product.RetailPrice))*100).toFixed(2) + '%)', 30, ' ', 2);
                        receipt += pad((productDetails.products[i].count.scanned.count * productDetails.products[i].product.RetailPrice - productDetails.products[i].discount).toFixed(2), 10, ' ', 1) + '\r\n';
                    }
                    receipt += ' \r\n';
                }
                receipt += '\r\n';
                receipt += pad('', 10, ' ', 2);
                receipt += pad('Sub-total ', 20, ' ', 2);
                receipt += pad('$ ', 2, ' ', 3);
                receipt += pad(productDetails.subTotal.toFixed(2), 8, ' ', 1) + '\r\n';
                receipt += pad('', 10, ' ', 2);
                receipt += pad('DISCOUNT ', 20, ' ', 2);
                receipt += pad('$ ', 2, ' ', 2);
                receipt += pad(productDetails.discount.toFixed(2), 8, ' ', 1) + '\r\n';
                receipt += pad('', 10, ' ', 2);
                receipt += pad('Net-total ', 20, ' ', 2);
                receipt += pad('$ ', 2, ' ', 2);
                receipt += pad(productDetails.netTotal.toFixed(2), 8, ' ', 1) + '\r\n';
                for(var i=0;i<productDetails.taxes.length;i++){
                    receipt += pad('', 10, ' ', 2);
                    receipt += pad(productDetails.taxes[i].name, 20, ' ', 2);
                    receipt += pad('$ ', 2, ' ', 2);
                    receipt += pad(productDetails.taxes[i].total.toFixed(2), 8, ' ', 1) + '\r\n';
                }
                receipt += pad('', 10, ' ', 2);
                receipt += pad('TOTAL ', 20, ' ', 2);
                receipt += pad('$ ', 2, ' ', 2);
                receipt += pad( productDetails.total.toFixed(2), 8, ' ', 1)+ '\r\n';
                receipt += '----------------------------------------'+ '\r\n';
                for(var i=0;i<productDetails.payments.length;i++){
                    receipt += pad('PAID BY : ' +  productDetails.payments[i].FullDescription, 30, ' ', 2);
                    receipt += pad(productDetails.payments[i].Symbol +' ', 2, ' ', 2);
                    receipt += pad(productDetails.payments[i].exchAmount.toFixed(2), 8, ' ', 1) + '\r\n';
                    if(productDetails.payments[i].ExchangeRate > 0){    
                        receipt += '    (' + productDetails.payments[i].ExchangeRate.toFixed(5) + ')' + '\r\n';
                    }
                }


                // Points
                if(!_.isEmpty(productDetails.customer)){
                    if(productDetails.pointsEarned > 0){
                        receipt += pad('Points Earned on This Sale : ', 30, ' ', 2);
                        receipt += pad('  ', 2, ' ', 2);
                        receipt += pad(productDetails.pointsEarned + '', 8, ' ', 1) + '\r\n';
                    }
                    if(productDetails.customer.Attributes.Points > 0 || productDetails.pointsEarned > 0){
                        receipt += pad('Grand Total Points : ', 30, ' ', 2);
                        receipt += pad('  ', 2, ' ', 2);
                        receipt += pad((productDetails.customer.Attributes.Points - productDetails.pointsSpent
                            + productDetails.pointsEarned).toFixed(0) + '' , 8, ' ', 1) + '\r\n';
                    }
                } else if(_.isEmpty(productDetails.customer) && productDetails.pointsEarned > 0){
                    receipt += pad('Points You Could Have Earned :', 30, ' ', 2);
                    receipt += pad(' ', 2, ' ', 3);
                    receipt += pad(productDetails.pointsEarned + '', 8, ' ', 1) + '\r\n';
                    receipt += pad('Ask about our Points Program today', 50, ' ', 2); 
                }


                var botMessageFormat = bottomMessage[0].Value.replace(/(.{40})/g, "$1\r\n");
    
                receipt += '\r\n';
                receipt += botMessageFormat;
                console.log(receipt);
                //debugger;
                return receipt;
            }
            
            var STR_PAD_LEFT = 1;
            var STR_PAD_RIGHT = 2;
            var STR_PAD_BOTH = 3;
    
            function pad(str, len, pad, dir) {
            
                if (typeof(len) == "undefined") { var len = 0; }
                if (typeof(pad) == "undefined") { var pad = ' '; }
                if (typeof(dir) == "undefined") { var dir = STR_PAD_RIGHT; }
            
                if (len + 1 >= str.length) {
                    switch (dir){
                        case STR_PAD_LEFT:
                            str = Array(len + 1 - str.length).join(pad) + str;
                        break;
                    
                        case STR_PAD_BOTH:
                            var right = Math.ceil((padlen = len - str.length) / 2);
                            var left = padlen - right;
                            str = Array(left+1).join(pad) + str + Array(right+1).join(pad);
                        break;
                    
                        default:
                            str = str + Array(len + 1 - str.length).join(pad);
                        break;
                    } // switch
                }
                return str;
            }

            function _getGridDim(product){
                var gridDim = {
                    Grid1:{ID: '', Value:''},
                    Grid2:{ID: '', Value:''},
                    Grid3:{ID: '', Value:''},
                    Grid4:{ID: '', Value:''},
                    Dim1:{ID: '', Name:''},
                    Dim2:{ID: '', Name:''},
                    Dim3:{ID: '', Name:''},
                    Dim4:{ID: '', Name:''},
                };
                    gridDim.Grid1 = product.Grid1 ? product.Grid1 : gridDim.Grid1;
                    gridDim.Grid2 = product.Grid2 ? product.Grid2 : gridDim.Grid2;
                    gridDim.Grid3 = product.Grid3 ? product.Grid3 : gridDim.Grid3;
                    gridDim.Grid4 = product.Grid4 ? product.Grid4 : gridDim.Grid4;
                    gridDim.Dim1  = product.Matrix.Dimension1 ? product.Matrix.Dimension1 : gridDim.Dim1;
                    gridDim.Dim2  = product.Matrix.Dimension2 ? product.Matrix.Dimension2 : gridDim.Dim2;
                    gridDim.Dim3  = product.Matrix.Dimension3 ? product.Matrix.Dimension3 : gridDim.Dim3;
                    gridDim.Dim4  = product.Matrix.Dimension4 ? product.Matrix.Dimension4 : gridDim.Dim4;
    
                return gridDim;
            }


            function init() {
                console.log('initializing Pos pay screen');
                $ionicLoading.show({
                    template:'wait...'
                });
                var calls = [];
                var tranid = $stateParams.tid || 0;
                $scope.tendkeys = [];
                $scope.manager = new transactionManager();
                $scope.paymentMode = true;
                $scope.transactionMade = false;
                $scope.logo = '';
                $scope.pay = {
                    tendKey: null,
                    amount: 0,
                    creditCardNumber: null,
                    issuedDate: null,
                    expiringDate: null,
                    secureCode: null
                };
                $scope.settings = $f.moduleSetting.pos.Settings;

                calls.push(posFctr.transaction.$get(tranid));
                calls.push(tendKeyFctr.$get());
                calls.push(sessionFctr.GetNextTransNo(
                    $f.moduleSetting.pos.Store.ID,
                    $f.moduleSetting.pos.Register.RegisterCode,
                    $f.pos_choiceType));
                calls.push(settingFctr.$getLogo());

                $q.all(calls).then(function (result) {
                    $scope.manager.$init(result[0]);
                    _.each(result[1], function (k) {
                        k.amount = 0;
                        k.tendKey = null;
                    });
                    $scope.tendkeys = result[1];
                    $scope.manager.transaction.currentNo = result[2];
                    if(result[3] != null)
                        $scope.logo += result[3].value;
                    $ionicLoading.hide();
                });
            }

        }]);