angular.module('aralco.pos.controllers').controller('posSelCustomer', ['$scope', '$rootScope', '$q','$state','$ionicHistory', '$stateParams', '$ionicModal', '$ionicLoading', 'customerFct', 'posFctr', 'popupFctr',
        function ($scope, $rootScope, $q,$state,$ionicHistory, $stateParams, $ionicModal, $ionicLoading, customerFct, posFctr, popupFctr) {
            $scope.param = {};
                $scope.param.searchterm = "";
            init();
            function getTransactionSequence(){
                var def = $q.defer();
                posFctr.transaction.$getPOSConfigurationValue('POS_TRAN_SEQ_COUNTER').then(function(data){
                    var sequence = 999;
                    if(data!=null)
                    {
                        $scope.posTranSeqObject =  JSON.parse(data.config_value);
                        switch ($f.pos_choice) {
                            case "Sales/Refunds":
                                sequence = $scope.posTranSeqObject.pos_next_sales_tran_no;
                                break;
                            case "Orders":
                                sequence = $scope.posTranSeqObject.pos_next_order_tran_no;
                                break;
                            case "Quote":
                                sequence = $scope.posTranSeqObject.pos_next_quote_tran_no;
                                break;
                            case "Rentals":
                                sequence = $scope.posTranSeqObject.pos_next_rental_tran_no;
                                break;
                            case "Layaway":
                                sequence = $scope.posTranSeqObject.pos_next_layaway_tran_no;
                                break;
                            case "GiftsRegistry":
                                sequence = $scope.posTranSeqObject.pos_next_giftsregistry_tran_no;
                                break;
                            case "GiftCards":
                                sequence = $scope.posTranSeqObject.pos_next_giftcards_tran_no;
                                break;
                            default:
                                break;
                        }

                        def.resolve(sequence);
                    }

                });
                return def.promise;
            }
            function updatePOSTranSeqCounterInDatabase(){
                switch ($f.pos_choice) {
                    case "Sales/Refunds":
                        $scope.posTranSeqObject.pos_next_sales_tran_no+=1;
                        break;
                    case "Orders":
                        $scope.posTranSeqObject.pos_next_order_tran_no+=1;
                        break;
                    case "Quote":
                        $scope.posTranSeqObject.pos_next_quote_tran_no+=1;
                        break;
                    case "Rentals":
                        $scope.posTranSeqObject.pos_next_rental_tran_no+=1;
                        break;
                    case "Layaway":
                        $scope.posTranSeqObject.pos_next_layaway_tran_no+=1;
                        break;
                    case "GiftsRegistry":
                        $scope.posTranSeqObject.pos_next_giftsregistry_tran_no+=1;
                        break;
                    case "GiftCards":
                        $scope.posTranSeqObject.pos_next_giftcards_tran_no+=1;
                        break;
                    
                    default:
                        break;
                }
                posFctr.transaction.$updatePOSConfigValue('POS_TRAN_SEQ_COUNTER', $scope.posTranSeqObject);
            }
            $scope.go = function (item) {
                //User Selected Customer
                $ionicLoading.show({
                    template: 'wait...'
                });
                if(_.isEmpty($stateParams.tid) && $scope.posTranSeqObject!=null)
                    updatePOSTranSeqCounterInDatabase();
                customerFct.$detail(item.ID).then(function (c) {
                    $scope.transaction.customer = c;
                    $scope.transaction.eventName = $f.moduleSetting.pos.eventName;
                    //$scope.transaction.number=_number+1
                    var tr = _.clone($scope.transaction);
                    posFctr.transaction.$create(tr).then(function (t) {
                        $ionicLoading.hide();
                        if($f.pos_choiceType == 12)
                            window.location.href='#/pos/giftcards/'+t.number;
                        else 
                            window.location.href='#/pos/products/'+t.number;
                        //$state.go('pos.main', {'tid': t});
                        //$state.transitionTo('pos.main', {'tid': t});
                    });
                });
            };

            $scope.Continue =  function(item){
                 //User Didnt Choose Customer
                if($f.pos_choice=='Quote') {
                    popupFctr.alert('Customer Not Selected!', 'please select a customer for Quotes');
                } else if($f.pos_choice=='Orders') {
                    popupFctr.alert('Customer Not Selected!', 'please select a customer for Orders');
                } else if($f.pos_choice=='Layaway') {
                    popupFctr.alert('Customer Not Selected!', 'please select a customer for Layaway');
                } else if($f.pos_choice=='GiftsRegistry') {
                    popupFctr.alert('Customer Not Selected!', 'please select a customer for Gift Registry');
                } else if($f.pos_choice=='Rentals') {
                    popupFctr.alert('Customer Not Selected!', 'please select a customer for Rental');
                } else {
                    $ionicLoading.show({
                        template: 'wait...'
                        });
                    //Update Counter Only,When Going in Loop
                    if(_.isEmpty($stateParams.tid) && $scope.posTranSeqObject!=null)
                        updatePOSTranSeqCounterInDatabase();
                    var tr = _.clone($scope.transaction);
                    posFctr.transaction.$create(tr).then(function (t) {
                        $ionicLoading.hide();
                        if($f.pos_choiceType == 12)
                            window.location.href='#/pos/giftcards/'+t.number;
                        else 
                            window.location.href='#/pos/products/'+t.number;
                    });
                }
            }

            $ionicModal.fromTemplateUrl('newcustomer.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.newCustomerModal = modal;
            });

            function init() {
                $ionicLoading.show({
                    template:'wait...'
                });
                $scope.transaction = new transaction();
                $scope.transaction.store = $f.moduleSetting.pos.Store;
                var tid = $stateParams.tid;
                //Coming from POS PAY SCREEN -LOOP
                if(tid==null || tid==''){
                    $ionicHistory.clearHistory();
                    getTransactionSequence().then(function(sequence){
                        $scope.transaction.number = sequence;
                        $ionicLoading.hide();
                    });
                }
                //Coming from POS MENU SCREEN-MAIN
                else{
                    $scope.transaction.number = tid;
                    $ionicLoading.hide();
                }
                switch ($f.pos_choice) {
                    case "Sales/Refunds":
                        $f.pos_choiceType = $scope.transaction.type = 0;
                        break;
                    case "Orders":
                        $f.pos_choiceType = $scope.transaction.type= 7;
                        break;
                    case "Quote":
                        $f.pos_choiceType = $scope.transaction.type= 8;
                        break;
                    case "Rentals":
                        $f.pos_choiceType = $scope.transaction.type= 10;
                        break;
                    case "Layaway":
                        $f.pos_choiceType = $scope.transaction.type= 1;
                        break;
                    case "GiftsRegistry":
                        $f.pos_choiceType = $scope.transaction.type= 11;
                        break;
                    case "GiftCards":
                        $f.pos_choiceType = $scope.transaction.type= 12;
                        break;
                    default:
                        break;
                }

                $scope.reqCustomer = '';
                $scope.searchDescription = '';

                $scope.pos_choice = $f.pos_choice;

                $scope.customer = [];


                $scope.param.page = 0;
                $scope.param.input = "";

                $scope.param.MoreAvailable = false;
                $scope.param.TotalFound = null;
            }

            $scope.clear = function () {
                init();
            };
            $scope.goBackToPOSHome = function(){
                $state.go('pos.assignstore');
                $ionicHistory.clearHistory();
            }
            $scope.search = function () {
                $ionicLoading.show({
                    template: 'wait...'
                });
                document.getElementById("barcodeInput").blur();
                $scope.param.input = $scope.param.searchterm;

                $scope.param.MoreAvailable = false;
                $scope.param.TotalFound = null;
                $scope.param.page = 0;


                $scope.loadMore().then(function () {
                    $ionicLoading.hide();
                }, function () {
                    $ionicLoading.hide();
                });
            };

            $scope.loadMore = function () {
                $scope.param.page = $scope.param.page + 1;

                return customerFct.$search($scope.param.input, $scope.param.page)
                    .then(function (searchResult) {
                        if ($scope.param.page <= 1) {
                            $scope.customer = [];
                        }

                        if (!_.isEmpty(searchResult.Result)) {
                            $scope.param.TotalFound = searchResult.Total || searchResult.Result.length;
                            $scope.param.MoreAvailable = searchResult.MoreAvailable || false;
                            _.each(searchResult.Result, function (c) {
                                c.detail = {
                                    Contact: {
                                        Address: {},
                                        Contact: {}
                                    },
                                    image: {value: null}
                                };

                                customerFct.$detail(c.ID, $f.ForceLoad || false)
                                    .then(function (detail) {
                                        if(!_.isEmpty(detail)){
                                            c.Contact = detail.Contact;
                                            c.Attributes = detail.Attributes;
                                            c.POSCustomerID = detail.POSCustomerID;
                                            c.Totals = detail.Totals;
                                            c.image = detail.image;

                                            //c.detail = detail;
                                            //var children = hege.concat(stale);
                                            //var a = new Address();
                                           // a.init(detail.Contact.Address);
                                            $scope.customer.push(c);
                                        }
                                    }, function (error) {
                                        //do nothing
                                    });

                                //customerFct.$getPicture(c.ID).then(function (pic) {
                                //    c.image = pic;
                                //},


                            });
                        } else {
                            popupFctr.alert('No results found', 'No results found for "' + $scope.param.searchterm + '"');
                        }

                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        return searchResult.Result;
                    });
            };

            $scope.moreDataCanBeLoaded = function () {
                return _.isEmpty($scope.param) ? false : $scope.param.MoreAvailable || false;
            };

            $rootScope.$on('customer.cancel-add-new', function () {
                $scope.newCustomerModal.hide();
            });

            $rootScope.$on('customer.ok-customer-add', function (event, data) {
                $scope.newCustomerModal.hide();
                $scope.customer = $scope.customer || [];
                $scope.go(data);
            });



            $scope.showNewCustomer = function () {
                $scope.newCustomerModal.show();
            };
        }]);