angular.module('aralco.pos.controllers').controller('posStart', ['$scope', '$q', '$ionicLoading', '$ionicModal','$filter', '$ionicHistory',
    'taxFctr', 'storeFctr', 'registerFctr', 'settingFctr', '$state','posFctr','$timeout','handleStoreValue','popupFctr','localScanService', 'sessionFctr', 'tendKeyFctr', 'accountFctr',
    function ($scope, $q, $ionicLoading, $ionicModal, $filter, $ionicHistory, taxFctr, storeFctr, registerFctr, settingFctr,$state,posFctr,$timeout,
    handleStoreValue,popupFctr,localScanService, sessionFctr, tendKeyFctr, accountFctr) {
        init();

        function init(){
            $ionicHistory.clearHistory();
            $ionicLoading.show({
                template:'wait...'
            });
            accountFctr.isLoggedAsync().then(function () {
                //console.log("Session OK");
                setup()
            });
            // },function () {
            //     console.log("Session Expired");
            // });
        }

        function setup(){

            $scope.param={
                isSoSActive:false
            };
            //$scope.posBODExists = false;
            // First We need To check if POS Start Day Exists,if so Disable SoS option
            try {
                posFctr.transaction.$getPOSConfigurationValue('POS_BOD').then(function (data) {
                    $ionicLoading.hide();
                    if (data == null) {
                        //No Existing StartOfDay Exists,proceed to prompt user to create new
                        console.log('No Existing POS SoS Exists');
                    } else {
                        $ionicLoading.hide();
                        var posSessionObject = new Object();
                        posSessionObject = JSON.parse(data.config_value);
                        //POS StartOfDay exists, Check For pending Transactions Now

                        $f.StartPOSSession();
                        $scope.param.isSoSActive = $f.isSoSActive;

                        //Get SoS Details from SoS object and store in session
                        $f.moduleSetting.pos.Store = posSessionObject.store;
                        $f.moduleSetting.pos.Register = posSessionObject.register;
                        $f.moduleSetting.pos.Settings = posSessionObject.settings;
                        $f.moduleSetting.pos.Session = posSessionObject.session;
                        $f.moduleSetting.pos.sodFloat = posSessionObject.sodFloat;
                        $f.moduleSetting.pos.Exchanges = posSessionObject.Exchanges;
                        $f.moduleSetting.pos.customerMode = posSessionObject.customerMode;
                        $f.moduleSetting.Store = $f.moduleSetting.Store.ID == 0 ? posSessionObject.store : $f.moduleSetting.Store;
                        if (handleStoreValue.storeValue != posSessionObject.store.Code) {
                            var test = $state;
                            popupFctr.alert('Alert!', 'This Session has been started in Store: ' + posSessionObject.store.Code + ' Register: ' + posSessionObject.register.RegisterCode);
                        }
                        handleStoreValue.storeValue = posSessionObject.store.Code
                        handleStoreValue.registerValue = posSessionObject.register.RegisterCode;
                    }
                }, function (error) {
                    console.log('pos BOD config cannot be resolved');
                });
            }
            catch (e){
                if (e.description.indexOf("transaction") !== -1) {
                    // if the error is about transaction not being a part of null
                    var message = "The POS module requires the The Offline SQL module which is not supported on your " +
                        "current browser. Please switch to Safari, Google Chrome, or the mobile app version.";
                    $ionicLoading.hide();
                    popupFctr.alert('There was an error...', message).then(function () {
                        $state.go('tab.dash');
                        $ionicHistory.clearHistory();
                    });
                } else {
                    throw e;
                }
            }
        }
      
        function startTransaction(type){
            posFctr.transaction.$checkTransactionPendingScans(type).then(function (data)
            {
                if( data > 0 ){
                    //Take Directly to POS Product Scanning screen
                    //Make sure we set the Start Day as Started
                    $ionicLoading.show({
                        template:'pending transaction exists...'
                    });
                    $timeout(function(){
                        $ionicLoading.hide();
                        if(type == 12)
                            window.location.href='#/pos/giftcards/'+data;
                        else 
                            window.location.href='#/pos/products/'+data;
                        
                    }
                    ,2000);
                } else {
                    $ionicLoading.show({
                        template:'wait...'
                    });
                    getPOSTranSeqCounterFromDatabase().then(function(tran_seq_object){
                        switch (type) {
                            case 0:
                                var tran_number = tran_seq_object.pos_next_sales_tran_no;
                                tran_seq_object.pos_next_sales_tran_no = tran_number+1;
                                break;
                            case 8:
                                var tran_number = tran_seq_object.pos_next_quote_tran_no;
                                tran_seq_object.pos_next_quote_tran_no = tran_number+1;
                                break;
                            case 7:
                                var tran_number = tran_seq_object.pos_next_order_tran_no
                                tran_seq_object.pos_next_order_tran_no = tran_number+1;
                                break;
                            case 10:
                                var tran_number = tran_seq_object.pos_next_rental_tran_no;
                                tran_seq_object.pos_next_rental_tran_no = tran_number+1;
                                break;
                            case 1:
                                var tran_number = tran_seq_object.pos_next_layaway_tran_no
                                tran_seq_object.pos_next_layaway_tran_no = tran_number+1;
                                break;
                            case 11:
                                var tran_number = tran_seq_object.pos_next_giftsregistry_tran_no
                                tran_seq_object.pos_next_giftsregistry_tran_no = tran_number+1;
                                break;
                            case 12:
                                var tran_number = tran_seq_object.pos_next_giftcards_tran_no
                                tran_seq_object.pos_next_giftcards_tran_no = tran_number+1;
                                break;
                            default:
                                break;
                        }
                        updatePOSTranSeqCounterInDatabase(tran_seq_object);
                        $ionicLoading.hide();
                        window.location.href='#/pos/start/'+tran_number;
                    });
                }
            });
        }

        //Check if any pending scans exist for any function
        function isFunctionAllowed(type){
            var def = $q.defer();
            sessionFctr.IsSession($f.moduleSetting.pos.Session.SessionID, $f.POSSystem.retrieve()).then(function(sessionActive){
                if(sessionActive){
                    checkPendingTransactionScan().then(function(transaction){
                        //pending Scans exist
                        if((transaction== null) || (transaction!=null && transaction.type==type) ){ //Sales Refunds
                            def.resolve(true);
                        } else {
                            var func_name ="";
                            switch (transaction.type) {
                                case 0:
                                    func_name = 'Sales/Refunds';
                                    break;
                                case 8:
                                    func_name = 'Quote';
                                    break;
                                case 7:
                                    func_name = 'Orders';
                                    break;
                                case 10:
                                    func_name = 'Rentals';
                                    break;
                                case 1:
                                    func_name = 'Layaway';
                                    break;
                                case 11:
                                    func_name = 'GiftsRegistry';
                                    break;
                                case 12:
                                    func_name = 'GiftsCards';
                                    break;
                                default:
                                    break;
                            }
                            popupFctr.alert('Alert!','Clear/Send the pending scans from ['+func_name +']');
                            def.resolve(false);
                        }
                    });
                } else {
                    popupFctr.errorAlert('Error!','This session has already been ended').then(function(){
                        posFctr.transaction.$deletePosConfigurationValue('POS_BOD');
                        $f.EndPOSSession();
                        $ionicLoading.hide();
                        $ionicHistory.clearHistory(); 
                        def.resolve(false);          
                        window.location.href='#/pos/posstart/';
                        
                    });
                }
            });   
            return def.promise;
        }

        $scope.startSalesReturns = function(){
            $ionicLoading.show({
                template:'wait...'
            });
            isFunctionAllowed(0).then(function(val){
                $ionicLoading.hide();
                if(val){
                    //Start of Sales/Refunds
                    //set a variable in $f to mark the POS flow
                    $f.pos_choice = 'Sales/Refunds';
                    $f.pos_choiceType = 0;
                    startTransaction(0);
                }
            })
        };

        $scope.startOrders = function(){
            isFunctionAllowed(7).then(function(val){
                if(val){
                    $f.pos_choice = 'Orders';
                    $f.pos_choiceType = 7;
                    startTransaction(7);
                }
            });
        };

        $scope.startQuote = function(){
            isFunctionAllowed(8).then(function(val){
                if(val){
                    $f.pos_choice = 'Quote';
                    $f.pos_choiceType = 8;
                    startTransaction(8);
                }
            });
        };

        $scope.startRentals = function(){
            isFunctionAllowed(10).then(function(val){
                if(val){
                    $f.pos_choice = 'Rentals';
                    $f.pos_choiceType = 10;
                    startTransaction(10);
                }
            });
        };

        $scope.startLayaway = function(){
            isFunctionAllowed(1).then(function(val){
                if(val){
                    $f.pos_choice = 'Layaway';
                    $f.pos_choiceType = 1;
                    startTransaction(1);
                }
            });
        };

        $scope.startGiftsRegistry = function(){
            isFunctionAllowed(11).then(function(val){
                if(val){
                    $f.pos_choice = 'GiftsRegistry';
                    $f.pos_choiceType = 11;
                    posFctr.transaction.$eventName($scope).then(function(eventName){
                        $f.moduleSetting.pos.eventName = eventName;
                        startTransaction(11);
                    })
                    
                }
            });
        };

        $scope.startGiftCards = function(){
            isFunctionAllowed(12).then(function(val){
                if(val){
                    $f.pos_choice = 'GiftCards';
                    $f.pos_choiceType = 12;
                    startTransaction(12);
                }
            });
        };

        $scope.startPOSDay = function(){
            if($scope.param.isSoSActive){
                popupFctr.alert('Alert!','Session already activated');
                return;
            } else {
                $ionicLoading.show({
                    template: 'wait ...'
                });
                //1. Set A store First
                var calls = [storeFctr.Get(), settingFctr.$get(), registerFctr.Get()];
                $q.all(calls).then(function (res) {
                    if(res[2] == ''){
                        popupFctr.alert('All Registers In Use!',"All mobile registers are in use! Contact Aralco if you need more.");
                         $ionicLoading.hide();
                        return;
                    }
                    $ionicLoading.hide();
                    _setSoSStore(res[0],res[1], res[2]).then(function(data){
                        if(data){
                            _saveSoSStore(data);   
                        }
                    })
                },function(error){
                    console.log('POS Stores could not be fetched');
                });
            }
        };

        function _setSoSStore(stores, settings, registers){
            $ionicLoading.show({
                template: '1. Please choose a store ...'
            });

            var sesExist = false;
            var sesExistData = {};
            sesExistData.pos = {};
            sesExistData.pos.session = sesExistData.pos.session || {};
            var def = $q.defer();

            // Filter stores with registers
            availStores = [];
            stores.forEach(function (s){
                registers.forEach(function(r) {
                    if(s.ID ==  r.StoreID && availStores.indexOf(s) === -1) 
                        availStores.push(s);
                })
            });
            
            $scope.Stores = availStores;
            $scope.settings = settings;
            $scope.data = {
                selectedStoreID: 0
             };

            // Select store modal
            $ionicModal.fromTemplateUrl('modules/store/templates/store-select.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.storeModal = modal;
                $ionicLoading.hide();
                $scope.storeModal.show();
            });

            // Store Selected
            $scope.Ok = function(){
                // Confirm If Store was selected
                if(!_.isEmpty($scope.data.selectedStoreID)){
                    $ionicLoading.show({
                        template:'wait...'
                    })
                   
                $scope.Registers =  registers.filter(function (r) {
                    return (r.StoreID == $scope.data.selectedStoreID);
                });
                     //Check if this user already has a session in a database
                sessionFctr.Get($scope.data.selectedStoreID, null, $f.UserInfo.EmployeeID).then(function(session){
                    if(!_.isEmpty(session)){
                        sesExist = true;
                        sesExistData.StoreID = session.StoreID;
                        sesExistData.RegisterCode = session.RegisterCode;
                        sesExistData.pos.session.SessionID = session.SessionID;
                        sesExistData.pos.session.SessionGUID = session.SessionGUID;
                        sesExistData.pos.session.POSSessionID = session.POSSessionID;
                        sesExistData.pos.POSSystem = session.POSSystem;
                        sesExistData.pos.sodFloat = session.SODFloat;
                        sesExistData.pos.Exchanges = session.Exchanges;
                        sesExistData.pos.customerMode = session.customerMode;
                        sesExistData.settings = $scope.settings.connection;
                    }

                    // If session exists then grab its info and taxes for the store
                    if(sesExist){
                        sesExistData.pos.store = _.findWhere($scope.Stores, {ID: parseInt(sesExistData.StoreID)});
                        sesExistData.pos.register = _.findWhere($scope.Registers, {RegisterCode: sesExistData.RegisterCode});
                        var calls = [   sessionFctr.GetExchangeRates(sesExistData.pos.session.SessionID, sesExistData.pos.POSSystem), 
                                        taxFctr.$getByStore(sesExistData.StoreID) ];
                        $q.all(calls).then(function (res) {
                                    sesExistData.pos.Exchanges = res[0];
                                    sesExistData.pos.store.taxes = res[1];
                                    if(_.isEmpty(sesExistData.Store)){
                                        sesExistData.Store = sesExistData.pos.store;
                                    }
                                    assignRegister(sesExistData, 'continued').then(function(){
                                        def.resolve(sesExistData);
                                    });
                        });

                    // Else allow assignment of a new register
                    } else {
                        $scope.settings.pos.store = _.findWhere($scope.Stores, {ID: parseInt($scope.data.selectedStoreID)});
                        
                        // Check existing registers for active sessions
                        var loopPromises = [];
                        _.each($scope.Registers, function (item) {
                            var deferred = $q.defer();
                            loopPromises.push(deferred.promise);
                            sessionFctr.Get(item.StoreID, item.RegisterCode, 0).then(function(session){
                                item.SessionID = session.SessionID;
                                item.SessionGUID = session.SessionGUID;
                                item.POSSessionID = session.POSSessionID;
                                item.Available = (typeof item.SessionID !== 'undefined' && item.RegisterID != 0) ? false : true;
                                deferred.resolve();
                        })});   

                        // Once the checks complete open a register select modal
                        $q.all(loopPromises).then(function () {
                        $ionicModal.fromTemplateUrl('modules/pos/templates/pos-assign-register.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                        }).then(function (modal) {
                        $scope.registerModal = modal;
                        $ionicLoading.hide();
                        $scope.registerModal.show();

                        
                        // On register select
                        $scope.RegisterOk = function(){
                            if(_.isEmpty($scope.data.selectedId) || $scope.settings.pos.register == undefined){
                                popupFctr.alert('Register not selected!','Please select a register...');
                            } else {  
                                // Filter the selected register from Register array
                                $scope.settings.pos.register = $scope.Registers.filter(function ( obj ) {
                                    return obj.RegisterID == $scope.data.selectedId;
                                })[0];

                                $scope.settings.pos.session ={};
                                
                                // Grab tax for the store.
                                taxFctr.$getByStore($scope.data.selectedStoreID).then(function (taxes) {
                                    $scope.settings.pos.store.taxes = taxes;
                                    if(_.isEmpty($scope.settings.Store))
                                        $scope.settings.Store = $scope.settings.pos.store;
                                    // If the selected register is Dynamic then generate a new register
                                    if($scope.settings.pos.register.RegisterCode == 'DM'){
                                        var existDynReg =  $scope.Registers.filter(function ( obj ) {
                                            return obj.ComputerName == 'DynamicMobile' && obj.Available == true;
                                        })[0]; 
                                        // Creates dynamic register and selects it
                                        generateDynamic(existDynReg).then(function(){
                                            assignRegister($scope.settings, 'started').then(function(){
                                                sessionFctr.StartOfDay($scope.settings.pos).then(function (session) {
                                                    $scope.settings.pos.session.SessionID = session.SessionID;
                                                    $scope.settings.pos.session.SessionGUID = session.SessionGUID;
                                                    $scope.settings.pos.session.POSSessionID = session.POSSessionID;
                                                    def.resolve($scope.settings);
                                                });
                                            });
                                        });
                                    } else {
                                        // If the selected register is predefined then display it 
                                        assignRegister($scope.settings, 'started').then(function(){
                                            sessionFctr.StartOfDay($scope.settings.pos).then(function (session) {
                                                $scope.settings.pos.session.SessionID = session.SessionID;
                                                $scope.settings.pos.session.SessionGUID = session.SessionGUID;
                                                $scope.settings.pos.session.POSSessionID = session.POSSessionID;
                                                def.resolve($scope.settings);
                                            });
                                       });
                                    } 
                                });    
                            }
                        };
                        $scope.RegisterCancel = function(){
                            $scope.registerModal.hide();
                        };
                        },function(error){
                            console.log('Register ID Not Fetched');
                            $scope.settings.pos.RegisterCode = null;
                            $ionicLoading.hide();
                            $scope.Cancel();
                            def.resolve(false);
                        });
                        });
                        }
                });
                }
            };
            //Store Selection Cancelled
            $scope.Cancel = function(){
                $scope.storeModal.hide();    
            };
            return def.promise;
        }

        // Save the selected store/register
        function _saveSoSStore(data) {
            // Object is created to store the info in cache
            var POS_SoS_object = new Object();
            POS_SoS_object.startDate = Date.now();
            $f.moduleSetting.pos.Store = POS_SoS_object.store = data.pos.store;
            $f.moduleSetting.pos.Register = POS_SoS_object.register = data.pos.register;
            $f.moduleSetting.pos.Settings = POS_SoS_object.settings = data.pos.settings;
            $f.moduleSetting.pos.Session = POS_SoS_object.session = data.pos.session;
            $f.moduleSetting.pos.sodFloat = POS_SoS_object.sodFloat =  data.pos.sodFloat;
            $f.moduleSetting.pos.Exchanges = POS_SoS_object.Exchanges = data.pos.Exchanges;
            $f.moduleSetting.pos.customerMode = POS_SoS_object.customerMode = data.pos.customerMode;
            
            // This is to keep store/register within global scope
            handleStoreValue.storeValue = POS_SoS_object.store.Code 
            handleStoreValue.registerValue = POS_SoS_object.register.RegisterCode;
            $f.moduleSetting.Store = data.pos.store;
            

            // Session.POST(POS_SOS_object) will go here
            //2. Other Float etc call Goes here
            // confirm floats

            //sessionFctr.EnterFloat($scope).then(function(float){
            
           // })
            /*


            */
            $f.StartPOSSession();
            $scope.param.isSoSActive = $f.isSoSActive;
            posFctr.transaction.$setPOSConfigValue('POS_BOD',POS_SoS_object);
        }

        $scope.startPOSEOD = function(transaction){
            if(!$scope.param.isSoSActive){
                popupFctr.alert('Alert!','No Session Started Yet!');
                return;
            } else {
                isFunctionAllowed().then(function(val){
                    if(val){
                        sessionFctr.IsTransaction($f.POSSystem.retrieve()).then(function(pendingTrans){
                            if(pendingTrans > 0){
                                popupFctr.alert('Alert!','Data transmission in progress </br>' + pendingTrans + ' transaction(s) still pending, </br> Please try again later!');
                            } else if (pendingTrans < 0) {
                                popupFctr.alert('Alert!','Data transmission in progress </br>1+ transaction(s) still pending, </br> Please try again later!');
                            } else {
                                var message="Are you sure you want to end the day?";
                                popupFctr.confirm('Confirmation!',message).then(function (result) {
                                    if (result === true) {
                                        if(transaction){
                                            posFctr.transaction.$delete(JSON.stringify(transaction.number),transaction.type);
                                            localScanService.Reset(JSON.stringify(transaction.number),transaction.type);
                                        }
                                        $ionicLoading.hide();
                                        window.location.href='#/pos/posend/';
                                    }
                                }); 
                            }
                        });
                    }          
                });         
            }
        }
        
        // Generate Dynamic Register
        function generateDynamic(existReg){
            var deferred = $q.defer();
            if(_.isEmpty(existReg)){
                registerFctr.Generate($scope.settings.pos.register).then(function(register) {
                    $scope.settings.pos.register = register;   
                    deferred.resolve(); 
                });
            } else {
                $scope.settings.pos.register = existReg;
                deferred.resolve();
            }
            return deferred.promise;       
        }

        // Assign Register
        function assignRegister(settings,action){
            var deferred = $q.defer();
            tendKeyFctr.$get().then(function(tendKeys){
                $scope.FloatOk = function(skip){
                    var settingRegisterID = settings.pos.register.RegisterID;
                    if(settings.pos.register.ComputerName == 'DynamicMobile'){
                        settingRegisterID = $scope.Registers.filter(function ( obj ) {
                            return obj.RegisterCode == 'DM';
                        })[0].RegisterID;
                    }
                    

                    settingFctr.$getPOS(settingRegisterID).then(function(posSettings){
                        
                        if (!skip){
                            settings.pos.sodFloat = $scope.float.value;
                            settings.pos.Exchanges = $scope.Exchanges;
                        }
                        settings.pos.settings = posSettings;
                        settingFctr.$save(settings).then(function () {               
                            // Display whcih generated register has been assigned
                            popupFctr.alert('Register has been assigned!','Session ' + action + ' in register ' + settings.pos.register.RegisterCode);    

                            if($scope.registerModal)
                                $scope.registerModal.hide();
                            if($scope.floatExchange)
                                $scope.floatExchange.hide();

                            $scope.storeModal.hide(); 
                            $ionicLoading.hide();    
                            deferred.resolve();  
                        }); 
                    });
                };
                $scope.FloatCancel = function(){
                    $scope.floatExchange.hide();
                };

                if(action === 'continued'){
                    $scope.FloatOk(true);
                } else {
                    $scope.Exchanges = tendKeys.filter(function (r) {
                        return (r.ExchangeRate != null  && r.ExchangeRate != 0);
                    });    
                    $scope.float = [];
                    $scope.float.value = 0;
                    $scope.float.readonly = false;
                    $ionicModal.fromTemplateUrl('modules/pos/templates/pos-float-exchange.html', {
                        scope: $scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {  
                        $scope.floatExchange = modal;
                        $ionicLoading.hide();
                        $scope.floatExchange.show();
                    });
                }
               
            });
            return deferred.promise; 
        }

        function getPOSTranSeqCounterFromDatabase(){
            var def = $q.defer();
            //Initialize configuration Object
            var posConfigurationObject = new Object();
            posConfigurationObject.pos_next_sales_tran_no = 1;
            posConfigurationObject.pos_next_quote_tran_no = 1;
            posConfigurationObject.pos_next_order_tran_no = 1;
            posConfigurationObject.pos_next_layaway_tran_no = 1;
            posConfigurationObject.pos_next_rental_tran_no = 1;
            posConfigurationObject.pos_next_repair_tran_no = 1;
            posConfigurationObject.pos_next_giftsregistry_tran_no = 1;
            posConfigurationObject.pos_next_giftcards_tran_no = 1;
            //2.Get Table Entry from Local database
            posFctr.transaction.$getPOSConfigurationValue('POS_TRAN_SEQ_COUNTER').then(function(data){
                if(data!=null){
                    posConfigurationObject =  JSON.parse(data.config_value);
                    def.resolve(posConfigurationObject);
                }else{
                    /** REMOVE BEFORE GO-LIVE [START]**/
                    //This is to handle previous code logic to have unique Transaction Counter
                    //posFctr.transaction.$totalTrans().then(function(_number){
//posConfigurationObject.pos_next_sales_tran_no = _number+1;
                        //DONT REMOVE THIS LINE
                        //Executed First Time when no such Table Entry exists
                        posFctr.transaction.$setPOSConfigValue('POS_TRAN_SEQ_COUNTER',posConfigurationObject);
                        //DONT REMOVE THIS LINE
                        def.resolve(posConfigurationObject);
                    //});
                    /** REMOVE BEFORE GO-LIVE [END]**/
                }
            },function(error){
                console.log('DB: POS_TRAN_SEQ_COUNTER cannot be resolved');
                def.reject('DB: POS_TRAN_SEQ_COUNTER cannot be resolved');
            });
             //a. Sales/Rentals
             return def.promise;
        }

        function syncAndUpdatePOSTranSeqCounterFromDatabase(){
            //1. Get Configuration From API
            //2. Once Retrieved Update Local Database Table to reflect those changes
        }

        function updatePOSTranSeqCounterInDatabase(posTranSeqObject){
            posFctr.transaction.$updatePOSConfigValue('POS_TRAN_SEQ_COUNTER',posTranSeqObject);
        }

        function checkPendingTransactionScan(){
            var def = $q.defer();
            var response = null
            posFctr.transaction.$checkPendingScansPOS().then(function(transaction){
                if(transaction!=null){
                    localScanService.GetScans(transaction.number, transaction.type).
                        then(function(data){
                            if(data!=null && data.length>0)
                                transaction.products = data;
                            def.resolve(transaction);
                        });
                } else {
                    def.resolve(response);
                }
            });
            return def.promise;
        }
    }]);