angular.module('aralco.pos.controllers').controller('posStoreAssignement', ['$scope', '$q', '$ionicLoading', '$filter', '$ionicHistory',
    'taxFctr', 'storeFctr', 'settingFctr', '$state','posFctr',
        function ($scope, $q, $ionicLoading, $filter, $ionicHistory, taxFctr, storeFctr, settingFctr, $state,posFctr) {
            init();

            function init() {
                $scope.Stores = [];
                $scope.settings = null;

                $scope.data = {
                    selectedStore: $f.store
                };

                $ionicLoading.show({
                    template: 'wait...'
                });

                var calls = [storeFctr.Get(), settingFctr.$get()];

                $q.all(calls).then(function (res) {
                    $scope.Stores = res[0];
                    _.each($scope.Stores, function (item) {
                        item.Address = item.Address || {};
                        item.Address.Latitude = item.Address.Latitude || 0;
                        item.Address.Longitude = item.Address.Longitude || 0;
                    });

                    $scope.settings = res[1];
                    if ($scope.settings.pos.store != null) {
                        $scope.data.selectedStore = $scope.settings.pos.store.ID;
                    }

                    $ionicLoading.hide();
                });
            }

            function done() {

                posFctr.transaction.$checkTransactionPendingScans().then(function (data)
                {
                    $ionicLoading.hide();
                    if( data > 0 ){
                        //var storeIDs = data.split("-");
                        if($f.pos_choiceType == 12)
                            window.location.href='#/pos/giftcards/'+data;
                        else 
                            window.location.href='#/pos/products/'+data;
                    }
                    else{

                        window.location.href='#/pos/start/';
                    }
              });
            }
            $scope.Ok = function () {
                $ionicLoading.show({
                    template: 'wait...'
                });

                $scope.settings.pos.store = _.findWhere($scope.Stores, {ID: parseInt($scope.data.selectedStore)});

                taxFctr.$getByStore($scope.data.selectedStore).then(function (taxes) {
                    $scope.settings.pos.store.taxes = taxes;
                    settingFctr.$save($scope.settings).then(function () {
                        done();
                    });
                });
            };

            $scope.Cancel = function () {
                var backView = $ionicHistory.backView();
                var requiredView = backView.stateName;
                $state.go(requiredView);
            }
        }]);