angular.module('aralco.pos.services').factory('posFctr', ['$http', '$rootScope', '$q', '$ionicModal', '$ionicLoading', 'dimFctr',
'$indexedDB','$cordovaSQLite', '$ionicPopup',
    function ($http, $rootScope, $q, $ionicModal, $ionicLoading, dimFctr, $indexedDB,$cordovaSQLite, $ionicPopup) {
        var self = this;

        // --- Below ---  Transaction related
        var table ={
            name:'TRANSACTIONS'
        }
        var scan_type = 3;
        function _createTran(tran) {
            if( tran === undefined )
                return _createTransaction(new transaction());
            else
                return _createTransaction(tran);
        }

        function _createTransaction(tran) {
            /// <summary>
            /// Save the transaction on the database
            /// </summary>
            /// <param name="tran"></param>
            /// <returns type=""></returns>
            var def = $q.defer();
            var query = "INSERT INTO {table} ( number, status,type,value) VALUES \
                    ({number} , {status},{type},'{value}' )"
            .replace("{table}", table.name)
                .replace("{number}", tran.number)
                .replace("{status}", 0)
                .replace("{type}",tran.type)
                .replace("{value}", JSON.stringify(tran).replace(/'/g, "''")); //Refer to Note above

            $cordovaSQLite.execute(db, query).then(function (value) {
                def.resolve(tran);
            }, function (ex) {
                console.log(ex.message);
                def.reject(ex.message);
            });
            /*$indexedDB.openStore('transaction', function (store) {
                store.upsert(tran).then(function (res) {
                    def.resolve(res);
                }, function (err) {
                    def.reject(err);
                });
            });*/

            return def.promise;
        }

        function _updateTran(number) {
            var query = "update  {table} set status = 1 WHERE\
                         number = {TXN_NUMBER} "
                .replace("{table}", table.name)
                .replace("{TXN_NUMBER}",number);
                //.replace("{TXN_STATUS}", 0);

            return $cordovaSQLite.execute(db, query);
        }

        function _deleteTran(number,type) {
            var query = "DELETE FROM {table} WHERE type={TXN_TYPE} AND number = {TXN_NUMBER}"
                        //WHERE\
                        //status = {TXN_STATUS}"
                .replace("{table}", table.name)
                .replace("{TXN_TYPE}",type)
                .replace("{TXN_NUMBER}",number);
                //.replace("{TXN_STATUS}", 0);

            return $cordovaSQLite.execute(db, query);
        }

        function _saveTran(tran) {
            /// <summary>
            /// Save the transaction on the database
            /// </summary>
            /// <param name="tran"></param>
            /// <returns type=""></returns>
            var def = $q.defer();
            var query = "update {table} set value= '{TXN_VALUE}',status={TXN_STATUS} \
                    where number = {TXN_NUMBER}"
                .replace("{table}", table.name)
                .replace("{TXN_NUMBER}", tran.number)
                .replace("{TXN_STATUS}", tran.status)
                .replace("{TXN_VALUE}", JSON.stringify(tran).replace(/'/g, "''")); //Refer to Note above

            $cordovaSQLite.execute(db, query).then(function (value) {
                def.resolve(value);
            }, function (ex) {
                console.log(ex.message);
                def.reject(ex.message);
            });

            return def.promise;
        }

        function _totalTransactions(){
            var def = $q.defer();
            var query = "SELECT * FROM {table} WHERE status=1"
                  .replace("{table}", table.name);
            $cordovaSQLite.execute(db, query).then(
                function (data) {
                    var value= 0;
                    if (data.rows != null && data.rows.length > 0) {
                        value= data.rows.length;
                    }
                    def.resolve(value);
                }, function (ex) {
                    def.reject(ex.message);
            });
            return def.promise;
        }

        function _findTran(tranId) {
            var def = $q.defer();
            tranId = parseInt(tranId);

            var query = "SELECT * FROM {table} \
                    WHERE  number= {TXN_NUMBER} AND \
                           status = {TXN_STATUS}"
                  .replace("{table}", table.name)
                   .replace("{TXN_NUMBER}", tranId)
                   .replace("{TXN_STATUS}", 0);
            $cordovaSQLite.execute(db, query).then(
                function (data) {
                    if (data.rows != null && data.rows.length > 0) {
                        var retval = [];
                        for (var i = 0; i < data.rows.length; i++) {
                            var ci = data.rows.item(i);
                            var _transaction = new transaction();
                            _.extend(_transaction, (JSON.parse (ci.value)));
                            _transaction.number = ci.number;
                            retval.push(_transaction);
                        }
                        //We know there will always be only one Transaction per Txn Number
                        data = retval[0];

                    }
                    else {
                        data = null;
                    };

                    def.resolve(data);

                }, function (ex) {

                    console.log(ex.message);
                    def.reject(ex.message);
            });
            return def.promise;
        }

        function _checkTranPendingScans(type) {
            var def = $q.defer();
            var query = "SELECT * FROM {table} where status ={TXN_STATUS} AND type ={TXN_TYPE}"
                  .replace("{table}", table.name)
                   .replace("{TXN_STATUS}", 0)
                   .replace("{TXN_TYPE}",type);
            $cordovaSQLite.execute(db, query).then(
                function (data) {
                    var value = -1;
                    if (data.rows != null && data.rows.length > 0) {
                        for (var i = 0; i < data.rows.length; i++) {
                            var ci = data.rows.item(i);
                            var _transaction = new transaction();
                            _.extend(_transaction, (JSON.parse (ci.value)));
                            _transaction.number = ci.number;
                            //if(_transaction.products.length>0){
                                value = _transaction.number;
                                break;
                            //}
                        }
                    }
                    else {
                        value = -1;
                    };

                    def.resolve(value);

                }, function (ex) {
                    console.log(ex.message);
                    def.reject(ex.message);
                });

            return def.promise;
        }

        function _checkPendingScansPOS() {
            var def = $q.defer();
            var query = "SELECT * FROM {table} where status ={TXN_STATUS}"
                  .replace("{table}", table.name)
                   .replace("{TXN_STATUS}", 0);
            $cordovaSQLite.execute(db, query).then(
                function (data) {
                    if (data.rows != null && data.rows.length > 0) {
                        for (var i = 0; i < data.rows.length; i++) {
                            var ci = data.rows.item(i);
                            var _transaction = new transaction();
                            _.extend(_transaction, (JSON.parse (ci.value)));
                            break;
                        }
                    }
                    else {
                       var _transaction = null;
                    };

                    def.resolve(_transaction);

                }, function (ex) {
                    console.log(ex.message);
                    def.reject(ex.message);
            });
            return def.promise;
        };

        function _setPOSConfigValue(configName,configValue){
            var def = $q.defer();
            var query = "insert into POS_CONFIG (config_value,config_status,config_name)  VALUES  \
                        ('{CONFIG_VALUE}',1 ,'{CONFIG_NAME}')"
                .replace("{CONFIG_NAME}", configName)
                .replace("{CONFIG_VALUE}", JSON.stringify(configValue).replace(/'/g, "''")); //Refer to Note above

            $cordovaSQLite.execute(db, query).then(function (value) {
                def.resolve(value);
            }, function (ex) {
                console.log(ex.message);
                def.reject(ex.message);
            });
            return def.promise;
        }

        function _getPOSConfigValue(configName){
            var def = $q.defer();
            var query = "SELECT * FROM POS_CONFIG where  config_name='{CONFIG_NAME}' and config_status=1"
                        .replace("{CONFIG_NAME}", configName);
            $cordovaSQLite.execute(db, query).then(
                function (data) {
                    if (data.rows != null && data.rows.length > 0) {
                        def.resolve(data.rows.item(0));
                    }
                    else{
                        def.resolve(null);
                    }
                },function (ex) {
                    console.log(ex.message);
                    def.reject(ex.message);
                });
            return def.promise;
        }

        function _updatePOSConfigValue(configName,configValue){
            var def = $q.defer();
            var query = "update POS_CONFIG set  \
                        config_value = '{CONFIG_VALUE}' WHERE config_name = '{CONFIG_NAME}'"
                .replace("{CONFIG_NAME}", configName)
                .replace("{CONFIG_VALUE}", JSON.stringify(configValue).replace(/'/g, "''")); //Refer to Note above

            $cordovaSQLite.execute(db, query).then(function (value) {
                def.resolve(value);
            }, function (ex) {
                console.log(ex.message);
                def.reject(ex.message);
            });
            return def.promise;
        }

        function _deactivatePOSconfigValue(configName){
            var def = $q.defer();
            var query = "update POS_CONFIG set config_status=0 \
                    where config_name = '{CONFIG_NAME}'"
                .replace("{CONFIG_NAME}", configName);

            $cordovaSQLite.execute(db, query).then(function (value) {
                def.resolve(value);
            }, function (ex) {
                console.log(ex.message);
                def.reject(ex.message);
            });
            return def.promise;
        }

        function _completeTransaction(productDetails){
            // debugger;
            var def= $q.defer();
            var isProductItems = [];
            var paymentItems = [];
            var process = '';
            
            switch(productDetails.type){
                case 7:
                    process = 'order/process';
                    break;
                case 8:
                    process = 'order/process';
                    break;
                case 0:
                    process = 'transaction/process';
                    break;    
                default:
                    process = 'order/process';
                    break;
            }
            var url = $f.serviceUrl + process;
           

            var billingAddress = null;
            var shippingAddress = null;
            var payment = null;
            var customerId = null;
            var paymentMethod = null;

            var totalDiscount = 0;

            for(var i=0;i<productDetails.products.length;i++){
                var gridDim =  _getGridDim(productDetails.products[i].product);
                var tax1 = null;
                var tax2 = null;
                if(productDetails.products[i].product.taxes){
                    tax1 = productDetails.products[i].product.taxes[0] ? productDetails.products[i].product.taxes[0].item_applicable : false;
                    tax2 = productDetails.products[i].product.taxes[1] ? productDetails.products[i].product.taxes[1].item_applicable : false;
                }
                var items = {
                    "productId": productDetails.products[i].product.ID,
                    "code": productDetails.products[i].product.Code,
                    "barcode": productDetails.products[i].product.Barcode,
                    "price":productDetails.products[i].product.RetailPrice,
                    "cost":productDetails.products[i].product.Cost,
                    "discount": productDetails.products[i].discount,
                    "quantity": productDetails.products[i].Quantity,
                    "weight": productDetails.products[i].product.UnitWeight,
                    "remarks": productDetails.products[i].remarks,
                    "dimensionId1": gridDim.Dim1.ID,
                    "dimensionId2": gridDim.Dim2.ID,
                    "dimensionId3": gridDim.Dim3.ID,
                    "dimensionId4": gridDim.Dim4.ID,
                    "gridId1": gridDim.Grid1.ID,
                    "gridId2": gridDim.Grid2.ID,
                    "gridId3": gridDim.Grid3.ID,
                    "gridId4": gridDim.Grid4.ID,
                    "dimensionName1": gridDim.Dim1.Name,
                    "dimensionName2": gridDim.Dim2.Name,
                    "dimensionName3": gridDim.Dim3.Name,
                    "dimensionName4": gridDim.Dim4.Name,
                    "gridName1": gridDim.Grid1.Value,
                    "gridName2": gridDim.Grid2.Value,
                    "gridName3": gridDim.Grid3.Value,
                    "gridName4": gridDim.Grid4.Value,
                    "hasTax1": tax1,
                    "hasTax2": tax2,
                    "transTypeAbbr": productDetails.products[i].returnFlag ? 1 : 0
                }
                totalDiscount += productDetails.products[i].discount;
                isProductItems.push(items);
            }

            if(productDetails.customer != null){
                customerId = productDetails.customer.ID;

                billingAddress = {
                    "name": productDetails.customer.Contact.Name ,
                    "surname": productDetails.customer.Contact.Surname,
                    "companyName": productDetails.customer.Company,
                    "address1": productDetails.customer.Contact.Address.Address1,
                    "address2": productDetails.customer.Contact.Address.Address2,
                    "city": productDetails.customer.Contact.Address.City,
                    "provinceState": productDetails.customer.Contact.Address.ProvinceState,
                    "country": productDetails.customer.Contact.Address.Country,
                    "zipPostalCode": productDetails.customer.Contact.Address.ZipPostalCode,
                    "phone": productDetails.customer.Contact.Contact.Phone1,
                    "email": productDetails.customer.Contact.Contact.Email
                }

                var shippingAddress = {
                    "name": productDetails.customer.Contact.Name,
                    "surname": productDetails.customer.Contact.Surname,
                    "companyName": productDetails.customer.Company,
                    "address1": productDetails.customer.Contact.Address.Address1,
                    "address2": productDetails.customer.Contact.Address.Address2,
                    "city": productDetails.customer.Contact.Address.City,
                    "provinceState": productDetails.customer.Contact.Address.ProvinceState,
                    "country": productDetails.customer.Contact.Address.Country,
                    "zipPostalCode": productDetails.customer.Contact.Address.ZipPostalCode,
                    "phone": productDetails.customer.Contact.Contact.Phone1,
                    "email": productDetails.customer.Contact.Contact.Email
                }
            }

            for(var i=0;i<productDetails.payments.length;i++){
                var paymentMethod = {
                    "TenderCode": productDetails.payments[i].Code,
                    "ScrDesc": productDetails.payments[i].FullDescription,
                    "Desc": productDetails.payments[i].Description || "",
                    "Status": productDetails.payments[i].Status,
                    "Message": productDetails.payments[i].Message || "",
                    "Amount": productDetails.payments[i].amount,
                    "ExchAmount": productDetails.payments[i].exchAmount,
                    "AuthorizationNumber": productDetails.payments[i].AuthorizationNumber|| "",
                    "ReferenceNumber": productDetails.payments[i].ReferenceNumber|| "",
                    "PaymentMethod": "",
                    "GiftCard": productDetails.payments[i].GiftCard
                }
                paymentItems.push(paymentMethod);
            }

            var payment = {
                "message": productDetails.remarks,
                "status": productDetails.status,
                "subTotal": productDetails.subTotal,
                "discount": totalDiscount,
                "shipping": 0.00, // nahi mil raha hai
                "tax1": productDetails.taxes[0] ? productDetails.taxes[0].total : 0,
                "tax1ID": productDetails.taxes[0] ? productDetails.taxes[0].id : 0,
                "tax2": productDetails.taxes[1] ? productDetails.taxes[1].total : 0,
                "tax2ID": productDetails.taxes[1] ? productDetails.taxes[1].id : 0,
                "total": productDetails.total,
                "totalPaid": productDetails.paid,
                "totalDue": productDetails.balance,
                "pointsIssued": productDetails.pointsEarned,
                "pointsSpent": productDetails.pointsSpent
            }

            var paramsValues =  {
                "clerkId": $f.UserInfo.EmployeeID,
                "transType": productDetails.type,
                "customerId": customerId,
                "SessionID": productDetails.session.SessionID,
                "SessionGUID": productDetails.session.SessionGUID,
                "POSSystem": $f.POSSystem.retrieve(),
                "Receipt": productDetails.receipt,
                "remarks": productDetails.remarks,
                "storeid": productDetails.store.ID,
                "regCode": productDetails.register.RegisterCode,
                "registerId": productDetails.register.RegisterID,
                "items":isProductItems,
                "billingAddress": billingAddress,
                "shippingAddress": shippingAddress,
                "payment": payment,
                "paymentMethods": paymentItems,
                "eventName": productDetails.eventName
            }

            var req = {
                method: 'post',
                url: url,
                data: paramsValues
            };
            
            $http(req).
                success(function (data, status, headers, config) {
                    console.log("Pos Register ID  Fetched successfully");
                    def.resolve(data)
                }).
                error(function (data, status) {
                    console.log("Pos Register ID Not FETCHED");
                    def.reject(data, status);
                });
            return def.promise;
        }

        function _getGridDim(product){
            var gridDim = {
                Grid1:{ID: '', Value:''},
                Grid2:{ID: '', Value:''},
                Grid3:{ID: '', Value:''},
                Grid4:{ID: '', Value:''},
                Dim1:{ID: '', Name:''},
                Dim2:{ID: '', Name:''},
                Dim3:{ID: '', Name:''},
                Dim4:{ID: '', Name:''},
            };
                gridDim.Grid1 = product.Grid1 ? product.Grid1 : gridDim.Grid1;
                gridDim.Grid2 = product.Grid2 ? product.Grid2 : gridDim.Grid2;
                gridDim.Grid3 = product.Grid3 ? product.Grid3 : gridDim.Grid3;
                gridDim.Grid4 = product.Grid4 ? product.Grid4 : gridDim.Grid4;
                if(product.Matrix){
                    gridDim.Dim1  = product.Matrix.Dimension1 ? product.Matrix.Dimension1 : gridDim.Dim1;
                    gridDim.Dim2  = product.Matrix.Dimension2 ? product.Matrix.Dimension2 : gridDim.Dim2;
                    gridDim.Dim3  = product.Matrix.Dimension3 ? product.Matrix.Dimension3 : gridDim.Dim3;
                    gridDim.Dim4  = product.Matrix.Dimension4 ? product.Matrix.Dimension4 : gridDim.Dim4;
                }
            return gridDim;
        }

        function _enterEventName($scope){
            /// <summary>
            /// Require Event Name
            /// </summary>
            var def = $q.defer();
            $ionicLoading.hide();
            $scope.eventNameInputEnterEvent = function(e){
                if( !$scope.param.eventName || _.isEmpty($scope.param.eventName)){
                    e.preventDefault();
                }
                else{               
                    var retVal = $scope.param.eventName;
                    $scope.param.eventName = null;
                    if ((retVal)) {
                        if(EventNameInput)
                            EventNameInput.close();
                        def.resolve(retVal);
                    }
                }   
            }
            var EventNameInput = $ionicPopup.show({
                template: '<input name="eventName_input" id="eventNameInput" autofocus type="text" inputmode="text" data-ng-enter="eventNameInputEnterEvent($event)" ng-model="param.eventName">',
                title: 'Enter Event Name',
                scope: $scope,
                buttons: [{ text: 'Cancel',
                    type: 'custom-popup-buttons'
                    },
                    {
                        text: '<b>Enter</b>',
                        type: 'button-positive',
                        onTap: function (e) {                  
                        //var pattern_input_qty = "/^[0-9]+(\.[0-9]{1,2})?$/";
                        if(!$scope.param.eventName || _.isEmpty($scope.param.eventName)){
                            //don't allow the user to close unless he enters wifi password
                            e.preventDefault();
                        }
                        else {
                            var retVal = $scope.param.eventName;
                            $scope.param.eventName = null;
                            return retVal;
                        }
                        }
                    }
                ]
            });     
            EventNameInput.then(function (res) {
                if ((res)) {
                    def.resolve(res);
                }
            });     
            return def.promise;
        }

        self.transaction = {
            $eventName: _enterEventName,
            $get: _findTran,
            $checkTransactionPendingScans: _checkTranPendingScans,
            $checkPendingScansPOS : _checkPendingScansPOS,
            $save: _saveTran,
            $update:_updateTran,
            $totalTrans : _totalTransactions,
            $create: _createTran,
            $delete: _deleteTran,
            $getPOSConfigurationValue: _getPOSConfigValue,
            $deletePosConfigurationValue:_deactivatePOSconfigValue,
            $setPOSConfigValue :_setPOSConfigValue,
            $updatePOSConfigValue :_updatePOSConfigValue,
            $completeTransaction : _completeTransaction
        };

        return self;
    }]);