(function () {
    
	var module = angular.module('aralco.posusergroups',['ionic']);
	
	module.factory('posuserGroupFactory', function($filter) {

        var elementId = 7;

        var groupList = [
            {
                name: "Allow Authorization of Purchase Order",
                value: false
            },
            {
                name: "Allow Bill to a Different Customer",
                value: false
            },
            {
                name: "Allow Bypass Minimum Deposite",
                value: false
            },
            {
                name: "Allow cancel item (Restaurent)",
                value: false
            },
            {
                name: "Allow changing tender on return",
                value: false
            },
            {
                name: "Allow Customer Credit Limit Override",
                value: false
            },
            {
                name: "Allow Deleting payments",
                value: false
            },
            {
                name: "Allow EOD Reprint",
                value: false
            },
            {
                name: "Allow Inventory Lookup Drillldown",
                value: false
            },
            {
                name: "Allow Maximum Discount Override",
                value: false
            },
            {
                name: "Allow New On Account Customer",
                value: false
            },
            {
                name: "Allow Oversell",
                value: false
            },
            {
                name: "Allow Viewing Reports",
                value: false
            },
            {
                name: "Bypass Staff Scheduling",
                value: false
            },
            {
                name: "Card Authorization Override",
                value: false
            },
            {
                name: "Change POS Settings",
                value: false
            },
            {
                name: "Changing Sales Person on transaction",
                value: false
            },
            {
                name: "Customer Account Tab",
                value: false
            },
            {
                name: "Customer Add",
                value: false
            },
            {
                name: "Customer Deletion",
                value: false
            },
            {
                name: "Customer Discount Rate",
                value: false
            },
            {
                name: "Customer Edit",
                value: false
            },
            {
                name: "Discount",
                value: false
            },
            {
                name: "Download data from Back Office",
                value: false
            },
            {
                name: "End of Day",
                value: false
            },
            {
                name: "End of Day (Recalculate)",
                value: false
            },
            {
                name: "Fingerprint Edit",
                value: false
            },
            {
                name: "Fingerprint Login Override",
                value: false
            },
            {
                name: "Price Override",
                value: false
            },
            {
                name: "Returns",
                value: false
            },
            {
                name: "Setup menu on POS",
                value: false
            },
            {
                name: "Ship From",
                value: false
            },
            {
                name: "Staff Hours Edit",
                value: false
            },
            {
                name: "Staff Hours View",
                value: false
            },
            {
                name: "Unlock Order",
                value: false
            },
            {
                name: "Use an Unknown Credit Note",
                value: false
            },
            {
                name: "Use an Unknown Gift Certificate",
                value: false
            },
            {
                name: "View and Edit Costs",
                value: false
            },
            {
                name: "View Costs in Inventory Drill Down",
                value: false
            },
            {
                name: "View Inventory from all zones",
                value: false
            },
            {
                name: "Voids",
                value: false
            }            
        ];
            
		var posuserGroups = [
			{
                ID: 1,
                name: "Administrator",
                desc: "Administrator",
                groups: angular.copy(groupList)
            },
            {
                ID: 2,
                name: "Part Time Staff",
                desc: "Part Time Staff",
                groups: angular.copy(groupList)
            },
            {
                ID: 3,
                name: "Manager",
                desc: "Manager",
                groups: angular.copy(groupList)
            },
            {
                ID: 4,
                name: "Backup",
                desc: "Backup",
                groups: angular.copy(groupList)
            },
            {
                ID: 5,
                name: "1",
                desc: "1",
                groups: angular.copy(groupList)
            },
            {
                ID: 6,
                name: "2",
                desc: "2",
                groups: angular.copy(groupList)
            }
		];

		return {
			getPOSuserGroups : function(searchText) {
				return $filter('filter')(posuserGroups, {name: searchText})
            },
            getGroupList : function() {
                return groupList;
            },
            addPOSuserGroup : function(posuserGroup) {
                var temp = {
                    ID: elementId++,
                    name: posuserGroup.name,
                    desc: posuserGroup.desc,
                    groups: angular.copy(posuserGroup.groups)
                }

                posuserGroups.push(temp);
            },
            deletePOSuserGroup: function(item) {
                var index = posuserGroups.findIndex(posuserGroup => posuserGroup.ID == item.ID);
                posuserGroups.splice(index, 1);
            },
            savePOSuserGroup: function(item,posuserGroup) {
                var index = posuserGroups.findIndex(posuserGroup => posuserGroup.ID == item.ID);
                posuserGroups[index].name = posuserGroup.name;
                posuserGroups[index].desc = posuserGroup.desc;
                posuserGroups[index].groups =angular.copy(posuserGroup.groups);
			},
			getPOSuserGroupByIndex : function(item) {
                return posuserGroups.filter(posuserGroup => posuserGroup.ID == item.ID)[0];
            }
		};
    });
    
	module.config(['$stateProvider', '$provide', '$urlRouterProvider',
	'$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
		$stateProvider
		.state('tab.posusergroups', {
			url: '/posusergroups',
			LoginRequired: true,
			views: {
				'tab-view': {
					templateUrl: 'modules/common_html/templates/view.html',
					controller: 'POSuserGroupController'
				}
			}
		})
		.state('tab.editposusergroups', {
			url: '/editposusergroup/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/posuser_groups/templates/posuser-groups-edit.html',
                    controller: 'EditPOSuserGroupController'
				}
			}
		})
		.state('tab.addposusergroups', {
			url: '/editposusergroup/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/posuser_groups/templates/posuser-groups-edit.html',
                    controller: 'AddPOSuserGroupController'
				}
			}	
		})
	}]);

    module.controller('POSuserGroupController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,posuserGroupFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;
        $scope.title = "Manage POS User Groups";
        $scope.searchTitle = "POSuser Groups"

        
       

        
            
            {
        }

        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'edit' && $scope.selectedItem != null){
                $state.go('tab.editposusergroups',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'add'){
                $state.go('tab.addposusergroups',{name: 'add'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteItem = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        posuserGroupFactory.deletePOSuserGroup($scope.selectedItem);
                        $rootScope.$emit('updatePOSuserGroups', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }

        $scope.searchItem = function() {
            $scope.entries = angular.copy(posuserGroupFactory.getPOSuserGroups($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updatePOSuserGroups', function(event, arg) {
            $scope.entries = angular.copy(posuserGroupFactory.getPOSuserGroups($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditPOSuserGroupController', function($scope,$state,$stateParams,$ionicPopup,$ionicHistory,$filter,$rootScope,posuserGroupFactory){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.posuserGroup = angular.copy(posuserGroupFactory.getPOSuserGroupByIndex($scope.selectedItem));
        $scope.posuserGroup.groups = $filter('orderBy')($scope.posuserGroup.groups,['-value','name']);
        $scope.searchTitle = $scope.posuserGroup.name;
        $scope.title = "Edit POS User Groups";

        
       

        
            
            {
        }

        $scope.autoFillDescription = function() {
            if($scope.posuserGroup.desc.length == 0) {
                $scope.posuserGroup.desc = $scope.posuserGroup.name;
            }
        }

        $scope.goBack = function() {
            var POSuserGroup = angular.copy(posuserGroupFactory.getPOSuserGroupByIndex($scope.selectedItem));
            POSuserGroup.groups = $filter('orderBy')(POSuserGroup.groups,['-value','name']);

            if(!angular.equals($scope.posuserGroup, POSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePOSuserGroup(); 
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.savePOSuserGroup = function() {
            posuserGroupFactory.savePOSuserGroup($scope.selectedItem,$scope.posuserGroup);
            $rootScope.$emit('updatePOSuserGroups', {
                editType: "Saved"
            });
            var popupMessage = $ionicPopup.alert( {
                title: 'Record saved successfully.',
                subTitle: ''
            })
            $scope.posuserGroup.groups = $filter('orderBy')($scope.posuserGroup.groups,['-value','name']);
        }

        $scope.clearPOSuserGroup = function() {
            var POSuserGroup = angular.copy(posuserGroupFactory.getPOSuserGroupByIndex($scope.selectedItem));
            POSuserGroup.groups = $filter('orderBy')(POSuserGroup.groups,['-value','name']);

            if(!angular.equals($scope.posuserGroup, POSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePOSuserGroup(); 
                    }
                    else{
                        $scope.posuserGroup = angular.copy(posuserGroupFactory.getPOSuserGroupByIndex($scope.selectedItem));
                        $scope.posuserGroup.groups = $filter('orderBy')($scope.posuserGroup.groups,['-value','name']);
                    }
                })
            }
        }

        $scope.deletePOSuserGroup = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    posuserGroupFactory.deletePOSuserGroup($scope.selectedItem);
                    $rootScope.$emit('updatePOSuserGroups', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            var POSuserGroup = angular.copy(posuserGroupFactory.getPOSuserGroupByIndex($scope.selectedItem));
            POSuserGroup.groups = $filter('orderBy')(POSuserGroup.groups,['-value','name']);

            if(!angular.equals($scope.posuserGroup, POSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.posuserGroup = angular.copy(posuserGroupFactory.getPOSuserGroupByIndex($scope.selectedItem));
                        $scope.posuserGroup.groups = $filter('orderBy')($scope.posuserGroup.groups,['-value','name']);
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('AddPOSuserGroupController', function($scope,$ionicPopup,$ionicHistory,$rootScope,posuserGroupFactory){
        $scope.showSearchbar = true;
        $scope.title = "Add POS User Group";

        $scope.posuserGroup = {
            name : "",
            desc : "",
            groups: angular.copy(posuserGroupFactory.getGroupList())
        }
        var oriPOSuserGroup = angular.copy($scope.posuserGroup);

        $scope.autoFillDescription = function() {
            if($scope.posuserGroup.desc.length == 0) {
                $scope.posuserGroup.desc = angular.copy($scope.posuserGroup.name);
            }
        }

        
       //var margintop = 75 + subtoppadding - 55;

        
            
            {
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.posuserGroup, oriPOSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePOSuserGroup(); 
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.savePOSuserGroup = function() {
            if(!angular.equals($scope.posuserGroup, oriPOSuserGroup)) {
                posuserGroupFactory.addPOSuserGroup($scope.posuserGroup);
                $rootScope.$emit('updatePOSuserGroups', {
                    editType: "Added"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                }).then(function() {
                    $scope.posuserGroup = angular.copy(oriPOSuserGroup);
                })
            }
        }

        $scope.addPOSuserGroup = function() {
            $scope.clearPOSuserGroup();
        }

        $scope.clearPOSuserGroup = function() {
            if(!angular.equals($scope.posuserGroup, oriPOSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePOSuserGroup(); 
                    }
                    $scope.posuserGroup = angular.copy(oriPOSuserGroup);
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.posuserGroup, oriPOSuserGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.posuserGroup = angular.copy(oriPOSuserGroup); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })
})();