(function () {
    
	var module = angular.module('aralco.pricezones',['ionic']);
	
	module.factory('priceZoneFactory', function($filter) {

        var elementId = 17;

        var zoneList = [
            "1-B.C. Prices",
            "2-Alberta",
            "3-Ontario",
            "4-U.S.A.",
            "5-Web",
            "Airport @ US$",
            "Amazon",
            "Duabi",
            "eBay",
            "Jamaican",
            "Kerrisdale",
            "Kuwait",
            "Mount pleasant",
            "Rental",
            "Saudi Arabia",
            "wholesale"
        ];

		var priceZones = [
			{
                ID: 1,
                name: "1-B.C. Prices",
                desc: "1-B.C. Prices",
                importPriceFrom: ""
            },
            {
                ID: 2,
                name: "2-Alberta",
                desc: "2-Alberta",
                importPriceFrom: ""
            },
            {
                ID: 3,
                name: "3-Ontario",
                desc: "3-Ontario",
                importPriceFrom: ""
            },
            {
                ID: 4,
                name: "4-U.S.A.",
                desc: "4-U.S.A.",
                importPriceFrom: ""
            },
            {
                ID: 5,
                name: "5-Web",
                desc: "5-Web",
                importPriceFrom: ""
            },
            {
                ID: 6,
                name: "Airport @ US$",
                desc: "Airport @ US$",
                importPriceFrom: ""
            },
            {
                ID: 7,
                name: "Amazon",
                desc: "Amazon",
                importPriceFrom: ""
            },
            {
                ID: 8,
                name: "Duabi",
                desc: "Duabi",
                importPriceFrom: ""
            },
            {
                ID: 9,
                name: "eBay",
                desc: "eBay",
                importPriceFrom: ""
            },
            {
                ID: 10,
                name: "Jamaican",
                desc: "Jamaican",
                importPriceFrom: ""
            },
            {
                ID: 11,
                name: "Kerrisdale",
                desc: "Kerrisdale",
                importPriceFrom: ""
            },
            {
                ID: 12,
                name: "Kuwait",
                desc: "Kuwait",
                importPriceFrom: ""
            },
            {
                ID: 13,
                name: "Mount pleasant",
                desc: "Mount pleasant",
                importPriceFrom: ""
            },
            {
                ID: 14,
                name: "Rental",
                desc: "Rental",
                importPriceFrom: ""
            },
            {
                ID: 15,
                name: "Saudi Arabia",
                desc: "Saudi Arabia",
                importPriceFrom: ""
            },
            {
                ID: 16,
                name: "wholesale",
                desc: "wholesale",
                importPriceFrom: ""
            }
		];

		return {
			 getPriceZones : function(searchText) {
                return $filter('filter')(priceZones, {name: searchText})
             },
             getZoneList : function() {
                return zoneList;
            },
			 addPriceZone : function(priceZone) {
				var temp = {
                    ID: elementId++,
					name: priceZone.name,
                    desc: priceZone.desc,
                    importPriceFrom: priceZone.importPriceFrom
				}

				priceZones.push(temp);
			 },
			 deletePriceZone: function(item) {
                var index = priceZones.findIndex(priceZone => priceZone.ID == item.ID);
                priceZones.splice(index, 1);
             },
			 savePriceZone: function(item,priceZone) {
                var index = priceZones.findIndex(priceZone => priceZone.ID == item.ID);
				priceZones[index].name = priceZone.name;
                priceZones[index].desc = priceZone.desc;
                priceZones[index].importPriceFrom = priceZone.importPriceFrom;
			},
			getPriceZoneByIndex : function(item) {
                return priceZones.filter(priceZone => priceZone.ID == item.ID)[0];
            }
		};
    });
	
	module.config(['$stateProvider', '$provide', '$urlRouterProvider',
	'$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
		$stateProvider
		.state('tab.pricezones', {
			url: '/pricezones',
			LoginRequired: true,
			views: {
				'tab-view': {
					templateUrl: 'modules/common_html/templates/view.html',
					controller: 'PriceZoneController'
				}
			}
		})
		.state('tab.editpricezones', {
			url: '/editpricezone/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/price_zones/templates/price-zones-edit.html',
                    controller: 'EditPriceZoneController'
				}
			}
		})
		.state('tab.addpricezones', {
			url: '/editpricezone/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/price_zones/templates/price-zones-edit.html',
                    controller: 'AddPriceZoneController'
				}
			}	
		})
	}]);

    module.controller('PriceZoneController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,priceZoneFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;
        $scope.title = "Manage Price Zones";
        $scope.searchTitle = "Price Zones";

        
       

        
            
            {
        }

        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'edit' && $scope.selectedItem != null){
                $state.go('tab.editpricezones',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'add'){
                $state.go('tab.addpricezones',{name: 'add'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteItem = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        priceZoneFactory.deletePriceZone($scope.selectedItem);
                        $rootScope.$emit('updatePriceZones', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }

        $scope.searchItem = function() {
            $scope.entries = angular.copy(priceZoneFactory.getPriceZones($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updatePriceZones', function(event, arg) {
            $scope.entries = angular.copy(priceZoneFactory.getPriceZones($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditPriceZoneController', function($scope,$state,$stateParams,$ionicPopup,$ionicHistory,$rootScope,priceZoneFactory){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.priceZone = angular.copy(priceZoneFactory.getPriceZoneByIndex($scope.selectedItem));
        $scope.searchTitle = $scope.priceZone.name;
        $scope.title = "Edit Zone";
        $scope.zoneList = angular.copy(priceZoneFactory.getZoneList());

        
       

        
            
            {
        }

        $scope.autoFillDescription = function() {
            if($scope.priceZone.desc.length == 0) {
                $scope.priceZone.desc = $scope.priceZone.name;
            }
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.priceZone, priceZoneFactory.getPriceZoneByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePriceZone(); 
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.savePriceZone = function() {
            priceZoneFactory.savePriceZone($scope.selectedItem,$scope.priceZone);
            $rootScope.$emit('updatePriceZones', {
                editType: "Saved"
            });            
            var popupMessage = $ionicPopup.alert( {
                title: 'Record saved successfully.',
                subTitle: ''
            })
        }

        $scope.clearPriceZone = function() {
            if(!angular.equals($scope.priceZone, priceZoneFactory.getPriceZoneByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePriceZone(); 
                    }
                    else{
                        $scope.priceZone = angular.copy(priceZoneFactory.getPriceZoneByIndex($scope.selectedItem));
                    }
                })
            }
        }

        $scope.deletePriceZone = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    priceZoneFactory.deletePriceZone($scope.selectedItem);
                    $rootScope.$emit('updatePriceZones', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.priceZone, priceZoneFactory.getPriceZoneByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.priceZone = angular.copy(priceZoneFactory.getPriceZoneByIndex($scope.selectedItem));
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('AddPriceZoneController', function($scope,$ionicPopup,$ionicHistory,$rootScope,priceZoneFactory){
        $scope.showSearchbar = true;
        $scope.title = "Add Price Zone";
        $scope.zoneList = angular.copy(priceZoneFactory.getZoneList());
        $scope.priceZone = {
            name : "",
            desc : "",
            importPriceFrom: ""
        }
        var oriPriceZone = angular.copy($scope.priceZone);

        $scope.autoFillDescription = function() {
            if($scope.priceZone.desc.length == 0) {
                $scope.priceZone.desc = angular.copy($scope.priceZone.name);
            }
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.priceZone, oriPriceZone)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePriceZone(); 
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.savePriceZone = function() {
            if(!angular.equals($scope.priceZone, oriPriceZone)) {
                priceZoneFactory.addPriceZone($scope.priceZone);
                $rootScope.$emit('updatePriceZones', {
                    editType: "Added"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                }).then(function() {
                    $scope.priceZone = angular.copy(oriPriceZone);
                })
            }
        }

        $scope.addPriceZone = function() {
            $scope.clearPriceZone();
        }

        $scope.clearPriceZone = function() {
            if(!angular.equals($scope.priceZone, oriPriceZone)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePriceZone(); 
                    }
                    $scope.priceZone = angular.copy(oriPriceZone);
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.priceZone, oriPriceZone)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.priceZone = angular.copy(oriPriceZone); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })
})();