﻿/// <reference path="../../js/aaralco.mobile.fwaralco.mobile.fw.js" />
/// <reference path="../../Scripts/underscore.js" />
(function () {
    'use strict';

    var module = angular.module('aralco.product', ['aralco.images', 'aralco.setting','aralco.product.controllers', 'aralco.product.services']);

    module.config(['$stateProvider', '$urlRouterProvider', function ($stateProvider, $urlRouterProvider) {
        // Each tab has its own nav history stack:
        $stateProvider
            .state('tab.products', {
                url: '/products',
                views: {
                    'tab-inventory': {
                        templateUrl: 'modules/product/templates/tab-products.html',
                        controller: 'ProdCtr'
                    }
                }
            })
            .state('tab.product-detail', {
                url: '/product/:prodId',
                views: {
                    'tab-inventory': {
                        templateUrl: 'modules/product/templates/product-detail.html',
                        controller: 'ProdDetailCtrl'
                    }
                }
            })
            .state('tab.product-inventory', {
                url: '/product/:prodId/Inventory',
                views: {
                    'tab-inventory': {
                        templateUrl: 'modules/product/templates/product-inventory.html',
                        controller: 'ProdInventory'
                    }
                }
            });
    }]);

    module.directive('productsFilterSetting', function () {
        return {
            transclude: true,
            templateUrl: 'modules/product/templates/products-filter-setting.html',
        };
    });

})();
