angular.module('aralco.product.controllers').controller('ProdCtr', ['$scope', '$state', '$ionicSideMenuDelegate', '$ionicLoading', 'prodFctr', '$filter', '$ionicPopover', 'popupFctr','departmentFctr','$ionicModal',
    function ($scope, $state, $ionicSideMenuDelegate, $ionicLoading, prodFctr, $filter, $ionicPopover, popupFctr,departmentFctr,$ionicModal) {
        $scope.toggleLeft = function () {
            $ionicSideMenuDelegate.toggleLeft();
        };
        var settings = {};
        $scope.enableFilter = true;
        $scope.clearSearch = function () {
            $scope.param.grids = {
                grid1: null,
                grid2: null,
                grid3: null,
                grid4: null
            };
            $scope.param.price_range = {
                min: null,
                max: null
            };
        };

        $scope.$watchGroup(['param.grids.grid1', 'param.grids.grid2', 'param.grids.grid3', 'param.grids.grid4', 'param.price_range.min', 'param.price_range.max'], function () {
            $scope.searchDescription = AdvancedDescription();
        });

        $scope.clear = function () {
            init();
        };

        $scope.searchDepartment = function () {
          $scope.param.limit=15;
          $scope.param.begin =0;
          $scope.copyBeginValue= 0;
          $ionicLoading.show({
              template:'wait...'
          })
          if(_.isEmpty($scope.departments)){
              departmentFctr.$LoadDepartments().then(
              function(data){
                  $scope.departments = [];
                  data =  _.sortBy( data, 'Name' );
                  _.each(data,function(department){
                      $scope.departments.push(department);
                  });
                  if($scope.departments.length>$scope.param.limit)
                      $scope.param.isNextDepAvailable = true;
                   $scope.filteredDepartments =  $scope.departments
                  //console.log(data);
                  $ionicLoading.hide();
                  $scope.departments_modal.show();
                  if($scope.param.department != "")
                  {
                    $scope.departments_modal.scope.$$childTail.param.departmentsearch = $scope.param.department;
                    $scope.departments_modal.scope.$$childTail.loadFilteredDepartments();
                  } else {
                    departmentFctr.$LoadDepartmentImages($scope.departments.slice($scope.param.begin,$scope.param.begin+$scope.param.limit));
                  }
              },function (error) {
                  popupFctr.alert('Not found', 'Product not found','barcodeInput');
                  $ionicLoading.hide();
              });
            } else {
              $scope.departments_modal.show();
              if($scope.param.department != ""){
                $scope.departments_modal.scope.$$childTail.param.departmentsearch = $scope.param.department;
                $scope.departments_modal.scope.$$childTail.loadFilteredDepartments();
              }
              $ionicLoading.hide();
          }
        }

        $scope.searchButtonEvent = function () {
              //debugger;
        }
        
        $scope.departments_modal = $ionicModal.fromTemplate('<div pos-departments></div>', {
          scope: $scope,
          animation: 'slide-in-up'
        });
      
        //This Function is called When a Department is Clicked in the Departments List
        $scope.loadProductsByDepID = function(id){
            $scope.param.selecteddepartment = _.findWhere($scope.departments,{ID: id});
            if($scope.param.selecteddepartment)
              $scope.param.department = $scope.param.selecteddepartment.Name;
            $scope.departments_modal.hide();
         }
         $scope.clearDepartmentSelection = function(){
             $scope.param.department = '';
             $scope.param.searchterm = '';
             $scope.param.selecteddepartment = null;
             $scope.param.isNextDepAvailable = false;
             $scope.products = [];
             $scope.param.TotalFound = null;
         }
        $scope.clearsearchproduct = function () {
           $scope.param.searchterm = '';
           $scope.param.isNextDepAvailable = false;
          $scope.products = [];
           $scope.param.TotalFound = null;
        }

      /// Search TextInput option
        $scope.search = function () {
            //1. Check if department is Selected ,if Selected ,then a blank Search Would Invoke showing
            //    Products of Selected Department
            if( $scope.param.selecteddepartment && _.isEmpty($scope.param.searchterm)){
                //Do A Department Product LookUp just like we do in POS
                console.log("Dep products --");
                $scope.param.input = $scope.param.selecteddepartment.ID;
                $scope.param.mode = 6;
                $scope.param.store = $f.moduleSetting.Store.ID;
                $scope.param.MoreAvailable = false;
                $scope.param.TotalFound = null;
                $scope.param.page = 0;
                $scope.param.ExcludeDeactivated = true;
                $ionicLoading.show({
                    template: 'Searching...'
                });
                $scope.loadMore().then(function () {
                    $ionicLoading.hide();
                }, function () {
                    $ionicLoading.hide();
                });
            } else if (!_.isEmpty($scope.param.searchterm)) {
                document.getElementById("barcodeInput").blur();
                $scope.param.input = $scope.param.searchterm;
                $scope.param.store = $f.moduleSetting.Store.ID;
                $scope.param.MoreAvailable = false;
                $scope.param.mode = 0;
                $scope.param.TotalFound = null;
                $scope.param.page = 0;
                $scope.param.ExcludeDeactivated = true;
                $ionicLoading.show({
                    template: 'Searching...'
                });

                $scope.loadMore(true).then(function () {
                    $ionicLoading.hide();
                }, function () {
                    $ionicLoading.hide();
                });
            } else if ($scope.param.selecteddepartment == undefined && _.isEmpty($scope.param.searchterm)){
                popupFctr.alert('Invalid Search', 'Please enter a name, barcode or department');
            }
        };

        $scope.loadMore = function (firstLoad = false) {
            if ($scope.param.input != null) {
            
                // If this is the first load the start with the first page which is 0.
                // Note for future developers: when you start developing, assume that the function doesn't work to begin with, it will save you time
                $scope.param.page += firstLoad ? 0:1;

                return prodFctr.Retrieve.$search($scope.param)
                    .then(function (searchResult) {
                        if ($scope.param.page <= 1) {
                            $scope.products = [];
                        }
                        if (!_.isEmpty(searchResult.Result)) {

                                $scope.param.TotalFound = searchResult.Total || searchResult.Result.length;
                                $scope.param.MoreAvailable = searchResult.MoreAvailable || false;
                                _.each(searchResult.Result, function (p) {
                                if (!_.isEmpty(p.images)) {
                                    p.image = p.images[0].value;
                                }
                                if(searchResult.Result.length == 1){
                                    $scope.products.push(p);
                                    $state.go('tab.product-detail',{'prodId': p.ID});
                                } else {
                                    $scope.products.push(p);
                                }
                            });
                        } else {
                            popupFctr.alert('No results found', 'No results found for "' + $scope.param.searchterm + '"');
                        }
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    });
            }
            
        };

        $scope.moreDataCanBeLoaded = function () {
            return _.isEmpty($scope.param) ? false : $scope.param.MoreAvailable || false;
        };

            $ionicModal.fromTemplateUrl('products-filter-setting.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.productsFilterSettingPopup = modal;
            });

            $ionicModal.fromTemplateUrl('products-filter-setting.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.productsFilterSettingPopup = modal;
            });

        $scope.openFilterSettingPopup = function ($event) {
          //debugger;
          $scope.productsFilterSettingPopup.show($event);
        };

        $scope.closeFilterSettingPopup = function () {
            $scope.productsFilterSettingPopup.hide();
        };

        // $ionicPopover.fromTemplateUrl('search-options.html', { scope: $scope })
        //     .then(function (popover) {
        //         $scope.popover = popover;
        //     });

        // $scope.openPopover = function ($event) {
        //   debugger;
        //   $scope.popover.show($event);
        // };
        //
        // $scope.closePopover = function () {
        //     $scope.popover.hide();
        // };
        //Cleanup the popover when we're done with it!
        // $scope.$on('$destroy', function () {
        //     $scope.popover.remove();
        // });
        // // Execute action on hide popover
        // $scope.$on('popover.hidden', function () {
        //
        // });
        // // Execute action on remove popover
        // $scope.$on('popover.removed', function () {
        //     // Execute action
        // });
        //
        // $scope.$on('popover.hideme', function () {
        //     $scope.popover.hide();
        // });

        init();

        function init() {
          $scope.selecteddepartment = "";
          $scope.filteredDepartments = [];

            $scope.searchDescription = '';
            $scope.advancedSearch = false;

            prodFctr.settings.$get('product').then(function (result) {
                settings = result;

                $scope.param = _.clone(prodFctr.Retrieve.SearchParam);
                $scope.clearSearch();
                $scope.param.isNextDepAvailable = false;
                $scope.param.isPrevDepAvailable = false;
                $scope.products = [];
                $scope.param.searchterm = "";
                $scope.param.department = "";
                $scope.param.page = 0;
                $scope.param.maxitems = settings.maxItems;
                $scope.param.forceLoad = settings.forceLoad;
                $scope.param.input = "";
                $scope.param.includePictures = true;
                $scope.param.MoreAvailable = false;
                $scope.param.TotalFound = null;
            });
        }

        function AdvancedDescription() {
            var Retval = [], params = [];
            var SearchParam = $scope.param;
            var addToParams = function (item) {
                if (!_.isEmpty(item)) {
                    params.push(item);
                }
            };

            addToParams(SearchParam.grids.grid1);
            addToParams(SearchParam.grids.grid2);
            addToParams(SearchParam.grids.grid3);
            addToParams(SearchParam.grids.grid4);

            if (!_.isEmpty(params.toString())) {
                Retval.push(params.toString());
            }

            var PriceText = '';
            if (_.isNumber(SearchParam.price_range.min)) {
                PriceText = PriceText + 'from ' + $filter('currency')(SearchParam.price_range.min) + ' ';
            }

            if (_.isNumber(SearchParam.price_range.max)) {
                PriceText = PriceText + 'up to ' + $filter('currency')(SearchParam.price_range.max);
            }

            PriceText = PriceText.trim();
            if (!_.isEmpty(PriceText)) {
                Retval.push(PriceText);
            }

            return Retval.join(" - ");;
        }
    }]);
