angular.module('aralco.product.controllers').controller('ProdDetailCtrl', ['$scope', '$q', '$stateParams', '$ionicLoading', '$ionicModal','$ionicActionSheet', 'prodFctr', '$filter',
        'storeFctr', 'helperFctr',
        function ($scope, $q, $stateParams, $ionicLoading, $ionicModal, $ionicActionSheet, prodFctr, $filter, storeFctr, helperFctr) {

            var prodId = $stateParams.prodId;

            $ionicModal.fromTemplateUrl('image-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.modal = modal;
            });

            $scope.order = '-Available';

            $scope.SetGrid = function (value, number, noToggle) {
                noToggle = !!noToggle;
                $scope.SelectedGrid.SetValue(value, number, noToggle);
            };

            $scope.setOrder = function (order) {
                $scope.order = order;
            };

            $scope.toggleGroup = function (group) {
                if ($scope.isGroupShown(group)) {
                    $scope.shownGroup = null;
                } else {
                    $scope.shownGroup = group;
                }
            };

            $scope.isGroupShown = function (group) {
                return $scope.shownGroup === group;
            };

            $scope.openModal = function () {
                $scope.modal.show();
            };

            $scope.closeModal = function () {
                $scope.modal.hide();
            };

            //Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function () {
                $scope.modal.remove();
            });
            // Execute action on hide modal
            $scope.$on('modal.hide', function () {
                // Execute action
            });
            // Execute action on remove modal
            $scope.$on('modal.removed', function () {
                // Execute action
            });
            $scope.$on('modal.shown', function () {
            });

            $scope.sortOrder = function() {

                // Show the action sheet
                var sortSheet
                 = $ionicActionSheet.show({
                    buttons: [
                    { text: 'Availability' },
                    { text: 'Store Name' },
                    { text: 'Store Number' }
                    ],
                    cancelText: 'Cancel',
                    cancel: function() {
                        // add cancel code..
                        },
                    buttonClicked: function(index) {
                        switch (index){
                            case 0 :
                                $scope.setOrder('-Available');
                                return true;
                            case 1 :
                                $scope.setOrder('Store.Info.Name');
                                return true;
                            case 2 :
                                $scope.setOrder('Store.Code');
                                return true;
                            }
                    }
                });
            };




            Init();

            function Init() {
                $scope.product = {};

                $scope.getValues = function (grid) {
                    return helperFctr.$GetGridValues(grid);
                };

                function LoadInventory() {

                    var reqParam = prodFctr.inventory.param;

                    reqParam.prodID = $scope.product.ID;
                    reqParam.grids.grid1 = $scope.SelectedGrid.Grid1;
                    reqParam.grids.grid2 = $scope.SelectedGrid.Grid2;
                    reqParam.grids.grid3 = $scope.SelectedGrid.Grid3;
                    reqParam.grids.grid4 = $scope.SelectedGrid.Grid4;
                    reqParam.forceLoad = $f.ForceLoad;

                    //After API Changes, Complete Inventory for a product will only be sent back ,
                    //if you skip store Number in Request param
                    reqParam.skipStore = true;
                    prodFctr.inventory.$get(reqParam).then(function (data) {
                        $scope.inventory = data;
                        storeFctr.Get().then(function (_stores) {
                            _.each($scope.inventory.Breakdown,function(item){
                                var store = _.findWhere(_stores, {Code: item.Store.Code});
                                if(!_.isEmpty(store))
                                    _.extend(item.Store,store);
                            })
                            var test = $scope.inventory.Breakdown;
                            $ionicLoading.hide();
                        }, function () {
                            $ionicLoading.hide();

                        });
                    }, function (data) {
                        $scope.inventory = null;
                        $ionicLoading.hide();
                    });
                }

                $scope.product = {};
                $scope.inventory = null;

                $scope.SelectedGrid = {
                    Grid1: null,
                    Grid2: null,
                    Grid3: null,
                    Grid4: null,
                    GetText: function (number) {
                        if ($scope.product == null || $scope.product.Matrix == null) {
                            return '';
                        }

                        var mtx = $scope.product.Matrix;
                        var _text = function (dim, id) {
                            var RetVal = '';

                            if (dim != null) {
                                RetVal = $filter('translate')('ALL');
                            }

                            if (id != null) {
                                var reqID = _.findWhere(dim.Grids, { ID: id });
                                if (reqID != null) {
                                    RetVal = reqID.Value;
                                }
                            }

                            return RetVal;
                        };

                        return _text(mtx["Dimension" + number], this["Grid" + number]);
                    },
                    SetValue: function (value, number, noToggle) {
                        this["Grid" + number] = this["Grid" + number] == value ? null : value;
                        if (!noToggle) {
                            $scope.toggleGroup(number);
                        }
                        LoadInventory();
                    }
                };

                prodFctr.Retrieve.$load(prodId).then(function (data) {
                    $scope.product = data;
                    LoadInventory();
                });
            }
        }]);
