﻿/// <reference path="../../js/aaralco.mobile.fwaralco.mobile.fw.js" />
/// <reference path="../../Scripts/underscore.js" />
(function () {
    'use strict';

    var module = angular.module('aralco.productsDetails', ['aralco.images', 'aralco.setting','aralco.productsDetails.controllers']);

    module.config(['$stateProvider', '$urlRouterProvider', function ($stateProvider, $urlRouterProvider) {
        // Each tab has its own nav history stack:
        $stateProvider
            .state('tab.productsDetails', {
                url: '/productsDetails',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/tab-products.html',
                        controller: 'ProdDetailsCtrl'
                    }
                }
            })
            .state('tab.tax', {
                url: '/tax',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/tax.html',
                        controller: 'ProdDetailsTaxCtrl'
                    }
                }
            })
            .state('tab.units', {
                url: '/units',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/units.html',
                        controller: 'ProdDetailsUnitCtrl'
                    }
                }
            })
            .state('tab.supplier', {
                url: '/supplier',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/suppliers.html',
                        controller: 'ProdDetailsSupplierCtrl'
                    }
                }
            })
            .state('tab.pricing', {
                url: '/pricing',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/pricing.html',
                        controller: 'ProdDetailsPricingCtrl'
                    }
                }
            })
            .state('tab.properties', {
                url: '/properties',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/properties.html',
                        controller: 'ProdDetailsPropertiesCtrl'
                    }
                }
            })
            .state('tab.grouping', {
                url: '/grouping',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/grouping.html',
                        controller: 'ProdDetailsGropingCtrl'
                    }
                }
            })
            .state('tab.web', {
                url: '/web',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/web.html',
                        controller: 'ProdDetailsWebCtrl'
                    }
                }
            })

            .state('tab.ordering', {
                url: '/ordering',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/ordering.html',
                        controller: 'OrderingCtrl'
                    }
                }
            })
            .state('tab.desc-pos', {
                url: '/desc-pos',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/desc-pos.html',
                        controller: 'DescPosCtrl'
                    }
                }
            })
            .state('tab.pic-sound', {
                url: '/pic-sound',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/product_details/templates/pic-sound.html',
                        controller: 'PicSoundCtrl'
                    }
                }
            })
    }]);



})();
