angular.module('aralco.productsDetails.controllers')
.controller('ProdDetailsPropertiesCtrl', [ 'productDetailsDataFctr','$http','$q','$scope', '$state','errorFctr', '$ionicSideMenuDelegate', '$ionicLoading', '$filter', '$ionicModal',
    function (productDetailsDataFctr,$http,$q, $scope, $state, errorFctr,$ionicSideMenuDelegate, $ionicLoading, $filter, $ionicModal) {

// Properties:
// CommisionDollar:0
// CommisionPercent:0
// DeactivateInventory:false
// DeactivateOrder:false
// DeactivateSell:false
// Tag:null
// Volume:0
// WarehouseLocation:null

// http://sync.aralco.com:7772/dimension/get
// http://sync.aralco.com:7772/dimension/detail/1468
// http://sync.aralco.com:7772/product/GetBarcodeSets

function propertiesDimensionGet() {
              var def = $q.defer();
              var url = $f.serviceUrl + "/dimension/get";
              var req = {
                  method: 'get',
                  url: url
              };
              errorFctr.specificallyHandled(function () {
                  return $http(req)
                      .then(function (data) {
                          def.resolve(data.data);
                          $scope.pricingDimensionGetDatas=data.data;

                      }, function (error) {
                          def.reject(error);
                      });
              });

              return def.promise;
}

function propertiesDimensionDetail() {
              var def = $q.defer();
              var url = $f.serviceUrl + "/dimension/detail/1468";
              var req = {
                  method: 'get',
                  url: url
              };
              errorFctr.specificallyHandled(function () {
                  return $http(req)
                      .then(function (data) {
                          def.resolve(data.data);
                          $scope.pricingDimensionDetailDatas=data.data;
                      }, function (error) {
                          def.reject(error);
                      });
              });

              return def.promise;
}

function propertiesGetBarcodeSets() {
              var def = $q.defer();
              var url = $f.serviceUrl + "/product/GetBarcodeSets";
              var req = {
                  method: 'get',
                  url: url
              };
              errorFctr.specificallyHandled(function () {
                  return $http(req)
                      .then(function (data) {
                          def.resolve(data.data);
                          $scope.pricingGetBarcodeSetsDatas=data.data;
                          $scope.filterbarcodesets = $scope.pricingGetBarcodeSetsDatas[0].Name;
                      }, function (error) {
                          def.reject(error);
                      });
              });

              return def.promise;
}
propertiesDimensionGet();
propertiesDimensionDetail();
propertiesGetBarcodeSets();



$ionicModal.fromTemplateUrl('modules/product_details/templates/properties-grid-modal.html', {
    scope: $scope
}).then(function(modal) {
    $scope.openGridPickValuesModal = modal;
});

$scope.clearsuppliersname = function(){
   $scope.param.suppliersname ="";
}

$scope.openPickValues =function(val){
 $scope.isgrid = val
 $scope.openGridPickValuesModal.show();
}
$scope.gridSelectValue = function(val){
  console.log("value");
}
$scope.closePickValues = function(){
    $scope.openGridPickValuesModal.hide();
}

$scope.nextView = function(){
   $state.go('tab.grouping');
   productDetailsDataFctr.setNextViewCountForBack();
}

$scope.searchproductcode = productDetailsDataFctr.getProductNameAndCode();

$scope.previousView = function(){
 $state.go('tab.pricing');
 productDetailsDataFctr.setPreviousViewCountForBack();
}
  $scope.propertiesDetails = productDetailsDataFctr.getProductDetails().Properties;
  $scope.propertiesTypeInfo = productDetailsDataFctr.getProductDetails().TypeInfo;
  $scope.propertiesUnit = productDetailsDataFctr.getProductDetails().Unit;
  $scope.propertiesUnitWeight = productDetailsDataFctr.getProductDetails().UnitWeight

  if(productDetailsDataFctr.getProductDetails().Matrix == null){
     productDetailsDataFctr.getProductDetails().Matrix = {
       Dimension1:null,
       Dimension2:null,
       Dimension3:null,
       Dimension4:null
    }
  }

  if(productDetailsDataFctr.getProductDetails().Matrix.Dimension1!=null){
        $scope.dimension1grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension1;
        $scope.dimension1grid.Grids = _.sortBy($scope.dimension1grid.Grids, 'Value');
   }

  if(productDetailsDataFctr.getProductDetails().Matrix.Dimension2!=null){
    $scope.dimension2grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension2;
    $scope.dimension2grid.Grids = _.sortBy($scope.dimension2grid.Grids, 'Value');
 }

  if(productDetailsDataFctr.getProductDetails().Matrix.Dimension3!=null){
    $scope.dimension3grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension3;
    $scope.dimension3grid.Grids = _.sortBy($scope.dimension3grid.Grids, 'Value');
  }

  if(productDetailsDataFctr.getProductDetails().Matrix.Dimension4!=null){
    $scope.dimension4grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension4;
    $scope.dimension4grid.Grids = _.sortBy($scope.dimension4grid.Grids, 'Value');
  }

 }]);
