(function () {
    
	var module = angular.module('aralco.productgroups',['ionic']);
	
	module.factory('productGroupFactory', function($filter) {

        var elementId = 20;

        var departmentList = [
            {
                name: "Accessories",
                value: false
            },
            {
                name: "Trailer",
                value: false
            },
            {
                name: "Axles",
                value: false
            },
            {
                name: "Active Shoes",
                value: false
            },
            {
                name: "Additions",
                value: false
            },
            {
                name: "Adhesive",
                value: false
            },
            {
                name: "Admissions",
                value: false
            },
            {
                name: "Adult",
                value: false
            },
            {
                name: "Adult Activity",
                value: false
            },
            {
                name: "Age 16+",
                value: false
            },
            {
                name: "Age 35",
                value: false
            },
            {
                name: "Age 6.15",
                value: false
            },
            {
                name: "Agriculture",
                value: false
            }
        ];
            
		var productGroups = [
			{
                ID: 1,
                name: "Action/Type",
                desc: "Action/Type",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 2,
                name: "Admission",
                desc: "Admission",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 3,
                name: "Age",
                desc: "Age",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 4,
                name: "Age Group",
                desc: "Age Group",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 5,
                name: "Aisle",
                desc: "Aisle",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 6,
                name: "Alberta",
                desc: "Alberta",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 7,
                name: "Alcohol Type",
                desc: "Alcohol Type",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 8,
                name: "Amperage",
                desc: "Amperage",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 9,
                name: "Animal",
                desc: "Animal",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 10,
                name: "Art Style",
                desc: "Art Style",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 11,
                name: "Art Type",
                desc: "Art Type",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 12,
                name: "Artwork",
                desc: "Artwork",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 13,
                name: "Aspect Ratio",
                desc: "Aspect Ratio",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 14,
                name: "Assessment",
                desc: "Assessment",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 15,
                name: "Audio",
                desc: "Audio",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 16,
                name: "Author",
                desc: "Author",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 17,
                name: "Auto Reorder",
                desc: "Auto Reorder",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 18,
                name: "Bag Model",
                desc: "Bag Model",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            },
            {
                ID: 19,
                name: "Barrel Shape",
                desc: "Barrel Shape",
                eCommerce: "",
                deactivate: "",
                showInProductLookup: "",
                departments: angular.copy(departmentList)
            }
		];

		return {
			getProductGroups : function(searchText) {
				return $filter('filter')(productGroups, {name: searchText})
            },
            getDepartmentList : function() {
                return departmentList;
            },
            addProductGroup : function(productGroup) {
                var temp = {
                    ID: elementId++,
                    name: productGroup.name,
                    desc: productGroup.desc,
                    eCommerce: productGroup.eCommerce,
                    deactivate: productGroup.deactivate,
                    showInProductLookup: productGroup.showInProductLookup,
                    departments: angular.copy(productGroup.departments)
                }

                productGroups.push(temp);
            },
            deleteProductGroup: function(item) {
                var index = productGroups.findIndex(productGroup => productGroup.ID == item.ID);
                productGroups.splice(index, 1);
            },
            
            saveProductGroup: function(item,productGroup) {
                var index = productGroups.findIndex(productGroup => productGroup.ID == item.ID);
                productGroups[index].name = productGroup.name;
                productGroups[index].desc = productGroup.desc;
                productGroups[index].eCommerce = productGroup.eCommerce;
                productGroups[index].deactivate = productGroup.deactivate;
                productGroups[index].showInProductLookup = productGroup.showInProductLookup;
                productGroups[index].departments =angular.copy(productGroup.departments);
			},
			getProductGroupByIndex : function(item) {
                return productGroups.filter(productGroup => productGroup.ID == item.ID)[0];
            }            
		};
    });
    
	module.config(['$stateProvider', '$provide', '$urlRouterProvider',
	'$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
		$stateProvider
		.state('tab.productgroups', {
			url: '/productgroups',
			LoginRequired: true,
			views: {
				'tab-view': {
					templateUrl: 'modules/common_html/templates/view.html',
					controller: 'ProductGroupController'
				}
			}
		})
		.state('tab.editproductgroups', {
			url: '/editproductgroup/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/product_groups/templates/product-groups-edit.html',
                    controller: 'EditProductGroupController'
				}
			}
		})
		.state('tab.addproductgroups', {
			url: '/editproductgroup/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/product_groups/templates/product-groups-edit.html',
                    controller: 'AddProductGroupController'
				}
			}	
		})
	}]);

    module.controller('ProductGroupController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,productGroupFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;
        $scope.title = "Manage Product Groupings";
        $scope.searchTitle = "Product Groups"

        
       

        
            
            {
        }

        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'edit' && $scope.selectedItem != null){
                $state.go('tab.editproductgroups',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'add'){
                $state.go('tab.addproductgroups',{name: 'add'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteItem = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        productGroupFactory.deleteProductGroup($scope.selectedItem);
                        $rootScope.$emit('updateProductGroups', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }

        $scope.searchItem = function() {
            $scope.entries = angular.copy(productGroupFactory.getProductGroups($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updateProductGroups', function(event, arg) {
            $scope.entries = angular.copy(productGroupFactory.getProductGroups($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditProductGroupController', function($scope,$state,$stateParams,$ionicPopup,$ionicHistory,$rootScope,productGroupFactory,$filter){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.productGroup = angular.copy(productGroupFactory.getProductGroupByIndex($scope.selectedItem));
        $scope.productGroup.departments = $filter('orderBy')($scope.productGroup.departments,['-value','name']);
        $scope.searchTitle = $scope.productGroup.name;
        $scope.title = "Edit Product Grouping";

        
       

        
            
            {
        }

        $scope.autoFillDescription = function() {
            if($scope.productGroup.desc.length == 0) {
                $scope.productGroup.desc = $scope.productGroup.name;
            }
        }

        $scope.goBack = function() {
            var ProductGroup = angular.copy(productGroupFactory.getProductGroupByIndex($scope.selectedItem));
            ProductGroup.departments = $filter('orderBy')(ProductGroup.departments,['-value','name']);

            if(!angular.equals($scope.productGroup, ProductGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveProductGroup(); 
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.saveProductGroup = function() {
            productGroupFactory.saveProductGroup($scope.selectedItem,$scope.productGroup);
            $rootScope.$emit('updateProductGroups', {
                editType: "Saved"
            });
            var popupMessage = $ionicPopup.alert( {
                title: 'Record saved successfully.',
                subTitle: ''
            })
            $scope.productGroup.departments = $filter('orderBy')($scope.productGroup.departments,['-value','name']);
        }

        $scope.clearProductGroup = function() {
            var ProductGroup = angular.copy(productGroupFactory.getProductGroupByIndex($scope.selectedItem));
            ProductGroup.departments = $filter('orderBy')(ProductGroup.departments,['-value','name']);

            if(!angular.equals($scope.productGroup, ProductGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveProductGroup(); 
                    }
                    else{
                        $scope.productGroup = angular.copy(productGroupFactory.getProductGroupByIndex($scope.selectedItem));
                        $scope.productGroup.departments = $filter('orderBy')($scope.productGroup.departments,['-value','name']);
                    }
                })
            }
        }

        $scope.deleteProductGroup = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    productGroupFactory.deleteProductGroup($scope.selectedItem);
                    $rootScope.$emit('updateProductGroups', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            var ProductGroup = angular.copy(productGroupFactory.getProductGroupByIndex($scope.selectedItem));
            ProductGroup.departments = $filter('orderBy')(ProductGroup.departments,['-value','name']);

            if(!angular.equals($scope.productGroup, ProductGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.productGroup = angular.copy(productGroupFactory.getProductGroupByIndex($scope.selectedItem));
                        $scope.productGroup.departments = $filter('orderBy')($scope.productGroup.departments,['-value','name']);
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('AddProductGroupController', function($scope,$ionicPopup,$ionicHistory,$rootScope,productGroupFactory){
        $scope.showSearchbar = true;
        $scope.title = "Add Product Grouping";

        $scope.productGroup = {
            name : "",
            desc : "",
            eCommerce: "",
            deactivate: "",
            showInProductLookup: "",
            departments: angular.copy(productGroupFactory.getDepartmentList())
        }
        var oriProductGroup = angular.copy($scope.productGroup);

        $scope.autoFillDescription = function() {
            if($scope.productGroup.desc.length == 0) {
                $scope.productGroup.desc = angular.copy($scope.productGroup.name);
            }
        }

        
       //var margintop = 75 + subtoppadding - 55;

        
            
            {
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.productGroup, oriProductGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveProductGroup(); 
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.saveProductGroup = function() {
            if(!angular.equals($scope.productGroup, oriProductGroup)) {
                productGroupFactory.addProductGroup($scope.productGroup);
                $rootScope.$emit('updateProductGroups', {
                    editType: "Added"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                }).then(function() {
                    $scope.productGroup = angular.copy(oriProductGroup);
                })
            }
        }

        $scope.addProductGroup = function() {
            $scope.clearProductGroup();
        }

        $scope.clearProductGroup = function() {
            if(!angular.equals($scope.productGroup, oriProductGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveProductGroup(); 
                    }
                    $scope.productGroup = angular.copy(oriProductGroup);
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.productGroup, oriProductGroup)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.productGroup = angular.copy(oriProductGroup); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })
})();