(function () {
    
	var module = angular.module('aralco.promotionstables',['ionic']);
	
	module.factory('promotionsTableFactory', function($filter) {

        var elementId = 20;

        var storeList = [
            {
                name: "- Lougheed M...",
                value: false
            },
            {
                name: "101 - Pacific Center",
                value: false
            },
            {
                name: "102 - Aralco Demo",
                value: false
            },
            {
                name: "103 - Park Royal",
                value: false
            },
            {
                name: "104 - Vancouver (Yaletown)",
                value: false
            },
            {
                name: "105 - Eaton Center Mall",
                value: false
            },
            {
                name: "106 - MetroTown Center",
                value: false
            },
            {
                name: "107 - Olympia Shopping Mall (Washington)",
                value: false
            },
            {
                name: "155 - Diamond World",
                value: false
            },
            {
                name: "308 - Living Things",
                value: false
            },
            {
                name: "801 - Olympia Shopping Center",
                value: false
            },
            {
                name: "802 - Lougheed Mall",
                value: false
            },
            {
                name: "803 - Web Store",
                value: false
            },
            {
                name: "99 - Warehouse",
                value: false
            },
            {
                name: "999 - Web Store",
                value: false
            }
        ];
            
		var promotionsTables = [
			{
                ID: 1,
                name: "- Consignment1",
                desc: "- Consignment1",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 2,
                name: "- Consignment2",
                desc: "- Consignment2",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 3,
                name: "Antique Show",
                desc: "Antique Show",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 4,
                name: "New Price",
                desc: "New Price",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 5,
                name: "Art Promo",
                desc: "Art Promo",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 6,
                name: "boxing Day",
                desc: "boxing Day",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 7,
                name: "Boxing Day BO",
                desc: "Boxing Day BO",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 8,
                name: "Dairy promo",
                desc: "Dairy promo",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 9,
                name: "Feb 14th Special",
                desc: "Feb 14th Special",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 10,
                name: "February",
                desc: "February",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 11,
                name: "Jewellery Promo",
                desc: "Jewellery Promo",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 12,
                name: "March",
                desc: "March",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 13,
                name: "mid March",
                desc: "mid March",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 14,
                name: "Spring Event",
                desc: "Spring Event",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 15,
                name: "Summer Special",
                desc: "Summer Special",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 16,
                name: "Valentine",
                desc: "Valentine",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 17,
                name: "Winter Special",
                desc: "Winter Special",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 18,
                name: "Xmas Prices",
                desc: "Xmas Prices",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            },
            {
                ID: 19,
                name: "Web Promo",
                desc: "Web Promo",
                fromDate: "",
                toDate: "",
                stores: angular.copy(storeList)
            }
		];

		return {
			getPromotionsTables : function(searchText) {
				return $filter('filter')(promotionsTables, {name: searchText})
            },
            getStoreList : function() {
                return storeList;
            },
            addPromotionsTable : function(promotionsTable) {
                var temp = {
                    ID: elementId++,
                    name: promotionsTable.name,
                    desc: promotionsTable.desc,
                    fromDate: promotionsTable.fromDate,
                    toDate: promotionsTable.toDate,
                    stores: angular.copy(promotionsTable.stores)
                }

                promotionsTables.push(temp);
            },
            deletePromotionsTable: function(item) {
                var index = promotionsTables.findIndex(promotionsTable => promotionsTable.ID == item.ID);
                promotionsTables.splice(index, 1);
            },
            savePromotionsTable: function(item,promotionsTable) {
                var index = promotionsTables.findIndex(promotionsTable => promotionsTable.ID == item.ID);
                promotionsTables[index].name = promotionsTable.name;
                promotionsTables[index].desc = promotionsTable.desc;
                promotionsTables[index].fromDate = promotionsTable.fromDate;
                promotionsTables[index].toDate = promotionsTable.toDate;
                promotionsTables[index].stores =angular.copy(promotionsTable.stores);
			},
			getPromotionsTableByIndex : function(item) {
                return promotionsTables.filter(promotionsTable => promotionsTable.ID == item.ID)[0];
            }
		};
    });
    
	module.config(['$stateProvider', '$provide', '$urlRouterProvider',
	'$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
		$stateProvider
		.state('tab.promotionstables', {
			url: '/promotionstables',
			LoginRequired: true,
			views: {
				'tab-view': {
					templateUrl: 'modules/common_html/templates/view.html',
					controller: 'PromotionsTableController'
				}
			}
		})
		.state('tab.editpromotionstables', {
			url: '/editpromotionstable/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/promotions_tables/templates/promotions-tables-edit.html',
                    controller: 'EditPromotionsTableController'
				}
			}
		})
		.state('tab.addpromotionstables', {
			url: '/editpromotionstable/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/promotions_tables/templates/promotions-tables-edit.html',
                    controller: 'AddPromotionsTableController'
				}
			}	
		})
	}]);

    module.controller('PromotionsTableController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,promotionsTableFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;
        $scope.title = "Manage Promotions";
        $scope.searchTitle = "Promotions Tables"

        
       

        
            
            {
        }

        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'edit' && $scope.selectedItem != null){
                $state.go('tab.editpromotionstables',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'add'){
                $state.go('tab.addpromotionstables',{name: 'add'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteItem = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        promotionsTableFactory.deletePromotionsTable($scope.selectedItem);
                        $rootScope.$emit('updatePromotionsTables', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }

        $scope.searchItem = function() {
            $scope.entries = angular.copy(promotionsTableFactory.getPromotionsTables($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updatePromotionsTables', function(event, arg) {
            $scope.entries = angular.copy(promotionsTableFactory.getPromotionsTables($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditPromotionsTableController', function($scope,$state,$stateParams,$ionicPopup,$ionicHistory,$filter,$rootScope,promotionsTableFactory){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.promotionsTable = angular.copy(promotionsTableFactory.getPromotionsTableByIndex($scope.selectedItem));
        $scope.promotionsTable.stores = $filter('orderBy')($scope.promotionsTable.stores,['-value','name']);
        $scope.searchTitle = $scope.promotionsTable.name;
        $scope.title = "Edit Promotion";
        $scope.checkAll = false;
        $scope.uncheckAll = false;

        
       

        
            
            {
        }

        $scope.autoFillDescription = function() {
            if($scope.promotionsTable.desc.length == 0) {
                $scope.promotionsTable.desc = $scope.promotionsTable.name;
            }
        }

        $scope.goBack = function() {
            var PromotionsTable = angular.copy(promotionsTableFactory.getPromotionsTableByIndex($scope.selectedItem));
            PromotionsTable.stores = $filter('orderBy')(PromotionsTable.stores,['-value','name']);
            
            if(!angular.equals($scope.promotionsTable, PromotionsTable)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePromotionsTable(); 
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.savePromotionsTable = function() {
            promotionsTableFactory.savePromotionsTable($scope.selectedItem,$scope.promotionsTable);
            $rootScope.$emit('updatePromotionsTables', {
                editType: "Saved"
            });
            var popupMessage = $ionicPopup.alert( {
                title: 'Record saved successfully.',
                subTitle: ''
            })
            $scope.promotionsTable.stores = $filter('orderBy')($scope.promotionsTable.stores,['-value','name']);
        }

        $scope.clearPromotionsTable = function() {
            var PromotionsTable = angular.copy(promotionsTableFactory.getPromotionsTableByIndex($scope.selectedItem));
            PromotionsTable.stores = $filter('orderBy')(PromotionsTable.stores,['-value','name']);

            if(!angular.equals($scope.promotionsTable, PromotionsTable)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePromotionsTable(); 
                    }
                    else{
                        $scope.promotionsTable = angular.copy(promotionsTableFactory.getPromotionsTableByIndex($scope.selectedItem));
                        $scope.promotionsTable.stores = $filter('orderBy')($scope.promotionsTable.stores,['-value','name']);
                        $scope.checkAll = false;
                        $scope.uncheckAll = false;
                    }
                })
            }
        }

        $scope.deletePromotionsTable = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    promotionsTableFactory.deletePromotionsTable($scope.selectedItem);
                    $rootScope.$emit('updatePromotionsTables', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            var PromotionsTable = angular.copy(promotionsTableFactory.getPromotionsTableByIndex($scope.selectedItem));
            PromotionsTable.stores = $filter('orderBy')(PromotionsTable.stores,['-value','name']);

            if(!angular.equals($scope.promotionsTable, PromotionsTable)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.promotionsTable = angular.copy(promotionsTableFactory.getPromotionsTableByIndex($scope.selectedItem));
                        $scope.promotionsTable.stores = $filter('orderBy')($scope.promotionsTable.stores,['-value','name']);
                        $scope.checkAll = false;
                        $scope.uncheckAll = false;
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.CheckAll = function() {
            if($scope.checkAll != true) {
                $scope.checkAll = true;
    
                for(var i = 0; i < $scope.promotionsTable.stores.length; i++) {
                    $scope.promotionsTable.stores[i].value = true;
                }
                if($scope.uncheckAll == true) {
                    $scope.uncheckAll = false;
                }
            } else {
                $scope.checkAll = false;
            }
        }

        $scope.UncheckAll = function() {
            if($scope.uncheckAll != true) {
                $scope.uncheckAll = true;
    
                for(var i = 0; i < $scope.promotionsTable.stores.length; i++) {
                    $scope.promotionsTable.stores[i].value = false;
                }
                if($scope.checkAll == true) {
                    $scope.checkAll = false;
                }
            } else {
                $scope.uncheckAll = false;
            }
        }
    })

    module.controller('AddPromotionsTableController', function($scope,$ionicPopup,$ionicHistory,$rootScope,promotionsTableFactory){
        $scope.showSearchbar = true;
        $scope.title = "Add Promotion";
        $scope.checkAll = false;
        $scope.uncheckAll = false;

        $scope.promotionsTable = {
            name : "",
            desc : "",
            fromDate: "",
            toDate: "",
            stores: angular.copy(promotionsTableFactory.getStoreList())
        }
        var oriPromotionsTable = angular.copy($scope.promotionsTable);

        $scope.autoFillDescription = function() {
            if($scope.promotionsTable.desc.length == 0) {
                $scope.promotionsTable.desc = angular.copy($scope.promotionsTable.name);
            }
        }

        
       //var margintop = 75 + subtoppadding - 55;

        
            
            {
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.promotionsTable, oriPromotionsTable)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePromotionsTable(); 
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.savePromotionsTable = function() {
            if(!angular.equals($scope.promotionsTable, oriPromotionsTable)) {
                promotionsTableFactory.addPromotionsTable($scope.promotionsTable);
                $rootScope.$emit('updatePromotionsTables', {
                    editType: "Added"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                }).then(function() {
                    $scope.promotionsTable = angular.copy(oriPromotionsTable);
                    $scope.checkAll = false;
                    $scope.uncheckAll = false;
                })
            }
        }

        $scope.addPromotionsTable = function() {
            $scope.clearPromotionsTable();
        }

        $scope.clearPromotionsTable = function() {
            if(!angular.equals($scope.promotionsTable, oriPromotionsTable)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.savePromotionsTable(); 
                    }
                    $scope.promotionsTable = angular.copy(oriPromotionsTable);
                    $scope.checkAll = false;
                    $scope.uncheckAll = false;
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.promotionsTable, oriPromotionsTable)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.promotionsTable = angular.copy(oriPromotionsTable);
                        $scope.checkAll = false;
                        $scope.uncheckAll = false; 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        $scope.CheckAll = function() {
            if($scope.checkAll != true) {
                $scope.checkAll = true;
    
                for(var i = 0; i < $scope.promotionsTable.stores.length; i++) {
                    $scope.promotionsTable.stores[i].value = true;
                }
                if($scope.uncheckAll == true) {
                    $scope.uncheckAll = false;
                }
            } else {
                $scope.checkAll = false;
            }
        }

        $scope.UncheckAll = function() {
            if($scope.uncheckAll != true) {
                $scope.uncheckAll = true;
    
                for(var i = 0; i < $scope.promotionsTable.stores.length; i++) {
                    $scope.promotionsTable.stores[i].value = false;
                }
                if($scope.checkAll == true) {
                    $scope.checkAll = false;
                }
            } else {
                $scope.uncheckAll = false;
            }
        }
    })
})();