(function () {

    var module = angular.module('aralco.productssetup',['ionic']);

    module.config(['$stateProvider', '$provide', '$urlRouterProvider',
    '$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {

        $stateProvider

        .state('tab.productssetup', {
            url: '/productssetup',
            LoginRequired: true,
            views: {
                'tab-view': {
                    templateUrl: 'modules/setup_option_products/templates/tab-products-setup-option.html',
                    controller: 'productssetupCtr'
                }
            }
        });



    }]);
   

    module.controller("productssetupCtr", ['$scope', 'deviceFctr','$filter','APP_ABOUT', function ($scope, deviceFctr,$filter,APP_ABOUT) {

        $scope.mainMenu = [];        
        $scope.subMenu = [];
        $scope.subMenu.push(new MenuItem("Store Groups", "ion-briefcase", "#/tab/storegroups", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Store Types", "ion-briefcase", "#/tab/storetypes", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Supplier Groups", "ion-plane", "#/tab/suppliergroups", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Customer Groups", "ion-ios-people", "#/tab/customergroups", 'Access to the list of of stores'));
        
        $scope.mainMenu.push(new MainMenuItem("Main Tables", "ion-clipboard", $scope.subMenu, 'View products and inventories'));

        $scope.subMenu = [];
        $scope.subMenu.push(new MenuItem("Product Groups", "ion-tshirt", "#/tab/productgroups", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Departments", "ion-bag", "#/tab/departments", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Dimensions", "ion-calculator", "#/tab/dimensions", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Barcode Sets", "ion-ios-barcode", "#/tab/barcodesets", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Tax Types", "ion-clipboard", "#/tab/taxtables", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Province /State", "ion-map", "#/tab/province", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Units of Measures", "ion-arrow-resize", "#/tab/unitsofmeasures", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Inventory Zones", "ion-archive", "#/tab/bosinventoryzones", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Price Zones", "ion-social-usd", "#/tab/pricezones", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Price Rounding Setup Table", "ion-arrow-graph-up-right", "#/tab/priceroundings", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Promotion Tables", "ion-easel", "#/tab/promotionstables", 'Access to the list of of stores'));
        
        $scope.mainMenu.push(new MainMenuItem("Product Setup Tables", "ion-clipboard", $scope.subMenu, 'View products and inventories'));

        $scope.subMenu = [];
        $scope.subMenu.push(new MenuItem("Currencies", "ion-cash", "#/tab/currencies", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Freight Services", "ion-plane", "#/tab/freightservices", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Duty Rates", "ion-briefcase", "#/tab/dutyrates", 'Access to the list of of stores'));
        
        $scope.mainMenu.push(new MainMenuItem("Imported Products Cost Tables", "ion-arrow-return-left", $scope.subMenu, 'Access to the list of of registers'));

        $scope.subMenu = [];
        $scope.subMenu.push(new MenuItem("BOS Staff Groups", "ion-ios-people", "#/tab/bosusergroups", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("POS Staff Groups", "ion-ios-people", "#/tab/posusergroups", 'Access to the list of of stores'));
        
        $scope.mainMenu.push(new MainMenuItem("User Rights", "ion-cash", $scope.subMenu, 'Access to the list of your customers'));
        
        $scope.subMenu = [];
        $scope.subMenu.push(new MenuItem("Zone Proximities", "ion-arrow-expand", "#/tab/Stores", 'Access to the list of of stores'));
        $scope.subMenu.push(new MenuItem("Store Proximities", "ion-briefcase", "#/tab/Stores", 'Access to the list of of stores'));
        
        $scope.mainMenu.push(new MainMenuItem("Distribution Setup", "ion-settings", $scope.subMenu, 'Staff form'));
        
        $scope.subMenu = [];
        $scope.subMenu.push(new MenuItem("Custom Screens", "ion-plus-circled", "#/tab/Stores", 'Access to the list of of stores'));

        $scope.mainMenu.push(new MainMenuItem("Custom Design Data Capture", "ion-settings", $scope.subMenu, 'Staff form'));

        $scope.subMenu = [];
        $scope.subMenu.push(new MenuItem("Trucks", "ion-android-car", "#/tab/Stores", 'Access to the list of of stores'));

        $scope.mainMenu.push(new MainMenuItem("Shipping", "ion-settings", $scope.subMenu, 'Staff form'));
        
        function MainMenuItem(text, icon, arr, description) {            
            return {
                text: text,
                icon: icon,
                menus: arr,
                description: description
            };
        }
        function MenuItem(text, icon, url, description) {            
            return {
                text: text,
                icon: icon,
                url: url,
                description: description
            };
        }
        
    }])    

})();