﻿/// <reference path="../../Scripts/underscore.js" />
(function () {

    'use strict';

    var module = angular.module('aralco.store', ['aralco.map']);


    module.config(['$stateProvider', '$urlRouterProvider', function ($stateProvider, $urlRouterProvider) {
        // Each tab has its own nav history stack:
        $stateProvider

        .state('tab.stores', {
            url: '/Stores',
            views: {
                'tab-view': {
                    templateUrl: 'modules/store/templates/tab-stores.html',
                    controller: 'storeCtr'
                }
            }
        })
    }]);


    module.directive('storeList', [
       function () {
           return {
               restrict: "A",
               transclude: true,
               scope: {},
               templateUrl: 'modules/store/templates/store-list.html',
               controller: ['$scope', '$rootScope', '$ionicLoading', '$filter', 'storeFctr',
           function ($scope, $rootScope,$ionicLoading, $filter, storeFctr) {
               $scope.Stores = [];

               $ionicLoading.show({
                   template: 'Wait please...'
               });

               storeFctr.Get().then(function (data) {
                   _.each(data, function (item) {
                       item.Address = item.Address || {};
                       item.Address.Latitude = item.Address.Latitude || 0;
                       item.Address.Longitude = item.Address.Longitude || 0;
                   })
                   $ionicLoading.hide();
                   $scope.Stores = data;

               }, function () {
                   $ionicLoading.hide();

               });
           }]

           }
       }]);



    module.factory('storeFctr', ['$q', '$http', '$ionicModal','$rootScope',   function ($q, $http, $ionicModal, $rootScope) {

        this.Get = function (id, forceLoad) {
            /// <summary>
            /// Load the specific product
            /// </summary>
            /// <param name="id"></param>
            var deferred = $q.defer();
            forceLoad = forceLoad || $f.ForceLoad;
            id = id || '';
            var url = $f.serviceUrl + "Store/Get/" + id + '?ForceLoad=' + forceLoad;
            var req = {
                method: 'get',
                //headers: h,
                url: url
            }


            $http(req).
              success(function (data, status, headers, config) {
                  deferred.resolve(data)
              }, function (data, status) {
                  deferred.reject(data, status);
              });

            return deferred.promise;
        }

        this.ChooseStore = function($scope){
            var def = $q.defer();
            //Show Popup To Select A Store 
            $ionicModal.fromTemplateUrl('modules/store/templates/store-select.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.storeModal = modal;
                $scope.storeModal.show();
            });
            function closeModal(){
                console.log('close modal called');
                 $scope.storeModal.remove();
            };
            $scope.$on('$destroy', function () {
                console.log('destroy modal called');
                $scope.storeModal.remove();
            });
            $scope.Ok = function () {
                closeModal();
                def.resolve($scope.data.selectedStoreID);
            }
            $scope.Cancel = function () {
                closeModal();
                def.reject();
            } 
            return def.promise;   
        }

        return this;
    }]);

    module.controller('storeCtr', ['$scope', '$q', '$ionicSideMenuDelegate', '$ionicLoading', 'storeFctr',
		function ($scope, $q, $ionicSideMenuDelegate, $ionicLoading, storeFctr) {
		    init();

		    function init() {

		    }

		}]
	)
})();