
(function () {

    'use strict';

    var module = angular.module('aralco.supplier', []);


    module.config(['$stateProvider', '$urlRouterProvider', function ($stateProvider, $urlRouterProvider) {
        // Each tab has its own nav history stack:
        $stateProvider
            .state('tab.suppliers', {
                url: '/suppliers',
                views: {
                    'tab-view': {
                        templateUrl: 'modules/supplier/templates/supplier.html',
                        controller: 'supplierCtr as vm'
                    }
                }
            });
    }]);
    module.controller('supplierCtr', ['$scope', 'supplierFctr', function ($scope, supplierFctr) {
		$scope.supplier = {};
        $scope.submitted = false;

        $scope.submit = function (form) {
            $scope.submitted = true;
            if(form.$valid) {
                $scope.save($scope.supplier);
            }
        }

        $scope.save = function (supplier) {
            //TODO:: code for save the supplier
        }
		}]
	);

    module.directive('supplierValidate', function () {
        return {
            strict: 'A',
            require: 'ngModel',
            link: function (scope, elem, attr, ngModel) {

                function validatePhone(field) {
                    var regexObj = /^\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$/;
                    return field ? regexObj.test(field) : true;
                }

                ngModel.$parsers.unshift(function (value) {
                    var valid = true;
                    if(attr.type === 'tel') {
                        // Validation for phone number
                        valid = validatePhone(value);
                        ngModel.$setValidity('phone', valid);
                    }
                    return valid ? value : null;
                });
            }
        }
    });
    
})();
