
angular.module('aralco.supplier').factory('supplierFctr', ['$q', '$http', '$ionicModal', function ($q, $http, $ionicModal) {
    var self = this;

    function _post(staff) {
        var def = $q.defer();
        // var url = "Customer/post/";

        url = $f.serviceUrl + url;

        var httpreq = {
            method: 'post',
            url: url,
            data: staff
        };

        $http(httpreq).success(
            function (data, status, headers, config) {
                def.resolve(data);
            }).error(
            function (data, status, headers, config) {
                def.reject(data, status);
            });

        return def.promise;
    }

    function _get(req) {
        var SearchParam = {
            input: "",
            mode: 0,
        }
        req = req || SearchParam;
        var def = $q.defer();

        var url = $f.serviceUrl + "Supplier/Search?input={input}&mode={mode}";
        url = url.replace('{input}', req.input);
        url = url.replace('{mode}', req.mode);

        var httpreq = {
            method: 'get',
            url: url
        };

        $http(httpreq).success(
            function (data, status, headers, config) {
                def.resolve(data);
            }).error(
            function (data, status, headers, config) {
                def.reject(data, status);
            });

        return def.promise;
    }

    function _chooseSupplier($scope){
        var def = $q.defer();
        //Show Popup To Select A Supplier 
        $ionicModal.fromTemplateUrl('modules/supplier/templates/supplier-select.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.SupplierModal = modal;
            $scope.SupplierModal.show();
        });
        function closeModal(){
            console.log('close modal called');
             $scope.SupplierModal.remove();
        };
        $scope.$on('$destroy', function () {
            console.log('destroy modal called');
            $scope.SupplierModal.remove();
        });
        $scope.Ok = function () {
            closeModal();
            def.resolve($scope.data.selectedSupplierID);
        }
        $scope.Cancel = function () {
            closeModal();
            def.reject();
        } 
        return def.promise;   
    }



    self.$post = _post;
    self.$get  = _get;
    self.$ChooseSupplier = _chooseSupplier;

    return self;
}]);