﻿/// <reference path="../../js/aaralco.mobile.fwaralco.mobile.fw.js" />

(function () {
    'use strict';

    var module = angular.module('aralco.taxes', []);


    module.factory('taxFctr', ['$q', '$http',
        function ($q, $http) {
            var self = this;

            var _byProduct = function (id, forceLoad) {
                var def = $q.defer();
                var url = "Tax/ByProduct/{id}?ForceLoad={forceLoad}";
                url = url.replace("{id}", id).replace("{forceLoad}", forceLoad || $f.ForceLoad);
                url = $f.serviceUrl + url;

                var httpreq = {
                    method: 'get',
                    url: url
                }

                $http(httpreq).success(function (data, status, headers, config) {
                    def.resolve(data);
                }).error(function (data, status) {
                    def.reject(data, status);
                });

                return def.promise;
            }

            var _byRegister = function (id, forceLoad) {
                var def = $q.defer();

                id = id || 3; //This is works only for test on dev computer! 
                              //put it on config  


                var url = "Tax/ByRegister/{id}?ForceLoad={forceLoad}";
                url = url.replace("{id}", id).replace("{forceLoad}", forceLoad || $f.ForceLoad);
                url = $f.serviceUrl + url;

                var httpreq = {
                    method: 'get',
                    url: url
                }

                $http(httpreq).success(function (data, status, headers, config) {
                    def.resolve(data);
                }).error(function (data, status) {
                    def.reject(data, status);
                });

                return def.promise;
            }

            var _byStore = function (id, forceLoad) {
                var def = $q.defer();

                id = id || 3; //This is works only for test on dev computer! 
                //put it on config  
                 
                var url = "Tax/ByStore/{id}?ForceLoad={forceLoad}";
                url = url.replace("{id}", id).replace("{forceLoad}", forceLoad || $f.ForceLoad);
                url = $f.serviceUrl + url;

                var httpreq = {
                    method: 'get',
                    url: url
                }

                $http(httpreq).success(function (data, status, headers, config) {
                    def.resolve(data);
                }).error(function (data, status) {
                    def.reject(data, status);
                });

                return def.promise;
            }

          
            self.$getByProduct = _byProduct;

            self.$getByRegister = _byRegister;

            self.$getByStore = _byStore;
           

            return self;

        }]);

})();
