(function () {
    
    var module = angular.module('aralco.tenderkeysetup',['ionic']);

    module.factory('tenderKeyFactory', function($filter) {

        var elementId = 6;

        var tenderKeys = [
            {
                ID: 1,
                name: "Cash",
                desc: "Cash",
                symbol : "A",
                exchangeRate : 0,
                disableKeyMobile : "",
                disableKeyDesktop : "",
                cashTender : "",
                cashCount : "",
                disableCashdraw : "",
                bankDiposite : "",
                card : "",
                authorization : "",
                giftCard : "",
                allowExcessPayment : "",
                refundByCash : "",
                changeLimit : 0
            },
            {
                ID: 2,
                name: "Visa",
                desc: "Visa",
                symbol : "B",
                exchangeRate : 0,
                disableKeyMobile : "",
                disableKeyDesktop : "",
                cashTender : "",
                cashCount : "",
                disableCashdraw : "",
                bankDiposite : "",
                card : "",
                authorization : "",
                giftCard : "",
                allowExcessPayment : "",
                refundByCash : "",
                changeLimit : 0
            },
            {
                ID: 3,
                name: "MasterCard",
                desc: "MasterCard",
                symbol : "C",
                exchangeRate : 0,
                disableKeyMobile : "",
                disableKeyDesktop : "",
                cashTender : "",
                cashCount : "",
                disableCashdraw : "",
                bankDiposite : "",
                card : "",
                authorization : "",
                giftCard : "",
                allowExcessPayment : "",
                refundByCash : "",
                changeLimit : 0
            },
            {
                ID: 4,
                name: "Amex",
                desc: "Amex",
                symbol : "D",
                exchangeRate : 0,
                disableKeyMobile : "",
                disableKeyDesktop : "",
                cashTender : "",
                cashCount : "",
                disableCashdraw : "",
                bankDiposite : "",
                card : "",
                authorization : "",
                giftCard : "",
                allowExcessPayment : "",
                refundByCash : "",
                changeLimit : 0
            },
            {
                ID: 5,
                name: "Debit",
                desc: "Debit",
                symbol : "E",
                exchangeRate : 0,
                disableKeyMobile : "",
                disableKeyDesktop : "",
                cashTender : "",
                cashCount : "",
                disableCashdraw : "",
                bankDiposite : "",
                card : "",
                authorization : "",
                giftCard : "",
                allowExcessPayment : "",
                refundByCash : "",
                changeLimit : 0
            }
        ];

        return {
            getTenderKeys : function(searchText) {
                return $filter('filter')(tenderKeys, {name: searchText})
            },
            addTenderKey : function(tenderKey) {
                var temp = {
                    ID: elementId++,
                    name: tenderKey.name,
                    desc: tenderKey.desc,
                    symbol : tenderKey.symbol,
                    exchangeRate : tenderKey.exchangeRate,
                    disableKeyMobile : tenderKey.disableKeyMobile,
                    disableKeyDesktop : tenderKey.disableKeyDesktop,
                    cashTender : tenderKey.cashTender,
                    cashCount : tenderKey.cashCount,
                    disableCashdraw : tenderKey.disableCashdraw,
                    bankDiposite : tenderKey.bankDiposite,
                    card : tenderKey.card,
                    authorization : tenderKey.authorization,
                    giftCard : tenderKey.giftCard,
                    allowExcessPayment : tenderKey.allowExcessPayment,
                    refundByCash : tenderKey.refundByCash,
                    changeLimit : tenderKey.changeLimit
                }

                tenderKeys.push(temp);
            },
            deleteTenderKey: function(item) {
                var index = tenderKeys.findIndex(tenderKey => tenderKey.ID == item.ID);
                tenderKeys.splice(index, 1);
            },
            saveTenderKey: function(item,tenderKey) {
                var index = tenderKeys.findIndex(tenderKey => tenderKey.ID == item.ID);
                tenderKeys[index].name = tenderKey.name;
                tenderKeys[index].desc = tenderKey.desc;
                tenderKeys[index].symbol = tenderKey.symbol;
                tenderKeys[index].exchangeRate = tenderKey.exchangeRate;
                tenderKeys[index].disableKeyMobile = tenderKey.disableKeyMobile;
                tenderKeys[index].disableKeyDesktop = tenderKey.disableKeyDesktop;
                tenderKeys[index].cashTender = tenderKey.cashTender;
                tenderKeys[index].cashCount = tenderKey.cashCount;
                tenderKeys[index].disableCashdraw = tenderKey.disableCashdraw;
                tenderKeys[index].bankDiposite = tenderKey.bankDiposite;
                tenderKeys[index].card = tenderKey.card;
                tenderKeys[index].authorization = tenderKey.authorization;
                tenderKeys[index].giftCard = tenderKey.giftCard;
                tenderKeys[index].allowExcessPayment = tenderKey.allowExcessPayment;
                tenderKeys[index].refundByCash = tenderKey.refundByCash;
                tenderKeys[index].changeLimit = tenderKey.changeLimit;
            },
            getTenderKeyByIndex : function(item) {
                return tenderKeys.filter(tenderKey => tenderKey.ID == item.ID)[0];
            }
        };
    });

    module.directive('selectOnClick', ['$window', function ($window) {
        if(ionic.Platform.isIOS()) {
            return {
                restrict: 'A',
                link: function (scope, element, attrs) {
                    element.on('click', function () {
                        if (!$window.getSelection().toString()) {
                            this.setSelectionRange(0, this.value.length)
                        }
                    });
                }
            };
        }
        else {
            return {
                restrict: 'A',
                link: function (scope, element) {
                    var focusedElement;
                    element.on('click', function () {
                        this.select();
                        focusedElement = this;
                    });
                    element.on('blur', function () {
                        focusedElement = null;
                    });
                }
            };
        }
    }]);

    module.config(['$stateProvider', '$provide', '$urlRouterProvider',
    '$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
        $stateProvider
        .state('tab.tenderkeysetup', {
            url: '/tenderkeysetup',
            LoginRequired: true,
            views: {
                'tab-view': {
                    templateUrl: 'modules/tender_key_setup/templates/tender-key-setup.html',
                    controller: 'TenderKeyController'
                }
            }
        })
        .state('tab.edittenderkey', {
            url: '/edittenderkey/:name',
            LoginRequired: true,  
            views: {
                'tab-view': {
                    templateUrl: 'modules/tender_key_setup/templates/tender-key-setup-details.html',
                    controller: 'EditTenderKeyController'
                }
            }
        })
        .state('tab.addtenderkey', {
            url: '/edittenderkey/:name',
            LoginRequired: true,
            views: {
                'tab-view': {
                    templateUrl: 'modules/tender_key_setup/templates/tender-key-setup-details.html',
                    controller: 'AddTenderkeyController'
                }
            }
        })
    }]);

    module.controller('TenderKeyController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,tenderKeyFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;

        
       

        
            
            
            {
        }

        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'editTender' && $scope.selectedItem != null){
                $state.go('tab.edittenderkey',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'addTender'){
                $state.go('tab.addtenderkey',{name: 'addTenderKey'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteTenderKey = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        tenderKeyFactory.deleteTenderKey($scope.selectedItem);
                        $rootScope.$emit('updateTenderKeys', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }

        $scope.searchItem = function() {
            $scope.entries = angular.copy(tenderKeyFactory.getTenderKeys($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updateTenderKeys', function(event, arg) {
            $scope.entries = angular.copy(tenderKeyFactory.getTenderKeys($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditTenderKeyController', function($scope,$state,$stateParams,$ionicPopup,$ionicHistory,$rootScope,tenderKeyFactory){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.tenderKey = angular.copy(tenderKeyFactory.getTenderKeyByIndex($scope.selectedItem));
        $scope.searchTitle = $scope.tenderKey.symbol + ". " + $scope.tenderKey.name;

        var vm = this;
        
        
       

        
            
            {
        }
        
        $scope.autoFillDescription = function() {
            if($scope.tenderKey.desc.length == 0) {
                $scope.tenderKey.desc = $scope.tenderKey.name;
            }
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.tenderKey, tenderKeyFactory.getTenderKeyByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveTenderKey();
                        if(angular.isDefined($scope.tenderKey.exchangeRate) && angular.isDefined($scope.tenderKey.changeLimit)) {
                            $ionicHistory.goBack();
                        }
                    }
                    else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }   
        }

        $scope.saveTenderKey = function() {
            if(angular.isDefined($scope.tenderKey.exchangeRate) && angular.isDefined($scope.tenderKey.changeLimit)) {
                tenderKeyFactory.saveTenderKey($scope.selectedItem,$scope.tenderKey);
                $rootScope.$emit('updateTenderKeys', {
                    editType: "Saved"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                })
            }
            else {
                var popupMessage = $ionicPopup.alert( {
                    title: 'Invalid Input.',
                    subTitle: ''
                })
            }
        }
        
        $scope.clearTenderKey = function() {
            if(!angular.equals($scope.tenderKey, tenderKeyFactory.getTenderKeyByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveTenderKey(); 
                    }
                    else{
                        $scope.tenderKey = angular.copy(tenderKeyFactory.getTenderKeyByIndex($scope.selectedItem));
                    }
                })
            }
        }

        $scope.deleteTenderKey = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    tenderKeyFactory.deleteTenderKey($scope.selectedItem);
                    $rootScope.$emit('updateTenderKeys', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.tenderKey, tenderKeyFactory.getTenderKeyByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.tenderKey = angular.copy(tenderKeyFactory.getTenderKeyByIndex($scope.selectedItem));
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('AddTenderkeyController', function($scope,$ionicPopup,$ionicHistory,$rootScope,tenderKeyFactory){
        $scope.showSearchbar = true;
        $scope.tenderKey = {
            symbol : "",
            name : "",
            desc : "",
            exchangeRate : 0,
            disableKeyMobile : "",
            disableKeyDesktop : "",
            cashTender : "",
            cashCount : "",
            disableCashdraw : "",
            bankDiposite : "",
            card : "",
            authorization : "",
            giftCard : "",
            allowExcessPayment : "",
            refundByCash : "",
            changeLimit : 0
        }
        var oriTenderKey = angular.copy($scope.tenderKey);

        $scope.autoFillDescription = function() {
            if($scope.tenderKey.desc.length == 0) {
                $scope.tenderKey.desc = $scope.tenderKey.name;
            }
        }

        
       //var margintop = 75 + subtoppadding - 55;

        
            
            {
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.tenderKey, oriTenderKey)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveTenderKey();
                        if(angular.isDefined($scope.tenderKey.exchangeRate) && angular.isDefined($scope.tenderKey.changeLimit)) {
                            $ionicHistory.goBack();
                        } 
                    }
                    else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }   
        }
        
        $scope.saveTenderKey = function() {
            if(!angular.equals($scope.tenderKey, oriTenderKey)) {
                if(angular.isDefined($scope.tenderKey.exchangeRate) && angular.isDefined($scope.tenderKey.changeLimit)) {
                    tenderKeyFactory.addTenderKey($scope.tenderKey);
                    $rootScope.$emit('updateTenderKeys', {
                        editType: "Added"
                    });
                    var popupMessage = $ionicPopup.alert( {
                        title: 'Record saved successfully.',
                        subTitle: ''
                    }).then(function() {
                        $scope.tenderKey = angular.copy(oriTenderKey);
                    })
                }
                else {
                    var popupMessage = $ionicPopup.alert( {
                        title: 'Invalid Input.',
                        subTitle: ''
                    })
                }
            }
        }

        $scope.addTenderKey = function() {
            $scope.clearTenderKey();
        }

        $scope.clearTenderKey = function() {
            if(!angular.equals($scope.tenderKey, oriTenderKey)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveTenderKey();
                        if(angular.isDefined($scope.tenderKey.exchangeRate) && angular.isDefined($scope.tenderKey.changeLimit)) {
                            $scope.tenderKey = angular.copy(oriTenderKey);
                        } 
                    }
                    else {
                        $scope.tenderKey = angular.copy(oriTenderKey);
                    }
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.tenderKey, oriTenderKey)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.tenderKey = angular.copy(oriTenderKey); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })
})();